(window["webpackJsonpcom_msomics_ms_app"] = window["webpackJsonpcom_msomics_ms_app"] || []).push([["routePage_msLoDCheck"],{

/***/ "../apps/module/ms_app/src/pages/lod-check.html":
/*!******************************************************!*\
  !*** ../apps/module/ms_app/src/pages/lod-check.html ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>LoD Check</h1></div>\r\n\r\n        <div class=\"page-panels grid full-width-panels\">\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">LoD Table</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Step</th>\r\n                                <th repeat.for=\"ci of compoundInfos\">${ci.name}</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"step of steps\">\r\n                                <th>${step.name}</th>\r\n                                <th repeat.for=\"ci of compoundInfos\">${ getLoD(step, ci.id) | significant }</th>\r\n                            </tr>\r\n                            <tr>\r\n                                <th>Average</th>\r\n                                <th repeat.for=\"ci of compoundInfos\">${ ci.lodAverage | significant }</th>\r\n                            </tr>\r\n                            <tr>\r\n                                <th>St Dev</th>\r\n                                <th repeat.for=\"ci of compoundInfos\">${ ci.lodStdev | significant }</th>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Charts</div>\r\n                <div class=\"panel-body grid text-center\" style=\"grid-template-columns: repeat(auto-fill, 400px);\">\r\n                    <div repeat.for=\"ci of compoundInfos\" style=\"margin-bottom:20px;\">\r\n                        <a href=\"/#/entity/Compound/${ci.id}\">${ci.name}</a>\r\n                        <c3chart setup.bind=\"ci.chartLoD\"></c3chart>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"display: none\">\r\n                <div class=\"panel-heading\">RS</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <tbody>\r\n                            <tr repeat.for=\"rs of resultSets\">\r\n                                <td>${rs.id}</td>\r\n                                <td>${rs.originID}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"display: none\">\r\n                <div class=\"panel-heading\">Hits</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <tbody>\r\n                            <tr repeat.for=\"hit of hits\">\r\n                                <td>${hit.resultSetID}</td>\r\n                                <td>${hit.compoundID}</td>\r\n                                <td>${hit.limitOfDetection | significant}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/pages/lod-check.ts":
/*!****************************************************!*\
  !*** ../apps/module/ms_app/src/pages/lod-check.ts ***!
  \****************************************************/
/*! exports provided: DemoMSLoDCheck */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DemoMSLoDCheck", function() { return DemoMSLoDCheck; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let DemoMSLoDCheck = class DemoMSLoDCheck {
    constructor(api) {
        this.api = api;
    }
    activate() {
        this.api.datasetQuery([
            { eClass: 'Step', collection: 'steps', filters: [{ field: 'Type', value: 'SCFA' }] },
            { eClass: 'ResultSet', collection: 'resultSets', filters: [{ field: 'OriginID', in: 'steps.ID' }] },
            { eClass: 'ResultMSHit', collection: 'hits', filters: [{ field: 'ResultSetID', in: 'resultSets.ID' }] },
            { eClass: 'Compound', collection: 'compounds', filters: [{ field: 'ID', in: 'hits.CompoundID' }] }
        ]).then(dataset => {
            this.steps = dataset.steps;
            this.resultSets = dataset.resultSets;
            this.hits = dataset.hits;
            this.compoundInfos = dataset.compounds.map(c => { return { id: c.id, name: c.name, nResults: 0, sum: 0 }; });
            for (let ci of this.compoundInfos) {
                ci.hits = this.hits.filter(h => h.compoundID === ci.id && h.limitOfDetection);
                if (ci.hits.length >= 2) {
                    ci.lodAverage = ci.hits.reduce((sum, hit) => sum += hit.limitOfDetection, 0) / ci.hits.length;
                    ci.lodVariance = ci.hits.reduce((variance, hit) => variance += Math.pow(hit.limitOfDetection - ci.lodAverage, 2), 0) / (ci.hits.length - 1);
                    ci.lodStdev = Math.sqrt(ci.lodVariance);
                }
                ci.chartLoD = {
                    data: {
                        columns: [
                            ['individual'].concat(ci.hits.map(h => h.limitOfDetection)),
                            ['white'].concat(ci.hits.map(h => ci.lodAverage - ci.lodStdev)),
                            ['yellow'].concat(ci.hits.map(h => ci.lodStdev * 0.8)),
                            ['green'].concat(ci.hits.map(h => ci.lodStdev * 0.4)),
                            ['yellow2'].concat(ci.hits.map(h => ci.lodStdev))
                        ],
                        type: 'bar',
                        types: { individual: 'line' },
                        groups: [['white', 'yellow', 'green', 'yellow2']],
                        order: null,
                        colors: {
                            white: '#ffffff',
                            yellow: '#ffff00',
                            green: '#55ff55',
                            yellow2: '#ffff00'
                        }
                    },
                    bar: { width: { ratio: 1 } }
                };
            }
        });
    }
    getStepName(hit) {
        let rs = this.resultSets.find(rs => rs.id === hit.resultSetID);
        let step = this.steps.find(s => s.id === rs.originID);
        return step.name;
    }
    getLoD(step, compoundID) {
        let rs = this.resultSets.find(rs => rs.originID === step.id);
        if (!rs)
            return '-';
        let hit = this.hits.find(h => h.resultSetID === rs.id && h.compoundID === compoundID);
        if (!hit)
            return '-';
        return hit.limitOfDetection;
    }
};
DemoMSLoDCheck = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DemoMSLoDCheck);



/***/ })

}]);
//# sourceMappingURL=routePage_msLoDCheck.f8d7769117c034d4fdbf.js.map