(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/audit-trail"],{

/***/ "../apps/core/administration/src/pages/administration/audit-trail.html":
/*!*****************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/audit-trail.html ***!
  \*****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Audit Trail</h1>\r\n        </div>\r\n\r\n        <div class=\"page-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <p class=\"float-right\">\r\n                        Click the\r\n                        <i class=\"fa fa-question-circle\"></i> in the lower left corner to get help.\r\n                    </p>\r\n                    <div class=\"form-group\">\r\n                        <label>Select Experiment</label>\r\n                        <span>\r\n                            <input-foreign-key e-class=\"Experiment\" value.bind=\"experimentID\"></input-foreign-key>\r\n                            <br/>\r\n                            <button disabled.bind=\"loading || !experimentID\" click.delegate=\"update()\">Load Audit Trail</button>\r\n                            <span class=\"loading\" if.bind=\"loading\"></span>\r\n                        </span>\r\n                    </div>\r\n\r\n                    <table if.bind=\"trail.length\" class=\"full-width\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Operation</th>\r\n                                <th>Record (${ trail.length})</th>\r\n                                <th>Status</th>\r\n                                <th>ID</th>\r\n                                <th>User</th>\r\n                                <th>UTC</th>\r\n                                <th>Comment</th>\r\n                                <th></th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"row of trail\">\r\n                                <td>${row.op}</td>\r\n                                <td>${row.eClass}</td>\r\n                                <td>${row.row.status}</td>\r\n                                <td>\r\n                                    <a href=\"/#/entity/${row.eClass}/${row.id}\">${row.id}</a>\r\n                                </td>\r\n                                <td>${row.user}</td>\r\n                                <td>${row.utc}</td>\r\n                                <td>${row.comment}</td>\r\n                                <td>\r\n                                    <div if.bind=\"row.row.name\">\r\n                                        <b>Name: </b>${ row.row.name }</div>\r\n                                    <div if.bind=\"row.changes.length\">\r\n                                        <b>Modified:</b>\r\n                                        <ul style=\"margin:0;\">\r\n                                            <li repeat.for=\"key of row.changes\">\r\n                                                <b>${key}:</b> ${ row.compareSummary[key] }\r\n                                            </li>\r\n                                        </ul>\r\n                                    </div>\r\n                                </td>\r\n                                <td>\r\n                                    <a click.delegate=\"details(row)\">Show details</a>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/audit-trail.ts":
/*!***************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/audit-trail.ts ***!
  \***************************************************************************/
/*! exports provided: AdminAuditTrail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdminAuditTrail", function() { return AdminAuditTrail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");




let AdminAuditTrail = class AdminAuditTrail {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.loading = false;
        this.trail = [];
    }
    activate() {
    }
    update() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.trail = [];
            this.loading = true;
            const dataset = yield this.server.datasetQuery([
                { view: 'AuditTrailExperiments', collection: 'experiments', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailFiles', collection: 'files', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailNotes', collection: 'notes', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailSteps', collection: 'steps', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailSamples', collection: 'samples', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailPlates', collection: 'plates', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailApprovals', collection: 'approvals', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailApprovalSignatures', collection: 'approvalSigs', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailResultSets', collection: 'rs', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailResultValues', collection: 'rvs', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] },
                { view: 'AuditTrailEvents', collection: 'events', filters: [{ field: 'experimentID', value: this.experimentID }], sortings: [{ field: 'modifiedUtc', direction: 'desc' }] }
            ]);
            const trail = [];
            trail.push(...this.transform(dataset.experiments, 'Experiment'));
            trail.push(...this.transform(dataset.files, 'File'));
            trail.push(...this.transform(dataset.notes, 'Note'));
            trail.push(...this.transform(dataset.steps, 'Step'));
            trail.push(...this.transform(dataset.samples, 'Sample'));
            trail.push(...this.transform(dataset.plates, 'Plate'));
            trail.push(...this.transform(dataset.approvals, 'Approval'));
            trail.push(...this.transform(dataset.approvalSigs, 'ApprovalSignature'));
            trail.push(...this.transform(dataset.rs, 'ResultSet'));
            trail.push(...this.transform(dataset.rvs, 'ResultValue'));
            trail.push(...this.transform(dataset.events, 'AuditEvent'));
            this.trail.push(...trail.sort((a, b) => (new Date(a.utc) > new Date(b.utc) ? -1 : 1)));
            for (const row of this.trail.filter(r => r.eClass !== 'Experiment')) {
                row.experiment = this.trail.find(e => e.eClass === 'Experiment' && new Date(e.utc) < new Date(row.utc));
            }
            this.loading = false;
        });
    }
    transform(rows, eClass) {
        const transformed = [];
        for (let i = 0; i < rows.length; i++) {
            const row = rows[i];
            const updated = {
                eClass: eClass,
                id: row.id,
                user: row.modifiedBy,
                utc: row.modifiedUtc,
                op: row.auditOp === 'I' ? 'Create' : 'Update',
                changes: [],
                row: row,
                comment: null,
                compareWith: null,
                compareSummary: {}
            };
            delete updated.row.eClass;
            if (eClass === 'AuditEvent') {
                updated.comment = row.type + ': ' + row.report;
            }
            if (row.auditOp === 'U') {
                updated.compareWith = rows.find(r => r.id === row.id && r.version === row.version - 1);
                updated.changes = Object.keys(row).filter(key => updated.compareWith[key] !== row[key] && !['auditOp', 'auditID', 'version', 'modifiedUtc'].includes(key));
                for (const key of updated.changes) {
                    updated.compareSummary[key] = this.truncate('' + updated.compareWith[key]) + ' > ' + this.truncate('' + updated.row[key]);
                }
            }
            transformed.push(updated);
        }
        return transformed;
    }
    details(row) {
        this.dialog.open({
            model: { row: row, trail: this.trail },
            viewModel: AuditDetails
        });
    }
    truncate(str) {
        return str.length > 20 ? str.substr(0, 20) + '...' : str;
    }
};
AdminAuditTrail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: ['admin/audit', 'admin/audit-trail'],
        title: 'Audit Trail',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], AdminAuditTrail);

class AuditDetails {
    constructor() {
        this.view = () => `
<ux-dialog style="width: 1000px">
    <ux-dialog-header>
        <h2>#{row.eClass}: #{row.id}</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <table class="full-width">
            <thead>
                <tr>
                    <th>User</th>
                    <th>UTC</th>
                    <th>Operation</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>#{row.user}</td>
                    <td>#{row.utc}</td>
                    <td>#{row.op}</td>
                </tr>
            </tbody>
        </table>
        
        <br/>        
        <h2>Changes</h2>

        <table if.bind="row.changes.length" class="full-width">
            <tr>
                <td></td>
                <th>Before</th>
                <th>Now</th>
            </tr>
            <tr repeat.for="key of row.changes">
                <td>#{key}</td>
                <td>#{row.compareWith[key]}</td>
                <td>#{row.row[key]}</td>
            </tr>
        </table>

        <br/>        
        <h2>Versions</h2>

        <table class="full-width">
            <thead>
                <tr>
                    <th>Version</th>
                    <th>Operation</th>
                    <th>Status</th>
                    <th>User</th>
                    <th>UTC</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                <tr repeat.for="r of trail">
                    <td>#{r.row.version}</td>
                    <td>#{r.op}</td>
                    <td>#{r.row.status}</td>
                    <td>#{r.user}</td>
                    <td>#{r.utc}</td>
                    <td>
                        <div if.bind="r.changes.length">
                            <b>Modified:</b>
                            <ul style="margin:0;">
                                <li repeat.for="key of r.changes">
                                    <b>#{key}:</b> #{ r.compareSummary[key] }
                                </li>
                            </ul>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>

        <br/>
        <h2>All details</h2>

        <div class="panel simple">
            <div class="panel-heading">
                Show All Details
                <collapsible default="collapsed"></collapsible>
            </div>
            <div class="panel-body">
                <table>
                    <tr>
                        <th>Field</th>
                        <th>Value</th>
                    </tr>
                    <tr repeat.for="key of row.row | objectKeys">
                        <td>#{key}</td>
                        <td>#{row.row[key]}</td>
                    </tr>
                </table>
            </div>
        </div>

        <div if.bind="row.experiment">
            <br/>
            <h2>Experiment details at this time: #{row.utc}</h2>

            <div class="panel simple">
                <div class="panel-heading">
                    Show Experiment Details
                    <collapsible default="collapsed"></collapsible>
                </div>
                <div class="panel-body">
                    <table>
                        <tr>
                            <th>Field</th>
                            <th>Value</th>
                        </tr>
                        <tr repeat.for="key of row.experiment.row | objectKeys">
                            <td>#{key}</td>
                            <td>#{row.experiment.row[key]}</td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>

    </ux-dialog-body>
    <ux-dialog-footer><button click.delegate="dialog.cancel()">Close</button></ux-dialog-footer>
</ux-dialog>
    `;
    }
    init(model) {
        this.row = model.row;
        this.trail = model.trail.filter(r => r.id === this.row.id);
    }
}


/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=audit-trail.e28d4943052103ad78ee.js.map