(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/users/user-roles"],{

/***/ "../apps/core/administration/src/pages/administration/users/assign-revoke-user-role.ts":
/*!*********************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/assign-revoke-user-role.ts ***!
  \*********************************************************************************************/
/*! exports provided: AssignRevokeUserRole */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AssignRevokeUserRole", function() { return AssignRevokeUserRole; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let AssignRevokeUserRole = class AssignRevokeUserRole {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.loading = true;
        this.newUserId = null;
        this.newUserEntity = null;
        this.selectedUsers = [];
        this.users = [];
        this.currentUsers = new Set();
        this.view = () => `
<ux-dialog style="width: 500px">
    <ux-dialog-header><h2>Assign/revoke role <i>#{role.name}</i></h2></ux-dialog-header>
    <ux-dialog-body>  
        <div class="loading" if.bind="loading"></div>
        <template else>
            <p><b>Users with role:</b></p>
            <p>
                <select multiple value.bind="selectedUsers" size="10">
                    <option repeat.for="user of users" model.bind="user">#{user.id}: #{user.name}</option>
                </select>
            </p>
            <p>
                <button class="float-right small" click.delegate="revoke()" disabled.bind="!selectedUsers.length">Revoke role from selected user(s)</button>
            </p>
            <br/><br/>
            <p>
                <input-foreign-key value.bind="newUserId"
                                    entity.bind="newUserEntity"
                                    placeholder="Assign new user"
                                    e-class="User"
                                    style="width: 100%">
                </input-foreign-key>
            </p>
            <p>
                <button class="float-right small" click.delegate="assign()" disabled.bind="!newUserEntity || !newUserEntity.id">Assign role to user</button>
            </p>
        </template>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button click.delegate="save()" disabled.bind="loading">Save</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>
`;
    }
    init(role) {
        this.role = role;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadUsers();
            this.loading = false;
        });
    }
    loadUsers() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.getEntities('User', [{ field: 'roles', op: 'contains', value: this.role.name }], [{ field: 'name', direction: 'asc' }]);
            this.users = response.data;
            for (const user of this.users) {
                this.currentUsers.add(user.id);
            }
        });
    }
    assign() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.users.push(this.newUserEntity);
            this.newUserEntity = null;
            this.newUserId = '';
        });
    }
    revoke() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.users = this.users.filter(u => !this.selectedUsers.find(su => su.id === u.id));
            this.selectedUsers = [];
        });
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            for (const user of this.users.filter(u => !this.currentUsers.has(u.id))) {
                yield this.server.putJson('api/userRole/assign', {
                    name: this.role.name,
                    userID: user.id
                });
            }
            for (const userID of Array.from(this.currentUsers).filter(cu => !this.users.find(u => u.id === cu))) {
                yield this.server.putJson('api/userRole/revoke', {
                    name: this.role.name,
                    userID: userID
                });
            }
            this.dialog.close();
        });
    }
};
AssignRevokeUserRole = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], AssignRevokeUserRole);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/user-roles.html":
/*!**********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/user-roles.html ***!
  \**********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-body no-overflow\">\r\n            <!--<button class=\"sm float-right\"><i class=\"fa fa-plus\"></i> Add new user role</button>-->\r\n            <div class=\"loading\" if.bind=\"loading\"></div>\r\n            <table class=\"full-width\" else>\r\n                <thead>\r\n                    <tr>\r\n                        <th>Role Name</th>\r\n                        <th></th>\r\n                    </tr>\r\n                </thead>\r\n                <tbody>\r\n                    <tr repeat.for=\"role of roles\" id=\"role-${role.name}\">\r\n                        <td>\r\n                            ${role.name}\r\n                            <div repeat.for=\"desc of role.descriptions\" style=\"font-size: 90%; color:gray;\">\r\n                                ${desc}\r\n                            </div>\r\n                        </td>\r\n                        <td>\r\n                            <dropdown-button title=\"Actions\" class=\"btn-link float-right\" fa-icon=\"ellipsis-h\" right-align=\"true\">\r\n                                <ul class=\"menu\">\r\n                                    <li class=\"menu-item\">\r\n                                        <a click.delegate=\"assignRevoke(role)\">\r\n                                            Assign users\r\n                                        </a>\r\n                                    </li>\r\n                                    <li class=\"menu-item\">\r\n                                        <a click.delegate=\"assignRevoke(role)\">\r\n                                            Revoke users\r\n                                        </a>\r\n                                    </li>\r\n                                </ul>\r\n                            </dropdown-button>\r\n                        </td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/user-roles.ts":
/*!********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/user-roles.ts ***!
  \********************************************************************************/
/*! exports provided: UserRoles */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UserRoles", function() { return UserRoles; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var _assign_revoke_user_role__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./assign-revoke-user-role */ "../apps/core/administration/src/pages/administration/users/assign-revoke-user-role.ts");





let UserRoles = class UserRoles {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.loading = true;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.roles = yield this.server.getJson('/api/userRole');
            this.loading = false;
        });
    }
    assignRevoke(role) {
        this.dialog.open({
            viewModel: _assign_revoke_user_role__WEBPACK_IMPORTED_MODULE_4__["AssignRevokeUserRole"],
            model: role,
            lock: true
        });
    }
};
UserRoles = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'admin/user-roles',
        title: 'User Roles',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], UserRoles);



/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=user-roles.e28d4943052103ad78ee.js.map