(window["webpackJsonpcom_scifeon_scifeon_apps_facs"] = window["webpackJsonpcom_scifeon_scifeon_apps_facs"] || []).push([["create_experiment"],{

/***/ "../apps/module/facs/src/pages/exp-create/exp-form.ts":
/*!************************************************************!*\
  !*** ../apps/module/facs/src/pages/exp-create/exp-form.ts ***!
  \************************************************************/
/*! exports provided: ExpForm */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExpForm", function() { return ExpForm; });
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../facs */ "../apps/module/facs/src/facs.ts");

class ExpForm {
    constructor(expCreate, user, bindingEngine) {
        this.expCreate = expCreate;
        this.user = user;
        this.bindingEngine = bindingEngine;
        this.notes = '';
        this.clearForm();
        this.initializeForm();
        this.changeScientistFilter();
    }
    get generatedMTR() {
        const ed = this.formValues.expMtrEd.padStart(2, '0');
        const no = this.formValues.expMtrNo.padStart(3, '0');
        return `${this.formValues.expName} - ${this.expCreate.expSetup.bnSOP} ${this.expCreate.expSetup.bnSOPVersion} ed. ${ed} - mtr#${no}`;
    }
    dispose() {
        this.expNameSubscription.dispose();
    }
    clearForm() {
        this.formValues = {
            expName: '',
            expScientistID: '',
            expDescription: '',
            expMtrEd: '??',
            expMtrNo: '???',
            stepInfectionAnalystID: this.user.id,
            stepHarvestAnalystID: this.user.id,
            stepStainingAnalystID: this.user.id,
            stepAcquisitionAnalystID: this.user.id,
            dateInfection: ''
        };
        this.notes = '';
        this.expCreate.selectedSOP = null;
        this.expCreate.selectedPosControl = null;
    }
    initializeForm() {
        let allowedPrefixes = ['PD', 'GMP'];
        if (!this.expCreate.isRegulated)
            allowedPrefixes.push('Exp');
        this.columns = [{
                name: 'expName',
                form: {
                    label: 'Experiment Name',
                    isRequired: true,
                    placeholder: 'E.g. GMP17A18',
                    rules: [{
                            satisfies: (value) => !!allowedPrefixes.find(prefix => value.startsWith(prefix)),
                            message: this.expCreate.isRegulated ?
                                'Must start with PD or GMP.' :
                                'Must start with Exp, PD or GMP.'
                        },
                        {
                            satisfies: (value) => !value.includes('_'),
                            message: 'Cannot contain underscore (_).'
                        },
                        {
                            satisfies: (value) => !value.includes(' '),
                            message: 'Cannot contain spaces.'
                        },
                        {
                            unique: {
                                eClass: 'Experiment',
                                field: 'name',
                                value: 'FACS-${value}'
                            },
                            message: 'Experiment with this name already exists.'
                        }]
                }
            },
            {
                name: 'dateInfection',
                type: 'date',
                form: {
                    label: 'Infection Date',
                    isRequired: true
                }
            },
            {
                name: 'expScientistID',
                foreignKeyTo: 'User',
                form: {
                    label: 'Scientist',
                    editor: 'foreign-key',
                    isRequired: false,
                    filters: []
                }
            },
            {
                name: 'stepInfectionAnalystID',
                foreignKeyTo: 'User',
                form: {
                    label: 'Analyst',
                    editor: 'foreign-key',
                    isRequired: false
                }
            },
            {
                name: 'expMtrEd',
                form: {
                    placeholder: '??, e.g. 01',
                    label: 'MTR Ed.',
                    editor: 'text',
                    isRequired: true
                }
            },
            {
                name: 'expMtrNo',
                form: {
                    placeholder: '???, e.g. 058',
                    label: 'MTR No.',
                    editor: 'text',
                    isRequired: true
                }
            }];
    }
    changeScientistFilter() {
        this.expNameSubscription = this.bindingEngine
            .propertyObserver(this.formValues, 'expName')
            .subscribe((newValue, oldValue) => {
            newValue = newValue.trim().toLowerCase();
            oldValue = oldValue.trim().toLowerCase();
            const column = this.columns.find(c => c.name === 'expScientistID');
            const filter = { field: 'roles', op: 'contains' };
            if (!oldValue.startsWith('pd') && newValue.startsWith('pd')) {
                filter.value = _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].RolePDScientist;
                column.form.filters = [filter];
            }
            else if (!oldValue.startsWith('gmp') && newValue.startsWith('gmp')) {
                filter.value = _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].RoleGMPScientist;
                column.form.filters = [filter];
            }
            else if (!newValue) {
                column.form.filters = [];
            }
        });
    }
}


/***/ }),

/***/ "../apps/module/facs/src/pages/exp-create/exp-samples.ts":
/*!***************************************************************!*\
  !*** ../apps/module/facs/src/pages/exp-create/exp-samples.ts ***!
  \***************************************************************/
/*! exports provided: ExpSamples */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExpSamples", function() { return ExpSamples; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! papaparse */ "./node_modules/papaparse/papaparse.js");
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(papaparse__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../facs */ "../apps/module/facs/src/facs.ts");



class ExpSamples {
    constructor(expCreate) {
        this.expCreate = expCreate;
        this.nextPositiveControl = 1;
        this.manualPosControlsPositions = [];
    }
    valid() {
        return new Promise((resolve, reject) => {
            this.hot.validateCells(function (valid) {
                resolve(valid);
            });
        });
    }
    repeatTopTiter() {
        const firstSample = this.expCreate.samples[this.hot.toPhysicalRow(0)];
        for (let smp of this.expCreate.samples.filter(smp => smp.name)) {
            if (!smp.attributes)
                smp.attributes = {};
            smp.attributes.expectedTiter = firstSample.attributes.expectedTiter;
            smp['6'] = firstSample['6'];
        }
        this.hot.render();
    }
    resetSamples() {
        this.nextPositiveControl = 1;
        this.hot = null;
        this.samplesList.innerHTML = '';
        this.samplesList.className = '';
        this.samplesList.removeAttribute('style');
        this.samplesList.removeAttribute('data-initialstyle');
        this.samplesList.removeAttribute('data-originalstyle');
        this.expCreate.samples = [];
    }
    removeEmptySamples() {
        const samples = this.getSamples();
        this.resetSamples();
        this.expCreate.samples = samples;
        this.initHot();
    }
    initSamplesList() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.initSamples();
            yield this.expCreate.updateWorkflow();
            this.initHot();
        });
    }
    updateDilutionText(changes) {
        if (changes && (changes[0][1] === 'isControl' || changes[0][1] === 'attributes.expectedTiter')) {
            const sample = this.expCreate.samples[this.hot.toPhysicalRow(changes[0][0])];
            const expTiter = sample.attributes && sample.attributes.expectedTiter;
            const dilution = _facs__WEBPACK_IMPORTED_MODULE_2__["FACS"].DILUTION_TEXTS[expTiter];
            if (dilution) {
                sample['6'] = dilution[sample.isControl ? 1 : 0];
            }
            if (sample.isControl && !sample.name) {
                sample.name = 'PosControl-' + this.nextPositiveControl++;
            }
            this.hot.render();
        }
    }
    initHot() {
        const settings = {
            data: this.expCreate.samples,
            rowHeaders: true,
            height: 400,
            colHeaders: ['LIMS ID', 'Name', 'Batch', 'Product', 'Process Step', 'Expected Titer', 'Dilutions', 'Pre-dilution', 'Sample Type', 'Positive Control'],
            columns: [
                { data: 'externalID' },
                { data: 'name' },
                { data: 'attributes.batchNo' },
                { data: 'attributes.productName' },
                { data: 'attributes.processStep' },
                {
                    data: 'attributes.expectedTiter',
                    type: 'dropdown',
                    source: _facs__WEBPACK_IMPORTED_MODULE_2__["FACS"].EXP_TITERS
                },
                { readOnly: true },
                { data: 'attributes.preDilution', type: 'numeric', numericFormat: { pattern: '0.00' } },
                { data: 'attributes.sampleType' },
                { data: 'isControl', type: 'checkbox' }
            ],
            minSpareRows: 1,
            stretchH: 'all',
            manualColumnResize: true,
            manualRowMove: true,
            contextMenu: ['row_above', 'row_below', 'remove_row'],
            afterChange: (changes, source) => this.updateDilutionText(changes),
            afterRender: () => this.expCreate.loading = false
        };
        this.hot = new Handsontable(this.samplesList, settings);
        this.hot.render();
    }
    getSamples() {
        if (!this.hot)
            return this.expCreate.samples;
        const samples = [];
        for (let i = 0; i < this.expCreate.samples.length; i++) {
            const sample = JSON.parse(JSON.stringify(this.expCreate.samples[this.hot.toPhysicalRow(i)]));
            if (!sample.name)
                continue;
            let newSample = {
                name: sample.name,
                description: sample.description,
                externalID: sample.externalID,
                externalSystem: sample.externalSystem,
                id: sample.id || '#idTestManAdded' + i,
                eClass: 'Sample',
                format: 'Vial',
                type: 'FACS-Input',
                sortIndex: i,
                attributes: sample.attributes || {},
                isControl: sample.isControl
            };
            if (newSample.isControl) {
                newSample.controlType = 'Positive';
                newSample.description = this.expCreate.selectedPosControl.label;
            }
            if (!newSample.attributes.preDilution) {
                newSample.attributes.preDilution = 1;
            }
            samples.push(newSample);
        }
        return samples;
    }
    initSamples(inputSamples = []) {
        let posControlPositions = (this.expCreate.expSetup.bnPosControls || []);
        for (const manPos of this.manualPosControlsPositions.filter(mp => !posControlPositions.includes(mp))) {
            posControlPositions.push(manPos);
        }
        posControlPositions = posControlPositions.sort((a, b) => a < b ? -1 : 1);
        this.expCreate.samples = JSON.parse(JSON.stringify(inputSamples));
        const createPosControlSample = () => ({
            id: '#idTestPC' + this.nextPositiveControl,
            name: 'PosControl-' + this.nextPositiveControl++,
            isControl: true,
            attributes: {
                expectedTiter: '1E9',
                preDilution: 1
            },
            6: _facs__WEBPACK_IMPORTED_MODULE_2__["FACS"].DILUTION_TEXTS['1E9'][1]
        });
        for (const posControlPosition of posControlPositions) {
            if (posControlPosition > this.expCreate.samples.length) {
                for (let i = this.expCreate.samples.length; i < posControlPosition; i++) {
                    if (posControlPosition - 1 === i) {
                        this.expCreate.samples.push(createPosControlSample());
                    }
                    else {
                        this.expCreate.samples.push({});
                    }
                }
            }
            else {
                this.expCreate.samples.splice(posControlPosition - 1, 0, createPosControlSample());
            }
        }
    }
    processFreezerWorks(csv) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.expCreate.loading = true;
            let ct = {};
            csv.data[0].map((title, index) => ct[title] = index);
            let sopFromFile = this.expCreate.sopTemplates.find(t => t.content.bnSOP === csv.data[1][ct['LabelAnalysis']]);
            if (sopFromFile) {
                this.expCreate.selectedSOP = sopFromFile;
                this.expCreate.sopChanged();
            }
            const samples = [];
            this.manualPosControlsPositions = [];
            for (let i = 1; i < csv.data.length; i++) {
                let row = csv.data[i];
                if (row[0] && row[0].toLowerCase() === 'poscontrol') {
                    this.manualPosControlsPositions.push(i + 2);
                    continue;
                }
                if (!row[0] || !row[ct['IDText']])
                    continue;
                samples.push({
                    id: '#idTest' + i,
                    name: row[ct['IDText']],
                    description: row[ct['SampleName']],
                    externalID: row[ct['IDText']],
                    externalSystem: 'SampleManager',
                    isControl: false,
                    attributes: {
                        processStep: row[ct['ProcessStep']],
                        productName: row[ct['ProductName']],
                        batchNo: row[ct['BatchNo']],
                        expectedTiter: "1E7",
                        preDilution: 1,
                        sampleType: row[ct['Type of Sample']]
                    },
                    6: _facs__WEBPACK_IMPORTED_MODULE_2__["FACS"].DILUTION_TEXTS['1E7'][0]
                });
            }
            this.initSamples(samples);
            yield this.expCreate.updateWorkflow();
            this.initHot();
        });
    }
    dropped(e) {
        try {
            if (e.detail.files.length > 1)
                throw Error('Please drop a single FreezerWorks file');
            let reader = new FileReader();
            const file = e.detail.files[0];
            reader.onload = eRead => {
                const fileContent = eRead.target.result;
                this.freezerWorksFile = {
                    name: file.name,
                    content: btoa(fileContent),
                    size: file.size,
                    mediaType: file.type,
                    type: 'FreezerWorks'
                };
                this.processFreezerWorks(papaparse__WEBPACK_IMPORTED_MODULE_1__["parse"](fileContent));
            };
            reader.readAsText(file);
        }
        catch (e) {
            throw {
                message: "I'm sorry, but the system could not read the file",
                hint: "Please make sure that you drop from the desktop or a file system, not from an e-mail or ZIP archive",
                exception: e
            };
        }
    }
}


/***/ }),

/***/ "../apps/module/facs/src/pages/exp-create/exp-workflow.ts":
/*!****************************************************************!*\
  !*** ../apps/module/facs/src/pages/exp-create/exp-workflow.ts ***!
  \****************************************************************/
/*! exports provided: ExpWorkflow */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExpWorkflow", function() { return ExpWorkflow; });
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../facs */ "../apps/module/facs/src/facs.ts");

class ExpWorkflow {
    constructor(expCreate) {
        this.expCreate = expCreate;
    }
    adjustDilutionInfo(stepInfo) {
        for (let smp of stepInfo.output.samples) {
            let smpParent = this.expCreate.samples.find(e => e.id && e.id === smp.parentID);
            if (!smpParent) {
                continue;
            }
            let nShiftDilution = _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].getNShiftDilution(smpParent.attributes.expectedTiter);
            smp.attributes.foldDilution = _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].DILUTIONS[smp.attributes.iDilution + nShiftDilution];
            if (smp.controlType === 'Positive' && smp.attributes.iDilution === 5) {
                smp.name = 'Blank-' + smp.name.substring(smp.name.length - 1);
                smp.controlType = 'Blank';
                smp.attributes.foldDilution = null;
                smp.parentID = null;
                smp.expectedTiter = null;
                smp.iDilution = null;
            }
        }
    }
    getWFTemplates() {
        let tptStepInfection = {
            eClass: 'Template',
            type: 'Step',
            name: 'FACSInfectionStep',
            content: {
                builder: 'Samples2Plates',
                entityValues: {
                    type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].StepTypeInfection,
                    name: 'Infection-${expName}',
                },
                plates: [
                    {
                        entityValues: {
                            name: 'Infection',
                            type: 'FACS-Culture'
                        },
                        nRows: 3,
                        nCols: 4,
                        layout: {
                            wells: [
                                { posRow: 0, posCol: 0, valueText: 'T-1', attributes: { iDilution: 5 } },
                                { posRow: 0, posCol: 1, valueText: 'T-1', attributes: { iDilution: 4 } },
                                { posRow: 0, posCol: 2, valueText: 'T-1', attributes: { iDilution: 3 } },
                                { posRow: 0, posCol: 3, valueText: 'T-1', attributes: { iDilution: 2 } },
                                { posRow: 1, posCol: 0, valueText: 'T-1', attributes: { iDilution: 1 } },
                                { posRow: 1, posCol: 1, valueText: 'T-1', attributes: { iDilution: 0 } },
                                { posRow: 1, posCol: 2, valueText: 'T-2', attributes: { iDilution: 5 } },
                                { posRow: 1, posCol: 3, valueText: 'T-2', attributes: { iDilution: 4 } },
                                { posRow: 2, posCol: 0, valueText: 'T-2', attributes: { iDilution: 3 } },
                                { posRow: 2, posCol: 1, valueText: 'T-2', attributes: { iDilution: 2 } },
                                { posRow: 2, posCol: 2, valueText: 'T-2', attributes: { iDilution: 1 } },
                                { posRow: 2, posCol: 3, valueText: 'T-2', attributes: { iDilution: 0 } },
                            ]
                        }
                    }
                ],
                options: {
                    postProcessing: stepInfo => this.adjustDilutionInfo(stepInfo)
                }
            }
        };
        let tptStepHarvest = {
            eClass: 'Template',
            type: 'Step',
            name: 'FACSHarvestStep',
            content: {
                entityValues: {
                    type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].StepTypeHarvest,
                    name: 'Harvest-${expName}',
                },
                builder: 'Plates2PlatesDirect',
                plates: [{
                        entityValues: {
                            name: 'Harvest',
                            type: 'FACS-Harvest'
                        },
                        nRows: 8,
                        nCols: 12,
                        directionIn: 'ByRow',
                        directionOut: 'ByRow'
                    }]
            }
        };
        this.tptStepStaining = {
            eClass: 'Template',
            type: 'Step',
            name: 'FACSStainingStep',
            content: {
                entityValues: {
                    type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].StepTypeStaining,
                    name: 'Staining-${expName}',
                },
                builder: 'Plates2PlatesDirect',
                plates: [{
                        entityValues: {
                            name: 'Count',
                            type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].PlateTypeAcquisition
                        },
                        nRows: 8,
                        nCols: 12,
                        directionIn: 'ByRow',
                        directionOut: 'ByRow'
                    }, {
                        entityValues: {
                            name: 'InfU',
                            type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].PlateTypeAcquisition
                        },
                        nRows: 8,
                        nCols: 12,
                        directionIn: 'ByRow',
                        directionOut: 'ByRow'
                    }, {
                        entityValues: {
                            name: 'Txg',
                            type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].PlateTypeAcquisition
                        },
                        nRows: 8,
                        nCols: 12,
                        directionIn: 'ByRow',
                        directionOut: 'ByRow'
                    }]
            }
        };
        let tptStepAcquisition = {
            eClass: 'Template',
            type: 'Step',
            name: 'FACSAcquisitionStep',
            content: {
                entityValues: {
                    type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].StepTypeAcquisition,
                    name: 'Acquisition-${expName}',
                },
                builder: 'Generic'
            }
        };
        let tptExperiment = {
            key: 'experiment',
            eClass: 'Template',
            type: 'Experiment',
            name: 'FACSBavarianQC',
            content: {
                setup: this.expCreate.expSetup,
                builder: 'Generic',
                entityValues: {
                    type: _facs__WEBPACK_IMPORTED_MODULE_0__["FACS"].ExperimentType,
                    name: 'FACS-${expName}',
                },
                steps: [
                    {
                        key: 'stepInfection',
                        template: 'FACSInfectionStep',
                        iDay: 0
                    },
                    {
                        key: 'stepHarvest',
                        template: 'FACSHarvestStep',
                        parent: 'stepInfection',
                        iDay: 1
                    },
                    {
                        key: 'stepStaining',
                        template: 'FACSStainingStep',
                        parent: 'stepHarvest',
                        iDay: 1
                    },
                    {
                        key: 'stepAcquisition',
                        template: 'FACSAcquisitionStep',
                        parent: 'stepStaining',
                        iDay: 1
                    }
                ]
            }
        };
        return {
            targets: [tptExperiment],
            dependencies: [tptStepInfection, tptStepHarvest, this.tptStepStaining, tptStepAcquisition]
        };
    }
}


/***/ }),

/***/ "../apps/module/facs/src/pages/exp-create/index.html":
/*!***********************************************************!*\
  !*** ../apps/module/facs/src/pages/exp-create/index.html ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Create Flow Cytometry Experiment</h1>\r\n            <button click.delegate=\"create()\">Create Experiment</button>\r\n        </div>\r\n        <div class=\"page-panels\">\r\n            <div class=\"grid\" style=\"margin-bottom: 10px; grid-auto-rows: minmax(0, max-content);\">\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Experiment Info</div>\r\n                    <div class=\"panel-body\">\r\n                        <entity-form columns.bind=\"expForm.columns\" object.bind=\"expForm.formValues\" horizontal.bind=\"false\" view-model.ref=\"expForm.form\"></entity-form>\r\n                        <div class=\"form-group\" style=\"margin: 0 5px\">\r\n                            <label>Generated MTR</label>\r\n                            <i>${expForm.generatedMTR}</i>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Options</div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <label>SOP</label>\r\n                            <select id=\"selectSOP\" value.bind=\"selectedSOP\" change.delegate=\"sopChanged()\">\r\n                                <option repeat.for=\"t of sopTemplates\" model.bind=\"t\" value.bind=\"t.name\">${t.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Positive Control</label>\r\n                            <select id=\"selectPosControl\" value.bind=\"selectedPosControl\" change.delegate=\"posControlChanged()\">\r\n                                <option repeat.for=\"t of posControlTemplates\" model.bind=\"t\" value.bind=\"t.id\">${t.content.label}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Transgenes</label>\r\n                            <span if.bind=\"expSetup.bnIncludeTransgeneStaining\">Transgene plate included</span>\r\n                            <span else>No transgene plate</span>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: span 2\">\r\n                    <div class=\"panel-heading\">Acceptance Criteria</div>\r\n                    <div class=\"panel-body\">\r\n                        <template if.bind=\"isRegulated\">\r\n                            <div style=\"display: flex\">\r\n                                <div style=\"flex: 50%\">\r\n                                    <div class=\"view-group\">\r\n                                        <label>Min-n</label>\r\n                                        <p class=\"bnMinAcceptedTubes\">${expSetup.bnMinAcceptedTubes}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Min Positive Cells (%)</label>\r\n                                        <p class=\"bnPctMinPositiveCells\">${expSetup.bnPctMinPositiveCells}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Max Positive Cells (%)</label>\r\n                                        <p class=\"bnPctMaxPositiveCells\">${expSetup.bnPctMaxPositiveCells}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Max Cell Count %CV</label>\r\n                                        <p class=\"bnPctMaxCellsPrWellCV\">${expSetup.bnPctMaxCellsPrWellCV}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Min Cells per Well</label>\r\n                                        <p class=\"bnMinCellsPrWell\">${expSetup.bnMinCellsPrWell | exponential}</p>\r\n                                    </div>                                    \r\n                                    <div class=\"view-group\">\r\n                                        <label>Min Txg Co-expression</label>\r\n                                        <p class=\"bnMinTxgCox\">${expSetup.bnMinTxgCox}</p>\r\n                                    </div>\r\n                                </div>\r\n                                <div style=\"flex: 50%\">\r\n                                    <div class=\"view-group\">\r\n                                        <label>Min Txg.U / Inf.U Ratio</label>\r\n                                        <p class=\"bnMinTxgInfURatio\">${expSetup.bnMinTxgInfURatio}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Max Inf.U %CV</label>\r\n                                        <p class=\"bnPctMaxInfUCV\">${expSetup.bnPctMaxInfUCV}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Min Inf.U, Positive Control</label>\r\n                                        <p class=\"bnMinPosControlInfU\">${expSetup.bnMinPosControlInfU | exponential}</p>\r\n                                    </div>\r\n                                    <div class=\"view-group\">\r\n                                        <label>Max Inf.U, Positive Control</label>\r\n                                        <p class=\"bnMaxPosControlInfU\">${expSetup.bnMaxPosControlInfU | exponential}</p>\r\n                                    </div>                                    \r\n                                    <div class=\"view-group\" repeat.for=\"key of expSetup.bnMinTxgInfURatios | objectKeys\">\r\n                                        <label>Min Txg.U / Inf.U ratio: ${key}</label>\r\n                                        <p class=\"bnMinTxgInfURatios-${key}\">${expSetup.bnMinTxgInfURatios[key]}</p>\r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                        </template>\r\n\r\n                        <template if.bind=\"!isRegulated\">\r\n                            <div style=\"display: flex\">\r\n                                <div style=\"flex: 50%;\">\r\n                                    <div class=\"form-group\">\r\n                                        <label>Min-n</label>\r\n                                        <input-number containerless class=\"bnMinAcceptedTubes\" value.bind=\"expSetup.bnMinAcceptedTubes\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Positive Cells (%)</label>\r\n                                        <input-number containerless class=\"bnPctMinPositiveCells\" value.bind=\"expSetup.bnPctMinPositiveCells\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Max Positive Cells (%)</label>\r\n                                        <input-number containerless class=\"bnPctMaxPositiveCells\" value.bind=\"expSetup.bnPctMaxPositiveCells\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Max Cell Count %CV</label>\r\n                                        <input-number containerless class=\"bnPctMaxCellsPrWellCV\" value.bind=\"expSetup.bnPctMaxCellsPrWellCV\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Cells per Well</label>\r\n                                        <input-number containerless class=\"bnMinCellsPrWell\" value.bind=\"expSetup.bnMinCellsPrWell\" />\r\n                                    </div>\r\n                                    \r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Txg Co-expression</label>\r\n                                        <input-number containerless class=\"bnMinTxgCox\" value.bind=\"expSetup.bnMinTxgCox\" />\r\n                                    </div>\r\n                                </div>\r\n                                <div style=\"flex: 50%; margin-left: 10px;\">\r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Txg.U / Inf.U Ratio</label>\r\n                                        <input-number containerless class=\"bnMinTxgInfURatio\" value.bind=\"expSetup.bnMinTxgInfURatio\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Max Inf.U %CV</label>\r\n                                        <input-number containerless class=\"bnPctMaxInfUCV\" value.bind=\"expSetup.bnPctMaxInfUCV\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Inf.U, Positive Control</label>\r\n                                        <input-number containerless class=\"bnMinPosControlInfU\" value.bind=\"expSetup.bnMinPosControlInfU\" />\r\n                                    </div>\r\n\r\n                                    <div class=\"form-group\">\r\n                                        <label>Max Inf.U, Positive Control</label>\r\n                                        <input-number containerless class=\"bnMaxPosControlInfU\" value.bind=\"expSetup.bnMaxPosControlInfU\" />\r\n                                    </div>\r\n                                    \r\n                                    <div class=\"form-group\">\r\n                                        <label>Min Txg.U / Inf.U ratios</label>\r\n                                        <dictionary-editor\r\n                                            class=\"bnMinTxgInfURatios\"\r\n                                            object.bind=\"expSetup.bnMinTxgInfURatios\"\r\n                                            type=\"number\"\r\n                                            placeholder=\"New Txg.U / Inf.U ratio\"></dictionary-editor>\r\n                                    </div>\r\n                                </div>\r\n                            </div>\r\n                        </template>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel full-width\">\r\n                    <div class=\"panel-heading\">\r\n                        <span>Samples\r\n                            <quick-help>Drag and drop rows to move position.\r\n                                <br/>Empty rows are automatically removed on create.</quick-help>\r\n                        </span>\r\n                        <button class=\"small\" style=\"margin-right: 5px;\" if.bind=\"expSamples.hot\" click.delegate=\"expSamples.repeatTopTiter()\">Repeat Top Titer</button>\r\n                        <button class=\"small\" style=\"margin-right: 5px;\" if.bind=\"expSamples.hot\" title=\"Remove empty samples\" click.delegate=\"expSamples.removeEmptySamples()\">Remove Empty</button>\r\n                        <button class=\"small\" if.bind=\"expSamples.hot\" title=\"Remove all samples\" click.delegate=\"expSamples.resetSamples()\">Reset</button>\r\n                    </div>\r\n                    <div class=\"panel-body text-center\">\r\n                        <div class=\"text-center loading\" if.bind=\"loading\"></div>\r\n                        <template if.bind=\"!loading && !expSamples.hot\">\r\n                            <dropzone style=\"max-width: 300px;\" title=\"Drop FreezerWorks CSV Here\" dropfiles.trigger=\"expSamples.dropped($event)\"></dropzone>\r\n                            <i>or</i>\r\n                            <br/>\r\n                            <button click.delegate=\"expSamples.initSamplesList()\">Add samples manually</button>\r\n                        </template>\r\n                        <div id=\"freezerworks-samples\" ref=\"expSamples.samplesList\"></div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel full-width\">\r\n                    <div class=\"panel-heading\">Notes</div>\r\n                    <div class=\"panel-body\" style=\"padding:0;\">\r\n                        <rich-text-editor value.bind=\"notes\" style=\"border:0;\"></rich-text-editor>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/module/facs/src/pages/exp-create/index.ts":
/*!*********************************************************!*\
  !*** ../apps/module/facs/src/pages/exp-create/index.ts ***!
  \*********************************************************/
/*! exports provided: AppFACSExpCreate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppFACSExpCreate", function() { return AppFACSExpCreate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_data__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/data */ "./packages/data/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../../facs */ "../apps/module/facs/src/facs.ts");
/* harmony import */ var _exp_form__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./exp-form */ "../apps/module/facs/src/pages/exp-create/exp-form.ts");
/* harmony import */ var _exp_samples__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./exp-samples */ "../apps/module/facs/src/pages/exp-create/exp-samples.ts");
/* harmony import */ var _exp_workflow__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./exp-workflow */ "../apps/module/facs/src/pages/exp-create/exp-workflow.ts");










let AppFACSExpCreate = class AppFACSExpCreate {
    constructor(server, router, user, workflowBuilder, bindingEngine) {
        this.server = server;
        this.router = router;
        this.user = user;
        this.workflowBuilder = workflowBuilder;
        this.bindingEngine = bindingEngine;
        this.isRegulated = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().configuration.isRegulated;
        this.samples = [];
        this.expWorkflow = new _exp_workflow__WEBPACK_IMPORTED_MODULE_9__["ExpWorkflow"](this);
        this.expSamples = new _exp_samples__WEBPACK_IMPORTED_MODULE_8__["ExpSamples"](this);
        this.expForm = new _exp_form__WEBPACK_IMPORTED_MODULE_7__["ExpForm"](this, this.user, this.bindingEngine);
    }
    init() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadTemplates();
        });
    }
    detached() {
        this.expForm.dispose();
    }
    create() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!(yield this.expSamples.valid()))
                throw new Error('Please, fix errors in Samples table.');
            this.expSamples.removeEmptySamples();
            if (this.samples.length === 0)
                throw new Error('Please, add samples by dropping a FreezerWorks CSV file on the Samples panel dropzone.');
            if (!(yield this.expForm.form.validate()))
                throw new Error('Please, check the errors in the Experiment Info form.');
            if (this.samples.filter(s => s.name && !s.attributes.expectedTiter).length)
                throw new Error('Please, set Expected Titer for all non-empty samples.');
            yield this.updateWorkflow();
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Saving...');
            const response = yield this.server.saveEntities(this.newEntities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            let exp = response.newEntities.find(e => e.eClass === 'Experiment');
            this.router.navigate('/eln/' + exp.id);
        });
    }
    updateWorkflow() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.cleanSetupObject();
            let options = {
                experiment: {
                    entityValues: {
                        scientistID: this.expForm.formValues.expScientistID,
                        analystID: this.expForm.formValues.stepInfectionAnalystID,
                        description: this.expForm.formValues.expDescription
                    },
                    attributes: {
                        mtr: this.expForm.generatedMTR
                    }
                },
                stepInfection: { entityValues: { analystID: this.expForm.formValues.stepInfectionAnalystID } },
                stepHarvest: { entityValues: { analystID: this.expForm.formValues.stepHarvestAnalystID } },
                stepStaining: { entityValues: { analystID: this.expForm.formValues.stepStainingAnalystID } },
                stepAcquisition: { entityValues: { analystID: this.expForm.formValues.stepAcquisitionAnalystID } }
            };
            const dateInfection = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from(this.expForm.formValues.dateInfection);
            if (dateInfection && dateInfection.isValid()) {
                options.experiment.entityValues.dateStarted = dateInfection;
                options.stepInfection.entityValues.dateStarted = dateInfection;
                options.stepHarvest.entityValues.dateStarted = dateInfection.clone().add(1, 'days');
                options.stepStaining.entityValues.dateStarted = dateInfection.clone().add(1, 'days');
                options.stepAcquisition.entityValues.dateStarted = dateInfection.clone().add(1, 'days');
            }
            let wfTemplates = this.expWorkflow.getWFTemplates();
            if (!this.expSetup.bnIncludeTransgeneStaining) {
                this.expWorkflow.tptStepStaining.content.plates = this.expWorkflow.tptStepStaining.content.plates.slice(0, 2);
            }
            const samples = this.samples.filter(s => s.name);
            const dsOut = yield this.workflowBuilder.execute(wfTemplates, {
                samples: samples,
                expName: this.expForm.formValues.expName
            }, options);
            this.newEntities = samples.concat(dsOut.entities);
            dsOut.experiment.setup = this.expSetup;
            dsOut.experiment.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].IN_PROGRESS;
            dsOut.experiment.externalID = this.expForm.formValues.expName;
            if (this.expForm.notes) {
                this.newEntities.push({
                    eClass: 'Note',
                    subjectClass: 'Experiment',
                    subjectID: dsOut.experiment.id,
                    type: 'Note',
                    content: this.expForm.notes
                });
            }
            if (this.expSamples.freezerWorksFile) {
                dsOut.experiment.files = [this.expSamples.freezerWorksFile];
            }
        });
    }
    loadTemplates() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const ds = yield this.server.datasetQuery([
                {
                    eClass: 'Template',
                    collection: 'templates',
                    filters: [{ field: 'Type', values: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].AllTemplateTypes }]
                }
            ]);
            this.allTemplates = ds.templates;
            this.sopTemplates = ds.templates.filter(t => t.type === _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].TemplateTypeSOPVersion).sort((a, b) => (a.name > b.name ? 1 : -1));
            this.selectedSOP = this.sopTemplates[0];
            this.sopChanged();
        });
    }
    sopChanged() {
        this.expSetup = this.selectedSOP.content;
        this.posControlTemplates = this.allTemplates.filter(t => t.type === 'FACS-PosControl-Batch' && t.content.sops.includes(this.selectedSOP.content.bnSOP));
        if (!this.selectedPosControl || !this.selectedPosControl.content.sops.includes(this.selectedSOP.content.bnSOP)) {
            this.selectedPosControl = this.posControlTemplates[0];
        }
        this.posControlChanged();
    }
    posControlChanged() {
        if (!this.selectedPosControl)
            return;
        this.expSetup.posControl = this.selectedPosControl.name;
        this.expSetup.bnMinPosControlInfU = this.selectedPosControl.content.bnMinPosControlInfU;
        this.expSetup.bnMaxPosControlInfU = this.selectedPosControl.content.bnMaxPosControlInfU;
    }
    cleanSetupObject() {
        if (typeof this.expSetup.bnMinAcceptedTubes === 'string')
            this.expSetup.bnMinAcceptedTubes = parseInt(this.expSetup.bnMinAcceptedTubes);
        if (typeof this.expSetup.bnMinCellsPrWell === 'string')
            this.expSetup.bnMinCellsPrWell = parseInt(this.expSetup.bnMinCellsPrWell);
        if (typeof this.expSetup.bnPctMinPositiveCells === 'string')
            this.expSetup.bnPctMinPositiveCells = parseFloat(this.expSetup.bnPctMinPositiveCells);
        if (typeof this.expSetup.bnPctMaxPositiveCells === 'string')
            this.expSetup.bnPctMaxPositiveCells = parseFloat(this.expSetup.bnPctMaxPositiveCells);
        if (typeof this.expSetup.bnMinTxgInfURatio === 'string')
            this.expSetup.bnMinTxgInfURatio = parseFloat(this.expSetup.bnMinTxgInfURatio);
        if (typeof this.expSetup.bnPctMaxInfUCV === 'string')
            this.expSetup.bnPctMaxInfUCV = parseFloat(this.expSetup.bnPctMaxInfUCV);
        if (typeof this.expSetup.bnPctMaxCellsPrWellCV === 'string')
            this.expSetup.bnPctMaxCellsPrWellCV = parseFloat(this.expSetup.bnPctMaxCellsPrWellCV);
        if (typeof this.expSetup.bnMinPosControlInfU === 'string')
            this.expSetup.bnMinPosControlInfU = parseFloat(this.expSetup.bnMinPosControlInfU);
        if (typeof this.expSetup.bnMaxPosControlInfU === 'string')
            this.expSetup.bnMaxPosControlInfU = parseFloat(this.expSetup.bnMaxPosControlInfU);
    }
};
AppFACSExpCreate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["route"])({
        route: 'facs/exp-create',
        title: 'Create Experiment',
        chunk: 'create_experiment'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        _scifeon_data__WEBPACK_IMPORTED_MODULE_2__["WorkflowBuilder"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["BindingEngine"]])
], AppFACSExpCreate);



/***/ }),

/***/ "./node_modules/papaparse/papaparse.js":
/*!*****************************************************************************************!*\
  !*** delegated ./node_modules/papaparse/papaparse.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/papaparse/papaparse.js");

/***/ }),

/***/ "./packages/data/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/data/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: WorkflowBuilder */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/data/index.ts");

/***/ })

}]);
//# sourceMappingURL=create_experiment.01ac3593419a3ad6c940.js.map