(window["webpackJsonpcom_scifeon_scifeon_apps_facs"] = window["webpackJsonpcom_scifeon_scifeon_apps_facs"] || []).push([["routePage_src/pages/file-results"],{

/***/ "../apps/module/facs/src/pages/file-results.html":
/*!*******************************************************!*\
  !*** ../apps/module/facs/src/pages/file-results.html ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-header\">\r\n        <h1>File Results: ${file.name} (${samples.length})</h1>\r\n    </div>\r\n\r\n    <div class=\"page-panels grid\">\r\n        <div class=\"panel\">\r\n            <div class=\"panel-heading\">Experiment &amp; Result-set</div>\r\n            <div class=\"panel-body\">\r\n                <div class=\"view-group\">\r\n                    <label>Experiment</label>\r\n                    <p><a href=\"/#/eln/${experiment.id}\">${experiment.name}</a></p>\r\n                </div>\r\n\r\n                <div class=\"view-group\">\r\n                    <label>Step</label>\r\n                    <p><a href=\"/#/entity/step/${step.id}\">${step.name}</a></p>\r\n                </div>\r\n\r\n                <div class=\"view-group\">\r\n                    <label>Result-set</label>\r\n                    <p><a href=\"/#/entity/resultset/${rs.id}\">${rs.name}</a></p>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-body\">\r\n                \r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th></th>\r\n                            <th></th>\r\n                            <th></th>\r\n                            <template repeat.for=\"pop of populations\">\r\n                                <th colspan=\"2\">${pop.name}</th>\r\n                            </template>\r\n                        </tr>\r\n                        <tr>\r\n                            <th>Tube</th>\r\n                            <th>LIMS ID</th>\r\n                            <th>Staining Sample</th>\r\n                            <template repeat.for=\"pop of populations\">\r\n                                <th>Count</th>\r\n                                <th>Pct Parent</th>\r\n                            </template>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\" data-sample-id=\"${sample.id}\">\r\n                            <td>${getTube(sample).name}</td>\r\n                            <td>${sample.name}</td>\r\n                            <td><a href=\"/#/entity/Sample/${sample.id\">${sample.id}</a></td>\r\n                            <template repeat.for=\"pop of populations\">\r\n                                <td data-population=\"${pop.name}\" data-field=\"count\">${getCount(sample, pop).count | fixed:0}</td>\r\n                                <td data-population=\"${pop.name}\" data-field=\"pctParent\">${getCount(sample, pop).pctParent | fixed:2}</td>\r\n                            </template>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/module/facs/src/pages/file-results.ts":
/*!*****************************************************!*\
  !*** ../apps/module/facs/src/pages/file-results.ts ***!
  \*****************************************************/
/*! exports provided: FACSFileResults */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FACSFileResults", function() { return FACSFileResults; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let FACSFileResults = class FACSFileResults {
    constructor(server) {
        this.server = server;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let fileID = context.params.id;
            const dataset = yield this.server.datasetQuery([
                { eClass: 'File', alias: 'file', filters: [{ field: 'ID', value: fileID }] },
                { eClass: 'ResultSet', alias: 'rs', filters: [{ field: 'ID', value: '$file.ResultSetID' }] },
                { eClass: 'Step', alias: 'step', filters: [{ field: 'ID', value: '$rs.OriginID' }] },
                { eClass: 'Experiment', alias: 'experiment', filters: [{ field: 'ID', value: '$step.ExperimentID' }] },
                { eClass: 'ResultFACSPopulation', collection: 'populations', filters: [{ field: 'FileID', value: fileID }] },
                { eClass: 'ResultFACSGatingSet', collection: 'gatingSets', filters: [{ field: 'FileID', value: fileID }] },
                { eClass: 'ResultFACSCount', collection: 'counts', filters: [{ field: 'PopulationID', in: 'populations.ID' }] },
                { eClass: 'ResultFACSTube', collection: 'tubes', filters: [{ field: 'ID', in: 'counts.TubeID' }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'ID', in: 'tubes.sampleID' }] }
            ]);
            this.file = dataset.file;
            this.step = dataset.step;
            this.experiment = dataset.experiment;
            this.rs = dataset.rs;
            this.populations = dataset.populations;
            this.gatingSets = dataset.gatingSets;
            this.tubes = dataset.tubes.sort((a, b) => a.name > b.name ? 1 : -1);
            this.counts = dataset.counts;
            this.samples = dataset.samples.sort((a, b) => a.id > b.id ? 1 : -1);
        });
    }
    getTube(sample) {
        return this.tubes.find(t => t.sampleID === sample.id);
    }
    getCount(sample, population) {
        let tube = this.tubes.find(t => t.sampleID === sample.id);
        let count = this.counts.find(c => c.tubeID === tube.id && c.populationID === population.id);
        if (count.count === 0)
            count.count = null;
        return count;
    }
};
FACSFileResults = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'facs/file-results/:id',
        title: 'FACS File Results'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], FACSFileResults);



/***/ })

}]);
//# sourceMappingURL=file-results.01ac3593419a3ad6c940.js.map