(window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] = window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] || []).push([["routePage_fermOnlineChart"],{

/***/ "../apps/demo/fermentation_app/src/pages/page-chart.html":
/*!***************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/pages/page-chart.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-panels\">\r\n        <div class=\"panel\">\r\n            <div class=\"panel-heading\">Online Data Chart</div>\r\n            <div class=\"panel-body\">\r\n                <h3>Result-set: ${rs.id}</h3>\r\n                <div class=\"form-group\">\r\n                    <label>Field</label>\r\n                    <select value.bind=\"selectedField\" change.delegate=\"updateChartData()\">\r\n                        <option repeat.for=\"field of fields\" model.bind=\"field\">${field}</option>\r\n                    </select>\r\n                </div>\r\n                <chart options.bind=\"chartOptions\" type=\"xy\" legends=\"none\"\r\n                    series-group.bind=\"seriesGroup\" ></chart>\r\n            </div>\r\n        </div>\r\n        <div class=\"panel\">\r\n            <div class=\"panel-heading\">Set Comparisons</div>\r\n            <div class=\"panel-body\">\r\n                <form>\r\n                    <label repeat.for=\"aSet of availableSets\">\r\n                        <input type=\"checkbox\" model.bind=\"aSet.id\" checked.bind=\"selectedSets\" change.delegate=\"updateChartData()\">\r\n                        ${aSet.name}\r\n                    </label>\r\n                </form>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "../apps/demo/fermentation_app/src/pages/page-chart.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/pages/page-chart.ts ***!
  \*************************************************************/
/*! exports provided: FermPageChart */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FermPageChart", function() { return FermPageChart; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let FermPageChart = class FermPageChart {
    constructor(server) {
        this.server = server;
        this.chartOptions = {
            exists: true
        };
        this.fields = ['TEMP_Value', 'STIRR_Value', 'pH_Value', 'PO2_Value', 'FLOW_A_Value', 'Balance1_Value'];
        this.selectedField = 'STIRR_Value';
        this.availableSets = [];
        this.selectedSets = [];
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.resultSetID = context.params.id;
            yield this.getAvailableSets();
            yield this.updateChartData();
        });
    }
    getAvailableSets() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.selectedSets.push(this.resultSetID);
            const dataset = yield this.server.datasetQuery([
                { eClass: 'ResultSet', collection: 'rs', filters: [{ field: 'Type', value: 'FermentationOnline' }] }
            ]);
            this.availableSets = dataset.rs.map(s => {
                return { id: s.id, name: s.name };
            });
        });
    }
    updateChartData() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let resultSets = this.selectedSets;
            const dataset = yield this.server.datasetQuery([
                { eClass: 'ResultSet', alias: 'rs', filters: [{ field: 'ID', value: this.resultSetID }] },
                { eClass: 'ResultFermOnline', collection: 'online',
                    filters: [{ field: 'ResultSetID', values: resultSets }],
                    operations: [
                        {
                            field: 'Content',
                            type: 'slice',
                            columns: ['Age_h', this.selectedField],
                            rowFilters: [{ field: 'Age_h', min: 1, max: 3 }]
                        }
                    ]
                }
            ]);
            this.rs = dataset.rs;
            this.online = dataset.online;
            this.seriesGroup = [];
            for (let result of dataset.online) {
                let timeSeries;
                if (result.content.timeSeries.length > 600)
                    timeSeries = this.reduce(result.content.timeSeries);
                else
                    timeSeries = result.content.timeSeries;
                this.seriesGroup.push({
                    name: result.name,
                    chartLabel: result.name,
                    category: 'series',
                    content: {
                        points: timeSeries.map(tsp => {
                            return { valueX: tsp[0], valueY: tsp[1] };
                        })
                    }
                });
            }
        });
    }
    reduce(timeSeries) {
        let fold = Math.floor(timeSeries.length / 300);
        let newTimeSeries = [];
        for (let i = 0; i < timeSeries.length / fold; i++) {
            let first = i * fold;
            let sumX = 0, sumY = 0;
            let j;
            for (j = 0; j < fold && j + first < timeSeries.length; j++) {
                sumX += timeSeries[j + first][0];
                sumY += timeSeries[j + first][1];
            }
            newTimeSeries.push([sumX / j, sumY / j]);
        }
        return newTimeSeries;
    }
};
FermPageChart = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], FermPageChart);



/***/ })

}]);
//# sourceMappingURL=routePage_fermOnlineChart.2a2cda3d4495c207608c.js.map