(window["webpackJsonpcom_scifeon_scifeon_apps_raw_data"] = window["webpackJsonpcom_scifeon_scifeon_apps_raw_data"] || []).push([["routePage_rdRequestCreate"],{

/***/ "../apps/demo/raw_data_app/src/pages/request-create.html":
/*!***************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/pages/request-create.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>New Request</h1>\r\n            <button click.delegate=\"createRequest()\">Create Request</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid\">\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">Request Info</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\">\r\n                        <label>Customer</label>\r\n                        <select value.bind=\"selectedCustomer\">\r\n                            <option repeat.for=\"customer of customers\" model.bind=\"customer\">${customer.name}</option>\r\n                        </select>\r\n                    </div>\r\n\r\n                    <div class=\"form-group\">\r\n                        <label>Notes</label>\r\n                        <rich-text-editor value.bind=\"note.content\"></rich-text-editor>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">Samples</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\">\r\n                        <button click.delegate=\"showAddSamplesPopup()\">Edit Samples</button>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <table>\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>External ID</th>\r\n                                    <th>Type</th>\r\n                                    <th>Content</th>\r\n                                    <th>Description</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"sample of samples\">\r\n                                    <td>${sample.externalID}</td>\r\n                                    <td>${sample.type}</td>\r\n                                    <td>${sample.content}</td>\r\n                                    <td>${sample.tags}</td>\r\n                                    <td>${sample.description}</td>\r\n                                    <td><span class=\"fa fa-remove\"></span></td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/raw_data_app/src/pages/request-create.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/pages/request-create.ts ***!
  \*************************************************************/
/*! exports provided: RequestCreate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RequestCreate", function() { return RequestCreate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);




let RequestCreate = class RequestCreate {
    constructor(server, router, user) {
        this.server = server;
        this.router = router;
        this.user = user;
        this.samples = [];
        this.nextInputSampleAlias = 1;
        this.selectedMethods = [];
        this.note = {
            eClass: 'Note',
            content: '',
            subjectClass: 'Request',
            subjectID: '#idRequest',
            type: 'EntryNotes'
        };
    }
    activate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Customer', collection: 'customers', filters: [{ field: 'Status', value: 'Completed' }] }
            ]);
            this.customers = [{ name: 'None' }].concat(dataset.customers.sort((a, b) => a.name > b.name ? 1 : -1));
        });
    }
    showAddSamplesPopup() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
        });
    }
    createRequest() {
        let entities = this.samples.map(sample => {
            sample.id = `#idSmp${this.nextInputSampleAlias++}`;
            sample.name = '!SampleID';
            sample.barcode = '!Barcode';
            sample.format = 'Vial';
            sample.requestID = '#idRequest';
            return sample;
        });
        entities.push({
            eClass: 'Collection',
            id: '#idPayloadCollection',
            type: 'Payload',
            collItems: entities.filter(e => e.eClass === 'Sample').map(s => {
                return { entityClass: 'Sample', entityID: s.id };
            })
        });
        let payload = {
            methods: this.selectedMethods.map(m => m.id),
            sampleMethodMap: []
        };
        this.selectedMethods.map(m => this.samples.map(s => {
            payload.sampleMethodMap.push({
                sampleID: s.id, methodID: m.id
            });
        }));
        entities.push({
            eClass: 'Request',
            id: '#idRequest',
            type: 'CustomerService',
            inboxID: '#idInbox',
            status: 'Sent',
            sentByID: this.user.id,
            customerID: this.selectedCustomer.id,
            payload: payload,
            dateSent: new Date(),
            description: 'IM, ' + this.selectedCustomer.name,
            xrefs: [{ type: 'Payload', toID: '#idPayloadCollection', toClass: 'Collection' }]
        });
        if (this.note.content.length > 0)
            entities.push(this.note);
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        this.server.saveEntities(entities, [{ eClass: 'RequestInbox', name: 'IMService', alias: '#idInbox' }])
            .then(response => {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            let requestID = response.newEntities.find(e => e.eClass === 'Request').id;
            this.router.navigate('/entity/request/' + requestID);
        });
    }
};
RequestCreate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], RequestCreate);



/***/ })

}]);
//# sourceMappingURL=routePage_rdRequestCreate.de6d265b36c210645d4b.js.map