import { LogLevel, Logger } from 'aurelia-logging';
export declare class ScifeonConsoleLogger {
    logLevel: LogLevel;
    loggerInstance: Logger;
    loggerName: string;
    constructor(app: any, loggerName: any);
    /**
     * Logs a debug message.
     *
     * @param message The message to log.
     * @param rest The data to log.
     */
    debug(message: string, ...rest: any[]): void;
    /**
     * Logs info.
     *
     * @param message The message to log.
     * @param rest The data to log.
     */
    info(message: string, ...rest: any[]): void;
    /**
     * Logs a warning.
     *
     * @param message The message to log.
     * @param rest The data to log.
     */
    warn(message: string, ...rest: any[]): void;
    /**
     * Logs an error.
     *
     * @param message The message to log.
     * @param rest The data to log.
     */
    error(message: string, ...rest: any[]): void;
    /**
     * Sets the level of logging for this logger instance.
     *
     * @param level Matches a value of logLevel specifying the level of logging.
     */
    setLevel(level: number): void;
}
export declare class ConsoleLogger extends ScifeonConsoleLogger {
}
