import { HttpClient } from 'aurelia-fetch-client';
import { DatasetQuery, Entity, Filter, Sorting } from './interfaces';
export declare class ServerAPI {
    private http;
    static SORT: {
        NONE: string;
        ASC: string;
        DESC: string;
    };
    constructor(http: HttpClient);
    get(url: any, contentType?: string): Promise<Response>;
    getJson(url: any): Promise<any>;
    delete(url: any): Promise<Response>;
    post(url: any, body: any, contentType?: string): Promise<Response>;
    postJson(url: any, payload: any): Promise<Response>;
    put(url: any, payload: any, contentType?: string): Promise<Response>;
    putJson(url: any, payload: any, contentType?: string): Promise<Response>;
    patch(url: any, payload: any, contentType?: string): Promise<Response>;
    patchJson(url: any, payload: any, contentType?: string): Promise<Response>;
    fetch(url: string, options: any): Promise<Response>;
    private createErrorFromResponse;
    save(entity: Entity): Promise<Entity>;
    updateEntity(entity: Entity): Promise<Entity>;
    saveEntities(entities: Entity[], lookups?: any[]): Promise<{
        newEntities: Entity[];
        updatedEntities: Entity[];
    }>;
    preprocessPayload(payload: any): void;
    private traversePayload;
    private formatProperty;
    datasetQuery(query: DatasetQuery[]): Promise<any>;
    getEntities(eClass: any, filters?: Filter[], sortings?: Sorting[], start?: any, length?: any): Promise<{
        data: Entity[];
        total: number;
    }>;
    getEntity(eClass: any, id: any): Promise<Entity>;
}
