import { PAGE_TYPE } from '@scifeon/plugins';
/**
 * Inspired by: https://stackoverflow.com/questions/43163909/solution-load-independently-compiled-webpack-2-bundles-dynamically?rq=1
 */
export declare class AppLoader {
    private loadedApps;
    private loadingApps;
    private logger;
    private coreApps;
    private demoApps;
    private moduleApps;
    private _enabledApps;
    constructor();
    enabledApps(): App[];
    /**
     * Used to load all SDK Apps when Scifeon loads.
     * This gives a better debugging experience, as all source maps are loaded immediately.
     */
    loadSdkApps(): Promise<void>;
    load(app: App): Promise<App>;
    loadAppPluginFunction(plugin: any): Promise<any>;
    private installMainCallback;
    private createLoadedApp;
    private loadChunk;
    private loadScript;
}
export interface App {
    name: string;
    namespace: string;
    version: string;
    author: string;
    description: string;
    scifeon: {
        appDependencies?: string[];
        runtimeVersion: string;
        cliVersion?: string;
        contributions: {
            routes: {
                id: string;
                route: string[];
                title: string;
                pageId: string;
                roles: string[];
                type?: PAGE_TYPE;
            }[];
            menu: any[];
            plugins: {
                id: string;
                src: string;
                types: string[];
            }[];
        };
        scopes: string[];
    };
    type: string;
    isEnabled: boolean;
    pluginsJsPath?: string;
    fqAppName?: string;
    exportedPlugins?: any[];
    hash?: string;
    hot: any;
    moduleId: string;
}
