import { Aurelia, Container, ViewCompiler } from 'aurelia-framework';
import { InlineViewStrategy } from 'aurelia-templating';
import { AppLoader } from './app-loader';
import { Context, Location, ScifeonPlugin } from './interfaces';
import { Plugin, PluginManager } from './plugin-manager';
export declare class PluginLoader {
    private pluginManager;
    private appLoader;
    private container;
    private viewCompiler;
    private logger;
    constructor(pluginManager: PluginManager, appLoader: AppLoader, container: Container, viewCompiler: ViewCompiler);
    getView(plugin: Plugin, instance: ScifeonPlugin, location?: Location, customView?: string): Promise<InlineViewStrategy>;
    private getHTML;
    getInstance<T>(plugin: Plugin, context: Context, location?: Location): Promise<T>;
    getMenuItems(menu: string): any[];
    boostrapPlugins(aurelia: Aurelia): Promise<void>;
    private registerScifeonDependencies;
}
