import { AppLoader } from './app-loader';
import { PLUGIN_TYPE } from './constants';
import { Context, Location } from './interfaces';
export declare class PluginManager {
    private appLoader;
    private logger;
    constructor(appLoader: AppLoader);
    add(func: any, types: PLUGIN_TYPE[], options?: any): void;
    getPlugins(types: PLUGIN_TYPE | PLUGIN_TYPE[], context?: Context): Promise<Plugin[]>;
    getPluginFromApp(id: string, app: any, reloadApp?: boolean): Promise<Plugin>;
    getConfig(plugin: Plugin, location?: Location, defaultConfig?: any): any;
    getAllPlugins(): Promise<any[]>;
    private loadAppsWithPluginTypes;
    private preparePluginsWithTypeFromApp;
    private preparePluginFromApp;
    private savePlugin;
    private getFuncBucket;
}
export interface Plugin {
    func: any;
    options: any;
    metadata: PluginMetadata;
}
export interface PluginMetadata {
    app?: any;
    id?: string;
    name?: string;
    description?: string;
    allOptions: any[];
    types?: PLUGIN_TYPE[];
}
