(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["customer"],{

/***/ "./SPA/services/router-steps/app-insights-step.ts":
/*!********************************************************!*\
  !*** ./SPA/services/router-steps/app-insights-step.ts ***!
  \********************************************************/
/*! exports provided: AppInsightsStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppInsightsStep", function() { return AppInsightsStep; });
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_0__);

class AppInsightsStep {
    constructor() {
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_0__["LogManager"].getLogger('AppInsights');
        if (window.location.hostname !== 'localhost' && window['appInsights']) {
            this.client = window['appInsights'];
        }
        else {
            this.logger.debug('AppInsights not loaded.');
        }
    }
    run(routingContext, next) {
        if (this.client) {
            if (routingContext.previousInstruction) {
                this.client.stopTrackPage(routingContext.previousInstruction.fragment, window.location.href);
            }
            else {
                this.client.trackPageView(routingContext.fragment, window.location.href);
            }
            this.logger.debug('Tracking page view:', routingContext.fragment);
            this.client.startTrackPage(routingContext.fragment);
        }
        return next();
    }
}


/***/ }),

/***/ "./SPA/services/router-steps/authorize-step.ts":
/*!*****************************************************!*\
  !*** ./SPA/services/router-steps/authorize-step.ts ***!
  \*****************************************************/
/*! exports provided: AuthorizeStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AuthorizeStep", function() { return AuthorizeStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var module_app_dev_bar__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! module/app/dev-bar */ "module/app/dev-bar");





let AuthorizeStep = class AuthorizeStep {
    constructor(user) {
        this.user = user;
    }
    run(navigationInstruction, next) {
        module_app_dev_bar__WEBPACK_IMPORTED_MODULE_4__["DevBar"].instance.route = navigationInstruction;
        if (navigationInstruction.getAllInstructions().some(i => i.config.settings
            && i.config.settings.roles
            && !this.user.hasOneOfRoles(...i.config.settings.roles))) {
            return next.cancel(new aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Redirect"]('no-access'));
        }
        else {
            return next();
        }
    }
};
AuthorizeStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], AuthorizeStep);



/***/ }),

/***/ "./SPA/services/router-steps/close-all-dialogs-step.ts":
/*!*************************************************************!*\
  !*** ./SPA/services/router-steps/close-all-dialogs-step.ts ***!
  \*************************************************************/
/*! exports provided: CloseAllDialogsStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CloseAllDialogsStep", function() { return CloseAllDialogsStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-dialog */ "aurelia-dialog");
/* harmony import */ var aurelia_dialog__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__);



let CloseAllDialogsStep = class CloseAllDialogsStep {
    constructor(dialog) {
        this.dialog = dialog;
    }
    run(navigationInstruction, next) {
        this.dialog.closeAll();
        return next();
    }
};
CloseAllDialogsStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__["DialogService"]])
], CloseAllDialogsStep);



/***/ }),

/***/ "./SPA/services/router-steps/loading-steps.ts":
/*!****************************************************!*\
  !*** ./SPA/services/router-steps/loading-steps.ts ***!
  \****************************************************/
/*! exports provided: LoadingAuthorizeStep, LoadingPreActivateStep, LoadingPreRenderStep, LoadingPostRenderStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingAuthorizeStep", function() { return LoadingAuthorizeStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreActivateStep", function() { return LoadingPreActivateStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreRenderStep", function() { return LoadingPreRenderStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPostRenderStep", function() { return LoadingPostRenderStep; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! nprogress */ "./node_modules/nprogress/nprogress.js");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(nprogress__WEBPACK_IMPORTED_MODULE_1__);


class LoadingAuthorizeStep {
    constructor() {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["configure"]({ showSpinner: false });
    }
    run(routingContext, next) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true);
        nprogress__WEBPACK_IMPORTED_MODULE_1__["start"]();
        return next();
    }
}
class LoadingPreActivateStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.2);
        return next();
    }
}
class LoadingPreRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.6);
        return next();
    }
}
class LoadingPostRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["done"]();
        return next();
    }
}


/***/ }),

/***/ "./SPA/services/router-steps/reset-help-context-url-step.ts":
/*!******************************************************************!*\
  !*** ./SPA/services/router-steps/reset-help-context-url-step.ts ***!
  \******************************************************************/
/*! exports provided: ResetHelpContextUrlStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResetHelpContextUrlStep", function() { return ResetHelpContextUrlStep; });
/* harmony import */ var _help__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../help */ "./SPA/services/help.js");
/* harmony import */ var _help__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_help__WEBPACK_IMPORTED_MODULE_0__);

class ResetHelpContextUrlStep {
    run(navigationInstruction, next) {
        _help__WEBPACK_IMPORTED_MODULE_0__["Help"].ContextUrl = '';
        return next();
    }
}


/***/ }),

/***/ "./node_modules/nprogress/nprogress.js":
/*!*****************************************************************************************!*\
  !*** delegated ./node_modules/nprogress/nprogress.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/nprogress/nprogress.js");

/***/ }),

/***/ "async!module/customer/dashboard":
/*!******************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=customer!./SPA/module/customer/dashboard.ts ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./dashboard.ts */ "module/customer/dashboard"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/customer/report/request":
/*!***********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=customer!./SPA/module/customer/report/request.ts ***!
  \***********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./request.ts */ "module/customer/report/request"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/customer/tenak/fill-freezer":
/*!***************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=customer!./SPA/module/customer/tenak/fill-freezer.ts ***!
  \***************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./fill-freezer.ts */ "module/customer/tenak/fill-freezer"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "customer":
/*!**************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/customer.ts ***!
  \**************************************************************/
/*! exports provided: CustomerApp */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CustomerApp", function() { return CustomerApp; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! services/router-steps/loading-steps */ "./SPA/services/router-steps/loading-steps.ts");
/* harmony import */ var services_router_steps_authorize_step__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! services/router-steps/authorize-step */ "./SPA/services/router-steps/authorize-step.ts");
/* harmony import */ var services_router_steps_reset_help_context_url_step__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! services/router-steps/reset-help-context-url-step */ "./SPA/services/router-steps/reset-help-context-url-step.ts");
/* harmony import */ var services_router_steps_close_all_dialogs_step__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! services/router-steps/close-all-dialogs-step */ "./SPA/services/router-steps/close-all-dialogs-step.ts");
/* harmony import */ var services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! services/router-steps/app-insights-step */ "./SPA/services/router-steps/app-insights-step.ts");








let CustomerApp = class CustomerApp {
    constructor(router) {
        this.router = router;
    }
    configureRouter(config, router) {
        config.title = 'scifeon';
        config.addAuthorizeStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_3__["LoadingAuthorizeStep"]);
        config.addPreActivateStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_3__["LoadingPreActivateStep"]);
        config.addPreRenderStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_3__["LoadingPreRenderStep"]);
        config.addPostRenderStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_3__["LoadingPostRenderStep"]);
        config.addAuthorizeStep(services_router_steps_authorize_step__WEBPACK_IMPORTED_MODULE_4__["AuthorizeStep"]);
        config.addPreActivateStep(services_router_steps_reset_help_context_url_step__WEBPACK_IMPORTED_MODULE_5__["ResetHelpContextUrlStep"]);
        config.addPreActivateStep(services_router_steps_close_all_dialogs_step__WEBPACK_IMPORTED_MODULE_6__["CloseAllDialogsStep"]);
        config.addAuthorizeStep(services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_7__["AppInsightsStep"]);
        let configMap = [
            { route: [''], name: 'Dashboard', moduleId: 'module/customer/dashboard', title: 'Dashboard' },
            { route: ['tenak/fill-freezer'], name: 'Dashboard', moduleId: 'module/customer/tenak/fill-freezer', title: 'Freezer' },
            { route: ['report/request/:id'], name: 'RequestReport', moduleId: 'module/customer/report/request', title: 'Request' },
        ];
        config.map(configMap);
        config.mapUnknownRoutes('module/customer/dashboard');
        this.router = router;
    }
};
CustomerApp = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_2__["Router"]])
], CustomerApp);



/***/ }),

/***/ "customer.html":
/*!***************************!*\
  !*** ./SPA/customer.html ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"module/error/error-panel\"></require>\r\n\r\n    <div id=\"scifeon-main-app\" style=\"padding-left: 0; background-color: #fff;\">\r\n        <router-view></router-view>\r\n        <error-panel></error-panel>\r\n    </div>\r\n</template>\r\n";

/***/ }),

/***/ "module/customer/dashboard":
/*!*******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/customer/dashboard.ts ***!
  \*******************************************************************************/
/*! exports provided: Dashboard */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Dashboard", function() { return Dashboard; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var services_auth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! services/auth */ "./SPA/services/auth.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let Dashboard = class Dashboard {
    constructor(auth, server, user) {
        this.auth = auth;
        this.server = server;
        this.user = user;
    }
    logout() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.auth.logout();
        });
    }
    activate() {
        this.server.datasetQuery([
            {
                eClass: 'Request', collection: 'requests', filters: [
                    { field: 'Status', values: ['Initial', 'InProgress', 'Sent', 'Received'] }
                ]
            }
        ]).then(dataset => {
            this.requests = dataset.requests;
        });
    }
};
Dashboard = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [services_auth__WEBPACK_IMPORTED_MODULE_2__["AuthService"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], Dashboard);



/***/ }),

/***/ "module/customer/dashboard.html":
/*!********************************************!*\
  !*** ./SPA/module/customer/dashboard.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <div class=\"page-with-sidebar\">\r\n        <div class=\"sidebar fixed\" style=\"display: flex;\">\r\n            <div style=\"flex: 1\">\r\n                <img src=\"/images/custom/tenak-logo.png\" style=\"display: block; margin: 25px auto 0 auto;\"/>\r\n            </div>\r\n            <div>    <div class=\"menu\"><a click.delegate=\"logout()\" title=\"Log out\">Log out</a></div>\r\n        </div>\r\n            <div>\r\n                Powered by\r\n                <a href=\"https://www.scifeon.com\">\r\n                    <img src=\"/images/logo.png\" style=\"display: block; margin: 0 auto 15px auto;\"/>\r\n                </a>\r\n            </div>\r\n        </div>\r\n        <div class=\"content\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Dashboard</div>\r\n                <div class=\"panel-body\">\r\n                    <h3>Put dashboard stuff here</h3>\r\n                    <p><a href=\"/#/tenak/fill-freezer\">Fill Freezer</a></p>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/customer/report/request":
/*!************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/customer/report/request.ts ***!
  \************************************************************************************/
/*! exports provided: RequestReport */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RequestReport", function() { return RequestReport; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let RequestReport = class RequestReport {
    constructor(server) {
        this.server = server;
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.request = yield this.server.getEntity('Request', params.id);
            this.request.files = [];
            this.request.notes = '(none)';
            this.server.getEntities('File', [{ field: 'SubjectClass', value: 'Request' }, { field: 'SubjectID', value: this.request.id }])
                .then(response => {
                this.request.files = response.data;
            });
            this.server.getEntities('Note', [{ field: 'SubjectClass', value: 'Request' }, { field: 'SubjectID', value: this.request.id }])
                .then(response => {
            });
        });
    }
};
RequestReport = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], RequestReport);



/***/ }),

/***/ "module/customer/report/request.html":
/*!*************************************************!*\
  !*** ./SPA/module/customer/report/request.html ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <h1 class=\"header\">Request: ${request.name} <span if.bind=\"request.id !== request.name\">(${request.id})</span></h1>\r\n\r\n    <table class=\"full-width\">\r\n        <tr>\r\n            <th>Description</th>\r\n            <th>Created Date</th>\r\n        </tr>\r\n        <tr>\r\n            <td>${request.description}</td>\r\n            <td>${request.createdDate | dateFormat}</td>\r\n        </tr>\r\n    </table>\r\n\r\n    <table class=\"full-width\">\r\n        <tr>\r\n            <th colspan=\"2\">Notes</th>\r\n        </tr>\r\n        <tr>\r\n            <td colspan=\"2\" innerhtml.bind=\"request.notes\"></td>\r\n        </tr>\r\n    </table>\r\n\r\n    <h1>Files</h1>\r\n    <p if.bind=\"!request.files.length\">\r\n        (no files yet)\r\n    </p>\r\n    <table class=\"full-width\" if.bind=\"request.files.length\">\r\n        <thead>\r\n            <tr>\r\n                <th>File</th>\r\n                <th>Date</th>\r\n            </tr>\r\n        </thead>\r\n        <tbody>\r\n            <tr repeat.for=\"file of request.files\">\r\n                <td><a href=\"/api/file/${file.id}\" title=\"Download file\">${file.name}</a></td>\r\n                <td>${file.createdDate | dateFormat}</td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n</template>";

/***/ }),

/***/ "module/customer/tenak/fill-freezer":
/*!****************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/customer/tenak/fill-freezer.ts ***!
  \****************************************************************************************/
/*! exports provided: TenakFillFreezer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TenakFillFreezer", function() { return TenakFillFreezer; });
class TenakFillFreezer {
}


/***/ }),

/***/ "module/customer/tenak/fill-freezer.html":
/*!*****************************************************!*\
  !*** ./SPA/module/customer/tenak/fill-freezer.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-sidebar\">\r\n        <div class=\"sidebar fixed\" style=\"display: flex;\">\r\n            <div>\r\n                <img src=\"/images/custom/tenak-logo.png\" style=\"display: block; margin: 25px auto 0 auto;\"/>\r\n            </div>\r\n            <div style=\"flex: 1\">\r\n                <h1>Fill Freezer Specific Sidebar Content</h1>\r\n            </div>\r\n            <div>\r\n                Powered by\r\n                <a href=\"https://www.scifeon.com\">\r\n                    <img src=\"/images/logo.png\" style=\"display: block; margin: 0 auto 15px auto;\"/>\r\n                </a>\r\n            </div>\r\n        </div>\r\n        <div class=\"content\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Store Samples</div>\r\n                <div class=\"panel-body\">\r\n                    <h3>Specify Samples</h3>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/error/error-panel":
/*!*****************************************!*\
  !*** ./SPA/module/error/error-panel.ts ***!
  \*****************************************/
/*! exports provided: ErrorPanel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ErrorPanel", function() { return ErrorPanel; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/error/bug-report-service */ "./SPA/module/error/bug-report-service.ts");
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");







let ErrorPanel = class ErrorPanel {
    constructor(errorManager, reportService, http, dialog) {
        this.errorManager = errorManager;
        this.reportService = reportService;
        this.http = http;
        this.dialog = dialog;
        this.errorManager.subscribe(this);
    }
    hide() {
        this.message = '';
    }
    showMessage(message, error = null) {
        const code = error ? error.code || -1 : -1;
        message = message || error ? error.message : '';
        const hint = error ? error.hint : '';
        const stack = error ? error.message + '\n' + (error.stack || error.stacktrace) : '';
        this.showApiError({
            code: code,
            message: message,
            hint: hint,
            stacktrace: stack
        });
    }
    showError(error) {
        if (!error)
            return;
        this.showApiError({
            code: error.code || -1,
            message: error.message,
            hint: error.hint,
            stacktrace: error.stack || error.stacktrace
        });
    }
    showApiError(error) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        this.error = error;
        this.message = error.message;
    }
    showDetails() {
        let html = '<pre><b>Message: </b> ' + this.message;
        if (this.error.hint) {
            html += '<br/><b>Hint:</b><br/>' + this.error.hint;
        }
        if (this.error.stacktrace) {
            html += '<br/><b>Stacktrace:</b><br/>' + this.error.stacktrace;
        }
        html += '</pre>';
        this.dialog.message(html);
    }
    report() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.reportService.report(this.error);
        });
    }
};
ErrorPanel = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__["ErrorManager"], module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__["BugReportService"], aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__["HttpClient"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ErrorPanel);



/***/ }),

/***/ "module/error/error-panel.html":
/*!*******************************************!*\
  !*** ./SPA/module/error/error-panel.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div id=\"error-panel\" class=\"toast toast-error\" if.bind=\"message\">\r\n        <div class=\"float-right\">\r\n            <span if.bind=\"error.stacktrace || error.hint\"><a click.delegate=\"showDetails()\">Show details</a> | </span>\r\n            <a href=\"#\" click.delegate=\"report()\" title=\"Submit Bug Report\">Report</a>\r\n            <button class=\"btn-clear float-right\" style=\"color: white;\" title=\"Close\" click.trigger=\"hide()\"></button>\r\n        </div>\r\n        ${message}\r\n    </div>\r\n    <div style=\"position:absolute;bottom:0; width: 100%;\" id=\"screenshot-screen-widener\"></div>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=customer.7d2e17d8ae74be98b4b6.js.map