(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["elements~entity~module/assayadm"],{

/***/ "./SPA/module/curve-fit/curve-fit.ts":
/*!*******************************************!*\
  !*** ./SPA/module/curve-fit/curve-fit.ts ***!
  \*******************************************/
/*! exports provided: CurveFit */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CurveFit", function() { return CurveFit; });
/* harmony import */ var ml_levenberg_marquardt__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ml-levenberg-marquardt */ "./node_modules/ml-levenberg-marquardt/lib/index.js");
/* harmony import */ var ml_levenberg_marquardt__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ml_levenberg_marquardt__WEBPACK_IMPORTED_MODULE_0__);

class CurveFit {
    getParameters(data) {
        data = data.filter(s => s.entity.type === "XY");
        let results = { series: [] };
        const options = {
            maxIterations: 50,
            damping: 0.001,
            initialValues: [110649, 233730.9835947, 0.0001, 1]
        };
        const I_BOTTOM = 0;
        const I_TOP = 1;
        const I_INFLECTION = 2;
        const I_SLOPE = 3;
        let model = function (p) {
            return x => {
                let r = p[I_BOTTOM] + (p[I_TOP] - p[I_BOTTOM]) / (1 + Math.pow(x / p[I_INFLECTION], p[I_SLOPE]));
                if (isNaN(r))
                    return -1e8;
                return r;
            };
        };
        for (let set of data) {
            let points = set.entity.content.points;
            points = points.filter(p => !p.isExcluded);
            let xValues = [];
            let yValues = [];
            for (let point of points) {
                xValues.push(point.valueX);
                yValues.push(point.valueY);
            }
            let ans = ml_levenberg_marquardt__WEBPACK_IMPORTED_MODULE_0__({ x: xValues, y: yValues }, model, options);
            ans.points = {
                x: xValues,
                y: yValues
            };
            let seriesRecord = {
                key: set.key,
                parameters: {
                    bottom: ans.parameterValues[I_BOTTOM],
                    top: ans.parameterValues[I_TOP],
                    ec50: ans.parameterValues[I_INFLECTION],
                    logEC50: Math.log10(ans.parameterValues[I_INFLECTION]),
                    slope: ans.parameterValues[I_SLOPE]
                }
            };
            results.series.push(seriesRecord);
        }
        return results;
    }
}


/***/ }),

/***/ "./node_modules/numeral/numeral.js":
/*!*************************************************************************************!*\
  !*** delegated ./node_modules/numeral/numeral.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/numeral/numeral.js");

/***/ }),

/***/ "element/chart":
/*!******************************!*\
  !*** ./SPA/element/chart.ts ***!
  \******************************/
/*! exports provided: Chart */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Chart", function() { return Chart; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var module_curve_fit_curve_fit__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! module/curve-fit/curve-fit */ "./SPA/module/curve-fit/curve-fit.ts");
/* harmony import */ var resources_value_converters_significant__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! resources/value-converters/significant */ "resources/value-converters/significant");




let Chart = class Chart {
    constructor(element, curveFit) {
        this.element = element;
        this.curveFit = curveFit;
        this.colors = ['#ff0000', '#00ff00', '#00BFFF', '#aaaa00', '#888888', '#00aaaa', '#aa00aa'];
        this.status = 'No Status';
    }
    resultsChanged() { this.updateChart(); }
    seriesGroupChanged() { this.updateChart(); }
    attached() {
        this.isAttached = true;
        this.updateChart();
    }
    updateChart() {
        this.status = 'Updating';
        if (!this.type || !this.isAttached || !this.chart)
            return;
        if (!this.results && !this.seriesGroup)
            return;
        switch (this.type) {
            case 'xy':
                this.createXY();
                break;
            default:
                throw new Error('Invalid chart type: ' + this.type);
        }
        this.status = 'Done';
    }
    createXY() {
        let data;
        let points;
        let columns = [];
        let types = {};
        let xs = {};
        let type = 'scatter';
        let point = {};
        let colors = {};
        let iColor = 0;
        data = this.results || this.seriesGroup;
        for (let instance of data) {
            if (!instance)
                continue;
            instance.chart = this;
            let key = instance.chartLabel || instance.name;
            let color = this.colors[iColor % this.colors.length];
            colors[key] = color;
            colors[key + '|Curve'] = color;
            colors[key + '|Excluded'] = '#000000';
            let columnPoints = [key];
            columns.push(columnPoints);
            let columnPointsX = [key + '|X'];
            columns.push(columnPointsX);
            xs[key] = key + '|X';
            let columnExcluded = [key + '|Excluded'];
            let columnExcludedX = [key + '|ExcludedX'];
            points = this.results ? instance.parent.entity.content.points : instance.content.points;
            for (let point of points) {
                let valueX = point.valueX;
                if (this.xAxis === 'log')
                    valueX = Math.log10(valueX);
                point.chartX = valueX;
                let valueY = point.valueY;
                if (this.yAxis === 'log')
                    valueY = Math.log10(valueY);
                point.chartY = valueY;
                if (point.isExcluded) {
                    columnExcludedX.push(valueX);
                    columnExcluded.push(valueY);
                }
                else {
                    columnPointsX.push(valueX);
                    columnPoints.push(valueY);
                }
            }
            if (columnExcluded.length > 1) {
                columns.push(columnExcluded);
                columns.push(columnExcludedX);
                xs[key + '|Excluded'] = key + '|ExcludedX';
            }
            let curve = instance.hasActivity ? instance.curve : null;
            if (!curve)
                curve = this.createMidpointCurve(instance);
            types[key] = 'scatter';
            let columnCurve = [key + '|Curve'];
            types[key + '|Curve'] = 'line';
            columns.push(columnCurve);
            let columnCurveX = [key + '|CurveX'];
            columns.push(columnCurveX);
            xs[key + '|Curve'] = key + '|CurveX';
            for (let point of curve) {
                let valueX = point.valueX;
                if (this.xAxis === 'log')
                    valueX = Math.log10(valueX);
                let valueY = point.valueY;
                if (this.yAxis === 'log')
                    valueY = Math.log10(valueY);
                columnCurveX.push(valueX);
                columnCurve.push(valueY);
            }
            point.show = false;
            iColor++;
        }
        let axis = {
            x: { tick: { fit: true } },
            y: { tick: { fit: true } }
        };
        axis.x.tick.format = d => {
            return new resources_value_converters_significant__WEBPACK_IMPORTED_MODULE_3__["SignificantValueConverter"]().toView(d, 3);
        };
        axis.y.tick.format = d => {
            return new resources_value_converters_significant__WEBPACK_IMPORTED_MODULE_3__["SignificantValueConverter"]().toView(d, 3);
        };
        this.c3chart = c3.generate({
            bindto: this.chart,
            data: {
                columns: columns,
                xs: xs,
                types: types,
                type: type,
                colors: colors,
                onclick: (e, element) => {
                    this.onclick(e, element);
                }
            },
            legend: {
                show: this.legends !== 'none'
            },
            axis: axis,
            point: point
        });
        for (let instance of data) {
            let key = instance.chartLabel || instance.name;
            key = key.replace(/\|/g, '-');
            $(`.c3-circles-${key}-Excluded circle`).addClass('excluded');
        }
        if (this.options && this.options.refLines) {
            let lines = [];
            if (this.yAxis === 'log') {
                for (let refLine of this.options.refLines)
                    lines.push({ value: Math.log10(refLine.valueY), text: refLine.name });
            }
            else {
                for (let refLine of this.options.refLines)
                    lines.push({ value: refLine.valueY, text: refLine.name });
            }
            this.c3chart.ygrids.add(lines);
        }
    }
    createMidpointCurve(instance) {
        let points;
        points = this.results ? instance.parent.entity.content.points : instance.content.points;
        points = points.filter(i => !i.isExcluded);
        points.sort((a, b) => a.valueX - b.valueX);
        let curvePoints = [];
        let lastCurvePoint = null;
        for (let point of points) {
            if (!lastCurvePoint) {
                lastCurvePoint = { valueX: point.valueX, valuesY: [point.valueY] };
                curvePoints.push(lastCurvePoint);
                continue;
            }
            if (point.valueX === 0.0) {
                if (lastCurvePoint === 0.0) {
                    lastCurvePoint.valuesY.push(point.valueY);
                    continue;
                }
                lastCurvePoint = { valueX: point.valueX, valuesY: [point.valueY] };
                curvePoints.push(lastCurvePoint);
                continue;
            }
            if (lastCurvePoint.valueX === point.valueX)
                lastCurvePoint.valuesY.push(point.valueY);
            else {
                lastCurvePoint = { valueX: point.valueX, valuesY: [point.valueY] };
                curvePoints.push(lastCurvePoint);
            }
        }
        for (let point of curvePoints)
            point.valueY = point.valuesY.reduce((a, b) => a + b) / point.valuesY.length;
        return curvePoints;
    }
    onclick(e, element) {
        let exclude = true;
        let instance;
        let category = 'none';
        let point;
        if (e.name.endsWith('|Excluded')) {
            e.name = e.name.substring(0, e.name.length - 9);
            exclude = false;
        }
        if (this.results) {
            instance = this.results.find(r => (r.chartLabel || r.name) === e.name);
            category = 'results';
        }
        else if (this.seriesGroup) {
            instance = this.seriesGroup.find(r => (r.chartLabel || r.name) === e.name);
            category = 'series';
        }
        if (!instance)
            return;
        point = (this.results ? instance.parent.entity.content.points : instance.content.points).find(p => p.chartY === e.value && p.chartX === e.x);
        if (!point)
            return;
        point.isExcluded = exclude;
        this.status = 'Exclusion Update';
        this.element.dispatchEvent(new CustomEvent('exclusion-update', { bubbles: true, detail: { chart: this, point: point, result: instance, exclude: exclude } }));
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "results", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "seriesGroup", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "type", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "options", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "xAxis", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "yAxis", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "axisRanges", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Chart.prototype, "legends", void 0);
Chart = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('chart'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element, module_curve_fit_curve_fit__WEBPACK_IMPORTED_MODULE_2__["CurveFit"]])
], Chart);



/***/ }),

/***/ "element/chart.html":
/*!********************************!*\
  !*** ./SPA/element/chart.html ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div ref=\"chart\"></div>\r\n</template>";

/***/ }),

/***/ "resources/value-converters/significant":
/*!*******************************************************!*\
  !*** ./SPA/resources/value-converters/significant.ts ***!
  \*******************************************************/
/*! exports provided: SignificantValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignificantValueConverter", function() { return SignificantValueConverter; });
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_0__);

class SignificantValueConverter {
    toView(value, digits = 3) {
        if (value === '<LOD')
            return value;
        if (isNaN(value))
            return '-';
        if (value === 0.0)
            return '0';
        let valueAbs = Math.abs(value);
        let magnitude = Math.floor(Math.log10(valueAbs));
        let valueInt = Math.round(valueAbs * Math.pow(10, -magnitude + digits - 1));
        let valueRounded = valueInt * Math.pow(10, magnitude - digits + 1);
        if (value < 0)
            valueRounded = -valueRounded;
        let format;
        if (value > 1e7 || value < -1e7 || (value > -1e-3 && value < 1e-3)) {
            format = '0,0';
            if (digits > 1)
                format += '.';
            let decimalDigits = digits - 1;
            while (decimalDigits > 0) {
                format += '0';
                decimalDigits--;
            }
            format += 'e+0';
        }
        else {
            format = '0,0.';
            let decimalDigits = digits - magnitude - 1;
            while (decimalDigits > 0) {
                format += '0';
                decimalDigits--;
            }
        }
        return numeral__WEBPACK_IMPORTED_MODULE_0__(valueRounded).format(format);
    }
}


/***/ })

}]);
//# sourceMappingURL=assayadm.7d2e17d8ae74be98b4b6.js.map