(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["elements~protected"],{

/***/ "./SPA/element/grid/grid-editor-base.js":
/*!**********************************************!*\
  !*** ./SPA/element/grid/grid-editor-base.js ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GridEditorBase = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _aureliaTemplatingResources = __webpack_require__(/*! aurelia-templating-resources */ "aurelia-templating-resources");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// CELL LOCATION PREFIXES
// trow: Table row, equal to tr-element.rowIndex
// tcol: Table col, equal to td-element.cellIndex

var GridEditorBase = exports.GridEditorBase = (_dec = (0, _aureliaFramework.inject)(_aureliaTemplatingResources.BindingSignaler, _aureliaFramework.TaskQueue), _dec(_class = function () {
    function GridEditorBase(signaler, queue) {
        _classCallCheck(this, GridEditorBase);

        this.signaler = signaler;
        this.queue = queue;
    }

    _createClass(GridEditorBase, [{
        key: 'attached',
        value: function attached() {
            var _this = this;

            this.keyDownListener = function (e) {
                if (!_this.hasFocus()) return;_this.keyDown(e);
            };
            window.addEventListener('keydown', this.keyDownListener, false);

            this.pasteListener = function (e) {
                if (!_this.hasFocus()) return;_this.paste(e);
            };
            window.addEventListener('paste', this.pasteListener, false);

            this.copyListener = function (e) {
                if (!_this.hasFocus()) return;_this.copy(e);
            };
            window.addEventListener('copy', this.copyListener, false);

            this.doubleClickListener = function (e) {
                if (!_this.hasFocus()) return;_this.doubleClick(e);
            };
            window.addEventListener('dblclick', this.doubleClickListener, false);

            this.outsideClickListener = function (e) {
                if (_this.hasFocus(e.target)) return;
            };
            window.addEventListener('click', this.outsideClickListener, false);

            this.tcolSelectStart = this.getTColMin();
            this.trowSelectStart = this.getTRowMin();
            this.tcolSelectEnd = this.getTColMin();
            this.trowSelectEnd = this.getTRowMin();
        }
    }, {
        key: 'detached',
        value: function detached() {
            window.removeEventListener('keydown', this.keyDownListener);
            window.removeEventListener('paste', this.pasteListener);
            window.removeEventListener('copy', this.copyListener);
            window.removeEventListener('dblclick', this.doubleClickListener);
            window.removeEventListener('click', this.outsideClickListener);
        }
    }, {
        key: 'getTDElement',
        value: function getTDElement(childElement) {
            for (var count = 0; childElement.localName !== 'td' && count < 10; count++) {
                childElement = childElement.parentElement;
            }
            if (childElement.localName === 'td') return childElement;
        }
    }, {
        key: 'hasFocus',
        value: function hasFocus() {
            var element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

            element = element || document.activeElement;
            while (element && element !== this.table && element.localName !== 'body') {
                element = element.parentElement;
            }
            return element && element.localName && element.localName === 'table';
        }
    }, {
        key: 'inputBlur',
        value: function inputBlur(e) {
            this.finishEdit();
        }
    }, {
        key: 'tdFocus',
        value: function tdFocus(e) {
            this.selectTD(this.getTDElement(e.srcElement));
        }

        // SELECTION ///////////////////////////////////////////////////////////////////

    }, {
        key: 'selectTD',
        value: function selectTD(td) {
            this.select(td.parentElement.rowIndex, td.cellIndex);
        }
    }, {
        key: 'select',
        value: function select(trow, tcol) {
            this.clearSelection();

            this.selectData(trow, tcol);

            this.tcolSelectStart = tcol;
            this.trowSelectStart = trow;
            this.tcolSelectEnd = tcol;
            this.trowSelectEnd = trow;
            this.hasSelection = true;

            $(this.table).find('tr:nth-child(' + (trow + 1) + ') td:nth-child(' + (tcol + 1) + ')').focus();
        }
    }, {
        key: 'setSelectionStart',
        value: function setSelectionStart(tdElement) {
            this.clearSelection();
            this.finishEdit();

            this.isMouseDown = true;

            this.tcolSelectStart = tdElement.cellIndex;
            this.trowSelectStart = tdElement.parentElement.rowIndex;
            this.tcolSelectEnd = this.tcolSelectStart;
            this.trowSelectEnd = this.trowSelectStart;

            this.selectData(this.trowSelectStart, this.tcolSelectStart);

            this.hasSelection = true;
            $(tdElement).focus();
        }
    }, {
        key: 'setSelectionEnd',
        value: function setSelectionEnd(trowSelectEnd, tcolSelectEnd) {
            if (trowSelectEnd === this.trowSelectEnd && tcolSelectEnd === this.tcolSelectEnd) return;
            this.trowSelectEnd = trowSelectEnd;
            this.tcolSelectEnd = tcolSelectEnd;

            this.clearSelection();
            this.hasSelection = true;

            var area = this.getSelectionArea();

            for (var trow = area.trowMin; trow <= area.trowMax; trow++) {
                for (var tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                    this.selectData(trow, tcol);
                }
            }
        }
    }, {
        key: 'getSelectionArea',
        value: function getSelectionArea() {
            if (!this.hasSelection) return {
                trowMin: 1, trowMax: this.nRows,
                tcolMin: 1, tcolMax: this.nCols
            };

            return {
                trowMin: this.trowSelectEnd > this.trowSelectStart ? this.trowSelectStart : this.trowSelectEnd,
                trowMax: this.trowSelectEnd < this.trowSelectStart ? this.trowSelectStart : this.trowSelectEnd,
                tcolMin: this.tcolSelectEnd > this.tcolSelectStart ? this.tcolSelectStart : this.tcolSelectEnd,
                tcolMax: this.tcolSelectEnd < this.tcolSelectStart ? this.tcolSelectStart : this.tcolSelectEnd
            };
        }

        // MOUSE ///////////////////////////////////////////////////////////////////////

    }, {
        key: 'mouseDown',
        value: function mouseDown(e) {
            //console.log('GRID: Mouse Down');
            var tdElement = this.getTDElement(e.srcElement);
            var tcol = tdElement.cellIndex;
            var trow = tdElement.parentElement.rowIndex;

            if (e.shiftKey && this.hasSelection) this.setSelectionEnd(trow, tcol);else this.setSelectionStart(tdElement);

            return false;
        }
    }, {
        key: 'mouseOver',
        value: function mouseOver(e) {
            this.mouse = e.srcElement.localName;
        }
    }, {
        key: 'mouseMove',
        value: function mouseMove(e) {
            if (!this.isMouseDown) return;
            var tdElement = this.getTDElement(e.srcElement);

            var tcolSelectEnd = tdElement.cellIndex;
            var trowSelectEnd = tdElement.parentElement.rowIndex;
            this.setSelectionEnd(trowSelectEnd, tcolSelectEnd);

            return false;
        }
    }, {
        key: 'mouseUp',
        value: function mouseUp(e) {
            this.isMouseDown = false;
        }
    }, {
        key: 'mouseEnter',
        value: function mouseEnter(e) {
            if (!this.isMouseDown) return;
            if (e.buttons % 2 === 0) this.isMouseDown = false;
        }
    }, {
        key: 'doubleClick',
        value: function doubleClick(e) {
            //console.log('GRID: Double Click');
            this.editCell(e);
        }

        // KEYBOARD ////////////////////////////////////////////////////////////////////

    }, {
        key: 'keyDown',
        value: function keyDown(e) {
            var _this2 = this;

            if (e.key === 'd' && e.ctrlKey) {
                this.fillDown();
                e.preventDefault();
                return;
            }

            if (e.key.length === 1 && !e.ctrlKey && !e.altKey) {
                this.editCell(e);
                return;
            }

            var tdElement = this.getTDElement(document.activeElement);
            if (!tdElement) return;
            var tcol = tdElement.cellIndex;
            var trow = tdElement.parentElement.rowIndex;

            switch (e.key) {
                case 'ArrowUp':
                    if (e.shiftKey) {
                        if (this.trowSelectEnd > 0) this.setSelectionEnd(this.trowSelectEnd - 1, this.tcolSelectEnd);
                    } else if (trow > 0) this.select(trow - 1, tcol);
                    break;
                case 'ArrowDown':
                    if (e.shiftKey) {
                        if (this.trowSelectEnd < this.getTRowMax()) this.setSelectionEnd(this.trowSelectEnd + 1, this.tcolSelectEnd);
                    } else if (trow < this.getTRowMax()) this.select(trow + 1, tcol);else if (trow === this.getTRowMax() && this.canAddRows()) {
                        this.addRow();
                        this.queue.queueMicroTask(function () {
                            _this2.select(trow + 1, tcol);
                        });
                    }
                    break;
                case 'ArrowLeft':
                    if (e.shiftKey) {
                        if (this.tcolSelectEnd > this.getTColMin()) this.tsetSelectionEnd(this.trowSelectEnd, this.tcolSelectEnd - 1);
                    } else if (tcol > this.getTColMin()) this.select(trow, tcol - 1);
                    break;
                case 'ArrowRight':
                    if (e.shiftKey) {
                        if (this.tcolSelectEnd < this.getTColMax()) this.setSelectionEnd(this.rowSelectEnd, this.colSelectEnd + 1);
                    } else if (tcol < this.getTColMax()) this.select(trow, tcol + 1);
                    break;
                case 'Enter':
                    var tdEnter = this.finishEdit();
                    var tcolEnter = tdEnter.cellIndex;
                    var trowEnter = tdEnter.parentElement.rowIndex;

                    if (trowEnter < this.getTRowMax()) this.select(trowEnter + 1, tcolEnter);else if (trow === this.getTRowMax() && this.canAddRows()) {
                        this.addRow();
                        this.queue.queueMicroTask(function () {
                            _this2.select(trow + 1, tcol);
                        });
                    } else this.select(trowEnter, tcolEnter);
                    break;
                case 'Tab':
                    var tdTab = tdElement;
                    if (this.tdCurrentEditor) tdTab = this.finishEdit();

                    var tcolTab = tdTab.cellIndex;
                    var trowTab = tdTab.parentElement.rowIndex;

                    if (e.shiftKey) {
                        if (tcolTab > 1) this.select(trowTab, tcolTab - 1);else if (trowTab > 1) this.select(trowTab - 1, this.getTColMax());else this.select(trowTab, tcolTab);
                    } else {
                        if (tcolTab < this.getTColMax()) this.select(trowTab, tcolTab + 1);else if (trowTab < this.getTRowMax()) this.select(trowTab + 1, this.getTColMin());else if (trowTab === this.getTRowMax() && this.canAddRows()) {
                            this.addRow();
                            this.queue.queueMicroTask(function () {
                                _this2.select(trowTab + 1, _this2.getTColMin());
                            });
                        } else this.select(trowTab, tcolTab);
                    }

                    e.preventDefault();
                    break;
                case 'Delete':
                    this.clearSelectedContent();
                    break;
                case 'F2':
                    this.editCell(e);
                    break;
                case 'Escape':
                    this.selectTD(this.cancelEdit());
                    break;
            }
        }

        // CELL EDITING ////////////////////////////////////////////////////////////////

    }, {
        key: 'cancelEdit',
        value: function cancelEdit() {
            if (!this.tdCurrentEditor) return;
            var td = this.tdCurrentEditor;
            this.tdCurrentEditor = null;
            this.editorContent = null;

            $(this.editor).hide();
            $(td).children().first().show();
            this.signaler.signal('updategrid');

            return td;
        }
    }, {
        key: 'finishEdit',
        value: function finishEdit() {
            if (!this.tdCurrentEditor) return;

            var td = this.tdCurrentEditor;
            this.tdCurrentEditor = null;
            //console.log(`GRID: Finish Edit Through - ${td.parentElement.rowIndex}, ${td.cellIndex} - from ${new Error().stack}`);

            var trow = td.parentElement.rowIndex;
            var tcol = td.cellIndex;
            this.setDataContent(trow, tcol, this.editorContent);

            $(this.editor).hide();
            $(td).children().first().show();
            this.editorContent = null;
            this.signaler.signal('updategrid');

            return td;
        }
    }, {
        key: 'editCell',
        value: function editCell(e) {
            if (e.srcElement.localName === 'input') return;

            this.clearSelection();
            this.finishEdit();

            var tdElement = this.getTDElement(e.srcElement);

            var tcol = tdElement.cellIndex;
            var trow = tdElement.parentElement.rowIndex;

            this.editorContent = this.getDataContent(trow, tcol);

            $(tdElement).children().first().hide(); // TODO: Do we actually need to use jQuery for this ?????
            $(tdElement).append($(this.editor).show());
            $(this.editor).children().first().focus();

            var tabIndexTD = $(tdElement).attr('tabindex');
            var tabIndex = parseInt(tabIndexTD) + 1;
            $(this.editor).attr('tabindex', tabIndex);
            this.tdCurrentEditor = tdElement;
        }

        // CLIPBOARD ///////////////////////////////////////////////////////////////////

    }, {
        key: 'paste',
        value: function paste(e) {
            if (!this.hasSelection) return;

            var content = e.clipboardData.getData('Text');
            var lines = content.trim().split('\n').map(function (l) {
                return l.split('\t');
            });

            var area = this.getSelectionArea();
            var tcolMax = this.getTColMax();

            for (var iLine = 0; iLine < lines.length; iLine++) {
                for (var iField = 0; iField < lines[iLine].length; iField++) {
                    var trow = area.trowMin + iLine;
                    var tcol = area.tcolMin + iField;

                    if (trow === this.getTRowMax() + 1 && this.canAddRows()) this.addRow();

                    if (trow <= this.getTRowMax() && tcol <= tcolMax) this.setDataContent(trow, tcol, lines[iLine][iField]);
                }
            }

            e.preventDefault();
        }
    }, {
        key: 'copy',
        value: function copy(e) {
            if (!this.hasSelection) return;

            var area = this.getSelectionArea();

            var content = '';
            for (var trow = area.trowMin; trow <= area.trowMax; trow++) {
                for (var tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                    if (tcol > area.tcolMin) content += '\t';
                    content += this.getDataContent(trow, tcol) || '';
                }
                content += '\n';
            }

            e.clipboardData.setData('text/plain', content);
            e.preventDefault();
        }

        // CONTENT MANIPULATION ////////////////////////////////////////////////////////

    }, {
        key: 'clear',
        value: function clear() {
            var trowMin = this.getTRowMin();
            var trowMax = this.getTRowMax();
            var tcolMin = this.getTColMin();
            var tcolMax = this.getTColMax();

            for (var trow = trowMin; trow <= trowMax; trow++) {
                for (var tcol = tcolMin; tcol <= tcolMax; tcol++) {
                    this.setDataContent(trow, tcol, null);
                }
            }
        }
    }, {
        key: 'clearSelectedContent',
        value: function clearSelectedContent() {
            var area = this.getSelectionArea();
            for (var trow = area.trowMin; trow <= area.trowMax; trow++) {
                for (var tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                    this.setDataContent(trow, tcol, '');
                }
            }
        }
    }, {
        key: 'fillDown',
        value: function fillDown() {
            var area = this.getSelectionArea();

            for (var trow = area.trowMin + 1; trow <= area.trowMax; trow++) {
                for (var tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                    var value = this.getDataContent(area.trowMin, tcol);
                    this.setDataContent(trow, tcol, value);
                }
            }
        }
    }]);

    return GridEditorBase;
}()) || _class);

/***/ }),

/***/ "./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js":
/*!*******************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js from dll-reference scifeon_vendor ***!
  \*******************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js");

/***/ }),

/***/ "./node_modules/file-saver/FileSaver.js":
/*!******************************************************************************************!*\
  !*** delegated ./node_modules/file-saver/FileSaver.js from dll-reference scifeon_vendor ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/file-saver/FileSaver.js");

/***/ }),

/***/ "element/plate-view":
/*!***********************************!*\
  !*** ./SPA/element/plate-view.ts ***!
  \***********************************/
/*! exports provided: PlateView */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PlateView", function() { return PlateView; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let PlateView = class PlateView {
    constructor() {
        this.rowNames = [];
    }
    bind() {
        this.createGrid();
    }
    nRowsChanged() { this.createGrid(); }
    nColsChanged() { this.createGrid(); }
    wellsChanged() { this.createGrid(); }
    createGrid() {
        if (this.plate) {
            this.nRows = this.plate.nRows;
            this.nCols = this.plate.nCols;
            if (!this.wells)
                this.wells = this.plate.sampleInfo.samples;
        }
        if (this.nRows > this.rowNames.length) {
            this.rowNames = this.rowNames.concat(['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P']);
        }
        if (this.wellTemplate === 'sample') {
            this.wellTemplate = well => `<a href="/#/entity/sample/${well.id}">${well.name}</a>`;
        }
        if (this.wellTemplate === 'layer') {
            this.wellTemplate = well => well.valueText;
        }
        this.columns = [];
        for (let iCol = 0; iCol < this.nCols; iCol++) {
            this.columns.push({ name: iCol + 1 });
        }
        this.grid = [];
        for (let iRow = 0; iRow < this.nRows; iRow++) {
            let row = { name: this.rowNames[iRow], wellInfos: [] };
            this.grid.push(row);
            for (let iCol = 0; iCol < this.nCols; iCol++) {
                row.wellInfos.push({
                    posRow: iRow,
                    posCol: iCol,
                    html: ''
                });
            }
        }
        for (let well of this.wells) {
            let row = this.grid[well.posRow];
            if (!row)
                continue;
            let wellInfo = row.wellInfos[well.posCol];
            if (!wellInfo)
                continue;
            wellInfo.data = well;
            wellInfo.well = well;
            wellInfo.html = this.wellTemplate(well);
        }
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "rowNames", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "wells", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "nRows", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "nCols", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "wellTemplate", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], PlateView.prototype, "plate", void 0);
PlateView = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('plate-view')
], PlateView);



/***/ }),

/***/ "element/plate-view.html":
/*!*************************************!*\
  !*** ./SPA/element/plate-view.html ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <table class=\"plate\">\r\n        <tbody>\r\n            <tr>\r\n                <th></th>\r\n                <th class=\"col-heading\" repeat.for=\"col of columns\">${col.name}</th>\r\n            </tr>\r\n            <tr repeat.for=\"row of grid\">\r\n                <th class=\"row-heading\">${row.name}</th>\r\n                <td repeat.for=\"wellInfo of row.wellInfos\"\r\n                    innerHtml.bind=\"wellInfo.html\"\r\n                    class=\"well\"\r\n                    css.bind=\"wellInfo.well.css\"></td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=elements~protected.7d2e17d8ae74be98b4b6.js.map