(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["eln"],{

/***/ "./SPA/module/eln/data/eln-cache.ts":
/*!******************************************!*\
  !*** ./SPA/module/eln/data/eln-cache.ts ***!
  \******************************************/
/*! exports provided: ELNCache */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNCache", function() { return ELNCache; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _eln_info__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./eln-info */ "./SPA/module/eln/data/eln-info.ts");


class ELNCache {
    static getElnInfo(server, experimentID) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let elnInfo = ELNCache.elnInfos.find(ei => ei.experiment.id === experimentID);
            if (elnInfo)
                yield elnInfo.refresh();
            else
                elnInfo = yield ELNCache.loadElnInfo(server, experimentID);
            return elnInfo;
        });
    }
    static loadElnInfo(server, experimentID) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const elnInfo = new _eln_info__WEBPACK_IMPORTED_MODULE_1__["ELNInfo"](server, experimentID);
            yield elnInfo.refresh();
            return elnInfo;
        });
    }
}
ELNCache.elnInfos = [];


/***/ }),

/***/ "./SPA/module/eln/data/eln-info.ts":
/*!*****************************************!*\
  !*** ./SPA/module/eln/data/eln-info.ts ***!
  \*****************************************/
/*! exports provided: ELNInfo */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNInfo", function() { return ELNInfo; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");


class ELNInfo {
    constructor(server, experimentID) {
        this.server = server;
        this.experimentID = experimentID;
        this.loading = {
            experiment: true,
            steps: true,
            notes: true,
            plates: true,
            all: true
        };
        this.experiment = {};
    }
    refresh() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading.experiment = true;
            this.loading.steps = true;
            this.loading.all = true;
            this.loading.plates = true;
            yield this.loadExperiment();
            this.loading.experiment = false;
            this.loadStepsAndResultSets()
                .then(() => this.loading.all = false);
        });
    }
    loadStepsAndResultSets() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const stepsDataset = yield this.server.datasetQuery([
                { eClass: 'Step', collection: 'steps', filters: [{ field: 'ExperimentID', value: this.experiment.id }], sortings: [{ field: 'id' }] },
                { eClass: 'Note', collection: 'notes', filters: [{ field: 'SubjectID', in: 'steps.ID' }, { field: 'SubjectClass', value: 'Step' }] },
                { eClass: 'ResultSet', collection: 'resultSets', filters: [{ field: 'OriginID', in: 'steps.ID' }], sortings: [{ field: 'id' }], include: ['files'] }
            ]);
            this.loading.steps = false;
            this.stepInfos = stepsDataset.steps.map(step => ({
                allDetailsLoaded: false,
                step: step,
                experiment: this.experiment,
                editable: this.editable,
                notes: stepsDataset.notes.filter(c => c.subjectID === step.id && c.type === 'Note'),
                noteProtocol: stepsDataset.notes.find(c => c.subjectID === step.id && c.type === 'Protocol'),
                noteSetup: stepsDataset.notes.find(n => n.subjectID === step.id && n.type === 'Setup'),
                resultSets: stepsDataset.resultSets.filter(rs => rs.originID === step.id)
            }));
            this.rsInfos = stepsDataset.resultSets.map(rs => ({
                rs: rs,
                files: rs.files
            }));
            const extraDataset = yield this.server.datasetQuery([
                { view: 'StepSampleInput', collection: 'inputs', filters: [{ field: 'StepID', values: this.stepInfos.map(si => si.step.id) }] },
                { view: 'StepProduct', collection: 'outputs', filters: [{ field: 'OriginID', values: this.stepInfos.map(si => si.step.id) }] },
                { eClass: 'Plate', collection: 'plates', filters: [{ field: 'OriginID', values: this.stepInfos.map(si => si.step.id) }] },
                { eClass: 'Request', collection: 'requests', filters: [{ field: 'ID', in: 'inputs.RequestID' }] }
            ]);
            this.requestInfos = extraDataset.requests.map(r => { return { request: r }; });
            this.plates = extraDataset.plates;
            for (const stepInfo of this.stepInfos) {
                if (!stepInfo.noteProtocol) {
                    stepInfo.noteProtocol = {
                        type: 'Protocol',
                        subjectID: stepInfo.step.id,
                        subjectClass: 'Step',
                        content: '',
                        eClass: 'Note'
                    };
                }
                if (!stepInfo.noteSetup) {
                    stepInfo.noteSetup = {
                        type: 'Setup',
                        subjectID: stepInfo.step.id,
                        subjectClass: 'Step',
                        content: '',
                        eClass: 'Note'
                    };
                }
                stepInfo.input = extraDataset.inputs.filter(i => i.stepID === stepInfo.step.id);
                stepInfo.output = extraDataset.outputs.filter(o => o.originID === stepInfo.step.id);
                stepInfo.plates = extraDataset.plates.filter(p => p.originID === stepInfo.step.id);
                stepInfo.allDetailsLoaded = true;
            }
            this.loading.plates = false;
        });
    }
    loadExperiment() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const experiment = yield this.server.getEntity('Experiment', this.experimentID);
            this.experiment = Object.assign(this.experiment, experiment);
            this.entity = this.experiment;
            this.editable = this.experiment.accessType === 'Write' && [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].IN_PROGRESS, _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].PLANNED, _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].INITIAL].includes(this.experiment.status);
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Note', collection: 'notes', filters: [{ field: 'SubjectID', value: this.experimentID }, { field: 'SubjectClass', value: 'Experiment' }], sortings: [{ field: 'createdUtc' }] },
                { eClass: 'Approval', collection: 'approvals', filters: [{ field: 'ExperimentID', value: this.experimentID }] },
                { view: 'ApprovalDocInfo', collection: 'approvalDocs', filters: [{ field: 'ApprovalID', in: 'approvals.ID' }] }
            ]);
            this.files = experiment.files;
            this.notes = dataset.notes.filter(c => c.type !== 'Abstract' && c.type !== 'Conclusion');
            this.conclusions = dataset.notes.filter(c => c.type === 'Conclusion');
            this.abstract = dataset.notes.find(c => c.type === 'Abstract');
            if (!this.abstract) {
                this.abstract = {
                    type: 'Abstract',
                    subjectID: this.experiment.id,
                    subjectClass: 'Experiment',
                    content: '',
                    eClass: 'Note'
                };
            }
            this.approvalInfos = dataset.approvals.map(a => ({
                approval: a,
                docs: dataset.approvalDocs.filter(ad => ad.approvalID === a.id)
            }));
        });
    }
}


/***/ }),

/***/ "./node_modules/treant-js/Treant.js":
/*!**************************************************************************************!*\
  !*** delegated ./node_modules/treant-js/Treant.js from dll-reference scifeon_vendor ***!
  \**************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/treant-js/Treant.js");

/***/ }),

/***/ "module/eln/index":
/*!**********************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/eln/index.ts ***!
  \**********************************************************************/
/*! exports provided: ELN */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELN", function() { return ELN; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-event-aggregator */ "aurelia-event-aggregator");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _data_eln_cache__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./data/eln-cache */ "./SPA/module/eln/data/eln-cache.ts");






let ELN = class ELN {
    constructor(server, ea) {
        this.server = server;
        this.ea = ea;
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.experimentID = params.id;
            const reload = !!this.elnInfo;
            if (reload) {
                yield this.attached();
            }
        });
    }
    determineActivationStrategy() {
        return aurelia_router__WEBPACK_IMPORTED_MODULE_4__["activationStrategy"].replace;
    }
    detached() {
        if (this.refreshSubscriber) {
            this.refreshSubscriber.dispose();
        }
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.elnInfo = yield _data_eln_cache__WEBPACK_IMPORTED_MODULE_5__["ELNCache"].getElnInfo(this.server, this.experimentID);
            if (!this.refreshSubscriber) {
                this.refreshSubscriber = this.ea.subscribe(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Event"].ELN.RELOAD, () => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                    yield this.elnInfo.refresh();
                    _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
                }));
            }
        });
    }
};
ELN = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_2__["EventAggregator"]])
], ELN);



/***/ }),

/***/ "module/eln/index.html":
/*!***********************************!*\
  !*** ./SPA/module/eln/index.html ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"entity/sidebar\"></require>\r\n    <require from=\"element/attributes\"></require>\r\n    <require from=\"./panels/eln-header\"></require>\r\n    <require from=\"./panels/eln-hierarchy\"></require>\r\n    <require from=\"./panels/eln-step-list\"></require>\r\n\r\n    <div class=\"page-with-sidebar\">\r\n        <sidebar context.bind=\"elnInfo\"></sidebar>\r\n        \r\n        <div class=\"content eln\">\r\n            <div class=\"detail-panels\">\r\n                <eln-header if.bind=\"elnInfo && !elnInfo.loading.experiment\" eln-info.bind=\"elnInfo\"></eln-header>\r\n\r\n                <eln-hierarchy if.bind=\"elnInfo && !elnInfo.loading.steps\" eln-info.bind=\"elnInfo\"></eln-hierarchy>\r\n                <eln-step-list if.bind=\"elnInfo && !elnInfo.loading.steps\" eln-info.bind=\"elnInfo\"></eln-step-list>\r\n                <div class=\"loading loading-lg full-width\" else></div>                \r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/pages/add-step":
/*!*******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/eln/pages/add-step.ts ***!
  \*******************************************************************************/
/*! exports provided: AddStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AddStep", function() { return AddStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_data__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/data */ "./packages/data/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/data-upload/file-processor */ "./SPA/module/data-upload/file-processor.ts");
/* harmony import */ var _data_eln_cache__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../data/eln-cache */ "./SPA/module/eln/data/eln-cache.ts");








let AddStep = class AddStep {
    constructor(fileProcessor, dialog, server, workflowBuilder, router, user, bindingEngine) {
        this.fileProcessor = fileProcessor;
        this.dialog = dialog;
        this.server = server;
        this.workflowBuilder = workflowBuilder;
        this.router = router;
        this.user = user;
        this.bindingEngine = bindingEngine;
        this.loading = false;
        this.dsInput = { plates: [], samples: [] };
        this.builders = [
            { label: 'Generic', name: 'Generic', inputMode: 'Any' },
            { label: 'Samples-to-Samples', name: 'Samples2Samples', inputMode: 'Samples' },
            { label: 'Samples-to-Plates', name: 'Samples2Plates', inputMode: 'Samples' },
            { label: 'Plates-to-Plates', name: 'Plates2Plates', inputMode: 'Plates' },
            { label: 'Plates-to-Plates Direct', name: 'Plates2PlatesDirect', inputMode: 'Plates' }
        ];
        this.initializeIMTemplate();
        this.selectedBuilder = this.builders[2];
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.elnInfo = yield _data_eln_cache__WEBPACK_IMPORTED_MODULE_7__["ELNCache"].getElnInfo(this.server, params.experimentID);
            if (this.elnInfo.loading.all) {
                this.bindingEngine.propertyObserver(this.elnInfo.loading, 'all').subscribe(() => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () { return yield this.initData(params.parentID); }));
            }
            else {
                yield this.initData(params.parentID);
            }
        });
    }
    initData(parentID) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let expName = this.elnInfo.experiment.name;
            if (expName.startsWith('EXP-'))
                expName = expName.substring(4);
            if (expName.startsWith('EX'))
                expName = expName.substring(2);
            const suggestedName = `Step-${expName}-${this.elnInfo.stepInfos.length + 1}`;
            this.step = {
                eClass: 'Step',
                id: '#idStep0',
                name: suggestedName,
                type: "Other",
                status: 'Initial',
                parentID: parentID,
                experimentID: this.elnInfo.experiment.id,
                userID: this.user.id
            };
            yield this.loadTemplates();
            if (parentID) {
                this.parentStepInfo = this.elnInfo.stepInfos.find(si => si.step.id === parentID);
                this.checkParentOutput();
            }
        });
    }
    checkParentOutput() {
        if (this.parentStepInfo.output.length < 1) {
            this.useParentOutput = false;
            return;
        }
        this.useParentOutput = true;
        this.parentPlates = this.parentStepInfo.output.filter(e => e.eClass === 'Plate');
        this.parentSamples = this.parentStepInfo.output.filter(e => e.eClass === 'Sample');
    }
    addStep() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.refreshOutput();
            const response = yield this.server.saveEntities(this.dsOutput.entities);
            this.router.navigate(`eln/${this.elnInfo.experiment.id}`);
        });
    }
    builderChange() {
    }
    loadTemplates() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let ds = yield this.server.datasetQuery([
                { eClass: 'Template', collection: 'templates', filters: [{ field: 'Type', value: 'Step' }] }
            ]);
            this.templates = ds.templates;
        });
    }
    useTemplate() {
        this.template.content = JSON.parse(JSON.stringify(this.selectedTemplate.content));
        if (this.template.content.builder) {
            this.selectedBuilder = this.builders.find(b => b.name === this.template.content.builder);
            this.builderChange();
        }
    }
    changeUseParentOutput() {
        let vm = this.inputSamplesEditor.au["input-samples-list"].viewModel;
        if (this.useParentOutput) {
            vm.addSamples(this.parentSamples);
        }
        else {
            vm.removeSamples(this.parentSamples);
        }
    }
    refreshOutput() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dsOut = yield this.workflowBuilder.execute({ targets: [this.template] }, this.dsInput, {
                experimentID: this.elnInfo.experiment.id,
                step: this.step
            });
            this.dsOutput = dsOut;
            this.dsOutput.plates = dsOut.entities.filter(e => e.eClass === 'Plate');
            this.dsOutput.samples = dsOut.entities.filter(e => e.eClass === 'Sample');
        });
    }
    initializeIMTemplate() {
        this.dsInput = {
            plates: [],
            samples: [
                { eClass: 'Sample', name: 'SMP01' },
                { eClass: 'Sample', name: 'SMP02' },
                { eClass: 'Sample', name: 'SMP03' },
                { eClass: 'Sample', name: 'SMP04' },
                { eClass: 'Sample', name: 'SMP05' }
            ]
        };
        this.template = {
            key: 'step',
            eClass: 'Template',
            type: 'Step',
            name: 'InMemory',
            content: {
                builder: 'Samples2Plates',
                entityValues: {
                    type: 'Other',
                    name: 'Infection-${expName}',
                },
                plates: [
                    {
                        entityValues: {
                            name: 'Infection',
                            type: 'FACS-Culture'
                        },
                        nRows: 3,
                        nCols: 4,
                        layout: {
                            wells: [
                                { posRow: 0, posCol: 0, valueText: 'T-1', attributes: { iDilution: 5 } },
                                { posRow: 0, posCol: 1, valueText: 'T-1', attributes: { iDilution: 4 } },
                                { posRow: 0, posCol: 2, valueText: 'T-1', attributes: { iDilution: 3 } },
                                { posRow: 0, posCol: 3, valueText: 'T-1', attributes: { iDilution: 2 } },
                                { posRow: 1, posCol: 0, valueText: 'T-1', attributes: { iDilution: 1 } },
                                { posRow: 1, posCol: 1, valueText: 'T-1', attributes: { iDilution: 0 } },
                                { posRow: 1, posCol: 2, valueText: 'T-2', attributes: { iDilution: 5 } },
                                { posRow: 1, posCol: 3, valueText: 'T-2', attributes: { iDilution: 4 } },
                                { posRow: 2, posCol: 0, valueText: 'T-2', attributes: { iDilution: 3 } },
                                { posRow: 2, posCol: 1, valueText: 'T-2', attributes: { iDilution: 2 } },
                                { posRow: 2, posCol: 2, valueText: 'T-2', attributes: { iDilution: 1 } },
                                { posRow: 2, posCol: 3, valueText: 'T-2', attributes: { iDilution: 0 } },
                            ]
                        }
                    }
                ]
            }
        };
    }
    filesDropped(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            alert('NOT SUPPORTED, YET');
        });
    }
    dropped(e) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            let context = {};
            let dataUploadInfo = yield this.fileProcessor.preprocessFiles(e.detail.files, context);
            yield dataUploadInfo.selectedPlugin.readFiles();
            const result = yield dataUploadInfo.selectedPlugin.getResult();
            if (result && result.entities) {
            }
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
};
AddStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_6__["FileProcessor"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        _scifeon_data__WEBPACK_IMPORTED_MODULE_2__["WorkflowBuilder"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["BindingEngine"]])
], AddStep);



/***/ }),

/***/ "module/eln/pages/add-step.html":
/*!********************************************!*\
  !*** ./SPA/module/eln/pages/add-step.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/grid/plate-editor\"></require>\r\n    <require from=\"element/grid/sample-plates-editor\"></require>\r\n    <require from=\"../panels/input-samples-list\"></require>\r\n\r\n    <style>\r\n        ux-dialog-body {\r\n            width: 1100px;\r\n            display: flex;\r\n        }\r\n\r\n        .dialog-header-content {\r\n            display: flex;\r\n        }\r\n\r\n        .dialog-header-content button {\r\n            margin-left: 10px;\r\n        }\r\n\r\n        div.addstep-header {\r\n            padding: 10px;\r\n            border-bottom: 1px solid #666;\r\n            display: flex;\r\n        }\r\n\r\n        div.addstep-content {\r\n            padding: 10px;\r\n        }\r\n\r\n        .mode-selector {\r\n            margin: 0 50px 10px 0;\r\n        }\r\n\r\n        .addstep-header .form-group {\r\n            margin: 5px 10px 0 0;\r\n        }\r\n    </style>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Add Step</h1>\r\n            <button class=\"primary\" click.delegate=\"addStep()\">Add Step</button>\r\n            <button>Save as Template</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <div class=\"view-group\">\r\n                        <label>Experiment</label>\r\n                        <a href=\"/#/eln/${elnInfo.experiment.id}\">${elnInfo.experiment.name}</a>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Type</label>\r\n                        <p>${elnInfo.experiment.type}</p>\r\n                    </div>\r\n\r\n                    <div if.bind=\"parentStepInfo\">\r\n                        <hr/>\r\n                        <div class=\"view-group\">\r\n                            <label>Parent Step</label>\r\n                            <p>${parentStepInfo.step.name}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Type</label>\r\n                            <p>${parentStepInfo.step.type}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Parent Output</label>\r\n                            <table>\r\n                                <tbody>\r\n                                    <tr><th>Plates</th><td>${parentPlates.length}</td></tr>\r\n                                    <tr><th>Samples</th><td>${parentSamples.length}</td></tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <input type=\"checkbox\" checked.bind=\"useParentOutput\" change.delegate=\"changeUseParentOutput()\"/>\r\n                            Use parent output\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div class=\"panel\" style=\"grid-column: span 3\">\r\n                <div class=\"panel-body\" style=\"display: flex\">\r\n                    <div>\r\n                        <div class=\"form-group\">\r\n                            <label>Step Name</label>\r\n                            <input value.bind=\"step.name\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Step Type</label>\r\n                            <input value.bind=\"step.type\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Step Builder</label>\r\n                            <select value.bind=\"selectedBuilder\">\r\n                                <option repeat.for=\"builder of builders\" model.bind=\"builder\">${builder.label}</option>\r\n                            </select>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div style=\"margin-left: 25px\">\r\n                        <h3>Load a template:</h3>\r\n                        <div class=\"form-group\">\r\n                            <label>Template</label>\r\n                            <select size=\"5\" class=\"listbox\" style=\"height: 100px;\" value.bind=\"selectedTemplate\">\r\n                                <option repeat.for=\"template of templates\" model.bind=\"template\">${template.name}</option>\r\n                            </select>\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <button click.delegate=\"useTemplate()\">Load Template</button>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div style=\"margin-left: 25px\">\r\n                        <h3>Import a File</h3>\r\n                        <dropzone dropfiles.trigger=\"dropped($event)\" title=\"Drop File Here\" style=\"height: 100%\"></dropzone>\r\n                        <ul>\r\n                            <li>TXT files => protocol</li>\r\n                            <li>CSV files => sample list / plate list</li>\r\n                            <li>Excel files => template, samples, complete step def</li>\r\n                        </ul>\r\n                    </div>\r\n                </div>\r\n\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 4\">\r\n                <div class=\"panel-heading\">Protocol <collapsible/></div>\r\n                <div class=\"panel-body\" style=\"padding: 0\">\r\n                    <rich-text-editor style=\"border:0;\" value.bind=\"template.content.protocolText\"></rich-text-editor>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">Step Input: ${selectedBuilder.inputMode} <collapsible/></div>\r\n                <div class=\"panel-body\">\r\n                    <template if.bind=\"selectedBuilder.inputMode === 'Samples'\" containerless>\r\n                        <div class=\"form-group\">\r\n                            <input type=\"checkbox\" checked.bind=\"useParentOutput\" change.delegate=\"changeUseParentOutput()\">\r\n                            <span>Include output from parent step as input</span>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <button class=\"small\">Add Plates</button>\r\n                            <button class=\"small\">Add Samples</button>\r\n                            <button class=\"small\">Add New Samples</button>\r\n                        </div>\r\n\r\n                        <h3>Samples</h3>\r\n                        <input-samples-list samples.bind=\"dsInput.samples\" ref=\"inputSamplesEditor\"></input-samples-list>\r\n\r\n                        <h3>Plates</h3>\r\n                        <table>\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>ID</th>\r\n                                    <th>Name</th>\r\n                                    <th>Type</th>\r\n                                    <th>Lineage</th>\r\n                                    <th>Description</th>\r\n                                    <th>Filled Wells</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"p of dsInput.plates\">\r\n                                    <td><a href=\"/#/entity/plate/${p.id}\">${p.name}</a></td>\r\n                                    <td>${p.type}</td>\r\n                                    <td>${p.lineage}</td>\r\n                                    <td>${p.description}</td>\r\n                                    <td>${p.content.wells.length}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </template>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">Step Output<collapsible/></div>\r\n                <div class=\"panel-body\">\r\n                    <p>\r\n                        <button class=\"small\" click.delegate=\"refreshOutput()\">Refresh</button>\r\n                    </p>\r\n                    <template repeat.for=\"plate of dsOutput.plates\">\r\n                        <h3>Plate: ${plate.name}</h3>\r\n                    </template>\r\n\r\n                    <!--                    <p>Samples:</p>\r\n                    <ul>\r\n                        <li repeat.for=\"sample of dsOutput.samples\">${sample.id}: ${sample.name}</li>\r\n                    </ul>\r\n    -->\r\n                </div>\r\n            </div>\r\n    \r\n            <div class=\"panel full-width\">\r\n                <div class=\"panel-heading\">Operations <collapsible/></div>\r\n                <div class=\"panel-body\">\r\n                    <div if.bind=\"selectedBuilder.name === 'Generic'\">\r\n                        (no operation)\r\n                    </div>\r\n\r\n                    <div if.bind=\"selectedBuilder.name === 'Samples2Samples'\">\r\n                        <h3>Samples to Samples</h3>\r\n                    </div>\r\n\r\n                    <div if.bind=\"selectedBuilder.name === 'Samples2Plates'\">\r\n                        <div class=\"form-group\">\r\n                            <label>Plate Format</label>\r\n                            <select value.bind=\"plateFormat\" style=\"width: 125px;\">\r\n                                <option>12 Wells</option>\r\n                                <option>24 Wells</option>\r\n                                <option>48 Wells</option>\r\n                                <option>96 Wells</option>\r\n                                <option>384 Wells</option>\r\n                                <option>1536 Wells</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <input type=\"checkbox\" checked.bind=\"isArrayPlate\">\r\n                            <span>Assay plate</span>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Layer: Sample Positions</label>\r\n                            <sample-plates-editor n-rows.bind=\"template.content.plates[0].nRows\"\r\n                                n-cols.bind=\"template.content.plates[0].nCols\"\r\n                                wells.bind=\"template.content.plates[0].layout.wells\"\r\n                                field-name=\"valueText\"></sample-plates-editor>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <button>Add Layer</button>\r\n                            <p>Provide suggestions: Concentration, pH, ...</p>\r\n                            <p>Popup: Specify type and value-type (text, number)</p>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div if.bind=\"selectedBuilder.name === 'Plates2Plates'\">\r\n                        <h3>Plates to Plates</h3>\r\n                    </div>\r\n\r\n                    <div if.bind=\"selectedBuilder.name === 'Plates2PlatesDirect'\">\r\n                        <h3>Plates to Plates Direct</h3>\r\n                    </div>\r\n\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/pages/edit-step-template":
/*!*****************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/eln/pages/edit-step-template.ts ***!
  \*****************************************************************************************/
/*! exports provided: EditStepTemplate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditStepTemplate", function() { return EditStepTemplate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);




let EditStepTemplate = class EditStepTemplate {
    constructor(server, router) {
        this.server = server;
        this.router = router;
        this.template = {
            eClass: 'Template',
            name: '',
            type: 'Step',
            content: {
                builder: 'Generic',
                entityValues: {},
            }
        };
    }
    save() {
        this.server.saveEntities([this.template])
            .then(response => {
            this.router.navigate('entity/template/' + response.newEntities[0].id);
        });
    }
};
EditStepTemplate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"]])
], EditStepTemplate);



/***/ }),

/***/ "module/eln/pages/edit-step-template.html":
/*!******************************************************!*\
  !*** ./SPA/module/eln/pages/edit-step-template.html ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Create Step Template</h1>\r\n            <button class=\"primary\" click.delegate=\"save()\">Save</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Template</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\">\r\n                        <label>Template Name</label>\r\n                        <input value.bind=\"template.name\"/>\r\n                    </div>\r\n\r\n                    <div class=\"form-group\">\r\n                        <label>Step Name</label>\r\n                        <input value.bind=\"template.content.entityValues.name\"/>\r\n                    </div>\r\n\r\n                    <div class=\"form-group\">\r\n                        <label>Step Type</label>\r\n                        <input value.bind=\"template.content.entityValue.type\"/>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Protocol</div>\r\n                <div class=\"panel-body\">\r\n                    <rich-text-editor value.bind=\"template.content.protocolText\"></rich-text-editor>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>>\r\n</template>";

/***/ }),

/***/ "module/eln/pages/step-setup":
/*!*********************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/eln/pages/step-setup.ts ***!
  \*********************************************************************************/
/*! exports provided: StepSetupSummary */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StepSetupSummary", function() { return StepSetupSummary; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let StepSetupSummary = class StepSetupSummary {
    constructor(server) {
        this.server = server;
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let ds = yield this.server.datasetQuery([
                { eClass: 'Step', alias: 'step', filters: [{ field: 'ID', value: params.id }] },
                { eClass: 'Experiment', alias: 'exp', filters: [{ field: 'ID', value: '$step.ExperimentID' }] },
                { view: 'StepSampleInput', collection: 'samples', filters: [{ field: 'StepID', value: params.id }] }
            ]);
            this.step = ds.step;
            this.exp = ds.exp;
            this.samples = ds.samples.sort((a, b) => a.sortIndex > b.sortIndex ? 1 : -1);
        });
    }
};
StepSetupSummary = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], StepSetupSummary);



/***/ }),

/***/ "module/eln/pages/step-setup.html":
/*!**********************************************!*\
  !*** ./SPA/module/eln/pages/step-setup.html ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <div class=\"page-panels grid\">\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-heading\">Step: ${step.name}</div>\r\n            <div class=\"panel-body\">\r\n                <div class=\"horz-view-groups\">\r\n                    <div class=\"view-group\">\r\n                        <label>Experiment</label>\r\n                        <p>\r\n                            <a href=\"/#/eln/${exp.id}\">${exp.name}</a>\r\n                        </p>\r\n                    </div>\r\n\r\n                    <div class=\"view-group\">\r\n                        <label>Step Type</label>\r\n                        <p>${step.type}</p>\r\n                    </div>\r\n\r\n                    <div class=\"view-group\">\r\n                        <label>Analyst</label>\r\n                        <p>${step.analystID}</p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-heading\">Step Input</div>\r\n            <div class=\"panel-body\">\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th>Position</th>\r\n                            <th>Sample</th>\r\n                            <th>External ID</th>\r\n                            <th>Type</th>\r\n                            <th>Description</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\">\r\n                            <td>${sample.sortIndex}</td>\r\n                            <td>${sample.name}</td>\r\n                            <td>${sample.externalID}</td>\r\n                            <td>${sample.type}</td>\r\n                            <td>${sample.description}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "module/eln/panels/eln-header":
/*!*********************************************!*\
  !*** ./SPA/module/eln/panels/eln-header.ts ***!
  \*********************************************/
/*! exports provided: ELNHeader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNHeader", function() { return ELNHeader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _data_eln_info__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../data/eln-info */ "./SPA/module/eln/data/eln-info.ts");




let ELNHeader = class ELNHeader {
    constructor(server) {
        this.server = server;
        this.newConclusion = {
            title: null,
            content: null
        };
    }
    initNewConclusion() {
        this.newConclusion.title = '';
        this.newConclusion.content = '';
    }
    saveNewConclusion() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const newConclusionObject = {
                eClass: 'Note',
                type: 'Conclusion',
                content: this.newConclusion.content,
                description: this.newConclusion.title,
                subjectClass: 'Experiment',
                subjectID: this.elnInfo.experiment.id,
            };
            const response = yield this.server.saveEntities([newConclusionObject]);
            this.elnInfo.conclusions.push(response.newEntities.find(e => e.eClass === 'Note'));
            this.resetNewConclusion();
        });
    }
    resetNewConclusion() {
        this.newConclusion.title = null;
        this.newConclusion.content = null;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", _data_eln_info__WEBPACK_IMPORTED_MODULE_3__["ELNInfo"])
], ELNHeader.prototype, "elnInfo", void 0);
ELNHeader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('eln-header'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], ELNHeader);



/***/ }),

/***/ "module/eln/panels/eln-header.html":
/*!***********************************************!*\
  !*** ./SPA/module/eln/panels/eln-header.html ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/attributes\"></require>\r\n    \r\n    <div class=\"panel full-width\">\r\n        <div class=\"panel-body\">\r\n            <div class=\"title\">\r\n                <inplace-edit-text entity.bind=\"elnInfo.experiment\" key=\"description\" editable.bind=\"elnInfo.editable\" placeholder=\"(title)\"></inplace-edit-text>\r\n            </div>\r\n            <div class=\"inline-group\">\r\n                <label>Abstract</label>\r\n                <inplace-edit-textarea entity.bind=\"elnInfo.abstract\" key=\"content\" editable.bind=\"elnInfo.editable\"></inplace-edit-textarea>\r\n            </div>\r\n            <div class=\"inline-group\">\r\n                <label show.bind=\"conclusions && !elnInfo.conclusions.length\">Conclusions</label>\r\n                <div class=\"no-content\" show.bind=\"conclusions && !elnInfo.conclusions.length\">No conclusions.</div>\r\n                <div class=\"inline-group\" repeat.for=\"conclusion of elnInfo.conclusions\">\r\n                    <label>Conclusion ${index}:\r\n                        <inplace-edit-text inline-style=\"true\" entity.bind=\"conclusion\" key=\"description\"\r\n                            placeholder=\"Title empty. Click to edit.\"></inplace-edit-text>\r\n                    </label>\r\n                    <inplace-edit-textarea entity.bind=\"conclusion\" key=\"content\"></inplace-edit-textarea>\r\n                </div>\r\n                <div if.bind=\"newConclusion.content !== null\">\r\n                    <input value.bind=\"newConclusion.title\" type=\"text\" placeholder=\"Conclusion title\" style=\"margin-bottom: 5px;\" />\r\n                    <rich-text-editor value.bind=\"newConclusion.content\" placeholder=\"Conclusion...\" focus-immediately.bind=\"true\"></rich-text-editor>\r\n                    <div class=\"float-right btn-group\" style=\"margin-top: 5px;\">\r\n                        <button class=\"small\" click.delegate=\"saveNewConclusion()\">Save</button>\r\n                        <button class=\"small secondary\" click.delegate=\"resetNewConclusion()\">Cancel</button>\r\n                    </div>\r\n                </div>\r\n                <button if.bind=\"elnInfo.editable\" show.bind=\"newConclusion.content === null\" class=\"small\" click.delegate=\"initNewConclusion()\"\r\n                    style=\"margin-top: 10px;\">Add conclusion</button>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div class=\"panel experiment-info full-width\">\r\n        <div class=\"panel-heading\">\r\n            <span>Experiment Info</span>\r\n            <collapsible default=\"collapsed\" />\r\n        </div>\r\n        <div class=\"panel-body\">\r\n            <attributes entity.bind=\"elnInfo.experiment\"></attributes>\r\n            <h3>Setup</h3>\r\n            <attributes kvp.bind=\"elnInfo.experiment.setup\"></attributes>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/panels/eln-hierarchy":
/*!************************************************!*\
  !*** ./SPA/module/eln/panels/eln-hierarchy.ts ***!
  \************************************************/
/*! exports provided: ELNHierarchy */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(Promise) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNHierarchy", function() { return ELNHierarchy; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var treant_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! treant-js */ "./node_modules/treant-js/Treant.js");
/* harmony import */ var treant_js__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(treant_js__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _data_eln_info__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../data/eln-info */ "./SPA/module/eln/data/eln-info.ts");






let ELNHierarchy = class ELNHierarchy {
    constructor(router, queue, server, bindingEngine) {
        this.router = router;
        this.queue = queue;
        this.server = server;
        this.bindingEngine = bindingEngine;
        this.stepHierarchyLoading = true;
        this.maxRow = 0;
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].getLogger('ELN-Hierarchy');
    }
    attached() {
        this.createStepHierarchyDiagram();
        this.bindingEngine.propertyObserver(this.elnInfo.loading, 'steps').subscribe(() => this.createStepHierarchyDiagram());
    }
    createStepHierarchyDiagram() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.stepHierarchy)
                return;
            this.logger.debug('Loading step hierarchy');
            this.stepHierarchyLoading = true;
            this.stepHierarchy.innerHTML = '';
            let config = {
                container: '#stepHierarchy',
                rootOrientation: 'WEST',
                connectors: {
                    type: "step",
                    style: {
                        "stroke-width": 2,
                        "stroke": "#ccc",
                        "arrow-end": 'classic-wide-long'
                    }
                },
                siblingSeparation: 15
            };
            const rootNode = yield this.buildStepHierarchy();
            let treeSetup = {
                chart: config,
                nodeStructure: rootNode
            };
            const height = this.maxRow * 80 + 80;
            if (!this.stepHierarchy)
                return;
            this.stepHierarchy.style.height = height + 'px';
            this.queue.queueMicroTask(() => {
                if (!this.stepHierarchy)
                    return;
                const chart = new treant_js__WEBPACK_IMPORTED_MODULE_4__["Treant"](treeSetup);
                this.stepHierarchyLoading = false;
                const addStepLinks = this.stepHierarchy.getElementsByClassName('add-step');
                for (let i = 0; i < addStepLinks.length; i++) {
                    const stepLink = addStepLinks.item(i);
                    let parentID = stepLink.getAttribute('data-parent-id');
                    stepLink.addEventListener('click', event => this.router.navigate(`eln/add-step?experimentID=${this.elnInfo.experiment.id}&parentID=${parentID}`));
                }
                const scrollToStepLinks = this.stepHierarchy.getElementsByClassName('step-node');
                for (let i = 0; i < scrollToStepLinks.length; i++) {
                    const stepLink = scrollToStepLinks.item(i);
                    let stepID = stepLink.getAttribute('data-step-id');
                    stepLink.addEventListener('click', event => this.scrollToStep(this.elnInfo.stepInfos.map(si => si.step).find(s => s.id === stepID)));
                }
            });
        });
    }
    scrollToStep(step) {
        this.queue.queueMicroTask(() => {
            const element = document.getElementById('Step-' + step.id);
            if (!element)
                return;
            element.style.transition = '';
            element.style.backgroundColor = '#aaa';
            if (element.classList.contains('collapsed')) {
                const collapseIcon = element.getElementsByClassName('collapsible-icon')[0];
                collapseIcon.click();
            }
            element.scrollIntoView();
            this.queue.queueMicroTask(() => {
                element.style.transition = 'background-color 7s';
                element.style.backgroundColor = 'white';
            });
        });
    }
    addNodes(rootNode, childNodes) {
        if (childNodes.length > this.maxRow) {
            this.maxRow = childNodes.length;
        }
        rootNode.children = [];
        childNodes.forEach(node => {
            const step = {
                innerHTML: `<div class="step-node" data-step-id="${node.id}">
                    <p class="node-name"><a href="/#/entity/step/${node.id}">${node.name}</a></p>
                    <p class="node-title">${node.status}</p>`
                    + (this.elnInfo.experiment.editable ? `<a class="add-step tooltip tooltip-right hide-in-print" data-parent-id="${node.id}" data-tooltip="Create child step"><div class="fa fa-plus-circle"></div></a>` : '') +
                    `</div>`,
                HTMLclass: 'status-' + node.status,
                children: []
            };
            rootNode.children.push(step);
            this.addNodes(step, node.childNodes);
        });
    }
    buildStepHierarchy() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const rootNode = {
                innerHTML: `<div class="exp-node">
                <p class="node-name">Experiment</p>
                <p class="node-desc">${this.elnInfo.experiment.name}</p>`
                    + (this.elnInfo.experiment.editable ? `<a class="add-step tooltip tooltip-right hide-in-print" data-tooltip="Create step"><div class="fa fa-plus-circle"></div></a>` : '') +
                    `</div>`,
                HTMLclass: 'root',
                children: []
            };
            if (this.elnInfo.stepInfos) {
                const rootSteps = this.elnInfo.stepInfos.filter(si => si.step.parentID === null).map(si => si.step);
                this.maxRow = rootSteps.length;
                const steps = yield Promise.all(rootSteps.map((step) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                    const response = yield this.server.getJson('/api/query/hierarchy/Step/' + step.id);
                    return response.children;
                })));
                this.addNodes(rootNode, steps);
                return rootNode;
            }
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", _data_eln_info__WEBPACK_IMPORTED_MODULE_5__["ELNInfo"])
], ELNHierarchy.prototype, "elnInfo", void 0);
ELNHierarchy = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('eln-hierarchy'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["TaskQueue"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["BindingEngine"]])
], ELNHierarchy);


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ }),

/***/ "module/eln/panels/eln-hierarchy.html":
/*!**************************************************!*\
  !*** ./SPA/module/eln/panels/eln-hierarchy.html ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel hide-in-print full-width\">\r\n        <div class=\"panel-heading\">Steps</div>\r\n        <div class=\"panel-body\">\r\n            <div class=\"loading\" if.bind=\"stepHierarchyLoading\">\r\n                <br />\r\n            </div>\r\n            <div id=\"stepHierarchy\" ref=\"stepHierarchy\"></div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/panels/eln-step":
/*!*******************************************!*\
  !*** ./SPA/module/eln/panels/eln-step.ts ***!
  \*******************************************/
/*! exports provided: ELNStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNStep", function() { return ELNStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-event-aggregator */ "aurelia-event-aggregator");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");
/* harmony import */ var _popups_add_resultset_popup__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../popups/add-resultset-popup */ "module/eln/popups/add-resultset-popup");









let ELNStep = class ELNStep {
    constructor(pluginManager, router, dialog, errorManager, server, ea, bindingEngine) {
        this.pluginManager = pluginManager;
        this.router = router;
        this.dialog = dialog;
        this.errorManager = errorManager;
        this.server = server;
        this.ea = ea;
        this.bindingEngine = bindingEngine;
        this.setupLocation = {
            type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL,
            position: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_SETUP
        };
        this.resultRenderers = {};
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["LogManager"].getLogger('ELN-Step');
        this.pluginsLoaded = false;
    }
    bind() {
        this.setupContext = Object.assign({ step: this.stepInfo.step, position: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_SETUP }, this.elnInfo);
        this.bindingEngine.propertyObserver(this.stepInfo, 'allDetailsLoaded').subscribe(() => this.loadRenderers());
    }
    collapsedChanged() {
        if (this.stepInfo && this.collapsed === false && !this.pluginsLoaded) {
            this.loadRenderers();
        }
    }
    dateStartedUpdated(event) {
        const oldStep = event.detail.old;
        const newStep = event.detail.new;
        if (oldStep.dateStarted !== newStep.dateStarted) {
            const days = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from(newStep.dateStarted).diff(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from((oldStep.dateStarted)));
            this.pushChildStepsDateStarted(newStep.id, days);
        }
    }
    validateDateStart(value) {
        if (this.stepInfo.step.parentID) {
            const parentStep = this.elnInfo.stepInfos.find(s => s.step.id === this.stepInfo.step.parentID).step;
            const parentDate = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from(parentStep.dateStarted);
            if (parentDate.diff(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from(value)) > 0) {
                return {
                    valid: false,
                    msg: `The date must be the same or after ${parentDate.format('D-MMM-YYYY')} (the parent step)`
                };
            }
        }
        return { valid: true };
    }
    pushChildStepsDateStarted(parentStepID, days) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const childSteps = this.elnInfo.stepInfos.filter(s => s.step.parentID === parentStepID);
            for (const step of childSteps.map(cs => cs.step)) {
                step.dateStarted = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].from(step.dateStarted).add(days);
                Object.assign(step, yield this.server.updateEntity(step));
                yield this.pushChildStepsDateStarted(step.id, days);
            }
        });
    }
    loadRenderers() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.pluginsLoaded || !this.stepInfo.allDetailsLoaded)
                return;
            this.logger.debug('Load plugins for step: ', this.stepInfo.step.id);
            yield this.loadSetupRenderers();
            if (this.stepInfo.resultSets) {
                for (const rs of this.stepInfo.resultSets) {
                    yield this.loadResultRenderers(rs);
                }
            }
            this.pluginsLoaded = true;
        });
    }
    loadSetupRenderers() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                const setupRenderers = yield this.pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL, this.setupContext);
                if (setupRenderers.length) {
                    this.setupRenderer = setupRenderers[setupRenderers.length - 1];
                }
            }
            catch (err) {
                this.errorManager.showMessage('Step setup renderers could not be loaded.', err);
            }
        });
    }
    loadResultRenderers(resultSet) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.resultRenderers[resultSet.id] = {
                plugin: null,
                context: Object.assign({
                    step: this.stepInfo.step,
                    resultSet: resultSet,
                    position: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_RESULTS
                }, this.elnInfo),
                location: {
                    type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL,
                    position: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_RESULTS
                }
            };
            try {
                const resultPlugins = yield this.pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL, this.resultRenderers[resultSet.id].context);
                if (resultPlugins.length) {
                    this.resultRenderers[resultSet.id].plugin = resultPlugins[resultPlugins.length - 1];
                }
            }
            catch (err) {
                this.errorManager.showMessage('Step result renderers could not be loaded.', err);
            }
        });
    }
    addChildStep() {
        this.router.navigate(`eln/add-step?experimentID=${this.elnInfo.experiment.id}&parentID=${this.stepInfo.step.id}`);
    }
    addResultSet() {
        this.dialog.open({
            view: __webpack_require__(/*! ../popups/add-resultset-popup.html */ "module/eln/popups/add-resultset-popup.html"),
            viewModel: _popups_add_resultset_popup__WEBPACK_IMPORTED_MODULE_8__["AddResultSetPopup"],
            model: { stepID: this.stepInfo.step.id, elnInfo: this.elnInfo }
        }).whenClosed(value => {
            if (value.wasCancelled)
                return;
            let rs = value.output;
            this.elnInfo.resultSets.push(rs);
            this.ea.publish(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Event"].ELN.RELOAD);
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELNStep.prototype, "stepInfo", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELNStep.prototype, "elnInfo", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Number)
], ELNStep.prototype, "index", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ELNStep.prototype, "collapsed", void 0);
ELNStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["customElement"])('eln-step'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_6__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"],
        module_error_error_manager__WEBPACK_IMPORTED_MODULE_7__["ErrorManager"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__["EventAggregator"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["BindingEngine"]])
], ELNStep);



/***/ }),

/***/ "module/eln/panels/eln-step-list":
/*!************************************************!*\
  !*** ./SPA/module/eln/panels/eln-step-list.ts ***!
  \************************************************/
/*! exports provided: ELNStepList */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELNStepList", function() { return ELNStepList; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _data_eln_info__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../data/eln-info */ "./SPA/module/eln/data/eln-info.ts");




let ELNStepList = class ELNStepList {
    constructor(router) {
        this.router = router;
    }
    addStep(parentID = null) {
        this.router.navigate(`eln/add-step?experimentID=${this.elnInfo.experiment.id}&parentID=${parentID}`);
    }
    addStepBottom() {
        const steps = this.elnInfo.stepInfos.map(si => si.step);
        this.addStep(steps.length > 0 ? steps[steps.length - 1].id : null);
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", _data_eln_info__WEBPACK_IMPORTED_MODULE_3__["ELNInfo"])
], ELNStepList.prototype, "elnInfo", void 0);
ELNStepList = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('eln-step-list'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_2__["Router"]])
], ELNStepList);



/***/ }),

/***/ "module/eln/panels/eln-step-list.html":
/*!**************************************************!*\
  !*** ./SPA/module/eln/panels/eln-step-list.html ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"./eln-step\"></require>\r\n\r\n\r\n    <div class=\"panel full-width\" if.bind=\"elnInfo.loading.steps\">\r\n        <div class=\"panel-body loading\">\r\n            \r\n        </div>\r\n    </div>\r\n    \r\n    <eln-step repeat.for=\"si of elnInfo.stepInfos\" \r\n            step-info.bind=\"si\" \r\n            eln-info.bind=\"elnInfo\"\r\n            index.bind=\"$index\">\r\n    </eln-step>\r\n    \r\n    <div class=\"text-right full-width\">\r\n        <button click.delegate=\"addStepBottom()\">Add Step</button>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/panels/eln-step.html":
/*!*********************************************!*\
  !*** ./SPA/module/eln/panels/eln-step.html ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel step full-width step-${index}\" id=\"step-${stepInfo.step.id}\">\r\n        <div class=\"panel-heading\">\r\n            <div class=\"name\">\r\n                Step: <a href=\"/#/entity/step/${stepInfo.step.id}\">${stepInfo.step.name} (${stepInfo.step.type})</a>\r\n            </div>\r\n            <div class=\"date\">\r\n                <inplace-edit-date entity.bind=\"stepInfo.step\" \r\n                                    key=\"dateStarted\" \r\n                                    entity-saved.delegate=\"dateStartedUpdated($event)\" \r\n                                    title=\"Date started\" \r\n                                    allow-empty.bind=\"false\"\r\n                                    width=\"150px\"\r\n                                    validate.call=\"validateDateStart(value)\"\r\n                                    editable.bind=\"stepInfo.editable\"></inplace-edit-date>\r\n            </div>\r\n            <div class=\"controls\">\r\n                <dropdown-button title=\"Open menu\" class=\"noframe\" fa-icon=\"plus\" right-align.bind=\"true\">\r\n                    <ul class=\"menu\" style=\"text-align:left;\">\r\n        <!--                <li class=\"menu-item\">\r\n                            <a click.delegate=\"addSpreadsheetSetupSection()\">\r\n                                Add spreadsgeet setup section\r\n                            </a>\r\n                        </li> -->\r\n                        <li class=\"menu-item\">\r\n                            <a click.delegate=\"addResultSet()\" title=\"Add result-set\">\r\n                                Add result-set\r\n                            </a>\r\n                        </li>\r\n                        <li class=\"menu-item\">\r\n                            <a click.delegate=\"addChildStep()\" title=\"Add child step\">\r\n                                Add child step\r\n                            </a>\r\n                        </li>\r\n                        <li class=\"menu-item\">\r\n                            <a click.delegate=\"addEmptyChildStep()\" title=\"Add empty child step\">\r\n                                Add empty child step\r\n                            </a>\r\n                        </li>\r\n                    </ul>\r\n                </dropdown-button>\r\n                <!--<span class=\"fa fa-info-circle\"></span>-->\r\n                <collapsible default=\"collapsed\" collapsed.bind=\"collapsed\" />\r\n            </div>\r\n            <div class=\"analyst\">\r\n                Analyst: \r\n                <inplace-edit-foreign-key entity.bind=\"stepInfo.step\" \r\n                                    key=\"analystID\" \r\n                                    e-class=\"User\"\r\n                                    title=\"Analyst\" \r\n                                    inline.bind=\"true\"\r\n                                    editable.bind=\"stepInfo.editable\"></inplace-edit-foreign-key>\r\n            </div>\r\n            <!--<div>Next Tasks: Do...</div>-->\r\n        </div>\r\n\r\n        <div class=\"panel-body\">\r\n            <section class=\"step-info\">\r\n                <div class=\"common-fields\">\r\n                    <div class=\"view-group\">\r\n                        <label>ID</label>\r\n                        <p><a href=\"/#/entity/step/${stepInfo.step.id}\">${stepInfo.step.id}</a></p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Type</label>\r\n                        <p>${stepInfo.step.type}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Status</label>\r\n                        <p>${stepInfo.step.status}</p>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section class=\"step-protocol\">\r\n                <div class=\"section-header\" if.bind=\"stepInfo.noteProtocol.content\">\r\n                    Protocol\r\n                </div>\r\n                <inplace-edit-textarea entity.bind=\"stepInfo.noteProtocol\" key=\"content\" placeholder=\"(protocol)\"></inplace-edit-textarea>\r\n            </section>\r\n\r\n            <section class=\"step-setup\">\r\n                <div class=\"section-header\" if.bind=\"stepInfo.noteSetup.content\">\r\n                    Setup\r\n                </div>\r\n                <inplace-edit-textarea entity.bind=\"stepInfo.noteSetup\" key=\"content\" placeholder=\"(setup)\"></inplace-edit-textarea>\r\n                \r\n                <render-plugin plugin.bind=\"setupRenderer\" \r\n                            context.bind=\"stepInfo\" \r\n                            location=\"setup\"></render-plugin>\r\n            </section>\r\n\r\n            <section repeat.for=\"rs of stepInfo.resultSets\" class=\"step-result-set step-result-set-${$index}\">\r\n                <div class=\"section-header\">Result Set: <a href=\"/#/entity/ResultSet/${rs.id}\">${rs.name}</a></div>\r\n                <div class=\"common-fields\">\r\n                    <div class=\"view-group\">\r\n                        <label>ID</label>\r\n                        <p><a href=\"/#/entity/ResultSet/${rs.id}\">${rs.id}</a></p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Type</label>\r\n                        <p>${rs.type}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Status</label>\r\n                        <p>${rs.status}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>User</label>\r\n                        <p>${rs.userID}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Date</label>\r\n                        <p>${rs.createdDate | dateFormat}</p>\r\n                    </div>\r\n                </div>\r\n                <div style=\"overflow:auto;\">\r\n                    <render-plugin plugin.bind=\"resultRenderers[rs.id].plugin\" \r\n                            context.bind=\"resultRenderers[rs.id].context\" \r\n                            location.bind=\"resultRenderers[rs.id].location\"></render-plugin>\r\n                </div>\r\n            </section>\r\n\r\n            <section if.bind=\"showHints\">\r\n                <div class=\"hints\">\r\n                    <h3>Hints</h3>\r\n                    <p>You can now add content to the step. This hints-section will disappear once you have content\r\n                        for the step, but you can show it using the info-icon in the step-heading.\r\n                    </p>\r\n                    <p><b>Add protocol:</b> Click the plus-icon in the step-heading to add a Protocol section\r\n                        where you can type in the lab steps.</p>\r\n                    <p><b>Add setup:</b> The content in the Setup section is typically auto-generated based on other data\r\n                        in the system, but you can also add a text and/or a spreadsheet section. Click the plus-icon\r\n                        in the step-heading.\r\n                    </p>\r\n                    <p><b>Add results:</b> The content in the Results section is typically auto-generated based on actual uploaded\r\n                        results, but you can also add a text and/or a spreadsheet section. Click the plus-icon\r\n                        in the step-heading.</p>\r\n                    <p><b>Add notes:</b> Click the plus-icon in the step heading to add a Notes section.</p>\r\n                </div>\r\n            </section>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/eln/panels/input-samples-list":
/*!*****************************************************!*\
  !*** ./SPA/module/eln/panels/input-samples-list.ts ***!
  \*****************************************************/
/*! exports provided: InputSamplesList */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputSamplesList", function() { return InputSamplesList; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


class InputSamplesList {
    attached() {
        this.initHot();
    }
    addSamples(samples) {
        this.updateFromHot();
        this.samples = this.samples.concat(samples);
        this.initHot();
    }
    removeSamples(samples) {
        this.updateFromHot();
        this.samples = this.samples.filter(s => samples.find(s2 => s2.id === s.id) === undefined);
        this.listElement.innerHTML = '';
        this.initHot();
    }
    initHot() {
        const settings = {
            data: this.samples,
            rowHeaders: true,
            height: 400,
            colHeaders: ['ID', 'Name', 'Plate', 'Type', 'Content'],
            columns: [
                { data: 'id', readOnly: true },
                { data: 'name' },
                { data: 'plateID' },
                { data: 'type' },
                { data: 'content' },
            ],
            minSpareRows: 1,
            stretchH: 'all',
            manualColumnResize: true,
            manualRowMove: true,
            contextMenu: ['row_above', 'row_below', 'remove_row']
        };
        this.hot = new Handsontable(this.listElement, settings);
        this.hot.render();
    }
    updateFromHot() {
        let newSamples = [];
        const nRows = this.hot.countRows();
        for (let i = 0; i < nRows; i++) {
            const sample = this.samples[this.hot.toPhysicalRow(i)];
            if (!sample.name)
                continue;
            let newSample = {
                name: sample.name,
                description: sample.description,
                id: sample.id || '#idTestManAdded' + i,
                eClass: 'Sample',
                format: 'Vial',
                type: sample.typ,
                content: sample.content,
                sortIndex: i,
                attributes: sample.attributes || {},
                isControl: sample.isControl
            };
            newSamples.push(sample);
        }
        this.samples = newSamples;
    }
}
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputSamplesList.prototype, "samples", void 0);


/***/ }),

/***/ "module/eln/panels/input-samples-list.html":
/*!*******************************************************!*\
  !*** ./SPA/module/eln/panels/input-samples-list.html ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div ref=\"listElement\"></div>\r\n</template>";

/***/ }),

/***/ "module/eln/popups/add-resultset-popup":
/*!******************************************************!*\
  !*** ./SPA/module/eln/popups/add-resultset-popup.ts ***!
  \******************************************************/
/*! exports provided: AddResultSetPopup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AddResultSetPopup", function() { return AddResultSetPopup; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! module/data-upload/file-processor */ "./SPA/module/data-upload/file-processor.ts");





let AddResultSetPopup = class AddResultSetPopup {
    constructor(fileProcessor, dialog, server, user) {
        this.fileProcessor = fileProcessor;
        this.dialog = dialog;
        this.server = server;
        this.user = user;
        this.protocol = '';
        this.loading = false;
        this.formTypes = ['FACS', 'MS', 'LC/MS', 'ELISA'];
    }
    init(model) {
        let expName = model.elnInfo.experiment.name;
        if (expName.startsWith('EXP-'))
            expName = expName.substring(4);
        if (expName.startsWith('EX'))
            expName = expName.substring(2);
        let suggestedName = `RS-${expName}-${model.elnInfo.resultSets.length + 1}`;
        this.rs = {
            eClass: 'ResultSet',
            id: '#idRS',
            name: suggestedName,
            type: "Other",
            status: 'Initial',
            originID: model.stepID,
            userID: this.user.id
        };
    }
    save(entities) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            const response = yield this.server.saveEntities(entities);
            if (response.newEntities) {
                this.rs.createdDate = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].createDotNetDate();
                this.rs.id = response.newEntities.find(e => e.eClass === 'ResultSet').id;
            }
            this.dialog.ok(this.rs);
        });
    }
    saveEmpty() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.save([this.rs]);
        });
    }
    saveFile() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.save([this.rs].concat(this.resultEntities));
        });
    }
    addUsingForm() {
        alert('NOT SUPPORTED, YET');
    }
    dropped(e) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            let context = {};
            let dataUploadInfo = yield this.fileProcessor.preprocessFiles(e.detail.files, context);
            yield dataUploadInfo.selectedPlugin.readFiles();
            const result = yield dataUploadInfo.selectedPlugin.getResult();
            if (result && result.entities) {
                this.resultEntities = result.entities;
                this.resultEntities.forEach(rv => rv.resultSetID = '#idRS');
            }
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
};
AddResultSetPopup = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_4__["FileProcessor"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], AddResultSetPopup);



/***/ }),

/***/ "module/eln/popups/add-resultset-popup.html":
/*!********************************************************!*\
  !*** ./SPA/module/eln/popups/add-resultset-popup.html ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n        <style>\r\n            .wrapper {\r\n                display: grid;\r\n                grid-template-columns: 1fr 1fr 1fr;\r\n                grid-gap: 20px;\r\n                margin-top: 15px;\r\n            }\r\n            .wrapper > div > div {\r\n                padding: 10px;\r\n            }\r\n            .wrapper > div:not(:first-child) > div {\r\n                margin-left: -10px;\r\n                padding-left: 20px;\r\n                border-left: 2px solid #d4e0ea;\r\n            }\r\n            select.listbox {\r\n                height: 100px;\r\n            }\r\n            .wrapper button {\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n            .dialog-header-content {\r\n                display: flex;\r\n            }\r\n        </style>\r\n        <ux-dialog>\r\n            <ux-dialog-header>\r\n                <h2 style=\"flex:1\">Add Result-set</h2>\r\n                <button class=\"small secondary\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n            </ux-dialog-header>\r\n            <ux-dialog-body style=\"width: 900px;\">\r\n                <h3>You can add a result-set in either of three ways:</h3>\r\n    \r\n                <div class=\"wrapper\">\r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Create an Empty Result-set</h3>\r\n                            <div class=\"form-group\">\r\n                                <label>Result-set Name</label>\r\n                                <input value.bind=\"rs.name\"/>\r\n                            </div>\r\n                            <div class=\"form-group\">\r\n                                <label>Result-set Type</label>\r\n                                <input value.bind=\"rs.type\"/>\r\n                            </div>\r\n                        </div> \r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button click.delegate=\"saveEmpty()\">Add Result-set</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                        \r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Select a Result-set Type with a Form</h3>\r\n                            <div class=\"form-group\">\r\n                                <label>Result-set Type</label>\r\n                                <select size=\"5\" class=\"listbox\">\r\n                                    <option repeat.for=\"type of formTypes\">${type}</option>\r\n                                </select>\r\n                            </div>\r\n                        </div> \r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button disabled=\"true\" click.delegate=\"addUsingForm()\">Go To Form</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n    \r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Upload a File</h3>\r\n                            <div class=\"form-group\">\r\n                                <dropzone dropfiles.trigger=\"dropped($event)\" title=\"Drop File Here\" style=\"height: 100%\"></dropzone>\r\n                            </div>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Result Entities</label>\r\n                            <p>${resultEntities.length}</p>\r\n                        </div>\r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button click.delegate=\"saveFile()\">Add Result-set</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </ux-dialog-body>\r\n        </ux-dialog>\r\n    </template>";

/***/ })

}]);
//# sourceMappingURL=eln.7d2e17d8ae74be98b4b6.js.map