(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["module/assayadm"],{

/***/ "./SPA/module/assaydm/models/curve-4pl.js":
/*!************************************************!*\
  !*** ./SPA/module/assaydm/models/curve-4pl.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Curve4PL = exports.Curve4PL = function () {
    function Curve4PL() {
        _classCallCheck(this, Curve4PL);

        this.jobType = 'R_4PL';

        this.name = '4PL', this.version = 1;
    }

    _createClass(Curve4PL, [{
        key: 'evaluateFit',
        value: function evaluateFit(result) {

            var parameters = result.entity.fitResult.parameters;
            var slope = parameters.slope;

            result.warning = {};
            if (slope < 0.5 && slope > -0.5) result.warning.slope = 'fitwarning';

            var window = Math.abs(parameters.top - parameters.bottom);
            result.window = window;

            if (window < .4) // TODO: Don't hardcode this ;-)
                result.warning.window = 'fitwarning';

            if (slope < 0.3 && slope > -0.3 || window < .2 || isNaN(slope) || !window) result.hasActivity = false;else result.hasActivity = true;
        }
    }, {
        key: 'calcFitValue',
        value: function calcFitValue(result, valueX) {
            var parameters = result.entity.fitResult.parameters;

            //Define the generic 4PL evaluation function
            var top = parameters.top;
            var bottom = parameters.bottom;
            var slope = parameters.slope;
            var inflection = parameters.ec50;
            return bottom + (top - bottom) / (1 + Math.pow(valueX / inflection, slope));
        }
    }, {
        key: 'calcFitCurve',
        value: function calcFitCurve(result) {
            if (!result.hasActivity) return;

            //Find x-range
            var points = result.parent.entity.content.points;
            var xValues = points.map(function (r) {
                return r.valueX;
            }).sort(function (a, b) {
                return a - b;
            });
            if (xValues.length < 2) return;

            var xmax = xValues[xValues.length - 1];
            var xmin = xValues[0];
            if (xmin === 0) {
                var i = 1;
                while (xmin === 0 && i < xValues.length) {
                    xmin = xValues[i];
                }
            }
            if (xmax - xmin === 0) return;

            //Evenly spaced points on LOG scale
            var pointCount = 50;
            var eXmin = Math.log(xmin) / Math.LN10;
            var eXmax = Math.log(xmax) / Math.LN10;
            var eDx = (eXmax - eXmin) / pointCount;

            //Calculate fit curve
            result.curve = [];
            for (var _i = 0; _i < pointCount; _i++) {
                var x = Math.pow(10, eXmin + _i * eDx);
                result.curve.push({ valueX: x, valueY: this.calcFitValue(result, x) });
            }

            result.parent.curve = result.curve;
        }
    }]);

    return Curve4PL;
}();

/***/ }),

/***/ "module/assaydm/analyzer":
/*!*****************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/assaydm/analyzer.ts ***!
  \*****************************************************************************/
/*! exports provided: AssayDMAnalyzer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AssayDMAnalyzer", function() { return AssayDMAnalyzer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-templating-resources */ "aurelia-templating-resources");
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_curve_fit_curve_fit__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/curve-fit/curve-fit */ "./SPA/module/curve-fit/curve-fit.ts");
/* harmony import */ var services_sci_calc_api__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! services/sci-calc-api */ "./SPA/services/sci-calc-api.js");
/* harmony import */ var services_sci_calc_api__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(services_sci_calc_api__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _models_curve_4pl__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./models/curve-4pl */ "./SPA/module/assaydm/models/curve-4pl.js");
/* harmony import */ var _models_curve_4pl__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_models_curve_4pl__WEBPACK_IMPORTED_MODULE_7__);








let AssayDMAnalyzer = class AssayDMAnalyzer {
    constructor(server, calc, signaler, router, curveFit) {
        this.server = server;
        this.calc = calc;
        this.signaler = signaler;
        this.router = router;
        this.curveFit = curveFit;
        this.model = new _models_curve_4pl__WEBPACK_IMPORTED_MODULE_7__["Curve4PL"]();
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.resultSetId = params.id;
        });
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            yield this.fetchData(this.resultSetId);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
    toggleColumnPopup() {
        this.popupColumnSelector.style.display = this.popupColumnSelector.style.display === 'none' ? 'block' : 'none';
    }
    toggleStandardCurveSettings() {
        this.popupStandardCurveSettings.style.display = this.popupStandardCurveSettings.style.display === 'none' ? 'block' : 'none';
    }
    exclusionUpdate(e) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let result = e.detail.result;
            const fitResponse = yield this.calc.doJob({ jobType: 'R_4PL', jobData: [result.parent] });
            let fit = fitResponse.series[0];
            fit.parameters.logEC50 = Math.log10(fit.parameters.ec50);
            result.entity.fitResult.parameters = fit.parameters;
            result.resultValues = fit.parameters;
            this.model.evaluateFit(result);
            this.model.calcFitCurve(result);
            e.detail.chart.updateChart();
        });
    }
    selectResult(result, e) {
        if (e && e.ctrlKey) {
            let i = this.selectedResults.indexOf(result);
            if (i >= 0) {
                this.selectedResults.splice(i, 1);
                this.selectedResults = [].concat(this.selectedResults);
            }
            else
                this.selectedResults = [result].concat(this.selectedResults);
        }
        else
            this.selectedResults = [result];
        let chartColors = ['#ff0000', '#00ff00', '#0000ff', '#aaaa00', '#888888', '#00aaaa', '#aa00aa'];
        for (let sample of this.samples)
            sample.cssClass = '';
        let iRow = 0;
        for (let result of this.selectedResults) {
            result.chartColor = chartColors[iRow % chartColors.length];
            for (let sample of result.samples)
                sample.cssClass = '#000';
            iRow++;
        }
    }
    setStatus(status, result) {
        if (result.entity.status === status)
            result.entity.status = 'Initial';
        else
            result.entity.status = status;
    }
    saveResults() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Saving...');
            let entities = this.createEntities('InProgress');
            yield this.server.saveEntities(entities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            this.router.navigate('/entity/Step/' + this.step.id);
        });
    }
    sendForApproval() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Saving for approval...');
            let entities = this.createEntities('Pending');
            this.server.saveEntities(entities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            this.router.navigate('/entity/step/' + this.step.id);
        });
    }
    createEntities(status) {
        let entities = [];
        for (let rt of this.resultTables) {
            if (rt.type === 'PlateLayer')
                continue;
            rt.resultSet.status = status;
            rt.resultSet.originID = this.step.id;
            entities.push(rt.resultSet);
            for (let result of rt.results) {
                result.entity.resultSetID = rt.resultSet.id;
                entities.push(result.entity);
            }
        }
        return entities;
    }
    fetchData(readerRSID) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'ResultSet', alias: 'rsReader', filters: [{ field: 'ID', value: readerRSID }] },
                { eClass: 'Step', alias: 'step', filters: [{ field: 'ID', value: '$rsReader.OriginID' }] },
                { eClass: 'Experiment', alias: 'exp', filters: [{ field: 'ID', value: '$step.ExperimentID' }] },
                { eClass: 'PlateLayer', collection: 'layersReader', filters: [{ field: 'ResultSetID', value: readerRSID }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'PlateID', in: 'layersReader.PlateID' }] },
                { eClass: 'Plate', collection: 'plates', filters: [{ field: 'ID', in: 'layersReader.PlateID' }] },
                { eClass: 'PlateLayer', collection: 'layers', filters: [{ field: 'PlateID', in: 'layersReader.PlateID' }] }
            ]);
            this.rsReader = dataset.rsReader;
            this.step = dataset.step;
            this.exp = dataset.exp;
            this.samples = dataset.samples;
            this.plates = dataset.plates;
            this.layersResultSet = dataset.layersReader;
            this.layers = dataset.layers;
            this.resultTables = [];
            let rtReader = this.prepareRTReader(this.plates, this.layers);
            this.resultTables.push(rtReader);
            let rtDataSeries = this.prepareRTDataSeries(rtReader, this.layers, this.samples);
            this.resultTables.push(rtDataSeries);
            yield this.runCurveFitting(rtDataSeries);
        });
    }
    keyColumns(rt, filter) {
        if (!rt)
            return [];
        filter = filter || 'show';
        return rt.columns.filter(c => c.type === 'key' && c[filter]);
    }
    resultColumns(rt) {
        if (!rt)
            return [];
        return rt.columns.filter(c => c.type === 'result' && c.show &&
            (c.format === 'number' || c.format === 'text'));
    }
    pointsColumns(rt) {
        if (!rt)
            return [];
        return rt.columns.filter(c => c.type === 'result' && c.format === 'collection-point');
    }
    runCurveFitting(rtDataSeries) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.calcStatus = 'Running';
            const fitResponse = yield this.calc.doJob({ jobType: this.model.jobType, jobData: rtDataSeries.results });
            this.calcStatus = 'Done';
            this.rtFit = {
                name: 'CurveFit',
                type: 'CurveFit',
                resultSet: {
                    eClass: 'ResultSet',
                    id: '#idRSCurveFit',
                    type: 'CurveFit'
                },
                columns: rtDataSeries.columns.filter(c => c.type === 'key').concat([
                    { type: 'result', name: 'ec50', label: 'EC50', format: 'number' },
                    { type: 'result', name: 'logEC50', label: 'LogEC50', format: 'number', show: true },
                    { type: 'result', name: 'top', label: 'Top', format: 'number', show: true },
                    { type: 'result', name: 'bottom', label: 'Bottom', format: 'number', show: true },
                    { type: 'result', name: 'slope', label: 'Slope', format: 'number', show: true },
                    { type: 'result', name: 'window', label: 'Window', format: 'number', show: true },
                    { type: 'result', name: 'hasActivity', label: 'Has Activity', format: 'text', show: false }
                ]),
                results: []
            };
            this.resultTables.push(this.rtFit);
            for (let fit of fitResponse.series) {
                let resultDS = rtDataSeries.results.find(res => res.key === fit.key);
                if (resultDS) {
                    let result = {
                        name: resultDS.name,
                        entity: {
                            eClass: 'ResultCurveFit',
                            name: resultDS.entity.name,
                            type: 'DoseResponse',
                            status: 'Initial',
                            model: this.model.name,
                            modelVersion: this.model.version,
                            subjectID: resultDS.entity.subjectID,
                            subjectClass: resultDS.entity.subjectClass,
                            fitResult: { parameters: fit.parameters }
                        },
                        parent: resultDS,
                        samples: resultDS.samples,
                        keyValues: resultDS.keyValues,
                        resultValues: fit.parameters
                    };
                    result.keyValues.status = 'Initial';
                    this.model.evaluateFit(result);
                    this.model.calcFitCurve(result);
                    this.rtFit.results.push(result);
                }
            }
            if (this.rtFit.results.length > 0)
                this.selectResult(this.rtFit.results[0], null);
        });
    }
    prepareRTReader(plates, layers) {
        let rtReader = {
            name: 'Reader',
            type: 'PlateLayer',
            columns: [
                { type: 'key', name: 'plate', label: 'Plate', format: 'text' },
                { type: 'result', name: 'wells', label: 'Wells', format: 'collection-well' }
            ],
            results: []
        };
        this.plateInfos = [];
        for (let layer of layers.filter(l => l.type === 'RawData')) {
            let plate = plates.find(p => p.id === layer.plateID);
            rtReader.results.push({
                layer: layer,
                plate: plate,
                name: layer.name,
                keyValues: { plate: plate.name },
                resultValues: { wells: layer.content.wells }
            });
            this.plateInfos.push({
                plate: plate,
                layerReader: layer
            });
        }
        return rtReader;
    }
    prepareRTDataSeries(rtReader, layers, samples) {
        let rt = {
            name: 'DataSeries',
            type: 'DataSeries',
            resultSet: {
                eClass: 'ResultSet',
                id: '#idRSDS',
                type: 'DataSeries'
            },
            columns: [
                { type: 'key', name: 'plate', label: 'Plate', format: 'text', show: true },
                { type: 'key', name: 'parentSampleID', label: 'Parent Sample', format: 'text' },
                { type: 'key', name: 'sampleName', label: 'Sample', format: 'text', show: true, chartLegend: true }
            ],
            results: []
        };
        rt.columns.push({ type: 'key', name: 'content', label: 'Content', format: 'text', show: true, chartLegend: true });
        rt.columns.push({ type: 'key', name: 'compound', label: 'Compound', format: 'text' });
        rt.columns.push({ type: 'key', name: 'batch', label: 'Batch', format: 'text' });
        for (let resRO of rtReader.results) {
            let samplesP = samples.filter(s => s.plateID === resRO.plate.id);
            let layersP = layers.filter(l => l.plateID === resRO.plate.id);
            let results = this.mapSamples(samplesP, [resRO.plate], layersP, 'Concentration', 'ReaderOutput', null);
            for (let result of results) {
                result.keyValues = {
                    plate: resRO.keyValues.plate,
                    parentSampleID: result.entity.subjectClass === 'Sample' ? result.entity.subjectID : null,
                    content: result.samples[0].content || result.samples[0].controlType,
                    batch: result.samples[0].content,
                    sampleName: result.samples[0].name
                };
                rt.results.push(result);
                if (result.layout.startsWith('C-'))
                    result.type = 'Control';
                else if (result.layout === 'Standard')
                    result.type = 'Standard';
                else
                    result.type = 'Test';
            }
        }
        return rt;
    }
    mapSamples(samples, plates, layers, typeXLayer, typeValueLayer, typeLayoutLayer) {
        let results = [];
        for (let plate of plates) {
            let layoutLayer = layers.find(pl => pl.type === typeLayoutLayer && pl.plateID === plate.id);
            let yLayer = layers.find(pl => pl.plateID === plate.id && pl.resultSetID === this.rsReader.id);
            for (let wellY of yLayer.content.wells) {
                let sample = samples.find(s => s.plateID === plate.id &&
                    s.posRow === wellY.posRow && s.posCol === wellY.posCol);
                if (!sample) {
                    continue;
                }
                let wellX;
                if (sample.attributes.idilution) {
                    wellX = {
                        posRow: sample.posRow,
                        posCol: sample.posCol,
                        valueDecimal: sample.attributes.idilution,
                        valueText: sample.attributes.idilution.toString()
                    };
                }
                let wellLayout;
                if (layoutLayer)
                    wellLayout = layoutLayer.content.wells.find(w => w.posRow === wellY.posRow && w.posCol === wellY.posCol);
                let key, layoutName;
                if (wellLayout)
                    layoutName = wellLayout.valueText;
                else
                    layoutName = sample.parentID || sample.name;
                key = plate.id + '|' + layoutName;
                let result = results.find(r => r.key === key);
                if (!result) {
                    let name = plate.name + '-' + sample.name;
                    result = {
                        name: name,
                        key: key,
                        layout: layoutName,
                        samples: [],
                        plateID: sample.plateID,
                        entity: {
                            eClass: 'ResultDataSeries',
                            id: '#' + key,
                            name: name,
                            content: {
                                replicates: 1,
                                points: []
                            }
                        }
                    };
                    results.push(result);
                    if (sample.parentID) {
                        result.entity.subjectID = sample.parentID;
                        result.entity.subjectClass = 'Sample';
                    }
                    else {
                        result.entity.subjectID = sample.plateID;
                        result.entity.subjectClass = 'Plate';
                    }
                    if (wellX) {
                        result.entity.type = 'XY';
                        result.entity.content.xFormat = 'numbers';
                        result.entity.content.yFormat = 'numbers';
                        result.entity.content.xTitle = sample.type;
                    }
                    else {
                        result.entity.type = 'Scalar';
                        result.entity.content.format = 'numbers';
                    }
                }
                result.samples.push(sample);
                if (wellX) {
                    if (!('valueDecimal' in wellX) || wellX.valueDecimal === null) {
                        if (!wellX.valueText)
                            continue;
                        if (typeof wellX.valueText === 'number')
                            wellX.valueDecimal = wellX.valueText;
                        else
                            wellX.valueDecimal = parseFloat(wellX.valueText.replace(',', '.'));
                    }
                    if (!wellX.valueDecimal)
                        continue;
                    if (wellY.valueText && !wellY.valueDecimal)
                        wellY.valueDecimal = parseFloat(wellY.valueText);
                    result.entity.content.points.push({
                        group: 0,
                        valueX: wellX.valueDecimal,
                        valueY: wellY.valueDecimal,
                        sampleID: sample.id,
                        parentID: sample.parentID,
                        posRow: sample.posRow,
                        posCol: sample.posCol
                    });
                }
                else {
                    result.entity.content.points.push({
                        group: 0,
                        valueY: wellY.valueDecimal,
                        sampleID: sample.id,
                        parentID: sample.parentID,
                        posRow: sample.posRow,
                        posCol: sample.posCol
                    });
                }
            }
        }
        for (let result of results) {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DSUtils"].calculateAverage(result);
        }
        return results;
    }
};
AssayDMAnalyzer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], services_sci_calc_api__WEBPACK_IMPORTED_MODULE_6__["SciCalcApi"], aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_4__["BindingSignaler"], aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"], module_curve_fit_curve_fit__WEBPACK_IMPORTED_MODULE_5__["CurveFit"]])
], AssayDMAnalyzer);



/***/ }),

/***/ "module/assaydm/analyzer.html":
/*!******************************************!*\
  !*** ./SPA/module/assaydm/analyzer.html ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/chart\"></require>\r\n    <require from=\"element/plate-view\"></require>\r\n    \r\n    <style>\r\n        td.Initial {\r\n            background-color: #ff0;\r\n        }\r\n        td.Canceled {\r\n            background-color: #f00;\r\n        }\r\n        td.Completed {\r\n            background-color: #0f0;\r\n        }\r\n    </style>\r\n\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Assay Analyzer</h1>\r\n            <button click.delegate=\"saveResults()\">Save</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels analyzer-panels\" style=\"height: auto;\">\r\n\r\n            <div class=\"panel header\">\r\n                <div class=\"panel-heading\">Step &amp; ResultSet <collapsible></collapsible></div>\r\n                <div class=\"panel-body\">\r\n                    <p>Step: <a href=\"/#/entity/Step/${step.id}\">${step.name}</a> (${step.type})</p>\r\n                    <p>Result set: <a href=\"/#/entity/ResultSet/${rs.id}\">${rs.name}</a></p>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel chart\">\r\n                <div class=\"panel-heading\">Chart <collapsible></collapsible></div>\r\n                <div class=\"panel-body\">\r\n                    <chart legends=\"none\" results.bind=\"selectedResults\" type=\"xy\" x-axis=\"log\" axis-ranges.bind=\"rangesNorm\"\r\n                        options.bind=\"chartOptions\" exclusion-update.delegate=\"exclusionUpdate($event)\"></chart>\r\n        \r\n                    <table class=\"table compact\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Color</th>\r\n                                <th repeat.for=\"c of keyColumns(rt, 'chartLegend') & signal:'colchange'\">${c.label}</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"row of selectedRows\">\r\n                                <td style=\"background-color: ${row.chartColor}\">&nbsp</td>\r\n                                <td repeat.for=\"c of keyColumns(rt, 'chartLegend') & signal:'colchange'\">${row.keyValues[c.name]}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n    \r\n            <div class=\"panel results\">\r\n                <div class=\"panel-heading\">\r\n                    <span>Test Results</span>\r\n                    <span class=\"icon glyphicon glyphicon-cog\" click.delegate=\"toggleColumnPopup()\"></span>\r\n                    <collapsible></collapsible>\r\n                </div>\r\n                <div class=\"panel-body\">\r\n                    <div style=\"float: right; width: 350px; display: none;\">\r\n                        <div class=\"popup-panel\" ref=\"popupColumnSelector\">\r\n                            <span class=\"glyphicon glyphicon-remove\" click.delegate=\"toggleColumnPopup()\" style=\"float:right; cursor:pointer;\"></span>\r\n                            <table class=\"table compact\">\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Column</th>\r\n                                        <th>In Table</th>\r\n                                        <th>Chart Legend</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"column of rtFit.columns\">\r\n                                        <td>${column.label}</td>\r\n                                        <td><input type=\"checkbox\" checked.bind=\"column.show\" change.delegate=\"updateRT()\" /></td>\r\n                                        <td><input if.bind=\"column.type==='key'\" type=\"checkbox\" checked.bind=\"column.chartLegend\" change.delegate=\"updateRT()\" /></td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                    <table class=\"table compact\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th repeat.for=\"c of keyColumns(rtFit) & signal:'colchange'\">${c.label}</th>\r\n                                <th repeat.for=\"c of resultColumns(rtFit) & signal:'colchange'\">${c.label}</th>\r\n                                <th>Status</th>\r\n                                <th>Set Status</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"r of rtFit.results\" class=\"${selectedResults.indexOf(r) >= 0 ? 'selected' : 'nots'}\"\r\n                                click.delegate=\"selectResult(r, $event)\" style=\"cursor: pointer\">\r\n                                <td repeat.for=\"c of keyColumns(rtFit) & signal:'colchange'\">\r\n                                    ${r.keyValues[c.name]}\r\n                                </td>\r\n                                <td repeat.for=\"c of resultColumns(rtFit) & signal:'colchange'\"\r\n                                    class=\"number ${row.dsNorm.warning[c.name]}\">\r\n                                    ${r.resultValues[c.name] | significant}\r\n                                </td>\r\n                                <td class=\"${r.entity.status}\">${r.entity.status}</td>\r\n                                <td style=\"text-align: center\">\r\n                                    <span class=\"fa fa-plus\" click.delegate=\"setStatus('Completed', r)\"></span>\r\n                                    <span class=\"fa fa-minus\" click.delegate=\"setStatus('Canceled', r)\"></span>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel plates\">\r\n                <div class=\"panel-heading\">Plates <collapsible></collapsible></div>\r\n                <div class=\"panel-body\">\r\n                    <template repeat.for=\"pi of plateInfos\">\r\n                        <h3>${pi.plate.name}</h3>\r\n                        <plate-view n-rows.bind=\"pi.plate.nRows\" n-cols.bind=\"pi.plate.nCols\"\r\n                            wells.bind=\"pi.layerReader.content.wells\" well-template=\"layer\"></plate-view>\r\n                        \r\n                    </template>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel rtables\">\r\n                <div class=\"panel-heading\">Result Tables <collapsible></collapsible></div>\r\n                <div class=\"panel-body\">\r\n                    <table class=\"table compact\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Results</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"rt of resultTables\">\r\n                                <td>${rt.name}</td>\r\n                                <td>\r\n                                    <table class=\"table inner\">\r\n                                        <tr>\r\n                                            <th>Result name</th>\r\n                                            <th repeat.for=\"c of keyColumns(rt)\">${c.label}</th>\r\n                                            <th repeat.for=\"c of resultColumns(rt)\">${c.label}</th>\r\n                                            <th repeat.for=\"c of pointsColumns(rt)\">${c.label}</th>\r\n                                        </tr>\r\n                                        <tr repeat.for=\"result of rt.results\">\r\n                                            <td>${result.name}</td>\r\n                                            <td repeat.for=\"c of keyColumns(rt)\">${result.keyValues[c.name]}</td>\r\n                                            <td repeat.for=\"c of resultColumns(rt)\">${result.resultValues[c.name] | significant}</td>\r\n                                            <td repeat.for=\"c of pointsColumns(rt)\">\r\n                                                <table class=\"table inner\">\r\n                                                    <tr><th>X</th><th>Y</th></tr>\r\n                                                    <tr repeat.for=\"point of result.resultValues[c.name]\">\r\n                                                        <td>${point.valueX | significant}</td>\r\n                                                        <td>${point.valueY | significant}</td>\r\n                                                    </tr>\r\n                                                </table>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"display: none\">\r\n                <div class=\"panel-heading\">All Data <collapsible></collapsible></div>\r\n                <div class=\"panel-body\">\r\n                    <p>Experiment: <a href=\"/#/eln/${exp.id}\">${exp.name}</a></p>\r\n                    <p>Step: <a href=\"/#/entity/Step/${step.id}\">${step.name}</a></p>\r\n                    <p>RS Reader: <a href=\"/#/entity/ResultSet/${rsReader.id}\">${rsReader.name}</a></p>\r\n\r\n                    <h3>Result Tables</h3>\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Type</th>\r\n                                <th>Results</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"rt of resultTables\">\r\n                                <td>${rt.name}</td>\r\n                                <td>${rt.type}</td>\r\n                                <td>${rt.results.length}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <h3>Plates</h3>\r\n                    <table>\r\n                        <tbody>\r\n                            <tr repeat.for=\"plate of plates\">\r\n                                <td><a href=\"/#/entity/Plate/${plate.id}\">${plate.id}</a> ${plate.name}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <h3>Layers</h3>\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Layer</th>\r\n                                <th>Plate</th>\r\n                                <th>Type</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"layer of layers\">\r\n                                <td><a href=\"/#/entity/PlateLayer/${layer.id}\">${layer.id}</a>: ${layer.name}</td>\r\n                                <td><a href=\"/#/entity/Plate/${layer.plateID}\">${layer.plateID}</a></td>\r\n                                <td>${layer.type}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <h3>Samples</h3>\r\n                    <table>\r\n                        <tbody>\r\n                            <tr repeat.for=\"sample of samples\">\r\n                                <td><a href=\"/#/entity/Sample/${sample.id}\">${sample.id}</a> ${sample.name}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/assaydm/designer":
/*!*****************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/assaydm/designer.ts ***!
  \*****************************************************************************/
/*! exports provided: AssayDMDesigner */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AssayDMDesigner", function() { return AssayDMDesigner; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _ui_assay_options_dialog__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./ui/assay-options-dialog */ "module/assaydm/ui/assay-options-dialog");
/* harmony import */ var _ui_assay_options_dialog__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_ui_assay_options_dialog__WEBPACK_IMPORTED_MODULE_6__);







let AssayDMDesigner = class AssayDMDesigner {
    constructor(server, router, pluginManager, dialog, sis, pluginLoader) {
        this.server = server;
        this.router = router;
        this.pluginManager = pluginManager;
        this.dialog = dialog;
        this.sis = sis;
        this.pluginLoader = pluginLoader;
        this.setup = {};
        this.nextInputSampleAlias = 0;
        this.iPlateContentRequest = 0;
        this.outputWellTemplate = (well) => {
            return `<a href='/#/entity/sample/${well.id}'>${well.name}</a>`;
        };
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.options = {
                experiment: 'new',
                parentStepID: null,
                experimentID: null,
                plateSize: '96W'
            };
            this.dialog.open({ viewModel: _ui_assay_options_dialog__WEBPACK_IMPORTED_MODULE_6__["AssayOptionsDialog"], model: this.options, lock: true, view: __webpack_require__(/*! ./ui/assay-options-dialog.html */ "module/assaydm/ui/assay-options-dialog.html") })
                .whenClosed((response) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                const context = { template: this.options.template.name };
                const assayPlugins = yield this.pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ASSAY_DEFINITION, context);
                const assayPlugin = assayPlugins[0];
                if (!assayPlugin)
                    throw new Error(`Missing assay definition: ${this.options.template}`);
                this.assay = yield this.pluginLoader.getInstance(assayPlugin, context);
                if (this.options.parentStepID)
                    yield this.loadParentStepInfo();
                else if (this.options.experimentID)
                    yield this.loadExperimentInfo();
                this.createSetup();
            }));
        });
    }
    loadExperimentInfo() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const experiment = yield this.server.getEntity('Experiment', this.options.experimentID);
            this.setup.experiment = experiment;
        });
    }
    loadParentStepInfo() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const parentStep = yield this.server.getEntity('Step', this.options.parentStepID);
            this.setup.parentStep = parentStep;
            this.options.experimentID = parentStep.experimentID;
            yield this.loadExperimentInfo();
        });
    }
    createSetup() {
        this.setup.experiment = this.setup.experiment || {
            eClass: 'Experiment',
            id: '#idExp',
            type: this.options.template.type || 'PlateAssay',
            status: 'Initial'
        };
        this.setup.step = {
            eClass: 'Step',
            id: '#idStep',
            name: 'PlateAssay',
            type: 'DoseResponse',
            analystID: this.setup.experiment.analystID,
            parentID: this.setup.parentStep ? this.setup.parentStep.id : null,
            experimentID: this.setup.experiment.id
        };
        this.setup.input = {
            samples: [],
            plates: [],
            layers: []
        };
        this.setup.output = {
            samples: [],
            plates: [],
            layers: [],
            rows: []
        };
        this.setup.layout = {
            nRows: 8,
            nCols: 12,
            layers: {
                'sample-layout': {
                    eClass: 'PlateLayer',
                    name: 'SampleLayout',
                    type: 'SampleLayout',
                    content: {
                        wells: []
                    }
                },
                'concentration': {
                    eClass: 'PlateLayer',
                    name: 'Concentration',
                    type: 'Concentration',
                    content: {
                        wells: []
                    }
                }
            }
        };
        switch (this.options.plateSize) {
            case '24W':
                this.setup.layout.nRows = 4;
                this.setup.layout.nCols = 6;
                break;
            case '96W':
                this.setup.layout.nRows = 8;
                this.setup.layout.nCols = 12;
                break;
            case '384W':
                this.setup.layout.nRows = 16;
                this.setup.layout.nCols = 24;
                break;
            case '1536W':
                this.setup.layout.nRows = 32;
                this.setup.layout.nCols = 48;
                break;
            default:
                throw new Error(`Invalid plate size: ${this.options.plateSize}`);
        }
        this.assay.prepareSetup(this.setup);
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
    }
    fillTitration() {
        let area = this.editorConc.getSelectionArea();
        let nPoints = area.trowMax - area.trowMin + 1;
        if (this.titrationPopup.direction === 'horizontal')
            nPoints = area.tcolMax - area.tcolMin + 1;
        let startConc = parseFloat(this.titrationPopup.startConc);
        let factor = parseFloat(this.titrationPopup.factor);
        for (let iPoint = 0; iPoint < nPoints; iPoint++) {
            let exponent = iPoint;
            if (this.titrationPopup.ascDesc === 'descending')
                exponent = -exponent;
            let conc = startConc * Math.pow(factor, exponent);
            if (this.titrationPopup.direction === 'horizontal') {
                let tcol = area.tcolMin + iPoint;
                for (let trow = area.trowMin; trow <= area.trowMax; trow++)
                    this.editorConc.setDataContent(trow, tcol, conc);
            }
            else {
                let trow = area.trowMin + iPoint;
                for (let tcol = area.tcolMin; tcol <= area.tcolMax; tcol++)
                    this.editorConc.setDataContent(trow, tcol, conc);
            }
        }
    }
    clearConc() {
        this.editorConc.clearSelectedContent();
    }
    showTitrationPopup() {
        this.titrationPopup.show();
    }
    showTemplatePopupSave() {
        this.templatePopupSave.templateID = null;
        this.templatePopupSave.show();
    }
    showTemplatePopupLoad() {
        this.templatePopupLoad.show();
    }
    loadTemplate() {
        this.templatePopupLoad.hide();
        this.setup.layout = this.templatePopupLoad.getSelectedTemplate().content;
    }
    saveTemplate() {
        let template = {
            eClass: 'Template',
            name: this.templatePopupSave.templateName,
            description: this.templatePopupSave.description,
            type: 'AssayDM.Layout',
            status: _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].COMPLETED,
            content: this.setup.layout
        };
        this.server.saveEntities([template])
            .then(response => {
            let templateID = response.newEntities[0].id;
            this.templatePopupSave.showReceipt(templateID);
        });
    }
    showAddSamplesSpreadsheet() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const samples = yield this.sis.getSamples();
            samples.forEach(s => {
                s.eClass = 'Sample';
                if (!s.id)
                    s.id = `#idSmp${this.nextInputSampleAlias++}`;
                s.format = 'Vial';
                if (s.name)
                    this.setup.input.samples.push(s);
            });
        });
    }
    addPlates(plates) {
        if (plates.length < 1)
            return;
        if (this.setup.mode === 'InputSamples')
            throw new Error('Please do not mix input-plates and input-samples');
        this.setup.mode = 'InputPlates';
        for (let plate of plates) {
            if (plate.nRows !== this.setup.operation.plate.nRows || plate.nCols !== this.setup.operation.plate.nCols)
                throw Error(`Plate ${plate.name} does not match the assay plate dimensions`);
            this.setup.input.plates.push(plate);
        }
        this.fetchInputPlateContent();
    }
    addSamples(samples) {
        if (samples.length < 1)
            return;
        if (this.setup.mode === 'InputPlates')
            throw new Error('Please do not mix input-plates and input-samples');
        this.setup.mode = 'InputSamples';
        for (let sample of samples)
            this.setup.input.samples.push(sample);
        this.assay.processInput(this.setup);
    }
    fetchInputPlateContent() {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        this.iPlateContentRequest++;
        let requestNo = this.iPlateContentRequest;
        let plateIDs = this.setup.input.plates.map(p => p.id);
        this.server.datasetQuery([
            { eClass: 'Sample', collection: 'samples', filters: [{ field: 'PlateID', values: plateIDs }] },
            { eClass: 'PlateLayer', collection: 'layers', filters: [{ field: 'PlateID', values: plateIDs }] }
        ]).then(dataset => {
            if (this.iPlateContentRequest > requestNo)
                return;
            this.setup.input.samples = dataset.samples;
            this.setup.input.layers = dataset.layers;
            this.assay.processInput(this.setup);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
    getSamples(plate) {
        let inputSamples = this.setup.input.samples.filter(s => s.plateID === plate.id);
        let outputSamples = this.setup.output.samples.filter(s => s.plateID === plate.id);
        return inputSamples.concat(outputSamples);
    }
    updateOutput() {
        this.assay.createOutput(this.setup);
    }
    createStep() {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        let step = this.setup.step;
        this.assay.createOutput(this.setup);
        let entities = [];
        this.setup.input.samples.filter(s => s.id.startsWith('#')).forEach(s => { entities.push(s); });
        if (this.setup.experiment.id.startsWith('#'))
            entities.push(this.setup.experiment);
        entities.push(step);
        step.input = this.setup.input.samples.map(s => { return { id: s.id, eClass: 'Sample' }; });
        step.input.push.apply(step.input, this.setup.input.plates.map(p => { return { eClass: 'Plate', id: p.id }; }));
        entities.push.apply(entities, this.setup.output.plates.filter(p => p.id.startsWith('#')));
        entities.push.apply(entities, this.setup.output.layers);
        entities.push.apply(entities, this.setup.output.samples);
        this.server.saveEntities(entities)
            .then(response => {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            let experiment = response.newEntities.find(e => e.eClass === 'Experiment');
            this.router.navigate('/eln/' + experiment.id);
        });
    }
};
AssayDMDesigner = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["SampleInputSelectorDialogService"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginLoader"]])
], AssayDMDesigner);



/***/ }),

/***/ "module/assaydm/designer.html":
/*!******************************************!*\
  !*** ./SPA/module/assaydm/designer.html ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/grid/plate-editor\"></require>\r\n    <require from=\"element/grid/sample-plates-editor\"></require>\r\n    <require from=\"element/plate-view\"></require>\r\n    <require from=\"./ui/titration-popup\"></require>\r\n    <require from=\"./ui/assay-template-popup-save\"></require>\r\n    <require from=\"./ui/assay-template-popup-load\"></require>\r\n\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>Setup Plate Assay</h1>\r\n            <button click.delegate=\"createStep()\">Create Assay</button>\r\n        </div>\r\n\r\n        <div>\r\n            <div class=\"page-panels\">\r\n                <div class=\"grid\" style=\"margin-bottom: 10px; grid-auto-rows: minmax(0, max-content);\">\r\n\r\n                    <div class=\"panel\" style=\"grid-column: span 1;\">\r\n                        <div class=\"panel-heading\">\r\n                            <span>Experiment Info</span>\r\n                            <collapsible />\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <div class=\"form-group\">\r\n                                <label>Name</label>\r\n                                <input value.bind=\"setup.experiment.name\" />\r\n                            </div>\r\n                            <div class=\"form-group\">\r\n                                <label>Type</label>\r\n                                <input value.bind=\"setup.experiment.type\" />\r\n                            </div>\r\n                            <div class=\"form-group\">\r\n                                <label>Scientist</label>\r\n                                <input value.bind=\"setup.experiment.scientistID\" />\r\n                            </div>\r\n                            <div class=\"form-group\">\r\n                                <label>Analyst</label>\r\n                                <input value.bind=\"setup.experiment.analystID\" />\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div class=\"panel\" style=\"grid-column: span 3;\">\r\n                        <div class=\"panel-heading\">\r\n                            <span>Input Samples</span>\r\n                            <collapsible />\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <button click.delegate=\"showAddSamplesSpreadsheet()\">Add Sample Using Spreadsheet</button>\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>ID</th>\r\n                                        <th>Name</th>\r\n                                        <th>Type</th>\r\n                                        <th>Content</th>\r\n                                        <th>Compound</th>\r\n                                        <th>Batch</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"sample of setup.input.samples\">\r\n                                        <td>\r\n                                            <a href=\"/#/entity/Sample/${sample.id}\">${sample.id}</a>\r\n                                        </td>\r\n                                        <td>${sample.name}</td>\r\n                                        <td>${sample.type}</td>\r\n                                        <td>${sample.content}</td>\r\n                                        <td>${sample.compoundID}</td>\r\n                                        <td>${sample.batchID}</td>\r\n                                        <td>${sample.description}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"grid full-width-panels\">\r\n                    <div class=\"panel\">\r\n                        <div class=\"panel-heading\">\r\n                            <span>Plate Layout</span>\r\n                            <collapsible />\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <assay-template-popup-save view-model.ref=\"templatePopupSave\" save-click.call=\"saveTemplate()\"></assay-template-popup-save>\r\n                            <assay-template-popup-load view-model.ref=\"templatePopupLoad\" load-click.call=\"loadTemplate()\"></assay-template-popup-load>\r\n\r\n                            <button click.delegate=\"showTemplatePopupLoad()\">Load Template</button>\r\n                            <button click.delegate=\"showTemplatePopupSave()\">Save Template</button>\r\n\r\n                            <h3>Samples</h3>\r\n                            <sample-plates-editor n-rows.bind=\"setup.layout.nRows\" n-cols.bind=\"setup.layout.nCols\" wells.bind=\"setup.layout.layers['sample-layout'].content.wells\"\r\n                                field-name=\"valueText\"></sample-plates-editor>\r\n\r\n                            <h3>Concentration</h3>\r\n                            <p>\r\n                                <button click.delegate=\"showTitrationPopup()\">\r\n                                    <span class=\"fa fa-sort-amount-desc\"></span>\r\n                                </button>\r\n                                <button click.delegate=\"clearConc()\">Clear</button>\r\n                            </p>\r\n                            <plate-editor view-model.ref=\"editorConc\" n-rows.bind=\"setup.layout.nRows\" n-cols.bind=\"setup.layout.nCols\" wells.bind=\"setup.layout.layers['concentration'].content.wells\"\r\n                                field-name=\"valueText\"></plate-editor>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div class=\"panel\">\r\n                        <div class=\"panel-heading\">\r\n                            <span>Assay Plates</span>\r\n                            <collapsible/>\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <p>\r\n                                <button click.delegate=\"updateOutput()\">Update</button>\r\n                            </p>\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Name</th>\r\n                                        <th>Barcode</th>\r\n                                        <th>Wells</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <template repeat.for=\"plate of setup.output.plates\">\r\n                                        <tr>\r\n                                            <td>${plate.name}</td>\r\n                                            <td>${plate.barcode}</td>\r\n                                            <td></td>\r\n                                            <td>${plate.description}</td>\r\n                                        </tr>\r\n                                        <tr>\r\n                                            <td colspan=\"4\">\r\n                                                <plate-view n-rows.bind=\"plate.nRows\" n-cols.bind=\"plate.nCols\" wells.bind=\"getSamples(plate)\" well-template.bind=\"outputWellTemplate\"></plate-view>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </template>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/assaydm/result-upload":
/*!**********************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/assaydm/result-upload.ts ***!
  \**********************************************************************************/
/*! exports provided: AssayDMResultUpload */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AssayDMResultUpload", function() { return AssayDMResultUpload; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _ui_envision_loader_dialog__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ui/envision-loader-dialog */ "module/assaydm/ui/envision-loader-dialog");
/* harmony import */ var _ui_envision_loader_dialog__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_ui_envision_loader_dialog__WEBPACK_IMPORTED_MODULE_5__);






let AssayDMResultUpload = class AssayDMResultUpload {
    constructor(server, dialog, router) {
        this.server = server;
        this.dialog = dialog;
        this.router = router;
    }
    activate(params) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.stepID = params.id;
            this.resultSet = {
                eClass: 'ResultSet',
                id: '#idRS',
                originID: this.stepID,
                type: 'ReaderOutput'
            };
            yield this.loadPlateInfo();
        });
    }
    loadPlateInfo() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Plate', collection: 'plates', filters: [{ field: 'OriginID', value: this.stepID }] },
                { eClass: 'PlateLayer', collection: 'layers', filters: [{ field: 'PlateID', in: 'plates.ID' }] }
            ]);
            this.plateInfos = dataset.plates.map(p => {
                return {
                    plate: p,
                    layer: {
                        eClass: 'PlateLayer',
                        name: p.name,
                        plateID: p.id,
                        resultSetID: '#idRS',
                        type: 'ReaderOutput',
                        content: { wells: [] }
                    }
                };
            });
            this.layers = dataset.layers;
        });
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Saving...');
            let entities = [this.resultSet];
            for (let pi of this.plateInfos)
                entities.push(pi.layer);
            yield this.server.saveEntities(entities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            this.router.navigate('/entity/step/' + this.stepID);
        });
    }
    dropped(e, plateInfo) {
        let dialogModel = { e: e, plateInfo: plateInfo };
        this.dialog.open({ viewModel: _ui_envision_loader_dialog__WEBPACK_IMPORTED_MODULE_5__["EnvisionLoaderDialog"], model: dialogModel, lock: true, view: __webpack_require__(/*! ./ui/envision-loader-dialog.html */ "module/assaydm/ui/envision-loader-dialog.html") })
            .whenClosed(response => {
            if (response.wasCancelled)
                return;
            plateInfo.layer.content.wells = dialogModel.selectedLayer.content.wells.filter(w => w.posRow < plateInfo.plate.nRows && w.posCol < plateInfo.plate.nCols);
        });
    }
};
AssayDMResultUpload = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"]])
], AssayDMResultUpload);



/***/ }),

/***/ "module/assaydm/result-upload.html":
/*!***********************************************!*\
  !*** ./SPA/module/assaydm/result-upload.html ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/grid/plate-editor\"></require>\r\n    <require from=\"element/plate-view\"></require>\r\n\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>\r\n                Upload Plate Reader Results:&nbsp;<e-link e-class=\"Step\" entity-id.bind=\"stepID\"></e-link>\r\n            </h1>\r\n            <button click.delegate=\"save()\">Save</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid full-width-panels\" style=\"height: auto;\">\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Result Set</div>\r\n                <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <label>Name</label>\r\n                            <input value.bind=\"resultSet.name\"/>\r\n                        </div>        \r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Description</label>\r\n                            <input value.bind=\"resultSet.description\"/>\r\n                        </div>        \r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" repeat.for=\"pi of plateInfos\">\r\n                <div class=\"panel-heading\"><a href=\"/#/entity/Plate/${pi.plate.id}\">${pi.plate.name}</a></div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\" style=\"width: 300px;\">\r\n                        <dropzone dropfiles.trigger=\"dropped($event, pi)\" title=\"Drop Reader File Here\"></dropzone>\r\n                    </div>\r\n                    <plate-editor n-rows.bind=\"pi.plate.nRows\" n-cols.bind=\"pi.plate.nCols\"\r\n                        wells.bind=\"pi.layer.content.wells\" field-name=\"valueText\"></plate-editor>\r\n                    <div class=\"form-group\">\r\n                        <label>Description</label>\r\n                        <input value.bind=\"pi.layer.description\"/>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/assaydm/ui/assay-options-dialog":
/*!*******************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-options-dialog.js ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AssayOptionsDialog = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AssayOptionsDialog = exports.AssayOptionsDialog = (_dec = (0, _aureliaFramework.inject)(_core.ServerAPI), _dec(_class = function () {
    function AssayOptionsDialog(api) {
        _classCallCheck(this, AssayOptionsDialog);

        this.api = api;

        this.getTemplates();
    }

    _createClass(AssayOptionsDialog, [{
        key: 'init',
        value: function init(options) {
            this.options = options;
            this.options.template = this.templates[0];
        }

        // /////////////////////////////////////////////////////////////

    }, {
        key: 'selectExperiment',
        value: function selectExperiment(id) {
            this.context.experimentID = id;
            this.experimentChanged();
            $('#experiment-select').hide();
            $('#parent-step').focus();
        }
    }, {
        key: 'experimentFocus',
        value: function experimentFocus() {
            var _this = this;

            if (!this.experiments) {
                this.experiments = [];
                this.api.getEntities('Experiment', [{ field: 'Status', value: 'InProgress' }]).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    _this.experiments = response.data;
                });
            }
            $('#experiment-select').show();
        }
    }, {
        key: 'experimentBlur',
        value: function experimentBlur() {
            if (this.inExpPopup) return;
            $('#experiment-select').hide();
        }
    }, {
        key: 'blurExpPopup',
        value: function blurExpPopup() {
            $('#experiment-select').hide();
            this.inExpPopup = false;
        }
    }, {
        key: 'enterExpPopup',
        value: function enterExpPopup() {
            this.inExpPopup = true;
        }
    }, {
        key: 'leaveExpPopup',
        value: function leaveExpPopup() {
            this.inExpPopup = false;
        }
    }, {
        key: 'clickExpPopup',
        value: function clickExpPopup(e) {
            e.preventDefault();
            $(this).focus();
        }

        // /////////////////////////////////////////////////////////////

    }, {
        key: 'experimentChanged',
        value: function experimentChanged() {
            var _this2 = this;

            this.steps = [];
            this.api.getEntities('Step', [{ field: 'ExperimentID', value: this.context.experimentID }]).then(function (response) {
                return response.json();
            }).then(function (response) {
                _this2.steps = response.data;
            });
        }
    }, {
        key: 'selectStep',
        value: function selectStep(id) {
            this.context.parentStepID = id;
            $('#step-select').hide();
        }
    }, {
        key: 'stepFocus',
        value: function stepFocus() {
            $('#step-select').show();
        }
    }, {
        key: 'stepBlur',
        value: function stepBlur() {
            if (this.inStepPopup) return;
            $('#step-select').hide();
        }
    }, {
        key: 'enterStepPopup',
        value: function enterStepPopup() {
            this.inStepPopup = true;
        }
    }, {
        key: 'leaveStepPopup',
        value: function leaveStepPopup() {
            this.inStepPopup = false;
        }

        // //////////////////////////////////////////////////////////////

    }, {
        key: 'getTemplates',
        value: function getTemplates() {
            this.templates = [{
                description: 'Generic step with input samples and plates',
                name: 'PlateAssayGeneric',
                path: '/module/wfm/step-create-generic',
                route: 'CreateStepGeneric',
                type: 'Generic'
            }, {
                description: 'Plate assay designer',
                name: 'Plate assay designer',
                path: '/module/assaydm/designer',
                route: 'CreateStepAssayDM',
                type: 'Plate'
            }, {
                description: 'Plate-based assay',
                name: 'Plate-based assay',
                path: '/module/assaydm/page/step-create',
                route: 'CreateStepAssayDM',
                type: 'Plate'
            }, {
                description: 'Plate-based ELISA or MSD assay',
                name: 'Quantitative ELISA',
                path: '/module/assaydm/page/step-create-elisa',
                route: 'CreateStepAssayELISA',
                type: 'ELISA'
            }, {
                description: 'Simple transfer of all samples in plates',
                name: 'Simple plate transfer',
                path: '/module/pns/step-create-plate-transfer',
                route: 'CreateStepPlateTransfer',
                type: 'Transfer'
            }, {
                description: 'Plate transfer of selected samples',
                name: 'Plate cherry pick',
                path: '/module/pns/step-create-cherry-pick',
                route: 'CreateStepCherryPick',
                type: 'CherryPick'
            }];
        }
    }]);

    return AssayOptionsDialog;
}()) || _class);

/***/ }),

/***/ "module/assaydm/ui/assay-options-dialog.html":
/*!*********************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-options-dialog.html ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"min-width: 500px;\">\r\n        <ux-dialog-header>Assay Options</ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div class=\"form-group\">\r\n                <label>Select a step category:</label>\r\n                <select value.bind=\"option.template\" attach-focus=\"true\">\r\n                    <option repeat.for=\"template of templates\"\r\n                            model.bind=\"options.template\">\r\n                        ${template.name}\r\n                    </option>\r\n                </select>\r\n                <p>\r\n                    <span class=\"fa fa-info-circle\"></span>\r\n                    ${options.template.description}\r\n                </p>\r\n            </div>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Select plate size</label>\r\n                <div class=\"radio\">\r\n                    <span><input type=\"radio\" value=\"24W\" checked.bind=\"options.plateSize\" />24 Wells</span>\r\n                    <span><input type=\"radio\" value=\"96W\" checked.bind=\"options.plateSize\" />96 Wells</span>\r\n                    <span><input type=\"radio\" value=\"384W\" checked.bind=\"options.plateSize\" />384 Wells</span>\r\n                    <span><input type=\"radio\" value=\"1536W\" checked.bind=\"options.plateSize\" />1,536 Wells</span>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Experiment</label>\r\n                <div class=\"radio\">\r\n                    <span><input type=\"radio\" value=\"new\" checked.bind=\"options.experiment\" />New</span>\r\n                    <span><input type=\"radio\" value=\"existing\" checked.bind=\"options.experiment\" />Existing</span>\r\n                </div>\r\n\r\n            </div>\r\n\r\n            <div if.bind=\"context.experiment ==='existing'\">\r\n\r\n                <div class=\"form-group\">\r\n                    <label>Experiment</label>\r\n                    <div id=\"experiment-select\" class=\"search-popover\" tabindex=\"-1\"\r\n                         mouseover.trigger=\"enterExpPopup()\" mouseout.trigger=\"leaveExpPopup()\"\r\n                         blur.trigger=\"blurExpPopup()\" click.trigger=\"clickExpPopup($event)\">\r\n                        <div class=\"panel-heading\">Select Experiment</div>\r\n                        <div class=\"panel-body\">\r\n                            <table class=\"table compact selectable\">\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Name</th>\r\n                                        <th>Type</th>\r\n                                        <th>Scientist</th>\r\n                                        <th>Analyst</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"exp of experiments\" click.delegate=\"$parent.selectExperiment(exp.id)\">\r\n                                        <td>${exp.name}</td>\r\n                                        <td>${exp.type}</td>\r\n                                        <td>${exp.scientistID}</td>\r\n                                        <td>${exp.analystID}</td>\r\n                                        <td>${exp.description}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                    <p><input style=\"width: 150px;\" value.bind=\"context.experimentID\" focus.trigger=\"experimentFocus()\" blur.trigger=\"experimentBlur()\" change.delegate=\"experimentChanged()\" /></p>\r\n                </div>\r\n\r\n                <div class=\"form-group\">\r\n                    <label>Parent Step</label>\r\n                    <div id=\"step-select\" class=\"search-popover\" mouseover.trigger=\"enterStepPopup()\" mouseout.trigger=\"leaveStepPopup()\">\r\n                        <div class=\"panel-heading\">Select Step</div>\r\n                        <div class=\"panel-body\">\r\n                            <table class=\"table compact selectable\">\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Name</th>\r\n                                        <th>Type</th>\r\n                                        <th>Analyst</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"step of steps\" click.delegate=\"$parent.selectStep(step.id)\">\r\n                                        <td>${step.name}</td>\r\n                                        <td>${step.type}</td>\r\n                                        <td>${step.analystID}</td>\r\n                                        <td>${step.description}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                    <p><input style=\"width: 150px;\" id=\"parent-step\" value.bind=\"context.parentStepID\" focus.trigger=\"stepFocus()\" blur.trigger=\"stepBlur()\" /></p>\r\n                </div>\r\n            </div>\r\n\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.trigger=\"dialog.ok()\">OK</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/assaydm/ui/assay-template-popup-load":
/*!************************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-template-popup-load.js ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AssayTemplatePopupLoad = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _desc, _value, _class2, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var AssayTemplatePopupLoad = exports.AssayTemplatePopupLoad = (_dec = (0, _aureliaFramework.inject)(_core.ServerAPI), _dec(_class = (_class2 = function () {
    function AssayTemplatePopupLoad(api) {
        _classCallCheck(this, AssayTemplatePopupLoad);

        _initDefineProp(this, 'loadClick', _descriptor, this);

        this.api = api;
    }

    _createClass(AssayTemplatePopupLoad, [{
        key: 'attached',
        value: function attached() {
            var _this = this;

            this.api.datasetQuery([{ eClass: 'Template', collection: 'templates', filters: [{ field: 'Type', value: 'AssayDM.Layout' }] }]).then(function (dataset) {
                _this.templates = dataset.templates;
            });
        }
    }, {
        key: 'getSelectedTemplate',
        value: function getSelectedTemplate() {
            var _this2 = this;

            return this.templates.find(function (t) {
                return t.id === _this2.selectedTemplateID;
            });
        }
    }, {
        key: 'show',
        value: function show() {
            $(this.popup).show();
        }
    }, {
        key: 'hide',
        value: function hide() {
            $(this.popup).hide();
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadClick();
        }
    }]);

    return AssayTemplatePopupLoad;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'loadClick', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class);

/***/ }),

/***/ "module/assaydm/ui/assay-template-popup-load.html":
/*!**************************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-template-popup-load.html ***!
  \**************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"form-wrapper\" ref=\"popup\">\r\n        <div class=\"popup-overlay\" click.trigger=\"hide()\"></div>\r\n        <div class=\"form-titration\">\r\n            <h3>Load Template</h3>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Select template:</label>\r\n                <select value.bind=\"selectedTemplateID\">\r\n                    <option repeat.for=\"template of templates\" value.bind=\"template.id\">${template.name}</option>\r\n                </select>\r\n            </div>\r\n\r\n            <button click.delegate=\"load()\">Load</button>\r\n        </div>\r\n    </div>\r\n</template>\r\n";

/***/ }),

/***/ "module/assaydm/ui/assay-template-popup-save":
/*!************************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-template-popup-save.js ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AssayTemplatePopupSave = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _desc, _value, _class2, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var AssayTemplatePopupSave = exports.AssayTemplatePopupSave = (_dec = (0, _aureliaFramework.inject)(_core.ServerAPI), _dec(_class = (_class2 = function () {
    function AssayTemplatePopupSave(api) {
        _classCallCheck(this, AssayTemplatePopupSave);

        _initDefineProp(this, 'saveClick', _descriptor, this);

        this.api = api;
        this.templateName = undefined;
        this.description = undefined;
    }

    _createClass(AssayTemplatePopupSave, [{
        key: 'show',
        value: function show() {
            $(this.popup).show();
        }
    }, {
        key: 'hide',
        value: function hide() {
            $(this.popup).hide();
        }
    }, {
        key: 'save',
        value: function save() {
            this.saveClick();
        }
    }, {
        key: 'showReceipt',
        value: function showReceipt(id) {
            this.templateID = id;
        }
    }]);

    return AssayTemplatePopupSave;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'saveClick', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class);

/***/ }),

/***/ "module/assaydm/ui/assay-template-popup-save.html":
/*!**************************************************************!*\
  !*** ./SPA/module/assaydm/ui/assay-template-popup-save.html ***!
  \**************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"form-wrapper\" ref=\"popup\">\r\n        <div class=\"popup-overlay\" click.trigger=\"hide()\"></div>\r\n        <div class=\"form-titration\">\r\n            <h3>Assay Template</h3>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Name</label>\r\n                <input value.bind=\"templateName\" />\r\n            </div>\r\n\r\n            <p if.bind=\"templateID\" class=\"highlight\">\r\n                Template created: <e-link e-class=\"Template\" entity-id.bind=\"templateID\"></e-link>\r\n            </p>\r\n\r\n            <button click.delegate=\"save()\">Save</button>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/assaydm/ui/envision-loader-dialog":
/*!*********************************************************!*\
  !*** ./SPA/module/assaydm/ui/envision-loader-dialog.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EnvisionLoaderDialog = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _peEnvision = __webpack_require__(/*! ../data-loaders/pe-envision */ "./SPA/module/assaydm/data-loaders/pe-envision.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EnvisionLoaderDialog = exports.EnvisionLoaderDialog = function () {
    function EnvisionLoaderDialog() {
        _classCallCheck(this, EnvisionLoaderDialog);

        this.wellTemplate = function (well) {
            return well.valueText;
        };
    }

    _createClass(EnvisionLoaderDialog, [{
        key: 'activate',
        value: function activate(model) {
            var _this = this;

            this.model = model;
            this.plate = model.plateInfo.plate;

            var reader = new FileReader();
            var file = model.e.detail.files[0];
            reader.onload = function (e) {
                var content = e.target.result;
                var envisionContent = new _peEnvision.PEEnvision().parse(file.name, content);
                _this.layers = envisionContent.plateLayers;
                _this.model.selectedLayer = _this.layers[0];
            };
            reader.readAsBinaryString(file);
        }
    }]);

    return EnvisionLoaderDialog;
}();

/***/ }),

/***/ "module/assaydm/ui/envision-loader-dialog.html":
/*!***********************************************************!*\
  !*** ./SPA/module/assaydm/ui/envision-loader-dialog.html ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/plate-view\"></require>\r\n\r\n    <ux-dialog style=\"width: 800px\">\r\n        <ux-dialog-header>Envision Loader</ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <h3>Please, select which plate layer to load</h3>\r\n            <template repeat.for=\"layer of layers\">\r\n\r\n                <h3>\r\n                    <input type=\"radio\" name=\"layerSelection\" model.bind=\"layer\" checked.bind=\"$parent.model.selectedLayer\"/>\r\n                    Layer ${layer.no}\r\n                </h3>\r\n                <table>\r\n                    <tr if.bind=\"layer.Label\"><th>Label</th><td>${layer.Label}</td></tr>\r\n                    <tr if.bind=\"layer.Measinfo\"><th>Measurement</th><td>${layer.Measinfo}</td></tr>\r\n                    <tr if.bind=\"layer.Formula\"><th>Formula</th><td>${layer.Formula}</td></tr>\r\n                </table>\r\n\r\n                <plate-view n-rows.bind=\"plate.nRows\" n-cols.bind=\"plate.nCols\" wells.bind=\"layer.content.wells\" well-template.bind=\"wellTemplate\"></plate-view>\r\n                \r\n            </template>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.trigger=\"dialog.ok()\">OK</button>\r\n            <button click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>\r\n";

/***/ }),

/***/ "module/assaydm/ui/titration-popup":
/*!**************************************************!*\
  !*** ./SPA/module/assaydm/ui/titration-popup.js ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TitrationPopup = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var TitrationPopup = exports.TitrationPopup = (_class = function () {
    function TitrationPopup() {
        _classCallCheck(this, TitrationPopup);

        _initDefineProp(this, 'fillClick', _descriptor, this);

        this.direction = 'horizontal';
        this.ascDesc = 'descending';
        this.factor = 2;
        this.startConc = 100;
    }

    _createClass(TitrationPopup, [{
        key: 'fill',
        value: function fill() {
            this.fillClick();
            this.hide();
        }
    }, {
        key: 'show',
        value: function show() {
            $(this.popup).show();
        }
    }, {
        key: 'hide',
        value: function hide() {
            $(this.popup).hide();
        }
    }]);

    return TitrationPopup;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'fillClick', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class);

/***/ }),

/***/ "module/assaydm/ui/titration-popup.html":
/*!****************************************************!*\
  !*** ./SPA/module/assaydm/ui/titration-popup.html ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"form-wrapper\" ref=\"popup\">\r\n        <div class=\"popup-overlay\" click.trigger=\"hide()\"></div>\r\n        <div class=\"form-titration\">\r\n            <h3>Titration Setup</h3>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Direction</label>\r\n                <p>\r\n                    <input type=\"radio\" name=\"direction\" value=\"horizontal\"\r\n                           checked.bind=\"direction\" />Horizontal\r\n                    <input type=\"radio\" name=\"direction\" value=\"vertical\"\r\n                           checked.bind=\"direction\" />Vertical\r\n                </p>\r\n            </div>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Start (top/left)</label>\r\n                <input value.bind=\"startConc\" />\r\n            </div>\r\n\r\n            <div class=\"form-group\">\r\n                <label>Dilution Factor</label>\r\n                <input value.bind=\"factor\" />\r\n                <input type=\"radio\" name=\"ascdesc\" value=\"ascending\"\r\n                       checked.bind=\"ascDesc\" />Ascending\r\n                <input type=\"radio\" name=\"ascdesc\" value=\"descending\"\r\n                       checked.bind=\"titrationAscDesc\" />Descending\r\n\r\n            </div>\r\n\r\n            <button click.delegate=\"fill()\">Fill</button>\r\n        </div>\r\n    </div>\r\n</template>\r\n";

/***/ })

}]);
//# sourceMappingURL=assayadm.7d2e17d8ae74be98b4b6.js.map