(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["module/data-upload"],{

/***/ "module/data-upload/visual-data-loader":
/*!*******************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/data-upload/visual-data-loader.ts ***!
  \*******************************************************************************************/
/*! exports provided: VisualDataLoader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VisualDataLoader", function() { return VisualDataLoader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var bluebird__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js");
/* harmony import */ var bluebird__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(bluebird__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_4__);





let VisualDataLoader = class VisualDataLoader {
    constructor(dataModel, server) {
        this.dataModel = dataModel;
        this.server = server;
        this.entityGroupClasses = [];
        this.selectedEClass = {};
        this.tab = 'input';
        this.waitingEntities = [];
        this.savedColumns = [
            {
                key: 'id',
                name: 'ID',
                renderer: (item, column) => '<a target="_blank" href="/#/entity/' + item.eClass + '/' + item.id + '">' + item.id + '</a>'
            },
            {
                key: 'eClass',
                name: 'Entity Class'
            }
        ];
        this.tableConfiguration = {
            enableSorting: false,
            showToolbar: false
        };
        dataModel.tables.filter(t => t.isEntity).forEach(t => {
            let group = this.entityGroupClasses.find(g => g.name === t.group);
            if (!group) {
                group = { name: t.group, classes: [] };
                this.entityGroupClasses.push(group);
            }
            group.classes.push({
                name: t.name,
                fields: t.columns.filter(c => !c.isShared || ['name', 'type', 'description', 'status'].indexOf(c.nameLC) !== -1).map(c => {
                    return {
                        key: c.nameLC,
                        name: c.name,
                        color: this.getRandomColor(),
                        area: null,
                        rawArea: null,
                        template: '',
                        toEnd: false,
                        singleValue: false,
                        renderer: (item, column) => item[column.key] ? item[column.key] : '',
                    };
                }).sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_4__(a.name, b.name))
            });
        });
        this.entityGroupClasses.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_4__(a.name, b.name));
        this.entityGroupClasses.forEach(group => group.classes.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_4__(a.name, b.name)));
    }
    dropped(e) {
        this.handleFiles(e.detail.files);
    }
    setToEnd(field) {
        if (!field.area)
            return;
        this.clearColor(field);
        if (!field.toEnd) {
            field.area.to.row = field.rawArea.to.row;
        }
        else {
            field.singleValue = false;
            field.area.to.row = this.data.length;
        }
        this.updateField(field);
    }
    setSingleValue(field) {
        if (!field.area)
            return;
        this.clearColor(field);
        if (!field.singleValue) {
            field.area.to.row = field.rawArea.to.row;
        }
        else {
            field.toEnd = false;
            field.area.to.row = field.area.from.row;
        }
        this.updateField(field);
    }
    setRange(field) {
        field.area = this.hot.getSelectedRange();
        field.rawArea = {
            from: { col: field.area.from.col, row: field.area.from.row },
            to: { col: field.area.to.col, row: field.area.to.row }
        };
        if (field.toEnd) {
            this.setToEnd(field);
        }
        else if (field.singleValue) {
            this.setSingleValue(field);
        }
        else {
            this.updateField(field);
        }
    }
    showTab(tab) {
        this.tab = tab;
        if (tab === 'output') {
            this.waitingEntities = [];
            this.selectedEClass.fields.filter(f => f.area && !f.singleValue).forEach(f => {
                for (let id = 0, r = f.area.from.row; r <= f.area.to.row; r++, id++) {
                    let row = this.waitingEntities.find(row => row.id === id);
                    if (!row) {
                        row = { id: id };
                        this.waitingEntities.push(row);
                    }
                    row[f.key] = this.hot.getDataAtCell(r, f.area.from.col);
                }
            });
            this.selectedEClass.fields.filter(f => f.singleValue).forEach(f => {
                this.waitingEntities.forEach(entity => entity[f.key] = this.hot.getDataAtCell(f.area.from.row, f.area.from.col));
            });
        }
    }
    upload() {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        this.waitingEntities.forEach(entity => {
            entity.eClass = this.selectedEClass.name;
            entity.id = '#id' + this.selectedEClass.name + entity.id;
        });
        this.selectedEClass.fields.forEach(f => this.savedColumns.push({ key: f.key, name: f.name, renderer: f.renderer }));
        this.server.saveEntities(this.waitingEntities)
            .then(response => {
            this.savedEntities = this.waitingEntities;
            for (let i = 0; i < response.newEntities.length; i++) {
                this.savedEntities[i].id = response.newEntities[i].id;
            }
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
        }, response => {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
        });
    }
    clearColor(field) {
        if (field.area) {
            for (let r = field.area.from.row; r <= field.area.to.row; r++) {
                for (let c = field.area.from.col; c <= field.area.to.col; c++) {
                    this.hot.setCellMeta(r, c, 'backgroundColor', 'transparent');
                }
            }
        }
    }
    updateField(field) {
        field.template = this.hot.getColHeader(field.area.from.col) + (field.area.from.row + 1);
        if (field.toEnd) {
            field.template += ':end';
        }
        else if (!field.singleValue) {
            field.template += ':' + this.hot.getColHeader(field.area.to.col) + (field.area.to.row + 1);
        }
        for (let r = field.area.from.row; r <= field.area.to.row; r++) {
            for (let c = field.area.from.col; c <= field.area.to.col; c++) {
                this.hot.setCellMeta(r, c, 'backgroundColor', field.color);
            }
        }
        this.hot.render();
    }
    getRandomColor() {
        let newColor = "rgba(";
        for (var i = 0; i < 3; i++) {
            newColor += Math.round(Math.random() * 256) + ',';
        }
        newColor += '0.2)';
        return newColor;
    }
    ;
    backgroundRenderer(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
        const backgroundColor = instance.getCellMeta(row, col)['backgroundColor'];
        td.style.background = backgroundColor;
    }
    handleFiles(files) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        if (files && files.length === 1 && files[0].name.toLowerCase().endsWith('.xlsx')) {
            const file = files[0];
            const reader = new FileReader();
            reader.onload = e => {
                if (file.name.toLowerCase().endsWith('.xlsx')) {
                    const workbook = XLSX.read(reader.result, { type: 'binary' });
                    const sheetName = workbook.SheetNames[0];
                    const sheet = workbook.Sheets[sheetName];
                    const json = XLSX.utils.sheet_to_json(sheet, { header: 1, defval: '' });
                    if (json.length) {
                        this.data = json;
                        bluebird__WEBPACK_IMPORTED_MODULE_3__["delay"](10).then(() => {
                            const hotElement = document.querySelector('#hot');
                            const hotSettings = {
                                data: this.data,
                                outsideClickDeselects: false,
                                readOnly: true,
                                stretchH: 'all',
                                autoWrapRow: true,
                                rowHeaders: true,
                                colHeaders: true,
                                manualRowResize: true,
                                manualColumnResize: true,
                                manualRowMove: true,
                                manualColumnMove: true,
                                cells: (row, col, prop) => {
                                    return {
                                        renderer: this.backgroundRenderer
                                    };
                                }
                            };
                            this.hot = new Handsontable(hotElement, hotSettings);
                        });
                    }
                }
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            };
            reader.readAsBinaryString(file);
        }
    }
};
VisualDataLoader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], VisualDataLoader);



/***/ }),

/***/ "module/data-upload/visual-data-loader.html":
/*!********************************************************!*\
  !*** ./SPA/module/data-upload/visual-data-loader.html ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/scirex-table\"></require>\r\n\r\n    <div class=\"page-with-header\">\r\n\r\n        <div class=\"page-header\"><h1>Scifeon Demo Pages</h1></div>\r\n        <div class=\"panel-group\">\r\n\r\n            <div class=\"page-panels grid full-width-panels\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Visual Data Upload Demo</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            This page shows different kinds of entities that can be uploaded to Scifeon. Picking an item from the drop-down menu opens an options menu and a files upload zone. <br>\r\n                            A Demo file is coming soon.\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"page-panels\">\r\n                <div if.bind=\"savedEntities\">\r\n                    <div class=\"panel\">\r\n                        <div class=\"panel-heading\">\r\n                            Result\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <scirex-table in-memory-items.bind=\"savedEntities\" style=\"width:100%;\" height=\"70vh\" columns.bind=\"savedColumns\" config.bind=\"tableConfiguration\"></scirex-table> \r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                <div class=\"flow-panels\" if.bind=\"!savedEntities\">\r\n                    <div class=\"panel\" style=\"width:20%;min-width:200px;\">\r\n                        <div class=\"panel-heading\">1. Choose Entity Class</div>\r\n                        <div class=\"panel-body\">\r\n                            <div class=\"form-group\">\r\n                                <label>Entity Class</label>\r\n                                <select value.bind=\"selectedEClass\">\r\n                                    <option>Select</option>\r\n                                    <optgroup repeat.for=\"group of entityGroupClasses\" label=\"${group.name}\">\r\n                                        <option repeat.for=\"class of group.classes\" model.bind=\"class\">${class.name}</option>\r\n                                    </option>\r\n                                </select>\r\n                            </div>                        \r\n                            <div class=\"form-group\" repeat.for=\"field of selectedEClass.fields\">\r\n                                <label>${field.name}</label>\r\n                                <div class=\"input-group\">\r\n                                    <input type=\"text\" value.bind=\"field.template\" placeholder=\"Choose range and set\" css=\"background-color: ${field.color}\">\r\n                                    <button class=\"input-group-btn\" click.delegate=\"setRange(field)\">Set</button>\r\n                                </div>\r\n                                <label>\r\n                                    <input type=\"checkbox\" checked.bind=\"field.toEnd\" change.delegate=\"setToEnd(field)\" />\r\n                                    Continue to last row\r\n                                </label>\r\n                                <label>\r\n                                    <input type=\"checkbox\" checked.bind=\"field.singleValue\" change.delegate=\"setSingleValue(field)\" />\r\n                                    Single value for all\r\n                                </label>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                    \r\n                    <div class=\"panel\" style=\"width:80%;margin-left:10px;\" if.bind=\"selectedEClass !== 'Select'\">\r\n                        <ul class=\"tab tab-block\" if.bind=\"data\">\r\n                            <li class=\"tab-item ${tab === 'input' ? 'active' : ''}\">\r\n                                <a href=\"#tabs\" click.delegate=\"showTab('input')\">\r\n                                2. Select input\r\n                                </a>\r\n                            </li>\r\n                            <li class=\"tab-item ${tab === 'output' ? 'active' : ''}\">\r\n                                <a href=\"#tabs\" click.delegate=\"showTab('output')\">\r\n                                3. Validate output\r\n                                </a>\r\n                            </li>\r\n                        </ul>\r\n                        <div class=\"panel-heading\" if.bind=\"!data\">\r\n                            2. Upload Excel Sheet\r\n                        </div>\r\n                        <div class=\"panel-body\">                        \r\n                            <dropzone if.bind=\"!data\" dropfiles.trigger=\"dropped($event)\" title=\"Drop Excel Files Here\"></dropzone>\r\n\r\n                            <div if.bind=\"data\">\r\n                                <div id=\"hot\" show.bind=\"tab === 'input'\" style=\"overflow:hidden;width:100%;height:87vh;\"></div>\r\n\r\n                                <div show.bind=\"tab === 'output'\">\r\n                                    <scirex-table in-memory-items.bind=\"waitingEntities\" style=\"width:100%;\" height=\"70vh\" columns.bind=\"selectedEClass.fields\" config.bind=\"tableConfiguration\"></scirex-table>    \r\n                                    <br/><br/>\r\n                                    <button class=\"float-right\" click.delegate=\"upload()\">Upload</button>\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=data-upload.7d2e17d8ae74be98b4b6.js.map