(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["public"],{

/***/ "./SPA/services/router-steps/app-insights-step.ts":
/*!********************************************************!*\
  !*** ./SPA/services/router-steps/app-insights-step.ts ***!
  \********************************************************/
/*! exports provided: AppInsightsStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppInsightsStep", function() { return AppInsightsStep; });
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_0__);

class AppInsightsStep {
    constructor() {
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_0__["LogManager"].getLogger('AppInsights');
        if (window.location.hostname !== 'localhost' && window['appInsights']) {
            this.client = window['appInsights'];
        }
        else {
            this.logger.debug('AppInsights not loaded.');
        }
    }
    run(routingContext, next) {
        if (this.client) {
            if (routingContext.previousInstruction) {
                this.client.stopTrackPage(routingContext.previousInstruction.fragment, window.location.href);
            }
            else {
                this.client.trackPageView(routingContext.fragment, window.location.href);
            }
            this.logger.debug('Tracking page view:', routingContext.fragment);
            this.client.startTrackPage(routingContext.fragment);
        }
        return next();
    }
}


/***/ }),

/***/ "./SPA/services/router-steps/loading-steps.ts":
/*!****************************************************!*\
  !*** ./SPA/services/router-steps/loading-steps.ts ***!
  \****************************************************/
/*! exports provided: LoadingAuthorizeStep, LoadingPreActivateStep, LoadingPreRenderStep, LoadingPostRenderStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingAuthorizeStep", function() { return LoadingAuthorizeStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreActivateStep", function() { return LoadingPreActivateStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreRenderStep", function() { return LoadingPreRenderStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPostRenderStep", function() { return LoadingPostRenderStep; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! nprogress */ "./node_modules/nprogress/nprogress.js");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(nprogress__WEBPACK_IMPORTED_MODULE_1__);


class LoadingAuthorizeStep {
    constructor() {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["configure"]({ showSpinner: false });
    }
    run(routingContext, next) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true);
        nprogress__WEBPACK_IMPORTED_MODULE_1__["start"]();
        return next();
    }
}
class LoadingPreActivateStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.2);
        return next();
    }
}
class LoadingPreRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.6);
        return next();
    }
}
class LoadingPostRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["done"]();
        return next();
    }
}


/***/ }),

/***/ "./node_modules/nprogress/nprogress.js":
/*!*****************************************************************************************!*\
  !*** delegated ./node_modules/nprogress/nprogress.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/nprogress/nprogress.js");

/***/ }),

/***/ "async!module/public/user/confirm":
/*!*****************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/module/public/user/confirm.ts ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./confirm.ts */ "module/public/user/confirm"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/public/user/forgot":
/*!****************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/module/public/user/forgot.ts ***!
  \****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./forgot.ts */ "module/public/user/forgot"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/public/user/login":
/*!***************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/module/public/user/login.ts ***!
  \***************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./login.ts */ "module/public/user/login"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/public/user/new-password":
/*!**********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/module/public/user/new-password.ts ***!
  \**********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./new-password.ts */ "module/public/user/new-password"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/public/windows-authentication-not-found":
/*!*************************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/module/public/windows-authentication-not-found.ts ***!
  \*************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.resolve(/*! require.ensure */).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./windows-authentication-not-found.ts */ "module/public/windows-authentication-not-found"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "module/error/error-panel":
/*!*****************************************!*\
  !*** ./SPA/module/error/error-panel.ts ***!
  \*****************************************/
/*! exports provided: ErrorPanel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ErrorPanel", function() { return ErrorPanel; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/error/bug-report-service */ "./SPA/module/error/bug-report-service.ts");
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");







let ErrorPanel = class ErrorPanel {
    constructor(errorManager, reportService, http, dialog) {
        this.errorManager = errorManager;
        this.reportService = reportService;
        this.http = http;
        this.dialog = dialog;
        this.errorManager.subscribe(this);
    }
    hide() {
        this.message = '';
    }
    showMessage(message, error = null) {
        const code = error ? error.code || -1 : -1;
        message = message || error ? error.message : '';
        const hint = error ? error.hint : '';
        const stack = error ? error.message + '\n' + (error.stack || error.stacktrace) : '';
        this.showApiError({
            code: code,
            message: message,
            hint: hint,
            stacktrace: stack
        });
    }
    showError(error) {
        if (!error)
            return;
        this.showApiError({
            code: error.code || -1,
            message: error.message,
            hint: error.hint,
            stacktrace: error.stack || error.stacktrace
        });
    }
    showApiError(error) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        this.error = error;
        this.message = error.message;
    }
    showDetails() {
        let html = '<pre><b>Message: </b> ' + this.message;
        if (this.error.hint) {
            html += '<br/><b>Hint:</b><br/>' + this.error.hint;
        }
        if (this.error.stacktrace) {
            html += '<br/><b>Stacktrace:</b><br/>' + this.error.stacktrace;
        }
        html += '</pre>';
        this.dialog.message(html);
    }
    report() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.reportService.report(this.error);
        });
    }
};
ErrorPanel = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__["ErrorManager"], module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__["BugReportService"], aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__["HttpClient"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ErrorPanel);



/***/ }),

/***/ "module/error/error-panel.html":
/*!*******************************************!*\
  !*** ./SPA/module/error/error-panel.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div id=\"error-panel\" class=\"toast toast-error\" if.bind=\"message\">\r\n        <div class=\"float-right\">\r\n            <span if.bind=\"error.stacktrace || error.hint\"><a click.delegate=\"showDetails()\">Show details</a> | </span>\r\n            <a href=\"#\" click.delegate=\"report()\" title=\"Submit Bug Report\">Report</a>\r\n            <button class=\"btn-clear float-right\" style=\"color: white;\" title=\"Close\" click.trigger=\"hide()\"></button>\r\n        </div>\r\n        ${message}\r\n    </div>\r\n    <div style=\"position:absolute;bottom:0; width: 100%;\" id=\"screenshot-screen-widener\"></div>\r\n</template>";

/***/ }),

/***/ "module/public/user/confirm":
/*!********************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/user/confirm.ts ***!
  \********************************************************************************/
/*! exports provided: Confirm */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Confirm", function() { return Confirm; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let Confirm = class Confirm {
    constructor(server) {
        this.server = server;
        this.isLoading = true;
    }
    activate(params) {
        if (!params.userId || !params.code) {
            this.isLoading = false;
        }
        else {
            const codeIndex = window.location.hash.indexOf('&code=');
            const code = window.location.hash.substr(codeIndex + 6);
            this.server.postJson('/api/user/confirm', {
                userId: params.userId,
                code: code
            })
                .then(response => response.json())
                .then(result => {
                if (result.newPasswordCode) {
                    this.userId = params.userId;
                    this.newPasswordCode = result.newPasswordCode;
                }
                this.isLoading = false;
            });
        }
    }
};
Confirm = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], Confirm);



/***/ }),

/***/ "module/public/user/confirm.html":
/*!*********************************************!*\
  !*** ./SPA/module/public/user/confirm.html ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <h1>Confirm email</h1>\r\n            <div if.bind=\"isLoading\" class=\"text-center\">\r\n                    Confirming...\r\n                <div class=\"loading loading-lg\"></div>\r\n                <br/>\r\n            </div>\r\n            <p if.bind=\"!isLoading && newPasswordCode\">\r\n                Your email address has been confimed. <a href=\"/#/new-password?userId=${userId}&code=${newPasswordCode}\">Click here to create a password.</a>\r\n            </p>\r\n            <p if.bind=\"!isLoading && !newPasswordCode\">\r\n                Your email address could not be confirmed. The link only works for 24 hours. <a href=\"/#/forgot\">Click here to request a new email by requesting a new password.</a>\r\n            </p>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/public/user/forgot":
/*!*******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/user/forgot.ts ***!
  \*******************************************************************************/
/*! exports provided: Forgot */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Forgot", function() { return Forgot; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let Forgot = class Forgot {
    constructor(server) {
        this.server = server;
        this.isLoading = false;
        this.sent = false;
    }
    send() {
        this.isLoading = true;
        this.server.postJson('/api/user/password/forgot', {
            email: this.email
        })
            .then(response => {
            this.sent = true;
        });
    }
};
Forgot = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], Forgot);



/***/ }),

/***/ "module/public/user/forgot.html":
/*!********************************************!*\
  !*** ./SPA/module/public/user/forgot.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <h1>Forgot password</h1>\r\n            <div if.bind=\"!sent\">\r\n                <p>\r\n                    Enter your username below, and we will send you a link to reset your password.\r\n                </p>\r\n                <form submit.trigger=\"send()\">\r\n                        <div class=\"form-group\">\r\n                        <label>Username</label>\r\n                        <input type=\"text\" value.bind=\"email\" placeholder=\"E-mail\"/>  \r\n                    </div>\r\n                    <div class=\"form-group\">     \r\n                        <div class=\"float-right\">\r\n                            <div if.bind=\"isLoading\" class=\"loading float-left\" style=\"margin-right:8px;\"></div>\r\n                            <button class=\"primary\" type=\"submit\" disabled.bind=\"!email\">Reset password</button>\r\n                        </div>                  \r\n                    </div>\r\n                </form>\r\n            </div>\r\n            <div if.bind=\"sent\">\r\n                <p>\r\n                    A link to reset your password has been sent to your email. Check your inbox and click this link to reset your password...\r\n                </p>\r\n            </div>\r\n            <br/><a href=\"/#/\">Go back to login...</a><br/>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/public/user/login":
/*!******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/user/login.ts ***!
  \******************************************************************************/
/*! exports provided: Login */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Login", function() { return Login; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var services_auth__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! services/auth */ "./SPA/services/auth.ts");




let Login = class Login {
    constructor(auth, router) {
        this.auth = auth;
        this.router = router;
        this.username = null;
        this.password = null;
        this.rememberMe = false;
        this.isLoading = false;
        this.validationErrors = null;
    }
    activate(params) {
        if (window.location.search.indexOf('ReturnUrl')) {
            this.returnUrl = decodeURIComponent(window.location.search).substring(12);
        }
    }
    login() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.isLoading = true;
            this.validationErrors = null;
            if (this.username && this.password) {
                try {
                    const response = yield this.auth.login(this.username, this.password, this.rememberMe);
                    if (this.returnUrl) {
                        window.location.href = this.returnUrl;
                    }
                    else if (window.location.hash.toLowerCase() === '#/login') {
                        window.location.href = '/';
                    }
                    else {
                        window.location.reload();
                    }
                }
                catch (error) {
                    this.validationErrors = error;
                    this.isLoading = false;
                }
            }
        });
    }
    get canLogin() {
        return this.username && this.password;
    }
    reset() {
        this.username = null;
        this.password = null;
        this.rememberMe = false;
        this.validationErrors = null;
        this.isLoading = false;
    }
};
Login = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [services_auth__WEBPACK_IMPORTED_MODULE_3__["AuthService"], aurelia_router__WEBPACK_IMPORTED_MODULE_2__["Router"]])
], Login);



/***/ }),

/***/ "module/public/user/login.html":
/*!*******************************************!*\
  !*** ./SPA/module/public/user/login.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <img src=\"/images/logo.png\" style=\"float:right;\" />\r\n            <h1><a href=\"https://scifeon.com\" target=\"_blank\">scifeon</a></h1>\r\n            <p>\r\n                Please login.\r\n                <br/><br/><br/>\r\n            </p>\r\n            <form submit.trigger=\"login()\">\r\n                <div class=\"form-group ${validationErrors !== null ? 'has-error' : ''}\">\r\n                    <input type=\"text\" value.bind=\"username\" id=\"username\" placeholder=\"Username\"/>\r\n                </div>\r\n                <div class=\"form-group ${validationErrors !== null ? 'has-error' : ''}\">\r\n                    <input type=\"password\" value.bind=\"password\" id=\"password\" placeholder=\"Password\"/>                    \r\n                    <p if.bind=\"validationErrors !== null\" class=\"form-input-hint\">${validationErrors}</p>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label class=\"form-switch\">\r\n                        <input type=\"checkbox\" id=\"rememberMe\" checked.bind=\"rememberMe\"/>\r\n                        <i class=\"form-icon\"></i> Remember login?\r\n                    </label>\r\n                    <div class=\"float-right\">\r\n                        <div if.bind=\"isLoading\" class=\"loading float-left\" style=\"margin-right:8px;\"></div>\r\n                        <button class=\"primary\" type=\"submit\" disabled.bind=\"!canLogin\">Log in</button>\r\n                        <button click.delegate=\"reset()\" class=\"btn-link\">Reset</button>\r\n                    </div>  \r\n                    <br/>\r\n                    <a href=\"/#/forgot\">Forgot password?</a>                \r\n                </div>\r\n            </form>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/public/user/new-password":
/*!*************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/user/new-password.ts ***!
  \*************************************************************************************/
/*! exports provided: NewPassword */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "NewPassword", function() { return NewPassword; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let NewPassword = class NewPassword {
    constructor(server) {
        this.server = server;
        this.isLoading = false;
        this.isConfirmed = false;
    }
    activate(params) {
        this.userId = params.userId;
        if (params.code) {
            const codeIndex = window.location.hash.indexOf('&code=');
            this.code = window.location.hash.substr(codeIndex + 6);
        }
    }
    setPassword() {
        this.isLoading = true;
        if (!this.userId || !this.code) {
            this.isLoading = false;
            this.isConfirmed = true;
        }
        else {
            this.server.postJson('/api/user/password/reset', {
                userId: this.userId,
                code: this.code.replace(/\s/g, '+'),
                password: this.password,
                repeatPassword: this.repeatPassword
            })
                .then(result => {
                this.isLoading = false;
                this.isConfirmed = true;
                this.password = this.repeatPassword = null;
            });
        }
    }
};
NewPassword = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], NewPassword);



/***/ }),

/***/ "module/public/user/new-password.html":
/*!**************************************************!*\
  !*** ./SPA/module/public/user/new-password.html ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <h1>New password</h1>\r\n            <div if.bind=\"!isConfirmed\">                \r\n                <p>\r\n                    Create a new password by entering it twice below.\r\n                </p>\r\n                <form submit.trigger=\"setPassword()\">\r\n                    <div class=\"form-group\">\r\n                        <label>New password</label>\r\n                        <input type=\"password\" value.bind=\"password\" placeholder=\"New password\"/>  \r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Repeat password</label>\r\n                        <input type=\"password\" value.bind=\"repeatPassword\" placeholder=\"Repeat password\"/>     \r\n                    </div>\r\n                    <div class=\"form-group\">     \r\n                        <div class=\"float-right\">\r\n                            <div if.bind=\"isLoading\" class=\"loading float-left\" style=\"margin-right:8px;\"></div>\r\n                            <button class=\"primary\" type=\"submit\" disabled.bind=\"!password || password !== repeatPassword\">Set password</button>\r\n                        </div>                  \r\n                    </div>\r\n                </form>\r\n            </div>\r\n            <div if.bind=\"isConfirmed\">\r\n                <p>\r\n                    Your password has been set. <a href=\"/#/\">Click here to login</a>\r\n                </p>\r\n            </div>\r\n            <br/><a href=\"/#/\">Go back to login...</a><br/>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/public/windows-authentication-not-found":
/*!****************************************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/windows-authentication-not-found.ts ***!
  \****************************************************************************************************/
/*! exports provided: WindowsAuthenticationNotFound */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WindowsAuthenticationNotFound", function() { return WindowsAuthenticationNotFound; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__);



let WindowsAuthenticationNotFound = class WindowsAuthenticationNotFound {
    constructor(http) {
        this.username = '';
        http.fetch('/api/auth/user')
            .then(response => response.json())
            .then(json => this.username = json.contextUser.name);
    }
};
WindowsAuthenticationNotFound = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__["HttpClient"]])
], WindowsAuthenticationNotFound);



/***/ }),

/***/ "module/public/windows-authentication-not-found.html":
/*!*****************************************************************!*\
  !*** ./SPA/module/public/windows-authentication-not-found.html ***!
  \*****************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <img src=\"/images/logo.png\" style=\"float:right;\" />\r\n            <h1>No access</h1>\r\n            <p>\r\n                Your user, <b>${username}</b>, does not have access to Scifeon.\r\n            </p>\r\n            <p>\r\n                If you think you should have access, please contact ...\r\n            </p>            \r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "public":
/*!************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/public.ts ***!
  \************************************************************/
/*! exports provided: PublicApp */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PublicApp", function() { return PublicApp; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! services/router-steps/app-insights-step */ "./SPA/services/router-steps/app-insights-step.ts");
/* harmony import */ var services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! services/router-steps/loading-steps */ "./SPA/services/router-steps/loading-steps.ts");






let PublicApp = class PublicApp {
    constructor(router) {
        this.router = router;
    }
    configureRouter(config, router) {
        config.title = 'scifeon';
        config.addAuthorizeStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_5__["LoadingAuthorizeStep"]);
        config.addPreActivateStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_5__["LoadingPreActivateStep"]);
        config.addPreRenderStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_5__["LoadingPreRenderStep"]);
        config.addPostRenderStep(services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_5__["LoadingPostRenderStep"]);
        config.addAuthorizeStep(services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_4__["AppInsightsStep"]);
        let configMap = [
            { route: ['login'], name: 'Login', moduleId: 'module/public/user/login', title: 'Login' },
            { route: ['confirm'], name: 'ConfirmLogin', moduleId: 'module/public/user/confirm', title: 'Confirm Login' },
            { route: ['forgot'], name: 'ForgotLogin', moduleId: 'module/public/user/forgot', title: 'Forgot Login' },
            { route: ['new-password'], name: 'NewPassword', moduleId: 'module/public/user/new-password', title: 'New Password' },
        ];
        config.map(configMap);
        if (_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().configuration.windowsAuthentication) {
            config.mapUnknownRoutes('module/public/windows-authentication-not-found');
        }
        else {
            config.mapUnknownRoutes('module/public/user/login');
        }
        this.router = router;
    }
};
PublicApp = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"]])
], PublicApp);



/***/ }),

/***/ "public.html":
/*!*************************!*\
  !*** ./SPA/public.html ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"module/error/error-panel\"></require>\r\n    <router-view></router-view>   \r\n    <error-panel></error-panel>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=public.7d2e17d8ae74be98b4b6.js.map