(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["resources"],{

/***/ "./SPA/services/validation.ts":
/*!************************************!*\
  !*** ./SPA/services/validation.ts ***!
  \************************************/
/*! exports provided: FormValidatorRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FormValidatorRenderer", function() { return FormValidatorRenderer; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-validation */ "aurelia-validation");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_2__);



aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('number', (value, obj) => {
    const num = numeral__WEBPACK_IMPORTED_MODULE_2__(+value).value();
    return value === null
        || value === undefined
        || num !== null;
}, `Must be a number.`);
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('integerRange', (value, obj, min, max) => {
    const num = numeral__WEBPACK_IMPORTED_MODULE_2__(+value).value();
    return value === null
        || value === undefined
        || num !== null
        || (num >= min && num <= max);
}, `Must be an integer between \${$config.min} and \${$config.max}.`, (min, max) => ({ min, max }));
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('date', (value, obj) => {
    if (!value)
        return true;
    const date = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].from(value, 'D-MMM-YYYY', true);
    return date.isValid();
}, `Must be a date on the format D-MMM-YYYY, e.g. ${_scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].local.toDateFormat()}.`);
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('datetime', (value, obj) => {
    if (!value)
        return true;
    const datetime = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].from(value, 'D-MMM-YYYY, HH:mm', true);
    return datetime.isValid();
}, `Must be a datetime on the format D-MMM-YYYY, HH:mm, e.g. ${_scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].local.toDateTimeFormat()}.`);
class FormValidatorRenderer {
    render(instruction) {
        for (let { result, elements } of instruction.unrender) {
            for (let element of elements) {
                this.remove(element, result);
            }
        }
        for (let { result, elements } of instruction.render) {
            for (let element of elements) {
                this.add(element, result);
            }
        }
    }
    add(element, result) {
        if (result.valid) {
            return;
        }
        const formGroup = element.closest('.form-group');
        if (!formGroup) {
            return;
        }
        let hint = null;
        if (formGroup.classList.contains('has-error')) {
            hint = formGroup.getElementsByClassName('form-input-hint').item(0);
        }
        else {
            hint = document.createElement('p');
            hint.className = 'form-input-hint';
            formGroup.appendChild(hint);
            formGroup.classList.add('has-error');
        }
        const message = document.createElement('span');
        message.textContent = result.message;
        message.id = `validation-message-${result.id}`;
        hint.appendChild(message);
    }
    remove(element, result) {
        if (result.valid) {
            return;
        }
        const formGroup = element.closest('.form-group');
        if (!formGroup) {
            return;
        }
        const hints = formGroup.getElementsByClassName('form-input-hint');
        if (!hints.length) {
            return;
        }
        const hint = hints.item(0);
        const message = formGroup.querySelector(`#validation-message-${result.id}`);
        if (message) {
            hint.removeChild(message);
            if (hint.childNodes.length === 0) {
                formGroup.classList.remove('has-error');
                formGroup.removeChild(hint);
            }
        }
    }
}


/***/ }),

/***/ "./node_modules/numeral/numeral.js":
/*!*************************************************************************************!*\
  !*** delegated ./node_modules/numeral/numeral.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/numeral/numeral.js");

/***/ }),

/***/ "./node_modules/ts-loader/index.js?silent=true!./SPA/resources/index.ts":
/*!*********************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/resources/index.ts ***!
  \*********************************************************************/
/*! exports provided: configure */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "configure", function() { return configure; });
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var services_validation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! services/validation */ "./SPA/services/validation.ts");


function configure(config) {
    config.globalResources([
        'resources/value-converters/date-format',
        'resources/value-converters/date-time-format',
        'resources/value-converters/json',
        'resources/value-converters/object-keys',
        'resources/value-converters/significant',
        'resources/value-converters/exponential',
        'resources/value-converters/fixed',
        'resources/value-converters/multiline',
        'resources/value-converters/multiline2li'
    ]);
}


/***/ }),

/***/ "resources/value-converters/date-format":
/*!*******************************************************!*\
  !*** ./SPA/resources/value-converters/date-format.ts ***!
  \*******************************************************/
/*! exports provided: DateFormatValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DateFormatValueConverter", function() { return DateFormatValueConverter; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

class DateFormatValueConverter {
    toView(value) {
        if (!value)
            return '-';
        return _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].toDateFormat(value);
    }
}


/***/ }),

/***/ "resources/value-converters/date-time-format":
/*!************************************************************!*\
  !*** ./SPA/resources/value-converters/date-time-format.ts ***!
  \************************************************************/
/*! exports provided: DateTimeFormatValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DateTimeFormatValueConverter", function() { return DateTimeFormatValueConverter; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

class DateTimeFormatValueConverter {
    toView(value) {
        if (!value)
            return '-';
        return _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].toDateTimeFormat(value);
    }
}


/***/ }),

/***/ "resources/value-converters/exponential":
/*!*******************************************************!*\
  !*** ./SPA/resources/value-converters/exponential.ts ***!
  \*******************************************************/
/*! exports provided: ExponentialValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExponentialValueConverter", function() { return ExponentialValueConverter; });
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_0__);

class ExponentialValueConverter {
    toView(value, digits) {
        if (!digits)
            digits = 3;
        if (value === '<LOD')
            return value;
        if (!value || isNaN(value))
            return '-';
        let valueAbs = Math.abs(value);
        let magnitude = Math.floor(Math.log10(valueAbs));
        let valueInt = Math.round(valueAbs * Math.pow(10, -magnitude + digits - 1));
        let valueRounded = valueInt * Math.pow(10, magnitude - digits + 1);
        if (value < 0)
            valueRounded = -valueRounded;
        let format = '0,0';
        if (digits > 1)
            format += '.';
        let decimalDigits = digits - 1;
        while (decimalDigits > 0) {
            format += '0';
            decimalDigits--;
        }
        format += 'e+0';
        return numeral__WEBPACK_IMPORTED_MODULE_0__(valueRounded).format(format);
    }
}


/***/ }),

/***/ "resources/value-converters/fixed":
/*!*************************************************!*\
  !*** ./SPA/resources/value-converters/fixed.ts ***!
  \*************************************************/
/*! exports provided: FixedValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FixedValueConverter", function() { return FixedValueConverter; });
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_0__);

class FixedValueConverter {
    toView(value, decimals = 2) {
        if (decimals == undefined)
            decimals = 2;
        if (value === '<LOD')
            return value;
        if (!value || isNaN(value))
            return '-';
        let format = '0,0.' + '0'.repeat(decimals);
        return numeral__WEBPACK_IMPORTED_MODULE_0__(value).format(format);
    }
}


/***/ }),

/***/ "resources/value-converters/json":
/*!************************************************!*\
  !*** ./SPA/resources/value-converters/json.ts ***!
  \************************************************/
/*! exports provided: JsonValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "JsonValueConverter", function() { return JsonValueConverter; });
class JsonValueConverter {
    toView(value) {
        return JSON.stringify(value, null, "  ");
    }
}


/***/ }),

/***/ "resources/value-converters/multiline":
/*!*****************************************************!*\
  !*** ./SPA/resources/value-converters/multiline.ts ***!
  \*****************************************************/
/*! exports provided: MultiLineValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MultiLineValueConverter", function() { return MultiLineValueConverter; });
class MultiLineValueConverter {
    toView(value) {
        if (!value)
            return '';
        return value.trim().replace('\n', '<br>');
    }
}


/***/ }),

/***/ "resources/value-converters/multiline2li":
/*!********************************************************!*\
  !*** ./SPA/resources/value-converters/multiline2li.ts ***!
  \********************************************************/
/*! exports provided: MultiLine2LIValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MultiLine2LIValueConverter", function() { return MultiLine2LIValueConverter; });
class MultiLine2LIValueConverter {
    toView(value) {
        if (!value)
            return '';
        let html = '';
        let items = value.split('\n');
        for (let item of items) {
            if (!item)
                continue;
            html += '<li>' + item + '</li>';
        }
        return html;
    }
}


/***/ }),

/***/ "resources/value-converters/object-keys":
/*!*******************************************************!*\
  !*** ./SPA/resources/value-converters/object-keys.ts ***!
  \*******************************************************/
/*! exports provided: ObjectKeysValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ObjectKeysValueConverter", function() { return ObjectKeysValueConverter; });
class ObjectKeysValueConverter {
    toView(obj) {
        let temp = [];
        for (let prop in obj) {
            temp.push(prop);
        }
        return temp;
    }
}


/***/ }),

/***/ "resources/value-converters/significant":
/*!*******************************************************!*\
  !*** ./SPA/resources/value-converters/significant.ts ***!
  \*******************************************************/
/*! exports provided: SignificantValueConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SignificantValueConverter", function() { return SignificantValueConverter; });
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_0__);

class SignificantValueConverter {
    toView(value, digits = 3) {
        if (value === '<LOD')
            return value;
        if (isNaN(value))
            return '-';
        if (value === 0.0)
            return '0';
        let valueAbs = Math.abs(value);
        let magnitude = Math.floor(Math.log10(valueAbs));
        let valueInt = Math.round(valueAbs * Math.pow(10, -magnitude + digits - 1));
        let valueRounded = valueInt * Math.pow(10, magnitude - digits + 1);
        if (value < 0)
            valueRounded = -valueRounded;
        let format;
        if (value > 1e7 || value < -1e7 || (value > -1e-3 && value < 1e-3)) {
            format = '0,0';
            if (digits > 1)
                format += '.';
            let decimalDigits = digits - 1;
            while (decimalDigits > 0) {
                format += '0';
                decimalDigits--;
            }
            format += 'e+0';
        }
        else {
            format = '0,0.';
            let decimalDigits = digits - magnitude - 1;
            while (decimalDigits > 0) {
                format += '0';
                decimalDigits--;
            }
        }
        return numeral__WEBPACK_IMPORTED_MODULE_0__(valueRounded).format(format);
    }
}


/***/ })

}]);
//# sourceMappingURL=resources.7d2e17d8ae74be98b4b6.js.map