(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["spreadsheet"],{

/***/ "./SPA/module/spreadsheet/functions/dataset-function.ts":
/*!**************************************************************!*\
  !*** ./SPA/module/spreadsheet/functions/dataset-function.ts ***!
  \**************************************************************/
/*! exports provided: SpreadsheetDatasetFunction */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SpreadsheetDatasetFunction", function() { return SpreadsheetDatasetFunction; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! services/scifeon-spreadsheet */ "./SPA/services/scifeon-spreadsheet.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let SpreadsheetDatasetFunction = class SpreadsheetDatasetFunction {
    constructor(spreadsheetService) {
        this.spreadsheetService = spreadsheetService;
    }
    getName() {
        return 'DS';
    }
    replaceAutofill(formula, direction, delta) {
        if (formula.toUpperCase().indexOf(this.getName()) === -1 || ['left', 'right'].indexOf(direction) !== -1)
            return formula;
        return formula.replace(/DS\(\s*[",'](\w+)[",']\s*,\s*[",'](\w+)[",']\s*,\s*(\d+)\s*\)/g, (match, p1, p2, p3) => {
            const row = parseInt(p3, 10) + delta;
            return `DS('${p1}', '${p2}', ${row})`;
        });
    }
    getValue(params) {
        if (params.length < 2)
            throw new Error('parameters missing');
        const datasetName = params[0];
        const columnName = params[1];
        const rowNumber = params[2];
        const content = this.spreadsheetService.dataset.content.find(c => c.name.toUpperCase() === datasetName);
        if (content) {
            const data = this.spreadsheetService.dataset[content.name];
            if (data.length) {
                const key = Object.keys(data[0]).find(k => k.toUpperCase() === columnName);
                if (key) {
                    let value = data[rowNumber][key];
                    if (value === undefined || value === null) {
                        value = '0';
                    }
                    return value;
                }
            }
        }
        return '0';
    }
};
SpreadsheetDatasetFunction = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_1__["ScifeonSpreadsheet"]])
], SpreadsheetDatasetFunction);



/***/ }),

/***/ "./SPA/module/spreadsheet/spreadsheet-events.ts":
/*!******************************************************!*\
  !*** ./SPA/module/spreadsheet/spreadsheet-events.ts ***!
  \******************************************************/
/*! exports provided: SpreadsheetEvents */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SpreadsheetEvents", function() { return SpreadsheetEvents; });
class SpreadsheetEvents {
    constructor(vm, spreadsheet, utils) {
        this.vm = vm;
        this.spreadsheet = spreadsheet;
        this.utils = utils;
        this.contextMenuOpen = false;
        this.previousDeps = [];
    }
    setHot(hot) {
        this.hot = hot;
        this.spreadsheet.clearItems();
    }
    afterContextMenuShow(menu) {
        this.contextMenuOpen = true;
    }
    afterContextMenuHide(menu) {
        this.contextMenuOpen = false;
    }
    afterSelection(r, c, r2, c2) {
        if (this.contextMenuOpen)
            return;
        this.vm.setCurrentCell(r, c);
        for (let i = 0; i < this.previousDeps.length; i++) {
            const item = this.spreadsheet.items.find(it => it.id === this.previousDeps[i]);
            if (item)
                item.style.border.color = null;
        }
        this.previousDeps = this.spreadsheet.getItem(r, c).formula.deps;
        for (let i = 0; i < this.previousDeps.length; i++) {
            const item = this.spreadsheet.items.find(it => it.id === this.previousDeps[i]);
            if (item)
                item.style.border.color = this.utils.getDependencyColor(i);
        }
        this.vm.setCurrentFormula(this.hot.getDataAtCell(r, c));
        this.hot.render();
    }
    editorKeydown(event) {
        if (event.keyCode === 27) {
            const selected = this.hot.getSelectedRange();
            if (!selected)
                return;
            this.vm.setCurrentFormula(this.hot.getDataAtCell(selected.from.row, selected.from.col));
        }
    }
    editorKeyup(event) {
        const editor = this.hot.getActiveEditor();
        if (!editor || !editor.isOpened())
            return;
        this.vm.setCurrentFormula(editor.getValue());
    }
    afterCreateRow(row, amount) {
        if (!this.hot)
            return;
        const selected = this.hot.getSelectedRange();
        if (!selected)
            return;
        const changes = this.spreadsheet.formula.getRowRefChanges(row, amount);
        this.hot.setDataAtCell(changes);
    }
    afterRemoveRow(row, amount) {
        const selected = this.hot.getSelectedRange();
        if (!selected)
            return;
        const changes = this.spreadsheet.formula.getRowRefChanges(row, (-1) * amount);
        this.hot.setDataAtCell(changes);
    }
    afterCreateCol(col, amount) {
        if (!this.hot)
            return;
        const selected = this.hot.getSelectedRange();
        if (!selected)
            return;
        const changes = this.spreadsheet.formula.getColRefChanges(col, amount);
        this.hot.setDataAtCell(changes);
    }
    afterRemoveCol(col, amount) {
        const selected = this.hot.getSelectedRange();
        if (!selected)
            return;
        const changes = this.spreadsheet.formula.getColRefChanges(col, (-1) * amount);
        this.hot.setDataAtCell(changes);
    }
    beforeAutofillInsidePopulate(index, direction, input, deltas, iterators, selected) {
        const rows = input.length;
        const cols = input ? input[0].length : 0;
        const value = input[index.row % rows][index.col % cols];
        if (value && value[0] === '=') {
            let delta = 0;
            if (direction === 'up') {
                delta = index.row - rows;
            }
            else if (direction === 'left') {
                delta = index.col - cols;
            }
            else if (direction === 'down') {
                delta = index.row + 1;
            }
            else if (direction === 'right') {
                delta = index.col + 1;
            }
            return {
                value: this.spreadsheet.formula.getUpdatedDragDownFormula(value, direction, delta),
                iterators: iterators
            };
        }
    }
}


/***/ }),

/***/ "./SPA/module/spreadsheet/spreadsheet-formula.ts":
/*!*******************************************************!*\
  !*** ./SPA/module/spreadsheet/spreadsheet-formula.ts ***!
  \*******************************************************/
/*! exports provided: SpreadsheetFormula */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SpreadsheetFormula", function() { return SpreadsheetFormula; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! hot-formula-parser */ "./node_modules/hot-formula-parser/dist/formula-parser.js");
/* harmony import */ var hot_formula_parser__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



class SpreadsheetFormula {
    constructor(spreadsheet, spreadsheetService, pluginManager, pluginLoader) {
        this.spreadsheet = spreadsheet;
        this.spreadsheetService = spreadsheetService;
        this.parser = new hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["Parser"]();
        this.pluginFunctions = [];
        pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].SPREADSHEET_FUNCTION)
            .then((plugins) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            for (let p = 0; p < plugins.length; p++) {
                const instance = yield pluginLoader.getInstance(plugins[p], null);
                this.pluginFunctions.push(instance);
                this.parser.setFunction(instance.getName(), function (params) {
                    return instance.getValue(params);
                });
            }
        }));
        const instance = this;
        this.parser.on('callCellValue', function (cellCoord, done) {
            const item = spreadsheet.getItem(cellCoord.row.index, cellCoord.column.index);
            if (instance.currentItem.id === item.id)
                throw new Error('circular reference');
            instance.addDepToCurrent(item);
            if (item.formula.result.error)
                throw new Error(item.formula.result.error);
            if (item.formula.result.value) {
                done(item.formula.result.value);
            }
            else {
                let value = item.content;
                if (value === undefined || value === null) {
                    value = '0';
                }
                done(value);
            }
        });
        this.parser.on('callRangeValue', function (startCellCoord, endCellCoord, done) {
            let fragment = [];
            for (let row = startCellCoord.row.index; row <= endCellCoord.row.index; row++) {
                let colFragment = [];
                for (let col = startCellCoord.column.index; col <= endCellCoord.column.index; col++) {
                    const item = spreadsheet.getItem(row, col);
                    instance.addDepToCurrent(item);
                    colFragment.push(item.content);
                }
                fragment.push(colFragment);
            }
            if (fragment) {
                done(fragment);
            }
        });
    }
    getResult(item, value) {
        this.currentItem = item;
        let newResult = {
            value: this.currentItem.content,
            error: null
        };
        if (this.currentItem.content && this.currentItem.content[0] === '=') {
            const newFormula = this.currentItem.content.substring(1).toUpperCase();
            if (!this.currentItem.formula.needUpdate && newFormula === this.currentItem.content) {
                return this.currentItem.formula.result;
            }
            this.currentItem.formula.deps = [];
            this.currentItem.formula.expr = newFormula;
            const parsed = this.parser.parse(this.currentItem.formula.expr);
            newResult.error = parsed.error;
            newResult.value = parsed.result;
        }
        if (this.currentItem.formula.result.value !== newResult.value || this.currentItem.formula.result.error !== newResult.error) {
            this.currentItem.formula.result.value = newResult.value;
            this.currentItem.formula.result.error = newResult.error;
            this.currentItem.formula.needUpdate = false;
            for (let i = 0; i < this.spreadsheet.items.length; i++) {
                if (this.spreadsheet.items[i].formula.deps.indexOf(this.currentItem.id) !== -1) {
                    this.spreadsheet.items[i].formula.needUpdate = true;
                }
            }
        }
        return newResult;
    }
    getColRefChanges(col, delta) {
        const itemIds = this.getRefItemIdsToColumn(col);
        let changes = [];
        for (let i = 0; i < itemIds.length; i++) {
            const id = itemIds[i];
            const item = this.spreadsheet.items.find(it => it.id === id);
            const newFormula = this.shiftCol(item.formula.expr, col, delta);
            changes.push([item.row, item.col + delta, '=' + newFormula]);
        }
        this.spreadsheet.clearItems();
        return changes;
    }
    getRowRefChanges(row, delta) {
        const itemIds = this.getRefItemIdsToRow(row);
        let changes = [];
        for (let i = 0; i < itemIds.length; i++) {
            const id = itemIds[i];
            const item = this.spreadsheet.items.find(it => it.id === id);
            const newFormula = this.shiftRow(item.formula.expr, row, delta);
            changes.push([item.row + delta, item.col, '=' + newFormula]);
        }
        this.spreadsheet.clearItems();
        return changes;
    }
    getUpdatedDragDownFormula(formula, direction, delta) {
        let type;
        if (['left', 'right'].indexOf(direction) !== -1) {
            type = 'col';
        }
        else if (['up', 'down'].indexOf(direction) !== -1) {
            type = 'row';
        }
        formula = formula.replace(/(\$?[A-Za-z]+\$?[0-9]+)/g, match => {
            const coords = hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["extractLabel"](match);
            if (type === 'row' && coords[0].isAbsolute) {
                return match;
            }
            if (type === 'col' && coords[1].isAbsolute) {
                return match;
            }
            if (type === 'row') {
                coords[0].index += delta;
            }
            else {
                coords[1].index += delta;
            }
            return hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["toLabel"](coords[0], coords[1]);
        });
        for (let p = 0; p < this.pluginFunctions.length; p++) {
            const plugin = this.pluginFunctions[p];
            if (plugin.replaceAutofill) {
                formula = plugin.replaceAutofill(formula, direction, delta);
            }
        }
        return formula;
    }
    shiftCol(formula, col, delta) {
        return formula.replace(/(\$?[A-Za-z]+\$?[0-9]+)/g, (match) => {
            const coords = hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["extractLabel"](match);
            if (col <= coords[1].index) {
                coords[1].index += delta;
                return hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["toLabel"](coords[0], coords[1]);
            }
            return match;
        });
    }
    shiftRow(formula, row, delta) {
        return formula.replace(/(\$?[A-Za-z]+\$?[0-9]+)/g, (match) => {
            const coords = hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["extractLabel"](match);
            if (row <= coords[0].index) {
                coords[0].index += delta;
                return hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["toLabel"](coords[0], coords[1]);
            }
            return match;
        });
    }
    addDepToCurrent(item) {
        if (this.currentItem.formula.deps.indexOf(item.id) === -1) {
            this.currentItem.formula.deps.push(item.id);
        }
    }
    getRefItemIdsToColumn(col) {
        let result = [];
        for (let i = 0; i < this.spreadsheet.items.length; i++) {
            const item = this.spreadsheet.items[i];
            const deps = item.formula.deps.filter(cell => {
                const coords = hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["extractLabel"](cell);
                return coords[1].index + 1 > col;
            });
            if (deps.length > 0 && result.indexOf(item.id) === -1) {
                result.push(item.id);
            }
        }
        return result;
    }
    getRefItemIdsToRow(row) {
        let result = [];
        for (let i = 0; i < this.spreadsheet.items.length; i++) {
            const item = this.spreadsheet.items[i];
            const deps = item.formula.deps.filter(cell => {
                const coords = hot_formula_parser__WEBPACK_IMPORTED_MODULE_1__["extractLabel"](cell);
                return coords[0].index + 1 > row;
            });
            if (deps.length > 0 && result.indexOf(item.id) === -1) {
                result.push(item.id);
            }
        }
        return result;
    }
}


/***/ }),

/***/ "./SPA/module/spreadsheet/spreadsheet.ts":
/*!***********************************************!*\
  !*** ./SPA/module/spreadsheet/spreadsheet.ts ***!
  \***********************************************/
/*! exports provided: Spreadsheet */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Spreadsheet", function() { return Spreadsheet; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../services/scifeon-spreadsheet */ "./SPA/services/scifeon-spreadsheet.ts");
/* harmony import */ var _functions_dataset_function__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./functions/dataset-function */ "./SPA/module/spreadsheet/functions/dataset-function.ts");
/* harmony import */ var _spreadsheet_formula__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./spreadsheet-formula */ "./SPA/module/spreadsheet/spreadsheet-formula.ts");







let Spreadsheet = class Spreadsheet {
    constructor(utils, spreadsheetService, pluginManager, pluginLoader) {
        this.utils = utils;
        this.spreadsheetService = spreadsheetService;
        this._items = [];
        pluginManager.add(_functions_dataset_function__WEBPACK_IMPORTED_MODULE_5__["SpreadsheetDatasetFunction"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].SPREADSHEET_FUNCTION]);
        this._formula = new _spreadsheet_formula__WEBPACK_IMPORTED_MODULE_6__["SpreadsheetFormula"](this, spreadsheetService, pluginManager, pluginLoader);
    }
    get items() {
        return this._items;
    }
    get formula() {
        return this._formula;
    }
    getResult(item, value) {
        if (item.content !== value) {
            item.content = value;
        }
        return this.formula.getResult(item, value);
    }
    getItem(row, col) {
        const id = this.utils.toLabel(row, col);
        let item = this.items.find(i => i.id === id);
        if (!item) {
            item = this.createItem(row, col);
        }
        return item;
    }
    createItem(row, col, content = null) {
        const id = this.utils.toLabel(row, col);
        const item = {
            id: id,
            row: row,
            col: col,
            formula: {
                result: {
                    value: null,
                    error: null
                },
                deps: [],
                needUpdate: true,
                expr: null
            },
            content: content,
            style: { border: { color: null }, background: { color: null } }
        };
        this.items.push(item);
        return item;
    }
    clearItems() {
        this._items = [];
    }
    setItemsFrom2DArray(data) {
        for (let r = 0; r < data.length; r++) {
            for (let c = 0; c < data[r].length; r++) {
                this.createItem(r, c, data[r][c]);
            }
        }
    }
};
Spreadsheet = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["SpreadsheetUtils"], _services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_4__["ScifeonSpreadsheet"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginLoader"]])
], Spreadsheet);



/***/ }),

/***/ "./SPA/services/scifeon-spreadsheet.ts":
/*!*********************************************!*\
  !*** ./SPA/services/scifeon-spreadsheet.ts ***!
  \*********************************************/
/*! exports provided: ScifeonSpreadsheet */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ScifeonSpreadsheet", function() { return ScifeonSpreadsheet; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);

var ScifeonSpreadsheet_1;



let ScifeonSpreadsheet = ScifeonSpreadsheet_1 = class ScifeonSpreadsheet {
    constructor(router, server, dataModel) {
        this.router = router;
        this.server = server;
        this.dataModel = dataModel;
        this.data = [[]];
        this.state = ScifeonSpreadsheet_1.STATES.NONE;
        this.data = [
            [1, 2, 3, 'Sum:', '=A1+B1+C1'],
            [2],
            [3],
            ['Sum:'],
            ['=A1+A2+A3']
        ];
    }
    loadWithUrlQuery(url) {
        this.state = ScifeonSpreadsheet_1.STATES.SIMPLE_QUERY;
        this.url = url;
        this.dataset = [];
        this.data = [[]];
        this.router.navigate('/spreadsheet/work');
    }
    reloadQueries() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.state === ScifeonSpreadsheet_1.STATES.SIMPLE_QUERY) {
                const response = yield this.server.get(this.url);
                const result = yield response.json();
                this.dataset = {
                    content: [
                        { name: 'Results', type: 'collection', eClass: 'Result' }
                    ],
                    Results: result.data
                };
            }
            return this.dataset;
        });
    }
};
ScifeonSpreadsheet.STATES = {
    NONE: 0,
    SIMPLE_QUERY: 1
};
ScifeonSpreadsheet = ScifeonSpreadsheet_1 = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"]])
], ScifeonSpreadsheet);



/***/ }),

/***/ "./node_modules/hot-formula-parser/dist/formula-parser.js":
/*!************************************************************************************************************!*\
  !*** delegated ./node_modules/hot-formula-parser/dist/formula-parser.js from dll-reference scifeon_vendor ***!
  \************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/hot-formula-parser/dist/formula-parser.js");

/***/ }),

/***/ "module/spreadsheet/export":
/*!*******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/spreadsheet/export.ts ***!
  \*******************************************************************************/
/*! exports provided: Export */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Export", function() { return Export; });
class Export {
    constructor(speadsheetService) {
        this.speadsheetService = speadsheetService;
    }
}


/***/ }),

/***/ "module/spreadsheet/export.html":
/*!********************************************!*\
  !*** ./SPA/module/spreadsheet/export.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"./steps\"></require>\r\n\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>Spreadsheet</h1></div>\r\n        <div class=\"columns\">\r\n            <spreadsheet-steps step=\"export\" containerLess></spreadsheet-steps>\r\n        </div>\r\n        \r\n        \r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/spreadsheet/index":
/*!******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/spreadsheet/index.ts ***!
  \******************************************************************************/
/*! exports provided: Index */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Index", function() { return Index; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../services/scifeon-spreadsheet */ "./SPA/services/scifeon-spreadsheet.ts");
/* harmony import */ var _spreadsheet__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./spreadsheet */ "./SPA/module/spreadsheet/spreadsheet.ts");
/* harmony import */ var _spreadsheet_events__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./spreadsheet-events */ "./SPA/module/spreadsheet/spreadsheet-events.ts");






let Index = class Index {
    constructor(spreadsheetService, spreadsheet, utils) {
        this.spreadsheetService = spreadsheetService;
        this.spreadsheet = spreadsheet;
        this.currentCell = { id: '', row: null, col: null };
        this.events = new _spreadsheet_events__WEBPACK_IMPORTED_MODULE_5__["SpreadsheetEvents"](this, spreadsheet, utils);
    }
    activate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dataset = yield this.spreadsheetService.reloadQueries();
        });
    }
    getColumnsFromDatasetName(name) {
        const data = this.dataset[name];
        if (!data.length)
            return [];
        return Object.keys(data[0]);
    }
    setCurrentFormula(formula) {
        this.currentFormula = formula;
        if (typeof formula === 'string') {
            this.currentFormulaHtml = formula.replace(/(\$?[A-Za-z]+\$?[0-9]+)/g, (match) => {
                const item = this.spreadsheet.items.find(i => i.id === match);
                if (!item)
                    return match;
                return `<span style="color: ${item.style.border.color}">${match}</span>`;
            });
        }
        else {
            this.currentFormulaHtml = formula;
        }
    }
    setCurrentCell(row, col) {
        this.currentCell = this.spreadsheet.getItem(row, col);
    }
    insert(datasetName, column) {
        const selected = this.hot.getSelectedRange();
        if (selected) {
            let header = this.spreadsheetService.data[selected.from.row];
            if (!header) {
                header = [];
                this.spreadsheetService.data[selected.from.row] = header;
            }
            header[selected.from.col] = column;
            const data = this.spreadsheetService.dataset[datasetName];
            for (let r = 0; r < data.length; r++) {
                const index = selected.from.row + r + 1;
                let row = this.spreadsheetService.data[index];
                if (!row) {
                    row = [];
                    this.spreadsheetService.data[index] = row;
                }
                row[selected.from.col] = `=DS('${datasetName}', '${column}', ${r})`;
            }
            this.hot.render();
        }
    }
    attached() {
        this.container = document.getElementById('hot');
        const settings = {
            data: this.spreadsheetService.data,
            rowHeaders: true,
            colHeaders: true,
            stretchH: 'all',
            minSpareCols: 1,
            minSpareRows: 1,
            minCols: 20,
            minRows: 20,
            outsideClickDeselects: false,
            contextMenu: true,
            manualColumnResize: true,
            manualRowResize: true,
            afterContextMenuShow: (menu) => this.events.afterContextMenuShow(menu),
            afterContextMenuHide: (menu) => this.events.afterContextMenuHide(menu),
            afterSelection: (r, c, r2, c2) => this.events.afterSelection(r, c, r2, c2),
            afterCreateRow: (row, amount) => this.events.afterCreateRow(row, amount),
            afterRemoveRow: (row, amount) => this.events.afterRemoveRow(row, amount),
            afterCreateCol: (col, amount) => this.events.afterCreateCol(col, amount),
            afterRemoveCol: (col, amount) => this.events.afterRemoveCol(col, amount),
            beforeAutofillInsidePopulate: (index, direction, input, deltas, iterators, selected) => this.events.beforeAutofillInsidePopulate(index, direction, input, deltas, iterators, selected)
        };
        const renderer = (instance, TD, row, col, prop, value, cellProperties) => this.formulaRenderer(instance, TD, row, col, prop, value, cellProperties);
        Handsontable.cellTypes['text'].renderer = renderer;
        Handsontable.cellTypes['numeric'].renderer = renderer;
        this.container.addEventListener('keyup', (event) => this.events.editorKeyup(event));
        this.container.addEventListener('keydown', (event) => this.events.editorKeydown(event));
        this.hot = new Handsontable(this.container, settings);
        this.events.setHot(this.hot);
    }
    detached() {
        Handsontable.cellTypes['text'].renderer = Handsontable.renderers.TextRenderer;
        Handsontable.cellTypes['numeric'].renderer = Handsontable.renderers.NumericRenderer;
    }
    formulaEdited() {
        this.hot.setDataAtCell(this.currentCell.row, this.currentCell.col, this.currentFormula);
        this.formulaElement.blur();
        this.events.afterSelection(this.currentCell.row, this.currentCell.col, null, null);
    }
    formulaRenderer(instance, TD, row, col, prop, value, cellProperties) {
        const item = this.spreadsheet.getItem(row, col);
        const newValue = this.spreadsheet.getResult(item, value);
        if (newValue.value) {
            TD.style.backgroundColor = 'white';
            value = newValue.value;
        }
        else if (newValue.error) {
            TD.style.backgroundColor = 'red';
            value = newValue.error;
        }
        if (item.style.border.color) {
            TD.className = 'dependency-cell';
            TD.style.borderColor = item.style.border.color;
        }
        if (item.style.background.color) {
            TD.style.backgroundColor = item.style.background.color;
        }
        if (cellProperties.type === 'numeric' || Handsontable.helper.isNumeric(value)) {
            Handsontable.renderers.NumericRenderer.apply(this, [instance, TD, row, col, prop, value, cellProperties]);
        }
        else {
            Handsontable.renderers.TextRenderer.apply(this, [instance, TD, row, col, prop, value, cellProperties]);
        }
    }
};
Index = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_services_scifeon_spreadsheet__WEBPACK_IMPORTED_MODULE_3__["ScifeonSpreadsheet"], _spreadsheet__WEBPACK_IMPORTED_MODULE_4__["Spreadsheet"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["SpreadsheetUtils"]])
], Index);



/***/ }),

/***/ "module/spreadsheet/index.html":
/*!*******************************************!*\
  !*** ./SPA/module/spreadsheet/index.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"./steps\"></require>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>Spreadsheet</h1></div>\r\n        \r\n        <div class=\"columns\">\r\n            <spreadsheet-steps step=\"work\" containerLess></spreadsheet-steps>\r\n        </div>\r\n\r\n        <div class=\"columns\">\r\n            <div style=\"display: grid;grid-template-columns: 300px 1fr;grid-gap: 10px;\">\r\n                <div class=\"panel\" style=\"grid-column: 1\">\r\n                    <div class=\"panel-heading\">Datasets</div>\r\n                    <div class=\"panel-body\">\r\n                        <div style=\"overflow:auto;height:87vh;\">\r\n                            <div class=\"form-group\" repeat.for=\"content of dataset.content\">\r\n                                <label>${content.name} (${dataset[content.name].length})</label>\r\n                                <div class=\"form-group\" repeat.for=\"column of getColumnsFromDatasetName(content.name)\">\r\n                                    <label>${column}</label>\r\n                                    <button click.delegate=\"insert(content.name, column)\">Insert at selected cell</button>\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 2\">\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"input-group\">\r\n                            <span class=\"input-group-addon\" innerHtml.bind=\"currentCell.id\" style=\"width:51px;text-align:right;\"></span>\r\n                            <!--<div class=\"form-input\" contenteditable innerhtml.bind=\"currentFormulaHtml\" change.delegate=\"formulaEdited()\" ref=\"formulaElement\"></div>-->\r\n                            <input type=\"text\" ref=\"formulaElement\" value.bind=\"currentFormula\" change.delegate=\"formulaEdited()\" readonly.bind=\"!currentCell.id\"/>\r\n                        </div>\r\n                        <div style=\"overflow:hidden;width:calc(100%-300px);height:87vh;\">\r\n                            <div id=\"hot\"></div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>   \r\n        </div> \r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/spreadsheet/query":
/*!******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/spreadsheet/query.ts ***!
  \******************************************************************************/
/*! exports provided: Query */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Query", function() { return Query; });
class Query {
    constructor(speadsheetService) {
        this.speadsheetService = speadsheetService;
    }
}


/***/ }),

/***/ "module/spreadsheet/query.html":
/*!*******************************************!*\
  !*** ./SPA/module/spreadsheet/query.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"./steps\"></require>\r\n\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>Spreadsheet</h1></div>\r\n        <div class=\"columns\">\r\n            <spreadsheet-steps step=\"query\" containerLess></spreadsheet-steps>\r\n        </div>\r\n        \r\n        \r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/spreadsheet/steps":
/*!*****************************************!*\
  !*** ./SPA/module/spreadsheet/steps.ts ***!
  \*****************************************/
/*! exports provided: SpreadsheetSteps */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SpreadsheetSteps", function() { return SpreadsheetSteps; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let SpreadsheetSteps = class SpreadsheetSteps {
    constructor() {
        this.steps = [];
    }
    bind() {
        this.steps.push({
            name: 'Build query',
            route: 'query',
            active: this.step === 'query'
        });
        this.steps.push({
            name: 'Work',
            route: 'work',
            active: this.step === 'work'
        });
        this.steps.push({
            name: 'Export',
            route: 'export',
            active: this.step === 'export'
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], SpreadsheetSteps.prototype, "step", void 0);
SpreadsheetSteps = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('spreadsheet-steps')
], SpreadsheetSteps);



/***/ }),

/***/ "module/spreadsheet/steps.html":
/*!*******************************************!*\
  !*** ./SPA/module/spreadsheet/steps.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <ul class=\"step\">\r\n            <li class=\"step-item ${step.active ? 'active' : ''}\" repeat.for=\"step of steps\">\r\n                <a href=\"/#/spreadsheet/${step.route}\">${step.name}</a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=spreadsheet.7d2e17d8ae74be98b4b6.js.map