(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["elements"],{

/***/ "./SPA/element/editor/input-renderer.ts":
/*!**********************************************!*\
  !*** ./SPA/element/editor/input-renderer.ts ***!
  \**********************************************/
/*! exports provided: InputRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputRenderer", function() { return InputRenderer; });
class InputRenderer {
    render(instruction) {
        for (let { result, elements } of instruction.unrender) {
            for (let element of elements) {
                this.remove(element, result);
            }
        }
        for (let { result, elements } of instruction.render) {
            for (let element of elements) {
                this.add(element, result);
            }
        }
    }
    add(element, result) {
        if (result.valid) {
            return;
        }
        element.classList.add('has-error');
        const formGroup = element.closest('.form-group');
        if (!formGroup)
            return;
        const hints = formGroup.getElementsByClassName('form-input-hint');
        let hint = null;
        if (hints.length > 0) {
            hint = hints.item(0);
        }
        else {
            hint = document.createElement('p');
            hint.classList.add('form-input-hint');
            hint.classList.add('has-error');
            formGroup.appendChild(hint);
        }
        const message = document.createElement('span');
        message.textContent = result.message;
        message.id = `validation-message-${result.id}`;
        hint.appendChild(message);
    }
    remove(element, result) {
        if (result.valid) {
            return;
        }
        element.classList.remove('has-error');
        const formGroup = element.closest('.form-group');
        if (!formGroup) {
            return;
        }
        const hints = formGroup.getElementsByClassName('form-input-hint');
        if (!hints.length)
            return;
        const hint = hints.item(0);
        const message = formGroup.querySelector(`#validation-message-${result.id}`);
        if (message) {
            hint.removeChild(message);
            if (hint.childNodes.length === 0) {
                formGroup.removeChild(hint);
            }
        }
    }
}


/***/ }),

/***/ "./SPA/services/validation.ts":
/*!************************************!*\
  !*** ./SPA/services/validation.ts ***!
  \************************************/
/*! exports provided: FormValidatorRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FormValidatorRenderer", function() { return FormValidatorRenderer; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-validation */ "aurelia-validation");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_2__);



aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('number', (value, obj) => {
    const num = numeral__WEBPACK_IMPORTED_MODULE_2__(+value).value();
    return value === null
        || value === undefined
        || num !== null;
}, `Must be a number.`);
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('integerRange', (value, obj, min, max) => {
    const num = numeral__WEBPACK_IMPORTED_MODULE_2__(+value).value();
    return value === null
        || value === undefined
        || num !== null
        || (num >= min && num <= max);
}, `Must be an integer between \${$config.min} and \${$config.max}.`, (min, max) => ({ min, max }));
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('date', (value, obj) => {
    if (!value)
        return true;
    const date = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].from(value, 'D-MMM-YYYY', true);
    return date.isValid();
}, `Must be a date on the format D-MMM-YYYY, e.g. ${_scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].local.toDateFormat()}.`);
aurelia_validation__WEBPACK_IMPORTED_MODULE_1__["ValidationRules"].customRule('datetime', (value, obj) => {
    if (!value)
        return true;
    const datetime = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].from(value, 'D-MMM-YYYY, HH:mm', true);
    return datetime.isValid();
}, `Must be a datetime on the format D-MMM-YYYY, HH:mm, e.g. ${_scifeon_core__WEBPACK_IMPORTED_MODULE_0__["DateUtils"].local.toDateTimeFormat()}.`);
class FormValidatorRenderer {
    render(instruction) {
        for (let { result, elements } of instruction.unrender) {
            for (let element of elements) {
                this.remove(element, result);
            }
        }
        for (let { result, elements } of instruction.render) {
            for (let element of elements) {
                this.add(element, result);
            }
        }
    }
    add(element, result) {
        if (result.valid) {
            return;
        }
        const formGroup = element.closest('.form-group');
        if (!formGroup) {
            return;
        }
        let hint = null;
        if (formGroup.classList.contains('has-error')) {
            hint = formGroup.getElementsByClassName('form-input-hint').item(0);
        }
        else {
            hint = document.createElement('p');
            hint.className = 'form-input-hint';
            formGroup.appendChild(hint);
            formGroup.classList.add('has-error');
        }
        const message = document.createElement('span');
        message.textContent = result.message;
        message.id = `validation-message-${result.id}`;
        hint.appendChild(message);
    }
    remove(element, result) {
        if (result.valid) {
            return;
        }
        const formGroup = element.closest('.form-group');
        if (!formGroup) {
            return;
        }
        const hints = formGroup.getElementsByClassName('form-input-hint');
        if (!hints.length) {
            return;
        }
        const hint = hints.item(0);
        const message = formGroup.querySelector(`#validation-message-${result.id}`);
        if (message) {
            hint.removeChild(message);
            if (hint.childNodes.length === 0) {
                formGroup.classList.remove('has-error');
                formGroup.removeChild(hint);
            }
        }
    }
}


/***/ }),

/***/ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js":
/*!*************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");

/***/ }),

/***/ "./node_modules/flatpickr/dist/flatpickr.js":
/*!**********************************************************************************************!*\
  !*** delegated ./node_modules/flatpickr/dist/flatpickr.js from dll-reference scifeon_vendor ***!
  \**********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/flatpickr/dist/flatpickr.js");

/***/ }),

/***/ "./node_modules/querystring-es3/decode.js":
/*!************************************************!*\
  !*** ./node_modules/querystring-es3/decode.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.



// If obj.hasOwnProperty has been overridden, then calling
// obj.hasOwnProperty(prop) will break.
// See: https://github.com/joyent/node/issues/1707
function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

module.exports = function(qs, sep, eq, options) {
  sep = sep || '&';
  eq = eq || '=';
  var obj = {};

  if (typeof qs !== 'string' || qs.length === 0) {
    return obj;
  }

  var regexp = /\+/g;
  qs = qs.split(sep);

  var maxKeys = 1000;
  if (options && typeof options.maxKeys === 'number') {
    maxKeys = options.maxKeys;
  }

  var len = qs.length;
  // maxKeys <= 0 means that we should not limit keys count
  if (maxKeys > 0 && len > maxKeys) {
    len = maxKeys;
  }

  for (var i = 0; i < len; ++i) {
    var x = qs[i].replace(regexp, '%20'),
        idx = x.indexOf(eq),
        kstr, vstr, k, v;

    if (idx >= 0) {
      kstr = x.substr(0, idx);
      vstr = x.substr(idx + 1);
    } else {
      kstr = x;
      vstr = '';
    }

    k = decodeURIComponent(kstr);
    v = decodeURIComponent(vstr);

    if (!hasOwnProperty(obj, k)) {
      obj[k] = v;
    } else if (isArray(obj[k])) {
      obj[k].push(v);
    } else {
      obj[k] = [obj[k], v];
    }
  }

  return obj;
};

var isArray = Array.isArray || function (xs) {
  return Object.prototype.toString.call(xs) === '[object Array]';
};


/***/ }),

/***/ "./node_modules/querystring-es3/encode.js":
/*!************************************************!*\
  !*** ./node_modules/querystring-es3/encode.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.



var stringifyPrimitive = function(v) {
  switch (typeof v) {
    case 'string':
      return v;

    case 'boolean':
      return v ? 'true' : 'false';

    case 'number':
      return isFinite(v) ? v : '';

    default:
      return '';
  }
};

module.exports = function(obj, sep, eq, name) {
  sep = sep || '&';
  eq = eq || '=';
  if (obj === null) {
    obj = undefined;
  }

  if (typeof obj === 'object') {
    return map(objectKeys(obj), function(k) {
      var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
      if (isArray(obj[k])) {
        return map(obj[k], function(v) {
          return ks + encodeURIComponent(stringifyPrimitive(v));
        }).join(sep);
      } else {
        return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
      }
    }).join(sep);

  }

  if (!name) return '';
  return encodeURIComponent(stringifyPrimitive(name)) + eq +
         encodeURIComponent(stringifyPrimitive(obj));
};

var isArray = Array.isArray || function (xs) {
  return Object.prototype.toString.call(xs) === '[object Array]';
};

function map (xs, f) {
  if (xs.map) return xs.map(f);
  var res = [];
  for (var i = 0; i < xs.length; i++) {
    res.push(f(xs[i], i));
  }
  return res;
}

var objectKeys = Object.keys || function (obj) {
  var res = [];
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) res.push(key);
  }
  return res;
};


/***/ }),

/***/ "./node_modules/querystring-es3/index.js":
/*!***********************************************!*\
  !*** ./node_modules/querystring-es3/index.js ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.decode = exports.parse = __webpack_require__(/*! ./decode */ "./node_modules/querystring-es3/decode.js");
exports.encode = exports.stringify = __webpack_require__(/*! ./encode */ "./node_modules/querystring-es3/encode.js");


/***/ }),

/***/ "./node_modules/ts-loader/index.js?silent=true!./SPA/element/index.ts":
/*!*******************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/element/index.ts ***!
  \*******************************************************************/
/*! exports provided: configure */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "configure", function() { return configure; });
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_0__);

function configure(config) {
    config.globalResources([
        'element/chart',
        'element/dropzone',
        'element/e-link',
        'element/plate-view',
        'element/c3chart',
        'element/list-view',
        'element/editor/rich-text-editor',
        'element/editor/autocomplete',
        'element/editor/input-foreign-key',
        'element/grid/record-editor-grid',
        'element/editor/inplace-edit-select',
        'element/editor/inplace-edit-text',
        'element/editor/inplace-edit-textarea',
        'element/editor/inplace-edit-date',
        'element/editor/inplace-edit-foreign-key',
        'element/collapsible',
        'element/entity-form',
        'element/render-plugin',
        'element/notes-panel',
        'element/quick-help',
        'element/dropdown-button',
        'element/editor/list-editor',
        'element/editor/dictionary-editor',
        'element/editor/input-number',
        'element/editor/input-date',
        'element/editor/input-datetime'
    ]);
}


/***/ }),

/***/ "element/c3chart":
/*!********************************!*\
  !*** ./SPA/element/c3chart.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.C3Chart = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _desc, _value, _class2, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var C3Chart = exports.C3Chart = (_dec = (0, _aureliaFramework.customElement)('c3chart'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec(_class = _dec2(_class = (_class2 = function () {
    function C3Chart() {
        _classCallCheck(this, C3Chart);

        _initDefineProp(this, 'setup', _descriptor, this);
    }

    _createClass(C3Chart, [{
        key: 'attached',
        value: function attached() {
            this.isAttached = true;
            this.setupChanged();
        }
    }, {
        key: 'setupChanged',
        value: function setupChanged() {
            if (!this.isAttached || !this.setup) return;

            this.setup.bindto = this.chart;
            this.c3 = c3.generate(this.setup);
        }
    }]);

    return C3Chart;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'setup', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class) || _class);

/***/ }),

/***/ "element/c3chart.html":
/*!**********************************!*\
  !*** ./SPA/element/c3chart.html ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div ref=\"chart\"></div>\r\n</template>";

/***/ }),

/***/ "element/collapsible":
/*!************************************!*\
  !*** ./SPA/element/collapsible.ts ***!
  \************************************/
/*! exports provided: CollapsibleCustomElement */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CollapsibleCustomElement", function() { return CollapsibleCustomElement; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);

var CollapsibleCustomElement_1;

let CollapsibleCustomElement = CollapsibleCustomElement_1 = class CollapsibleCustomElement {
    constructor() {
        this.states = [];
        this.loadStates();
    }
    attached() {
        this.setPanel(this.container);
        const id = this.hashJavaDJB2(this.panel.baseURI + '-' + this.getXPathForElement(this.panel));
        this.state = this.states.find(s => s.id === id);
        if (!this.state) {
            this.state = {
                id: id,
                collapsed: this.default === 'collapsed'
            };
        }
        if (this.state.collapsed) {
            this.toggle();
        }
        else {
            this.collapsed = false;
        }
    }
    setPanel(element) {
        this.panel = element.parentElement;
        if (!this.panel.classList.contains('panel') && !this.panel.classList.contains('panel')) {
            this.setPanel(this.panel);
        }
    }
    toggle() {
        this.collapsed = !this.collapsed;
        if (this.collapsed) {
            this.panel.classList.add('collapsed');
        }
        else {
            this.panel.classList.remove('collapsed');
        }
        this.state.collapsed = this.collapsed;
        this.saveState();
    }
    loadStates() {
        const states = localStorage.getItem(CollapsibleCustomElement_1.STATES_KEY);
        if (states) {
            this.states = JSON.parse(states);
        }
    }
    saveState() {
        this.loadStates();
        let state = this.states.find(s => s.id === this.state.id);
        if (!state) {
            this.states.push(this.state);
        }
        else {
            state.collapsed = this.state.collapsed;
        }
        localStorage.setItem(CollapsibleCustomElement_1.STATES_KEY, JSON.stringify(this.states));
    }
    getXPathForElement(element) {
        const idx = (sib, name = null) => sib
            ? idx(sib.previousElementSibling, name || sib.localName) + (sib.localName == name)
            : 1;
        const segs = elm => !elm || elm.nodeType !== 1
            ? ['']
            : elm.id && document.querySelector(`#${elm.id}`) === elm
                ? [`id("${elm.id}")`]
                : [...segs(elm.parentNode), `${elm.localName.toLowerCase()}[${idx(elm)}]`];
        return segs(element).join('/');
    }
    hashJavaDJB2(str) {
        let hash = 0, char;
        if (str == 0)
            return hash;
        for (let i = 0, l = str.length; i < l; i++) {
            char = str.charCodeAt(i);
            hash = ((hash << 5) - hash) + char;
            hash |= 0;
        }
        return hash;
    }
    ;
};
CollapsibleCustomElement.STATES_KEY = 'scifeon-collapsible-states';
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], CollapsibleCustomElement.prototype, "default", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].fromView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], CollapsibleCustomElement.prototype, "collapsed", void 0);
CollapsibleCustomElement = CollapsibleCustomElement_1 = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [])
], CollapsibleCustomElement);



/***/ }),

/***/ "element/collapsible.html":
/*!**************************************!*\
  !*** ./SPA/element/collapsible.html ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <span ref=\"container\" class=\"collapsible-icon hide-in-print\" click.delegate=\"toggle()\">\r\n        <span if.bind=\"!collapsed\" class=\"fa fa-chevron-up\" title=\"Hide panel content\"></span>\r\n        <span else class=\"fa fa-chevron-down\" title=\"Show panel content\"></span>\r\n    </span>\r\n</template>";

/***/ }),

/***/ "element/dropdown-button":
/*!****************************************!*\
  !*** ./SPA/element/dropdown-button.ts ***!
  \****************************************/
/*! exports provided: DropdownButton */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DropdownButton", function() { return DropdownButton; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let DropdownButton = class DropdownButton {
    constructor(element) {
        this.element = element;
        this.class = '';
        this.title = '';
        this.rightAlign = false;
        this.outsideClickDismisses = true;
        this.disabled = false;
        this.dropdownClass = 'dropdown';
        this.clickHandler = event => {
            if (this.button && !this.button.contains(event.target)) {
                if (this.clickDismisses) {
                    this.close('content');
                }
                else if (this.outsideClickDismisses && !this.content.contains(event.target)) {
                    this.close('outside');
                }
            }
        };
    }
    close(click = 'manual') {
        document.removeEventListener('click', this.clickHandler);
        this.dropdownClass = this.dropdownClass.replace(/\s?active\s?/gi, '');
        this.element.dispatchEvent(new CustomEvent('close', { detail: { click: click }, bubbles: true }));
    }
    open(click = 'manual') {
        document.addEventListener('click', this.clickHandler);
        this.dropdownClass += ' active';
        this.element.dispatchEvent(new CustomEvent('open', { detail: { click: click }, bubbles: true }));
    }
    bind() {
        if (this.rightAlign) {
            this.dropdownClass += ' dropdown-right';
        }
        this.class += ' dropdown-toggle';
    }
    click() {
        if (this.dropdownClass.includes('active')) {
            this.close('button');
        }
        else {
            this.open('button');
        }
    }
    secondaryClick() {
        this.element.dispatchEvent(new CustomEvent('secondary-click', { bubbles: true }));
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "class", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "title", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "faIcon", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "text", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], DropdownButton.prototype, "rightAlign", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], DropdownButton.prototype, "clickDismisses", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], DropdownButton.prototype, "outsideClickDismisses", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], DropdownButton.prototype, "secondaryAction", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "secondaryTitle", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "secondaryText", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], DropdownButton.prototype, "secondaryIcon", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], DropdownButton.prototype, "disabled", void 0);
DropdownButton = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('dropdown-button'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element])
], DropdownButton);



/***/ }),

/***/ "element/dropdown-button.html":
/*!******************************************!*\
  !*** ./SPA/element/dropdown-button.html ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class.bind=\"dropdownClass\">\r\n        <div class=\"btn-group\">\r\n            <button disabled.bind=\"disabled\" ref=\"button\" class.bind=\"class\" tabindex=\"0\" title.bind=\"title\" click.delegate=\"click()\">${text ? text + ' ' : ''}\r\n                <i if.bind=\"faIcon\" class=\"fa fa-${faIcon}\"></i>\r\n            </button>\r\n            <button disabled.bind=\"disabled\" title.bind=\"secondaryTitle\" if.bind=\"secondaryAction\">\r\n                ${secondaryText ? secondaryText + ' ' : ''}\r\n                <i click.delegate=\"secondaryClick()\" class.bind=\"secondaryIcon ? 'fa fa-' + secondaryIcon : ''\"></i>\r\n            </button>\r\n        </div>\r\n        <div class=\"dropdown-content\" ref=\"content\">\r\n            <slot></slot>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/dropzone":
/*!*********************************!*\
  !*** ./SPA/element/dropzone.ts ***!
  \*********************************/
/*! exports provided: Dropzone */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Dropzone", function() { return Dropzone; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let Dropzone = class Dropzone {
    constructor(element) {
        this.element = element;
        this.title = 'Drop files to upload';
        this.buttonText = 'Select...';
    }
    attached() {
        this.fileInput.onchange = event => this.handleFiles(event.target.files);
    }
    handleFiles(files) {
        this.element.dispatchEvent(new CustomEvent('dropfiles', { bubbles: true, detail: { files } }));
    }
    handleDrop(event) {
        event.stopPropagation();
        event.preventDefault();
        this.handleFiles(event.dataTransfer.files);
    }
    handleDragOver(event) {
        event.stopPropagation();
        event.preventDefault();
        event.dataTransfer.dropEffect = 'copy';
    }
    handleDragEnter(event) {
        this.dropzone.classList.add('hover');
    }
    handleDragLeave(event) {
        this.dropzone.classList.remove('hover');
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Dropzone.prototype, "title", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Dropzone.prototype, "buttonText", void 0);
Dropzone = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('dropzone'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element])
], Dropzone);



/***/ }),

/***/ "element/dropzone.html":
/*!***********************************!*\
  !*** ./SPA/element/dropzone.html ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div ref=\"dropzone\" class=\"dropzone\"\r\n            dragenter.delegate=\"handleDragEnter($event)\" \r\n            dragleave.delegate=\"handleDragLeave($event)\"\r\n            dragover.delegate=\"handleDragOver($event)\" \r\n            drop.delegate=\"handleDrop($event)\" >\r\n        <button click.delegate=\"fileInput.click()\" class=\"small\">${buttonText}</button>\r\n        <input type=\"file\" ref=\"fileInput\" style=\"display: none;\" multiple=\"multiple\"/>\r\n        &nbsp;&nbsp;<i>or</i>&nbsp;&nbsp;\r\n        ${title}\r\n        &nbsp;&nbsp;<span class=\"fa fa-download\"></span>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/e-link":
/*!*******************************!*\
  !*** ./SPA/element/e-link.ts ***!
  \*******************************/
/*! exports provided: ELink */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ELink", function() { return ELink; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let ELink = class ELink {
    constructor(server) {
        this.server = server;
    }
    bind() {
        if (this.entity) {
            this.eClass = this.entity.eClass;
            this.id = this.entity.id;
            this.label = this.entity.name;
        }
        else if (this.entityId && this.eClass) {
            this.label = this.entityId;
            this.server.getEntity(this.eClass, this.entityId).then(entity => {
                if (entity) {
                    this.entity = entity;
                    this.id = this.entity.id;
                    this.label = entity.name;
                }
            });
        }
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELink.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELink.prototype, "entityId", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELink.prototype, "label", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ELink.prototype, "eClass", void 0);
ELink = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('e-link'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], ELink);



/***/ }),

/***/ "element/e-link.html":
/*!*********************************!*\
  !*** ./SPA/element/e-link.html ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <span if.bind=\"label && id\" class=\"e-link\"><a href=\"/#/entity/${eClass}/${id}\">${label}</a></span>\r\n    <span if.bind=\"label && !id\" class=\"e-link\">${label}</span>\r\n    <span if.bind=\"!label\" class=\"no-content\">(none)</span>\r\n</template>";

/***/ }),

/***/ "element/editor/autocomplete":
/*!********************************************!*\
  !*** ./SPA/element/editor/autocomplete.ts ***!
  \********************************************/
/*! exports provided: Autocomplete */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Autocomplete", function() { return Autocomplete; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-binding */ "./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_binding__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_pal__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-pal */ "./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js");
/* harmony import */ var aurelia_pal__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_pal__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__);






let nextID = 0;
let Autocomplete = class Autocomplete {
    constructor(element, server) {
        this.element = element;
        this.server = server;
        this.placeholder = '';
        this.delay = 300;
        this.inputValue = '';
        this.suggestionsUL = null;
        this.id = nextID++;
        this.expanded = false;
        this.suggestions = [];
        this.index = -1;
        this.loading = false;
        this.latestUserInput = '';
        this.updatingInput = false;
        this.focused = false;
    }
    bind() {
        this.display(this.value);
    }
    valueChanged(value) {
        if (this.updatingInput || (this.latestUserInput && this.latestUserInput === value))
            return;
        if (typeof this.value !== 'object') {
            this.display(this.value);
        }
    }
    inputValueChanged(value) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.updatingInput)
                return;
            this.display(value);
            if (!this.service)
                return;
            this.loading = true;
            const suggestions = yield this.service.suggest(value);
            this.index = -1;
            this.suggestions.splice(0, this.suggestions.length, ...suggestions);
            if (suggestions.length === 0) {
                this.collapse();
            }
            else {
                this.expand();
            }
            this.loading = false;
        });
    }
    keydown(key) {
        if (!this.expanded) {
            return true;
        }
        if (key === 40) {
            if (this.index < this.suggestions.length - 1) {
                this.index++;
                this.display(this.getValue(this.suggestions[this.index]));
            }
            else {
                this.index = -1;
                this.display(this.latestUserInput);
            }
            this.scroll();
            return;
        }
        if (key === 38) {
            if (this.index === -1) {
                this.index = this.suggestions.length - 1;
                this.display(this.getValue(this.suggestions[this.index]));
            }
            else if (this.index > 0) {
                this.index--;
                this.display(this.getValue(this.suggestions[this.index]));
            }
            else {
                this.index = -1;
                this.display(this.latestUserInput);
            }
            this.scroll();
            return;
        }
        if (key === 27) {
            this.display(this.latestUserInput);
            this.collapse();
            return;
        }
        if (key === 13) {
            if (this.index >= 0) {
                this.select(this.suggestions[this.index], true);
            }
            return;
        }
        return true;
    }
    blur() {
        this.focused = false;
        this.collapse();
        this.element.dispatchEvent(aurelia_pal__WEBPACK_IMPORTED_MODULE_4__["DOM"].createCustomEvent('blur', {}));
    }
    suggestionClicked(suggestion) {
        this.select(suggestion, true);
    }
    focus() {
        this.focused = true;
        this.element.firstElementChild.firstElementChild.focus();
    }
    hasFocus() {
        this.focused = true;
        this.inputValueChanged(this.inputValue);
    }
    select(suggestion, notify) {
        const value = this.getValue(suggestion);
        this.display(value);
        this.collapse();
        if (notify) {
            const event = aurelia_pal__WEBPACK_IMPORTED_MODULE_4__["DOM"].createCustomEvent('change', { bubbles: true });
            event.value = suggestion;
            event.autocomplete = this;
            this.element.dispatchEvent(event);
        }
    }
    display(value) {
        this.updatingInput = true;
        this.inputValue = value;
        this.latestUserInput = value;
        this.value = value;
        this.updatingInput = false;
    }
    getName(suggestion) {
        if (suggestion == null) {
            return '';
        }
        return this.service.getName(suggestion);
    }
    getValue(suggestion) {
        if (suggestion == null) {
            return '';
        }
        return this.service.getValue(suggestion);
    }
    collapse() {
        this.expanded = false;
        this.index = -1;
    }
    expand() {
        if (!this.focused)
            return;
        this.expanded = true;
        if (this.suggestionsUL) {
            this.suggestionsUL.style.width = this.element.firstElementChild.firstElementChild.clientWidth + 'px';
        }
    }
    scroll() {
        const ul = this.suggestionsUL;
        const li = ul.children.item(this.index === -1 ? 0 : this.index);
        if (li.offsetTop + li.offsetHeight > ul.offsetHeight) {
            ul.scrollTop += li.offsetHeight;
        }
        else if (li.offsetTop < ul.scrollTop) {
            ul.scrollTop = li.offsetTop;
        }
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_templating__WEBPACK_IMPORTED_MODULE_3__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Autocomplete.prototype, "service", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_templating__WEBPACK_IMPORTED_MODULE_3__["bindable"])({ defaultBindingMode: aurelia_binding__WEBPACK_IMPORTED_MODULE_2__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Autocomplete.prototype, "value", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_templating__WEBPACK_IMPORTED_MODULE_3__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Autocomplete.prototype, "placeholder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_templating__WEBPACK_IMPORTED_MODULE_3__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Autocomplete.prototype, "delay", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_binding__WEBPACK_IMPORTED_MODULE_2__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Autocomplete.prototype, "inputValue", void 0);
Autocomplete = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element, _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], Autocomplete);



/***/ }),

/***/ "element/editor/autocomplete.html":
/*!**********************************************!*\
  !*** ./SPA/element/editor/autocomplete.html ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"has-icon-right\">\r\n        <input type=\"text\" \r\n            ref=\"textINPUT\"\r\n            autocomplete=\"off\"\r\n            aria-autocomplete=\"list\"\r\n            aria-expanded.bind=\"expanded\"\r\n            aria-owns.one-time=\"'au-autocomplete-' + id + '-suggestions'\"\r\n            aria-activedescendant.bind=\"index >= 0 ? 'au-autocomplete-' + id + '-suggestion-' + index : ''\"\r\n            id.one-time=\"'au-autocomplete-' + id\"\r\n            placeholder.bind=\"placeholder\"\r\n            value.bind=\"inputValue & debounce:delay\"\r\n            keydown.delegate=\"keydown($event.which)\"\r\n            blur.trigger=\"blur()\"\r\n            focus.trigger=\"hasFocus()\"/>\r\n        <i if.bind=\"loading\" class=\"form-icon loading\"></i>       \r\n        <i else class=\"form-icon fa fa-caret-down\" style=\"cursor:pointer; right: -6px;\" click.trigger=\"textINPUT.focus()\"></i>\r\n    </div>\r\n    <ul class=\"suggestions\" \r\n        role=\"listbox\"\r\n        show.bind=\"expanded\"\r\n        id.one-time=\"'au-autocomplete-' + id + '-suggestions'\"\r\n        ref=\"suggestionsUL\">\r\n        <li repeat.for=\"suggestion of suggestions\" \r\n            id.one-time=\"'au-autocomplete-' + id + '-suggestion-' + $index\"\r\n            role=\"option\"\r\n            class-name.bind=\"($index === index ? 'selected' : '') + ' suggestion'\"\r\n            mousedown.delegate=\"suggestionClicked(suggestion)\">\r\n            <template replaceable part=\"suggestion\">\r\n                <span>${getName(suggestion)}</span>\r\n            </template>\r\n        </li>\r\n    </ul>\r\n</template>";

/***/ }),

/***/ "element/editor/dictionary-editor":
/*!*************************************************!*\
  !*** ./SPA/element/editor/dictionary-editor.ts ***!
  \*************************************************/
/*! exports provided: ListEditor */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ListEditor", function() { return ListEditor; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let ListEditor = class ListEditor {
    constructor(element) {
        this.element = element;
        this.type = 'string';
        this.placeholder = 'New key';
    }
    bind() {
        this.setObjectKeys();
    }
    objectChanged() {
        this.setObjectKeys();
    }
    addKey() {
        if (!this.object)
            this.object = {};
        this.object[this.newKey.trim()] = null;
        this.newKey = '';
        this.setObjectKeys();
        this.dispatchChangeEvent();
        this.element.dispatchEvent(new CustomEvent('add-key', { bubbles: true }));
    }
    removeKey(key) {
        delete this.object[key];
        this.setObjectKeys();
        this.dispatchChangeEvent();
        this.element.dispatchEvent(new CustomEvent('remove-key', { bubbles: true }));
    }
    dispatchChangeEvent() {
        this.element.dispatchEvent(new CustomEvent('change', { bubbles: true }));
    }
    dispatchBlurEvent() {
        this.element.dispatchEvent(new CustomEvent('blur'));
    }
    setObjectKeys() {
        if (this.object) {
            this.objectKeys = Object.keys(this.object);
        }
        else {
            this.objectKeys = [];
        }
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ListEditor.prototype, "object", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ListEditor.prototype, "type", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ListEditor.prototype, "placeholder", void 0);
ListEditor = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('dictionary-editor'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element])
], ListEditor);



/***/ }),

/***/ "element/editor/dictionary-editor.html":
/*!***************************************************!*\
  !*** ./SPA/element/editor/dictionary-editor.html ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>    \r\n    <form class=\"input-group\" submit.trigger=\"removeKey(key)\" repeat.for=\"key of objectKeys\" style=\"margin-bottom: 2px;\">\r\n        <span class=\"input-group-addon addon-sm\" style=\"width:12rem\">${key}</span>\r\n        <template if.bind=\"type === 'number'\">\r\n            <input-number class=\"input-sm key-${key}\" value.bind=\"object[key]\" keyup.delegate=\"dispatchChangeEvent()\" blur.trigger=\"dispatchBlurEvent()\" />\r\n        </template>\r\n        <template else>\r\n            <input class=\"input-sm key-${key}\" type=\"text\" value.bind=\"object[key]\" keyup.delegate=\"dispatchChangeEvent()\" blur.trigger=\"dispatchBlurEvent()\" />\r\n        </template>\r\n        <button type=\"submit\" class=\"input-group-btn small\" title=\"Remove\" style=\"width:6rem\">Remove</button>\r\n    </form>\r\n    <form class=\"input-group\" submit.trigger=\"addKey()\">\r\n        <input type=\"text\" class=\"input-sm new-key\" value.bind=\"newKey\" placeholder.bind=\"placeholder\" />\r\n        <button type=\"submit\" class=\"input-group-btn small\" title=\"Add\" disabled.bind=\"!newKey\" style=\"width:6rem\">Add</button>\r\n    </form>\r\n</template>";

/***/ }),

/***/ "element/editor/inplace-edit":
/*!********************************************!*\
  !*** ./SPA/element/editor/inplace-edit.ts ***!
  \********************************************/
/*! exports provided: InplaceEdit */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEdit", function() { return InplaceEdit; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let InplaceEditCounter = 0;
let InplaceEdit = class InplaceEdit {
    constructor(server, bindingEngine, element, queue) {
        this.bindingEngine = bindingEngine;
        this.element = element;
        this.queue = queue;
        this.editable = true;
        this.editMode = false;
        this.validate = value => ({ valid: true });
        this.allowEmpty = true;
        this.inline = false;
        this.saving = false;
        this.valid = true;
        this.validMsg = '';
        this.server = server;
        this.elementId = 'scifeon-inplace-edit-' + InplaceEditCounter++;
        this.inputView = new aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["InlineViewStrategy"](`<template>${this.view()}</template>`);
        this.clickedOutsideMouseDown = event => {
            this.clickedPosition = [event.pageX, event.pageY];
        };
        this.clickedOutsideMouseUp = event => {
            if (this.clickedPosition[0] !== event.pageX || this.clickedPosition[1] !== event.pageY)
                return;
            const isInputInPath = (target) => {
                if (target.classList.contains('flatpickr-calendar')) {
                    return true;
                }
                else if (target === this.input) {
                    return true;
                }
                else if (target.parentElement) {
                    return isInputInPath(target.parentElement);
                }
                else {
                    return false;
                }
            };
            if (!isInputInPath(event.target)) {
                this.saveField();
            }
        };
    }
    bind() {
        if (this.entity && this.key) {
            this.entityChanged();
        }
        if (!this.placeholder) {
            this.placeholder = '(none)';
        }
    }
    entityChanged() {
        if (this.entity && this.key) {
            if (this.entityKeySubscription) {
                this.entityKeySubscription.dispose();
            }
            this.entityKeySubscription = this.bindingEngine
                .propertyObserver(this.entity, this.key)
                .subscribe((newValue, oldValue) => this.setValueFromEntity());
            this.setValueFromEntity();
        }
    }
    editField() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            document.addEventListener('mousedown', this.clickedOutsideMouseDown);
            document.addEventListener('mouseup', this.clickedOutsideMouseUp);
            this.oldValue = JSON.parse(JSON.stringify(this.value));
            this.editValue = JSON.parse(JSON.stringify(this.value));
            this.editMode = true;
            this.queue.queueTask(() => {
                this.addCustomEventListeners();
                this.focus();
            });
        });
    }
    saveField() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.canSave)
                return;
            const validateResult = this.validate({ value: this.editValue });
            if (validateResult && !validateResult.valid) {
                this.valid = false;
                this.validMsg = validateResult.msg;
                return;
            }
            this.valid = true;
            this.validMsg = '';
            this.removeEventListeners();
            if (this.value !== JSON.parse(JSON.stringify(this.editValue))) {
                this.saving = true;
                this.value = JSON.parse(JSON.stringify(this.editValue));
                const oldEntity = JSON.parse(JSON.stringify(this.entity));
                yield this.save(this.value);
                this.element.dispatchEvent(new CustomEvent('entity-saved', { bubbles: true, detail: { old: oldEntity, new: this.entity } }));
                this.saving = false;
            }
            this.editValue = null;
            this.editMode = false;
        });
    }
    resetField() {
        this.removeEventListeners();
        this.editValue = null;
        this.editMode = false;
    }
    get loading() {
        return this.value === undefined;
    }
    removeEventListeners() {
        document.removeEventListener('mousedown', this.clickedOutsideMouseDown);
        document.removeEventListener('mouseup', this.clickedOutsideMouseUp);
        this.removeCustomEventListeners();
    }
    setValueFromEntity() {
        if (this.key.toLowerCase().startsWith('attributes.')) {
            if (!this.entity.attributes)
                this.entity.attributes = {};
            this.value = this.entity.attributes[this.key.substring(11)];
        }
        else {
            this.value = this.entity[this.key];
        }
        if (!this.value) {
            this.value = '';
        }
        this.editValue = this.value;
    }
    get isEmpty() {
        return this.value === undefined || this.value === '';
    }
    get canSave() {
        return this.allowEmpty || (this.editValue !== undefined && this.editValue !== '' && this.editValue !== null);
    }
    save(value) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.entity)
                return;
            if (this.key.startsWith('attributes.')) {
                this.entity.attributes[this.key.substring(11)] = value;
            }
            else {
                this.entity[this.key] = value;
            }
            let updateDef;
            if (this.entity.id) {
                updateDef = {
                    id: this.entity.id,
                    eClass: this.entity.eClass,
                    version: this.entity.version
                };
                if (this.key.startsWith('attributes.')) {
                    updateDef.attributes = this.entity.attributes;
                }
                else {
                    updateDef[this.key] = value;
                }
            }
            else {
                updateDef = this.entity;
            }
            this.entity = Object.assign(this.entity, yield this.server.save(updateDef));
        });
    }
    focus() { }
    addCustomEventListeners() { }
    removeCustomEventListeners() { }
    view() { return ''; }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEdit.prototype, "editable", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEdit.prototype, "value", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEdit.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InplaceEdit.prototype, "key", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], InplaceEdit.prototype, "editMode", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Function)
], InplaceEdit.prototype, "validate", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEdit.prototype, "allowEmpty", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InplaceEdit.prototype, "placeholder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InplaceEdit.prototype, "title", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEdit.prototype, "inline", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InplaceEdit.prototype, "width", void 0);
InplaceEdit = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["BindingEngine"], Element, aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["TaskQueue"]])
], InplaceEdit);



/***/ }),

/***/ "element/editor/inplace-edit-date":
/*!*************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-date.ts ***!
  \*************************************************/
/*! exports provided: InplaceEditDate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEditDate", function() { return InplaceEditDate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _inplace_edit__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./inplace-edit */ "element/editor/inplace-edit");





let InplaceEditDate = class InplaceEditDate extends _inplace_edit__WEBPACK_IMPORTED_MODULE_4__["InplaceEdit"] {
    view() {
        return `<input-date id.bind="elementId" value.bind="editValue" margin-right.bind="55"></input-date>`;
    }
    setValueFromEntity() {
        if (this.entity[this.key]) {
            this.value = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].toDateFormat(this.entity[this.key]);
        }
        if (!this.value) {
            this.value = '';
        }
        this.editValue = this.value;
    }
};
InplaceEditDate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_templating__WEBPACK_IMPORTED_MODULE_3__["useView"])('./inplace-edit.html'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('inplace-edit-date')
], InplaceEditDate);



/***/ }),

/***/ "element/editor/inplace-edit-foreign-key":
/*!********************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-foreign-key.ts ***!
  \********************************************************/
/*! exports provided: InplaceEditForeignKey */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEditForeignKey", function() { return InplaceEditForeignKey; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _inplace_edit__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./inplace-edit */ "element/editor/inplace-edit");




let InplaceEditForeignKey = class InplaceEditForeignKey extends _inplace_edit__WEBPACK_IMPORTED_MODULE_3__["InplaceEdit"] {
    constructor() {
        super(...arguments);
        this.delay = 300;
        this.filters = null;
        this.sortings = null;
    }
    view() {
        return `
        <input-foreign-key id.bind="elementId"
                           if.bind="editValue !== null"
                           value.bind="editValue"
                           delay.bind="delay"
                           filters.bind="filters"
                           sortings.bind="sortings"
                           e-class.bind="eClass">
        </input-foreign-key>`;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InplaceEditForeignKey.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEditForeignKey.prototype, "delay", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].toView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEditForeignKey.prototype, "filters", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].toView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InplaceEditForeignKey.prototype, "sortings", void 0);
InplaceEditForeignKey = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__["useView"])('./inplace-edit.html'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('inplace-edit-foreign-key')
], InplaceEditForeignKey);



/***/ }),

/***/ "element/editor/inplace-edit-select":
/*!***************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-select.ts ***!
  \***************************************************/
/*! exports provided: InplaceEditSelect */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEditSelect", function() { return InplaceEditSelect; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _inplace_edit__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./inplace-edit */ "element/editor/inplace-edit");



let InplaceEditSelect = class InplaceEditSelect extends _inplace_edit__WEBPACK_IMPORTED_MODULE_2__["InplaceEdit"] {
    get valueToName() {
        const name = this.options.find(o => o.value === this.value);
        return name ? name.name : this.value;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], InplaceEditSelect.prototype, "options", void 0);
InplaceEditSelect = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('inplace-edit-select')
], InplaceEditSelect);



/***/ }),

/***/ "element/editor/inplace-edit-select.html":
/*!*****************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-select.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"loading\" show.bind=\"value === undefined\"></div>\r\n\r\n    <div class=\"input-placeholder ${class}\" css.bind=\"style\" show.bind=\"!editMode && value !== undefined\" click.delegate=\"editField()\">\r\n        <span class=\"no-content\" show.bind=\"isEmpty\">${placeholder}</span>\r\n        <span if.bind=\"!inlineStyle\" class=\"fa fa-pencil\" title=\"Edit\"></span>\r\n        <span innerhtml.bind=\"valueToName\" show.bind=\"!isEmpty\"></span>\r\n        <span if.bind=\"inlineStyle\" class=\"fa fa-pencil\" title=\"Edit\"></span>\r\n    </div>\r\n\r\n    <div class=\"input ${class}\" css.bind=\"style\" if.bind=\"editMode\" ref=\"input\">\r\n        <select id.bind=\"elementId\" value.bind=\"editValue\">\r\n            <option value.bind=\"option.value\" repeat.for=\"option of options\">${option.name}</option>\r\n        </select>\r\n        <div class=\"save-reset\">\r\n            <div class=\"btn-group\">\r\n                <button class=\"fa fa-check\" title=\"Save\" click.delegate=\"saveField()\"></button>\r\n                <button class=\"fa fa-times secondary\" title=\"Cancel\" click.delegate=\"resetField()\"></button>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/editor/inplace-edit-text":
/*!*************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-text.ts ***!
  \*************************************************/
/*! exports provided: InplaceEditText */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEditText", function() { return InplaceEditText; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _inplace_edit__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./inplace-edit */ "element/editor/inplace-edit");




let InplaceEditText = class InplaceEditText extends _inplace_edit__WEBPACK_IMPORTED_MODULE_3__["InplaceEdit"] {
    focus() {
        this.inputElement.focus();
    }
    keyupEvent(event) {
        if (event.key === 'Enter') {
            this.saveField();
        }
    }
    view() {
        return `<input class="field" id.bind="elementId" type="text" value.bind="editValue" ref="inputElement" keyup.delegate="keyupEvent($event)" />`;
    }
};
InplaceEditText = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__["useView"])('./inplace-edit.html'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('inplace-edit-text')
], InplaceEditText);



/***/ }),

/***/ "element/editor/inplace-edit-textarea":
/*!*****************************************************!*\
  !*** ./SPA/element/editor/inplace-edit-textarea.ts ***!
  \*****************************************************/
/*! exports provided: InplaceEditTextarea */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InplaceEditTextarea", function() { return InplaceEditTextarea; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _inplace_edit__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./inplace-edit */ "element/editor/inplace-edit");




let InplaceEditTextarea = class InplaceEditTextarea extends _inplace_edit__WEBPACK_IMPORTED_MODULE_3__["InplaceEdit"] {
    get isEmpty() {
        return !this.value;
    }
    view() {
        return `<rich-text-editor id.bind="elementId" if.bind="editValue !== null" value.bind="editValue" focus-immediately="true"></rich-text-editor>`;
    }
};
InplaceEditTextarea = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_templating__WEBPACK_IMPORTED_MODULE_2__["useView"])('./inplace-edit.html'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('inplace-edit-textarea')
], InplaceEditTextarea);



/***/ }),

/***/ "element/editor/inplace-edit.html":
/*!**********************************************!*\
  !*** ./SPA/element/editor/inplace-edit.html ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class.bind=\"inline ? 'inline' : ''\" css.bind=\"width ? 'width:' + width : ''\">\r\n        <div class=\"loading\" if.bind=\"loading\"></div>\r\n\r\n        <div class=\"placeholder\" if.bind=\"!editMode && !loading\" title.bind=\"title ? title : ''\">\r\n            <span class=\"no-content hide-in-print\" if.bind=\"isEmpty\">${placeholder}</span>\r\n            <span innerhtml.bind=\"value\" else class=\"value\"></span>\r\n            <span class=\"fa fa-pencil edit\" title=\"Edit\" click.delegate=\"editField()\" if.bind=\"editable\"></span>\r\n        </div>\r\n    \r\n        <div class=\"input ${!valid ? 'has-error' : ''}\" if.bind=\"editMode\" ref=\"input\">\r\n            <compose containerLess\r\n                        if.bind=\"inputView\"\r\n                        view.bind=\"inputView\">\r\n            </compose>\r\n            <span class=\"error\" if.bind=\"validMsg\">\r\n                ${validMsg}\r\n            </span>\r\n            <div class=\"save-reset\">\r\n                <div class=\"btn-group\" if.bind=\"!saving\">\r\n                    <button class=\"fa fa-check save\" title=\"Save\" click.delegate=\"saveField()\" disabled.bind=\"!canSave\"></button>\r\n                    <button class=\"fa fa-times secondary\" title=\"Cancel\" click.delegate=\"resetField()\"></button>\r\n                </div>\r\n                <div else class=\"loading\">-</div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/editor/input-date":
/*!******************************************!*\
  !*** ./SPA/element/editor/input-date.ts ***!
  \******************************************/
/*! exports provided: InputDate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputDate", function() { return InputDate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-validation */ "aurelia-validation");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _input_renderer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./input-renderer */ "./SPA/element/editor/input-renderer.ts");
/* harmony import */ var flatpickr__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! flatpickr */ "./node_modules/flatpickr/dist/flatpickr.js");
/* harmony import */ var flatpickr__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(flatpickr__WEBPACK_IMPORTED_MODULE_4__);





let InputDate = class InputDate {
    constructor(element, validationControllerFactory, queue) {
        this.element = element;
        this.queue = queue;
        this.placeholder = '';
        this.allowInput = true;
        this.time = false;
        this.controller = validationControllerFactory.createForCurrentScope();
        this.controller.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["validateTrigger"].changeOrBlur;
    }
    attached() {
        if (this.validateInput) {
            this.controller.addRenderer(new _input_renderer__WEBPACK_IMPORTED_MODULE_3__["InputRenderer"]());
            aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationRules"].ensure((o) => o.value)
                .satisfiesRule(this.time ? 'datetime' : 'date')
                .on(this);
        }
        this.class += this.time ? ' datetime' : ' date';
        this.flatpickrInstance = flatpickr__WEBPACK_IMPORTED_MODULE_4___default()(this.dateElement, {
            enableTime: this.time,
            dateFormat: this.time ? 'd-M-Y, H:i' : 'd-M-Y',
            time_24hr: true,
            allowInput: this.allowInput,
            onReady() {
                this.showTimeInput = true;
            },
            locale: {
                firstDayOfWeek: 1
            },
            onOpen: (selectedDates, dateStr, instance) => {
                if (this.marginRight) {
                    this.queue.queueMicroTask(() => {
                        const calendar = instance.calendarContainer;
                        const right = Number(calendar.style.right.replace('px', ''));
                        calendar.style.right = (right + this.marginRight) + 'px';
                    });
                }
            }
        });
    }
    detached() {
        if (this.flatpickrInstance)
            this.flatpickrInstance.destroy();
    }
    dispatchBlurEvent() {
        this.queue.queueMicroTask(() => {
            this.element.dispatchEvent(new CustomEvent('blur'));
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Date)
], InputDate.prototype, "value", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InputDate.prototype, "class", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InputDate.prototype, "id", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputDate.prototype, "placeholder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputDate.prototype, "allowInput", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputDate.prototype, "validateInput", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Number)
], InputDate.prototype, "marginRight", void 0);
InputDate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('input-date'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element, aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationControllerFactory"], aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["TaskQueue"]])
], InputDate);



/***/ }),

/***/ "element/editor/input-date.html":
/*!********************************************!*\
  !*** ./SPA/element/editor/input-date.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <input  ref=\"dateElement\"\r\n            class.bind=\"class\"  \r\n            id.bind=\"id\" \r\n            value.bind=\"value & validate\"            \r\n            blur.trigger=\"dispatchBlurEvent()\"\r\n            placeholder.bind=\"placeholder\" />\r\n</template>";

/***/ }),

/***/ "element/editor/input-datetime":
/*!**********************************************!*\
  !*** ./SPA/element/editor/input-datetime.ts ***!
  \**********************************************/
/*! exports provided: InputDateTime */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputDateTime", function() { return InputDateTime; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _input_date__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./input-date */ "element/editor/input-date");



let InputDateTime = class InputDateTime extends _input_date__WEBPACK_IMPORTED_MODULE_2__["InputDate"] {
    constructor() {
        super(...arguments);
        this.time = true;
    }
};
InputDateTime = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('input-datetime'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["useView"])('./input-date.html')
], InputDateTime);



/***/ }),

/***/ "element/editor/input-foreign-key":
/*!*************************************************!*\
  !*** ./SPA/element/editor/input-foreign-key.ts ***!
  \*************************************************/
/*! exports provided: InputForeignKey */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputForeignKey", function() { return InputForeignKey; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _autocomplete__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./autocomplete */ "element/editor/autocomplete");



let InputForeignKey = class InputForeignKey extends _autocomplete__WEBPACK_IMPORTED_MODULE_2__["Autocomplete"] {
    constructor() {
        super(...arguments);
        this.entity = null;
        this.filters = null;
        this.sortings = null;
    }
    bind() {
        if (!this.eClass) {
            throw new Error('The e-class attribute is required.');
        }
        this.service = new ForeignKeySuggestionService(this.eClass, this.server, this.filters, this.sortings);
        this.entity = {
            eClass: this.eClass,
            id: this.value
        };
        super.bind();
    }
    filtersChanged() {
        this.service.setFilters(this.filters);
    }
    sortingsChanged() {
        this.service.setSortings(this.sortings);
    }
    blur() {
        super.blur();
        this.validate();
    }
    select(suggestion, notify) {
        this.entity = suggestion.value;
        super.select(suggestion, notify);
    }
    validate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const inputValue = this.inputValue || '';
            if (!inputValue.trim() || (this.entity && this.entity.id && this.entity.id.toLowerCase() === inputValue.trim().toLowerCase()))
                return;
            this.loading = true;
            try {
                this.entity = yield this.server.getEntity(this.eClass, inputValue);
            }
            catch (_a) {
                this.entity = null;
            }
            this.loading = false;
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputForeignKey.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].fromView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputForeignKey.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].toView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputForeignKey.prototype, "filters", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].toView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputForeignKey.prototype, "sortings", void 0);
InputForeignKey = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('input-foreign-key')
], InputForeignKey);

class ForeignKeySuggestionService {
    constructor(eClass, server, filters = [], sortings = []) {
        this.eClass = eClass;
        this.server = server;
        this.filters = filters;
        this.sortings = sortings;
        if (this.eClass.toLowerCase() === 'user' && this.sortings && !this.sortings.length) {
            this.sortings = [{ field: 'name' }];
        }
    }
    setFilters(filters) {
        this.filters = filters;
    }
    setSortings(sortings) {
        this.sortings = sortings;
    }
    suggest(value) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            value = value ? value.toLowerCase() : '';
            const response = yield this.server.postJson('/api/query/suggest/' + this.eClass + '/' + value, { filters: this.filters, sortings: this.sortings });
            const suggestions = yield response.json();
            return suggestions.map(s => {
                return {
                    value: s,
                    name: s.name.replace(new RegExp('(' + value + ')', 'gim'), '<span class="query">$1</span>'),
                    displayId: s.id.replace(new RegExp('(' + value + ')', 'gim'), '<span class="query">$1</span>'),
                };
            });
        });
    }
    getName(suggestion) {
        return suggestion.name;
    }
    getValue(suggestion) {
        return suggestion.value.id;
    }
}


/***/ }),

/***/ "element/editor/input-foreign-key.html":
/*!***************************************************!*\
  !*** ./SPA/element/editor/input-foreign-key.html ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"has-icon-right\">\r\n        <input type=\"text\" \r\n            ref=\"textINPUT\"\r\n            autocomplete=\"off\"\r\n            aria-autocomplete=\"list\"\r\n            aria-expanded.bind=\"expanded\"\r\n            aria-owns.one-time=\"'au-autocomplete-' + id + '-suggestions'\"\r\n            aria-activedescendant.bind=\"index >= 0 ? 'au-autocomplete-' + id + '-suggestion-' + index : ''\"\r\n            id.one-time=\"'au-autocomplete-' + id\"\r\n            placeholder.bind=\"placeholder\"\r\n            value.bind=\"inputValue & debounce:delay\"\r\n            keydown.delegate=\"keydown($event.which)\"\r\n            blur.trigger=\"blur()\"\r\n            focus.trigger=\"hasFocus()\"/>\r\n        <i if.bind=\"loading\" class=\"form-icon loading\"></i>       \r\n        <i else class=\"form-icon fa fa-caret-down\" style=\"cursor:pointer; right: -6px;\" click.trigger=\"textINPUT.focus()\"></i>\r\n    </div>\r\n    <ul class=\"suggestions\" \r\n        role=\"listbox\"\r\n        show.bind=\"expanded\"\r\n        id.one-time=\"'au-autocomplete-' + id + '-suggestions'\"\r\n        ref=\"suggestionsUL\">\r\n        <li repeat.for=\"suggestion of suggestions\" \r\n            id.one-time=\"'au-autocomplete-' + id + '-suggestion-' + $index\"\r\n            role=\"option\"\r\n            class-name.bind=\"($index === index ? 'selected' : '') + ' suggestion'\"\r\n            mousedown.delegate=\"suggestionClicked(suggestion)\">\r\n            <template replaceable part=\"suggestion\">\r\n                <span innerhtml.bind=\"suggestion.name\"></span> \r\n                <span class=\"float-right\" style=\"font-weight:bold;font-size:80%;\">(<span innerhtml.bind=\"suggestion.displayId\"></span>)</span>\r\n            </template>\r\n        </li>\r\n    </ul>\r\n    <template if.bind=\"inputValue\">\r\n        <p if.bind=\"!entity\" class=\"form-input-hint\">${inputValue} not found.</p>\r\n        <p if.bind=\"entity && entity.name\" class=\"form-input-hint\">Name: ${entity.name}</p>\r\n    </template>\r\n</template>";

/***/ }),

/***/ "element/editor/input-number":
/*!********************************************!*\
  !*** ./SPA/element/editor/input-number.ts ***!
  \********************************************/
/*! exports provided: InputNumber */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputNumber", function() { return InputNumber; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-validation */ "aurelia-validation");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! numeral */ "./node_modules/numeral/numeral.js");
/* harmony import */ var numeral__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(numeral__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _input_renderer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./input-renderer */ "./SPA/element/editor/input-renderer.ts");





let InputNumber = class InputNumber {
    constructor(element, validationControllerFactory, queue) {
        this.element = element;
        this.queue = queue;
        this.placeholder = '';
        this.validateInput = true;
        this.keyUpInput = false;
        this.controller = validationControllerFactory.createForCurrentScope();
        this.controller.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["validateTrigger"].changeOrBlur;
    }
    bind() {
        if (this.validateInput) {
            this.controller.addRenderer(new _input_renderer__WEBPACK_IMPORTED_MODULE_4__["InputRenderer"]());
            aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationRules"].ensure((o) => o.valueString)
                .satisfiesRule('number')
                .on(this);
        }
        this.class += ' number';
        this.valueChanged();
    }
    valueChanged() {
        if (!this.keyUpInput) {
            if (this.value) {
                this.valueString = '' + this.value;
                this.value = numeral__WEBPACK_IMPORTED_MODULE_3__(+this.valueString).value();
            }
            else {
                this.valueString = '';
            }
        }
        this.keyUpInput = false;
    }
    keyUp() {
        this.keyUpInput = true;
        const value = numeral__WEBPACK_IMPORTED_MODULE_3__(+this.valueString).value();
        if (this.valueString && !this.valueString.endsWith('.') && value !== null) {
            this.value = value;
        }
        else {
            this.value = null;
        }
        this.dispatchKeyUpEvent();
    }
    dispatchBlurEvent() {
        this.queue.queueMicroTask(() => {
            this.element.dispatchEvent(new CustomEvent('blur'));
        });
    }
    dispatchKeyUpEvent() {
        this.queue.queueMicroTask(() => {
            this.element.dispatchEvent(new CustomEvent('keyup', { bubbles: true }));
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Number)
], InputNumber.prototype, "value", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], InputNumber.prototype, "class", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputNumber.prototype, "placeholder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], InputNumber.prototype, "validateInput", void 0);
InputNumber = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('input-number'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element, aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationControllerFactory"], aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["TaskQueue"]])
], InputNumber);



/***/ }),

/***/ "element/editor/input-number.html":
/*!**********************************************!*\
  !*** ./SPA/element/editor/input-number.html ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <input class.bind=\"class\" \r\n           value.bind=\"valueString & validate\" \r\n           keyup.delegate=\"keyUp()\" \r\n           blur.trigger=\"dispatchBlurEvent()\" \r\n           placeholder.bind=\"placeholder\" />\r\n</template>";

/***/ }),

/***/ "element/editor/list-editor":
/*!*******************************************!*\
  !*** ./SPA/element/editor/list-editor.ts ***!
  \*******************************************/
/*! exports provided: ListEditor */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ListEditor", function() { return ListEditor; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let ListEditor = class ListEditor {
    constructor(element) {
        this.element = element;
        this.type = 'string';
        this.placeholder = 'New value';
    }
    addItem() {
        if (!this.items)
            this.items = [];
        this.items.push(this.newItem);
        this.newItem = '';
        this.dispatchChangeEvent();
    }
    removeItem(index) {
        this.items.splice(index, 1);
        this.dispatchChangeEvent();
    }
    dispatchChangeEvent() {
        this.element.dispatchEvent(new CustomEvent('change', { bubbles: true }));
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], ListEditor.prototype, "items", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ListEditor.prototype, "type", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ListEditor.prototype, "placeholder", void 0);
ListEditor = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('list-editor'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element])
], ListEditor);



/***/ }),

/***/ "element/editor/list-editor.html":
/*!*********************************************!*\
  !*** ./SPA/element/editor/list-editor.html ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <form class=\"input-group\" submit.trigger=\"removeItem(i)\" repeat.for=\"i of items.length\" style=\"margin-bottom: 2px;\">\r\n        <template if.bind=\"type === 'number'\">\r\n            <input-number class=\"input-sm\" value.bind=\"items[i]\" keyup.delegate=\"dispatchChangeEvent()\" />\r\n        </template>\r\n        <template else>\r\n            <input class=\"input-sm\" type=\"text\" value.bind=\"items[i]\" keyup.delegate=\"dispatchChangeEvent()\" />\r\n        </template>\r\n        <button type=\"submit\" class=\"input-group-btn small\" title=\"Remove\" style=\"width:6rem\">Remove</button>\r\n    </form>\r\n    <form class=\"input-group\" submit.trigger=\"addItem()\">\r\n        <template if.bind=\"type === 'number'\">\r\n            <input-number class=\"input-sm\" value.bind=\"newItem\" placeholder.bind=\"placeholder\" />\r\n        </template>\r\n        <template else>\r\n            <input type=\"text\" class=\"input-sm\" value.bind=\"newItem\" placeholder.bind=\"placeholder\" />\r\n        </template>\r\n        <button type=\"submit\" class=\"input-group-btn small\" title=\"Add\" style=\"width:6rem\" disabled.bind=\"!newItem\">Add</button>\r\n    </form>\r\n</template>";

/***/ }),

/***/ "element/editor/rich-text-editor":
/*!************************************************!*\
  !*** ./SPA/element/editor/rich-text-editor.ts ***!
  \************************************************/
/*! exports provided: RichTextEditor */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RichTextEditor", function() { return RichTextEditor; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let no = 0;
let RichTextEditor = class RichTextEditor {
    constructor() {
        this.showToolbar = true;
        this.placeholder = 'Enter text here...';
        this.focusImmediately = false;
        this.toolbar = [
            ['style', ['style', 'clear']],
            ['face', ['fontname', 'fontsize']],
            ['font', ['bold', 'italic', 'underline', 'strikethrough', 'subscript', 'superscript', 'color']],
            ['layout', ['ul', 'ol', 'paragraph', 'height']],
            ['insert', ['picture', 'link', 'hr', 'table']],
            ['misc', ['undo', 'redo']]
        ];
        this.id = 'rich-text-editor-' + no++;
    }
    bind() {
        if (!this.height) {
            this.height = 150;
        }
    }
    valueChanged(newValue) {
        if (this.editor && this.editor.summernote('code') !== newValue) {
            this.editor.summernote('code', newValue);
        }
    }
    attached() {
        this.editor = $(`#${this.id}`);
        this.editor.summernote({
            minHeight: 100,
            placeholder: this.placeholder,
            height: this.height,
            focus: this.focusImmediately,
            toolbar: this.toolbar
        });
        this.editor.summernote('code', this.value);
        this.editor.on('summernote.change', (we, contents, $editable) => this.value = contents);
        this.editor.on('summernote.focus', () => this.class = 'has-focus');
        this.editor.on('summernote.blur', () => {
            this.class = '';
            if (this.editor.summernote('isEmpty')) {
                this.value = '';
            }
        });
        if (this.focusImmediately) {
            this.class = 'has-focus';
        }
    }
    detached() {
        this.editor.off('summernote.change');
        this.editor.off('summernote.focus');
        this.editor.off('summernote.blur');
        this.editor.summernote('destroy');
        this.editor = null;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], RichTextEditor.prototype, "value", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RichTextEditor.prototype, "showToolbar", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RichTextEditor.prototype, "placeholder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RichTextEditor.prototype, "focusImmediately", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], RichTextEditor.prototype, "tabindex", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Number)
], RichTextEditor.prototype, "height", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RichTextEditor.prototype, "toolbar", void 0);
RichTextEditor = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["inlineView"](`<template>
    <div id.bind="id" class.bind="class"></div>
</template>`),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('rich-text-editor')
], RichTextEditor);



/***/ }),

/***/ "element/entity-form":
/*!************************************!*\
  !*** ./SPA/element/entity-form.ts ***!
  \************************************/
/*! exports provided: EntityForm */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EntityForm", function() { return EntityForm; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-validation */ "aurelia-validation");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var services_validation__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! services/validation */ "./SPA/services/validation.ts");





let EntityForm = class EntityForm {
    constructor(datamodel, server, validator, controllerFactory) {
        this.datamodel = datamodel;
        this.server = server;
        this.validator = validator;
        this.prevUniqueValues = {};
        this.valueIsUnique = {};
        this.isBound = false;
        this.horizontal = true;
        this.fields = [];
        this.valid = false;
        this.dirty = false;
        this.object = {};
        this.delay = 100;
        this.parsedColumns = [];
        this.sortOrder = ['name', 'type', 'description', 'status'];
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["LogManager"].getLogger('EntityForm');
        this.controller = controllerFactory.createForCurrentScope(validator);
        this.controller.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["validateTrigger"].changeOrBlur;
        this.controller.addRenderer(new services_validation__WEBPACK_IMPORTED_MODULE_4__["FormValidatorRenderer"]());
    }
    bind() {
        if (!this.isBound) {
            this.logger.debug('Input: ', this.object, this.eClass, this.fields, this.horizontal);
            if (typeof this.fields === 'string') {
                this.fields = this.fields.split(',').map(f => f.trim());
            }
            if (this.columns) {
                let columns = [];
                for (let column of this.columns) {
                    columns.push(this.datamodel.setProperties(column));
                }
                this.columns = columns;
                this.sortOrder = this.columns.map(c => c.nameLC);
            }
            this.loadTable();
            this.loadFields();
        }
        this.isBound = true;
        this.orgObject = JSON.stringify(this.object);
    }
    loadTable() {
        if (this.eClass) {
            this.object.eClass = this.eClass;
            if (!this.object.id && !this.object.status) {
                this.object.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_3__["Status"].INITIAL;
            }
            this.table = this.datamodel.find(this.eClass);
            this.logger.debug('Loaded model: ', this.table);
        }
    }
    loadFields() {
        const fields = this.columns ? this.columns : this.table.columns.filter(c => this.filterFields(c));
        for (let f = 0; f < fields.length; f++) {
            const field = fields[f];
            this.setObjectProperty(field);
            field.id = 'field-' + field.nameLCF;
            this.setInputEditor(field);
        }
        const sortedFields = this.sortFields(fields);
        let objectValidationRules = [];
        const otherValidationRules = {};
        for (const field of sortedFields) {
            const rule = this.loadValidationRules(field);
            const parsedColumn = {
                desc: field,
                object: field.objectKey ? this.object[field.objectKey] : this.object,
                validationRules: rule ? rule.rules : []
            };
            if (parsedColumn.validationRules.length) {
                if (parsedColumn.desc.objectKey) {
                    if (!otherValidationRules[parsedColumn.desc.objectKey]) {
                        otherValidationRules[parsedColumn.desc.objectKey] = [];
                    }
                    otherValidationRules[parsedColumn.desc.objectKey] = otherValidationRules[parsedColumn.desc.objectKey].concat(parsedColumn.validationRules);
                }
                else {
                    objectValidationRules = objectValidationRules.concat(parsedColumn.validationRules);
                }
            }
            this.parsedColumns.push(parsedColumn);
        }
        if (objectValidationRules.length) {
            this.controller.addObject(this.object, objectValidationRules);
        }
        for (const key in otherValidationRules) {
            this.controller.addObject(this.object[key], otherValidationRules[key]);
        }
        this.logger.debug('Object: ', this.object);
        this.controller.subscribe(event => this.validateForm(event));
    }
    setObjectProperty(field) {
        if (field.objectKey && !this.object[field.objectKey]) {
            this.object[field.objectKey] = {};
        }
        const object = field.objectKey ? this.object[field.objectKey] : this.object;
        if (object[field.propertyKey] === undefined) {
            if (field.type === 'bool') {
                const value = field.defaultValue ? field.defaultValue.trim() === '1' : false;
                object[field.propertyKey] = value;
            }
            else {
                object[field.propertyKey] = field.defaultValue || null;
            }
        }
    }
    loadValidationRules(field) {
        const rule = aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationRules"].ensure(field.propertyKey).displayName(field.form.label).satisfies(() => true);
        field.form.rules = field.form.rules || [];
        if (field.size && !Number.isNaN(Number.parseInt(field.size))) {
            const size = Number.parseInt(field.size);
            rule.then().maxLength(size);
        }
        if (field.nameLCF === 'email') {
            rule.then().email();
        }
        if (['int', 'long', 'double', 'number'].includes(field.type)) {
            rule.then().satisfiesRule('number');
        }
        if (field.type === 'date' || field.dbType === 'DATE') {
            rule.then().satisfiesRule('date');
        }
        if (field.type === 'datetime' || field.dbType === 'DATETIME2') {
            rule.then().satisfiesRule('datetime');
        }
        if (field.form.isRequired) {
            rule.then().required().withMessage('Required field.');
        }
        if (this.eClass
            && field.nameLCF === 'name'
            && !this.table.allowDuplicateNames
            && this.table.tableCategory !== 'ResultEntity'
            && !field.form.rules.some(r => r.unique && r.unique.field.toLowerCase() === 'name')) {
            field.form.rules.push({
                unique: {
                    field: 'Name',
                    eClass: this.eClass
                },
                message: 'Must be unique.'
            });
        }
        this.loadCustomValidationRules(field, rule);
        return rule;
    }
    loadCustomValidationRules(field, rule) {
        for (const customRule of field.form.rules) {
            let ruleApplied;
            if (customRule.satisfies) {
                ruleApplied = rule.then().satisfies(customRule.satisfies);
            }
            else if (customRule.unique) {
                ruleApplied = rule.then().satisfies((value) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                    if (!value)
                        return !field.form.isRequired;
                    if (this.prevUniqueValues[field.name] === value)
                        return this.valueIsUnique[field.name];
                    this.prevUniqueValues[field.name] = value;
                    let uniqueValue = value;
                    if (customRule.unique.value) {
                        if (typeof customRule.unique.value === 'string') {
                            uniqueValue = new Function('value', `return \`${customRule.unique.value}\`;`)(value);
                        }
                        else if (typeof customRule.unique.value === 'function') {
                            uniqueValue = customRule.unique.value(value);
                        }
                    }
                    const dataset = yield this.server.datasetQuery([{
                            collection: 'empty',
                            eClass: customRule.unique.eClass,
                            filters: [{
                                    field: customRule.unique.field,
                                    value: uniqueValue
                                }]
                        }]);
                    this.valueIsUnique[field.name] = !dataset.empty.length;
                    return this.valueIsUnique[field.name];
                }));
            }
            if (ruleApplied && customRule.message) {
                ruleApplied.withMessage(customRule.message);
            }
        }
    }
    setInputEditor(field) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (field.nameLCF === 'type' && this.eClass) {
                field.form.editor = 'autocomplete';
                field.form.suggestionService = new TypeSuggestionService(this.eClass, this.server);
            }
            else if (field.nameLCF === 'status') {
                field.form.editor = 'status';
            }
            else if (field.nameLCF === 'email' && this.eClass === 'user') {
                field.form.editor = 'text';
                field.form.isRequired = true;
            }
            else if (['int', 'long', 'double', 'number'].includes(field.type)) {
                field.form.editor = 'number';
            }
            else if (field.type === 'bool') {
                field.form.editor = 'checkbox';
            }
            else if (field.type === 'stringList' || (field.isShared && field.nameLCF === 'tags')) {
                field.form.editor = 'list';
                field.form.list = { type: 'string' };
            }
            else if (field.type === 'numberList') {
                field.form.editor = 'list';
                field.form.list = { type: 'number' };
            }
            else if (field.type === 'date' || field.dbType === 'DATE') {
                field.form.editor = 'datepicker';
            }
            else if (field.type === 'datetime' || field.dbType === 'DATETIME2') {
                field.form.editor = 'datetimepicker';
            }
        });
    }
    sortFields(fields) {
        if (this.fields.length) {
            this.sortOrder = this.fields;
        }
        else if (this.table && this.table.formOrder.length) {
            this.sortOrder = this.table.formOrder;
        }
        this.logger.debug('Sort order: ', this.sortOrder);
        this.sortOrder = this.sortOrder.map(s => s.toLowerCase());
        return fields.sort((a, b) => {
            let indexA = this.sortOrder.indexOf(a.nameLC);
            indexA = indexA === -1 ? 100 : indexA;
            let indexB = this.sortOrder.indexOf(b.nameLC);
            indexB = indexB === -1 ? 100 : indexB;
            if (indexA < indexB) {
                return -1;
            }
            else if (indexA > indexB) {
                return 1;
            }
            else {
                return 0;
            }
        });
    }
    filterFields(column) {
        if (this.fields.indexOf(column.nameLCF) !== -1)
            return true;
        if (this.fields.length)
            return false;
        if (column.form.hide)
            return false;
        if (this.sortOrder.indexOf(column.nameLCF) !== -1)
            return true;
        if (column.isShared)
            return false;
        if (column.nameLC === 'setup')
            return false;
        return true;
    }
    validateForm(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (event.type === 'validate') {
                this.logger.debug('Validation event: ', event);
                yield this.updateIsValid();
            }
        });
    }
    updateIsValid() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let valid = true;
            for (const parsedColumn of this.parsedColumns.filter(pc => pc.validationRules.length)) {
                const results = yield this.validator.validateObject(parsedColumn.object, parsedColumn.validationRules);
                this.logger.debug('Validation results: ', results);
                valid = valid && results.every(result => result.valid);
            }
            this.valid = valid;
            this.logger.debug('Is valid: ', this.valid);
            this.dirty = JSON.stringify(this.object) !== this.orgObject;
            this.logger.debug('Is dirty: ', this.dirty);
        });
    }
    validate(field = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const validateField = (f) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () { return this.controller.validate({ object: f.object, propertyName: f.desc.propertyKey, rules: f.validationRules }); });
            if (field) {
                yield validateField(field);
            }
            else {
                for (const f of this.parsedColumns.filter(pc => pc.validationRules.length)) {
                    yield validateField(f);
                }
            }
            yield this.updateIsValid();
            return this.valid;
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "horizontal", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "fields", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "valid", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "dirty", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "object", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], EntityForm.prototype, "columns", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], EntityForm.prototype, "delay", void 0);
EntityForm = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('entity-form'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_3__["DataModel"], _scifeon_core__WEBPACK_IMPORTED_MODULE_3__["ServerAPI"], aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["Validator"], aurelia_validation__WEBPACK_IMPORTED_MODULE_2__["ValidationControllerFactory"]])
], EntityForm);

class TypeSuggestionService {
    constructor(eClass, server) {
        this.eClass = eClass;
        this.server = server;
    }
    loadTypes() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('/api/query/suggest/field/' + this.eClass + '/type');
            const types = yield response.json();
            this.types = types.map(t => t.value);
        });
    }
    suggest(value) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.types) {
                yield this.loadTypes();
            }
            value = value ? value.toLowerCase() : '';
            const suggestions = this.types
                .filter(x => x.toLowerCase().indexOf(value) > -1)
                .sort();
            return suggestions.map(s => {
                return {
                    value: s,
                    name: s.replace(new RegExp('(' + value + ')', 'gim'), '<span class="query">$1</span>')
                };
            });
        });
    }
    getName(suggestion) {
        return suggestion.name;
    }
    getValue(suggestion) {
        return suggestion.value;
    }
}


/***/ }),

/***/ "element/entity-form.html":
/*!**************************************!*\
  !*** ./SPA/element/entity-form.html ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/status-selector\"></require>  \r\n    <div class-name.bind=\"'form' + (horizontal ? '-horizontal' : '')\">\r\n        <div class=\"form-group\" repeat.for=\"column of parsedColumns\">\r\n            <label>\r\n                <span innerhtml.bind=\"column.desc.form.label\"></span>\r\n                <span if.bind=\"column.desc.form.isRequired\" title=\"Required\" class=\"required-indicator\">*</span>\r\n                <quick-help if.bind=\"column.desc.description\">\r\n                    <span innerhtml.bind=\"column.desc.description\"></span>\r\n                    <div if.bind=\"column.desc.docLink\" class=\"doc-link\">\r\n                        <a href=\"https://docs.scifeon.com/${column.desc.docLink}\" target=\"_blank\">Learn more here\r\n                            <i class=\"fa fa-external-link\"></i>\r\n                        </a>\r\n                    </div>\r\n                </quick-help>\r\n            </label>\r\n\r\n            <input if.bind=\"column.desc.form.editor === 'text'\" \r\n                   type=\"text\" \r\n                   id.bind=\"column.desc.id\"\r\n                   class.bind=\"column.desc.form.editor\" \r\n                   value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\" \r\n                   placeholder.bind=\"column.desc.form.placeholder\"></input>\r\n\r\n            <input-number if.bind=\"column.desc.form.editor === 'number'\" \r\n                   type=\"text\" \r\n                   id.bind=\"column.desc.id\"\r\n                   validate-input.bind=\"false\"\r\n                   value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\" \r\n                   placeholder.bind=\"column.desc.form.placeholder\"></input-number>\r\n\r\n           <input-date if.bind=\"column.desc.form.editor === 'datepicker'\"                \r\n                   id.bind=\"column.desc.id\" \r\n                   validate-input.bind=\"false\"\r\n                   value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\" \r\n                   placeholder.bind=\"column.desc.form.placeholder\"></input-date>      \r\n\r\n            <input-datetime if.bind=\"column.desc.form.editor === 'datetimepicker'\"                \r\n                   id.bind=\"column.desc.id\" \r\n                   validate-input.bind=\"false\"\r\n                   value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\" \r\n                   placeholder.bind=\"column.desc.form.placeholder\"></input-datetime>      \r\n\r\n            <list-editor if.bind=\"column.desc.form.editor === 'list'\" \r\n                         items.bind=\"column.object[column.desc.propertyKey]\" \r\n                         id.bind=\"column.desc.id\"\r\n                         type.bind=\"column.desc.form.list.type\"\r\n                         placeholder.bind=\"column.desc.nameLCF === 'tags' ? 'New tag' : column.desc.form.placeholder\"\r\n                         change.delegate=\"validate(column)\"></list-editor>\r\n\r\n            <dictionary-editor if.bind=\"column.desc.form.editor === 'dictionary'\" \r\n                         column.object.bind=\"column.object[column.desc.propertyKey]\" \r\n                         id.bind=\"column.desc.id\"\r\n                         type.bind=\"column.desc.form.dictionary && column.desc.form.dictionary.type\"\r\n                         placeholder.bind=\"column.desc.form.placeholder\"\r\n                         change.delegate=\"validate(column)\"></dictionary-editor>\r\n\r\n            <autocomplete if.bind=\"column.desc.form.editor === 'autocomplete'\" \r\n                          id.bind=\"column.desc.id\" \r\n                          value.bind=\"column.object[column.desc.propertyKey] & validate\"\r\n                          placeholder.bind=\"column.desc.form.label\" \r\n                          delay.bind=\"delay\" \r\n                          service.bind=\"column.desc.form.suggestionService\">\r\n                <template replace-part=\"suggestion\">\r\n                    <span innerhtml.bind=\"suggestion.name\"></span>\r\n                </template>\r\n            </autocomplete>\r\n\r\n            <input-foreign-key if.bind=\"column.desc.form.editor === 'foreign-key'\" \r\n                               value.bind=\"column.object[column.desc.propertyKey] & validate\" \r\n                               id.bind=\"column.desc.id\"\r\n                               placeholder.bind=\"column.desc.form.label\" \r\n                               delay.bind=\"delay\" \r\n                               e-class.bind=\"column.desc.foreignKeyTo\"\r\n                               filters.bind=\"column.desc.form.filters\"\r\n                               sortings.bind=\"column.desc.form.sortings\">\r\n            </input-foreign-key>\r\n\r\n            <textarea if.bind=\"column.desc.form.editor === 'textarea'\" \r\n                      id.bind=\"column.desc.id\" \r\n                      value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\"></textarea>\r\n\r\n            <rich-text-editor if.bind=\"column.desc.form.editor === 'rte'\" \r\n                              id.bind=\"column.desc.id\" \r\n                              value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\"></rich-text-editor>\r\n\r\n            <status-selector if.bind=\"column.desc.form.editor === 'status'\" \r\n                             id.bind=\"column.desc.id\" \r\n                             entity.bind=\"column.object\"></status-selector>\r\n\r\n            <select if.bind=\"column.desc.form.editor === 'select'\" \r\n                    id.bind=\"column.desc.id\" \r\n                    value.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\">\r\n                <option repeat.for=\"option of column.desc.form.selectOptions\">\r\n                    ${option}\r\n                </option>\r\n            </select>\r\n\r\n            <label if.bind=\"column.desc.form.editor === 'checkbox'\" class=\"form-switch\" css.bind=\"horizontal === true ? 'grid-column: 2' : ''\">\r\n                <input type=\"checkbox\" checked.bind=\"column.object[column.desc.propertyKey] & validate & debounce:delay\" id.bind=\"column.desc.id\" />\r\n                <i class=\"form-icon\"></i>\r\n            </label>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/grid/record-editor-grid":
/*!************************************************!*\
  !*** ./SPA/element/grid/record-editor-grid.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RecordEditorGrid = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _gridEditorBase = __webpack_require__(/*! ./grid-editor-base */ "./SPA/element/grid/grid-editor-base.js");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

// CELL LOCATIONS PREFIXES
// trow: Table row, equal to tr-element.rowIndex
// tcol: Table col, equal to td-element.cellIndex
// irow: Data row, equal to trow - 1
// icol: Data col, equal to tcol

var RecordEditorGrid = exports.RecordEditorGrid = (_class = function (_GridEditorBase) {
    _inherits(RecordEditorGrid, _GridEditorBase);

    _createClass(RecordEditorGrid, [{
        key: 'nRowsChanged',
        value: function nRowsChanged() {
            this.nRows = parseInt(this.nRows);this.createGrid();
        }
    }, {
        key: 'fieldsChanged',
        value: function fieldsChanged() {
            this.createGrid();
        }
    }, {
        key: 'recordsChanged',
        value: function recordsChanged() {
            this.createGrid();
        }
    }]);

    function RecordEditorGrid() {
        var _ref;

        _classCallCheck(this, RecordEditorGrid);

        for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
            rest[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_ref = RecordEditorGrid.__proto__ || Object.getPrototypeOf(RecordEditorGrid)).call.apply(_ref, [this].concat(rest)));

        _initDefineProp(_this, 'nRows', _descriptor, _this);

        _initDefineProp(_this, 'fields', _descriptor2, _this);

        _initDefineProp(_this, 'records', _descriptor3, _this);

        return _this;
    }

    _createClass(RecordEditorGrid, [{
        key: 'getCol',
        value: function getCol(fieldName) {
            for (var iCol = 0; iCol < this.fields.length; iCol++) {
                if (this.fields[iCol].name === fieldName) return iCol;
            }throw new Error('Field not found: ' + fieldName);
        }
    }, {
        key: 'getTRowMin',
        value: function getTRowMin() {
            return 1;
        }
    }, {
        key: 'getTRowMax',
        value: function getTRowMax() {
            return this.nRows;
        }
    }, {
        key: 'getTColMin',
        value: function getTColMin() {
            return 0;
        }
    }, {
        key: 'getTColMax',
        value: function getTColMax() {
            return this.fields.length - 1;
        }
    }, {
        key: 'canAddRows',
        value: function canAddRows() {
            return true;
        }

        // SELECTION ///////////////////////////////////////////////////////////////////

    }, {
        key: 'clearSelection',
        value: function clearSelection() {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.rows[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var row = _step.value;
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = this.fields[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var field = _step2.value;

                            row.htmlClass[field.name] = '';
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            this.hasSelection = false;
        }
    }, {
        key: 'selectData',
        value: function selectData(trow, tcol) {
            this.rows[trow - 1].htmlClass[this.fields[tcol].name] = 'selected';
        }

        // CONTENT /////////////////////////////////////////////////////////////////////

    }, {
        key: 'addRow',
        value: function addRow(iRow) {
            if (iRow === undefined) iRow = this.nRows; // Called without parameter: Just add another row

            this.records.push({});

            var row = {
                tabIndex: {},
                htmlClass: {},
                record: this.records[iRow]
            };

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = this.fields[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var field = _step3.value;

                    row.tabIndex[field.name] = this.nextTabIndex;
                    this.nextTabIndex += 2;
                    row.htmlClass[field.name] = '';
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            this.rows.push(row);

            if (iRow === this.nRows) this.nRows++;
        }
    }, {
        key: 'createGrid',
        value: function createGrid() {
            if (this.rows) return; // Already in progress
            if (!this.nRows || !this.fields || !this.records) return;

            this.rows = [];
            this.nextTabIndex = 1;
            for (var iRow = 0; iRow < this.nRows; iRow++) {
                this.addRow(iRow);
            }
        }

        // CONTENT MANIPULATION ////////////////////////////////////////////////////////

    }, {
        key: 'setDataContent',
        value: function setDataContent(trow, tcol, content) {
            var irow = trow - 1;
            var icol = tcol;
            this.rows[irow].record[this.fields[icol].name] = content;
        }
    }, {
        key: 'getDataContent',
        value: function getDataContent(trow, tcol) {
            var irow = trow - 1;
            return this.rows[irow].record[this.fields[tcol].name];
        }
    }]);

    return RecordEditorGrid;
}(_gridEditorBase.GridEditorBase), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'nRows', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'fields', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'records', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class);

/***/ }),

/***/ "element/grid/record-editor-grid.html":
/*!**************************************************!*\
  !*** ./SPA/element/grid/record-editor-grid.html ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <table ref=\"table\" class=\"record-grid\" mouseup.delegate=\"mouseUp($event)\" mouseenter.trigger=\"mouseEnter($event)\">\r\n        <tbody>\r\n            <tr>\r\n                <th repeat.for=\"field of fields\">${field.label}</th>\r\n            </tr>\r\n            <tr repeat.for=\"row of rows\">\r\n                <td repeat.for=\"field of fields\" tabindex.bind=\"row.tabIndex[field.name]\" class.bind=\"row.htmlClass[field.name]\"\r\n                    dblclick.delegate=\"editCell($event)\" mousedown.delegate=\"mouseDown($event)\"\r\n                    mousemove.delegate=\"mouseMove($event)\" focus.trigger=\"tdFocus($event)\"\r\n                    field-name.bind=\"field.name\">\r\n                    <span class=\"content\">${row.record[field.name] & signal:'updategrid'}</span>\r\n                </td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n    <div ref=\"editor\" class=\"cell-editor\" style=\"display: none\"><input value.bind=\"editorContent\" blur.trigger=\"inputBlur()\" /></div>\r\n\r\n</template>";

/***/ }),

/***/ "element/list-view":
/*!**********************************!*\
  !*** ./SPA/element/list-view.ts ***!
  \**********************************/
/*! exports provided: ListView */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ListView", function() { return ListView; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-templating-resources */ "aurelia-templating-resources");
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var entity_list_export_dialog__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! entity/list/export-dialog */ "entity/list/export-dialog");









let ListView = class ListView {
    constructor(server, router, dialog, dataModel, pluginManager, pluginLoader, signaler) {
        this.server = server;
        this.router = router;
        this.dialog = dialog;
        this.dataModel = dataModel;
        this.pluginManager = pluginManager;
        this.pluginLoader = pluginLoader;
        this.signaler = signaler;
        this.config = {};
        this.allColumns = [];
        this.visibleColumns = [];
        this.listColumnPlugins = {};
        this.fixedColumnFilters = [];
        this.filterColumns = [];
        this.availableFilterColumns = [];
        this.selectedFilterColumnKeys = [];
        this.filters = {};
        this.items = [];
        this.routeParameters = {};
        this.fixedColumnsViewModels = [];
        this.filterColumnsViewModels = [];
        this.colNames = [
            'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
            'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
            'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
            'AA', 'AB', 'AC', 'AD', 'AE', 'AF', 'AG', 'AH', 'AI',
            'AJ', 'AK', 'AL', 'AM', 'AN', 'AO', 'AP', 'AQ', 'AR',
            'AS', 'AT', 'AU', 'AV', 'AW', 'AX', 'AY', 'AZ',
            'BA', 'BB', 'BC', 'BD', 'BE', 'BF', 'BG', 'BH', 'BI',
            'BJ', 'BK', 'BL', 'BM', 'BN', 'BO', 'BP', 'BQ', 'BR',
            'BS', 'BT', 'BU', 'BV', 'BW', 'BX', 'BY', 'BZ'
        ];
        this.state = {
            loading: true,
            hasMoreItems: true,
            page: 0,
            currentTotal: 0,
            total: 0,
            sort: {
                key: '',
                dir: ''
            }
        };
        this.defaultConfig = {
            options: {
                allowMoveColumns: true,
                allowSort: true,
                allowFilter: true,
                allowExport: true,
                allowAddColumns: true,
                updateURL: false
            },
            initial: {
                filters: [],
                sorting: {
                    key: 'createdDate',
                    dir: 'desc'
                },
                columns: ['id', 'name', 'type', 'status', 'description', 'createdBy', 'createdDate']
            },
            pageSize: 100
        };
        this.view = () => __webpack_require__(/*! ./list-view.html */ "element/list-view.html");
    }
    bind() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.config = Object.assign({}, this.defaultConfig, this.config);
            this.selectedColumnKeys = Object.assign([], this.config.initial.columns);
            this.routeParameters.eClass = this.eClass;
            this.eClassDescription = this.dataModel.find(this.eClass);
            this.allColumns = JSON.parse(JSON.stringify(this.eClassDescription.columns));
            const excludeFilters = this.allColumns.filter(x => x.type === 'int' || x.type === 'bool' || x.nameLCF === 'name').concat(this.fixedColumnFilters);
            this.availableFilterColumns = this.allColumns.filter(x => !excludeFilters.map(({ nameLCF }) => nameLCF).includes(x.nameLCF));
            for (const plugin of yield this.pluginManager.getPlugins([_scifeon_plugins__WEBPACK_IMPORTED_MODULE_7__["PLUGIN_TYPE"].LIST_COLUMN], { eClass: this.eClass })) {
                const instance = yield this.pluginLoader.getInstance(plugin, { eClass: this.eClass });
                const column = this.dataModel.setProperties(instance.getColumn());
                this.listColumnPlugins[column.name] = instance;
                this.allColumns.push(column);
            }
            const sessionParams = sessionStorage.getItem(`list-${this.eClass}`);
            if (this.config.options.updateURL) {
                const params = this.router.currentInstruction.queryParams;
                const hasURLQuery = params['$filter'] || params['$select'] || params['$orderby'];
                this.applyRouteParametes(sessionParams && !hasURLQuery ? JSON.parse(sessionParams) : params);
            }
            this.initialFixedColumnFilters(['type', 'status']);
            this.setVisibleColumns();
            this.initialColumnSort();
            this.handleTableHeight();
            yield this.loadNextPage();
        });
    }
    updateRouterParameters(parameters) {
        if (!this.config.options.updateURL)
            return;
        sessionStorage.setItem(`list-${this.eClass}`, JSON.stringify(parameters));
        this.router.navigateToRoute('GenericList', parameters, { replace: true });
    }
    updateRouteParameter(name, value) {
        if (!this.config.options.updateURL)
            return;
        let parameter;
        switch (name) {
            case 'select':
                parameter = value.map(({ nameLCF }) => nameLCF).join(',');
                break;
            case 'filter':
                parameter = this.getFilterParameters(value);
                break;
            case 'orderby':
                parameter = `${value.key} ${value.dir}`;
                break;
            default: parameter = value;
        }
        if (parameter)
            this.routeParameters[`$${name}`] = parameter;
        else
            delete this.routeParameters[`$${name}`];
        this.updateRouterParameters(this.routeParameters);
    }
    updateRouteParameterByObject(object) {
        Object.assign(this.routeParameters, object);
        this.updateRouterParameters(this.routeParameters);
    }
    translateOpFilterToOData(filter) {
        switch (filter.op) {
            case 'contains':
                {
                    if (filter['value'])
                        return `substringof(${filter['field']},${filter['value']})`;
                    else
                        return '';
                }
                ;
            default: return '';
        }
    }
    translateFilterToOData(filter) {
        if (filter.hasOwnProperty('in') && filter['in'].length) {
            return `${filter['field']} in (${filter['in'].join(',')})`;
        }
        else if (filter.hasOwnProperty('op')) {
            return this.translateOpFilterToOData(filter);
        }
        return '';
    }
    getFilterParameters(value) {
        let filters = [];
        for (let filter of Object.values(value)) {
            let translated = this.translateFilterToOData(filter);
            if (translated)
                filters.push(translated);
        }
        return filters.join(' and ');
    }
    initialFixedColumnFilters(filterNames) {
        for (const filterNameLCF of filterNames) {
            const columnFilter = this.allColumns.find(c => c.nameLCF === filterNameLCF);
            if (columnFilter) {
                this.fixedColumnFilters.push(columnFilter);
            }
        }
    }
    initializeFilters(filters) {
        let filterArrays = filters.split(' and ');
        for (let filter of filterArrays) {
            let columnNameLCF;
            let filterValue;
            let filterFormType;
            let isAddColumn = false;
            if (filter.indexOf('substringof') !== -1) {
                let filterString = filter.slice(12, filter.lenght).slice(0, -1);
                columnNameLCF = filterString.split(',')[0];
                filterValue = filterString.split(',')[1];
                if (columnNameLCF === 'name') {
                    this.filterTerm = filterValue;
                }
                this.updateFiltersObject({ detail: { field: columnNameLCF, op: 'contains', value: filterValue } });
                isAddColumn = !this.fixedColumnFilters.find(c => c.nameLCF === columnNameLCF) && !this.filterColumns.find(c => c.nameLCF === columnNameLCF) && columnNameLCF !== 'name';
                filterFormType = 'text';
            }
            else {
                let ops = filter.split(' in ');
                let filterString = ops[1].slice(1, ops[1].length).slice(0, -1);
                columnNameLCF = ops[0];
                filterValue = filterString.split(',');
                this.updateFiltersObject({ detail: { field: columnNameLCF, in: filterValue } });
                isAddColumn = !this.fixedColumnFilters.find(c => c.nameLCF === columnNameLCF) && !this.filterColumns.find(c => c.nameLCF === columnNameLCF);
                filterFormType = 'select';
            }
            const column = this.allColumns.find(c => c.nameLCF === columnNameLCF);
            if (column) {
                Object.assign(column, { filterOptions: { value: filterValue, type: filterFormType } });
            }
            if (column && isAddColumn) {
                this.filterColumns.push(column);
                this.selectedFilterColumnKeys.push(columnNameLCF);
            }
        }
    }
    applyRouteParametes(params) {
        for (const key in params) {
            switch (key) {
                case '$select':
                    this.selectedColumnKeys = params[key].split(',').filter(k => this.allColumns.some(c => c.nameLC === k.toLowerCase()));
                    break;
                case '$orderby':
                    const split = params[key].split(' ');
                    if (!this.allColumns.some(c => c.nameLC === split[0].toLowerCase()))
                        break;
                    const sort = { key: split[0], dir: split[1] };
                    this.state.sort = sort;
                    break;
                case '$filter':
                    this.initializeFilters(params[key]);
            }
        }
        this.updateRouteParameterByObject(params);
    }
    changeFilterColumns() {
        this.filterColumns = this.allColumns.filter(c => this.selectedFilterColumnKeys.includes(c.nameLCF));
        this.handleTableHeight();
    }
    selectedFilterColumnsChanged() {
        const existingKeys = this.selectedFilterColumnKeys;
        const deletedKeys = this.filterColumns.map(({ nameLCF }) => nameLCF).filter(function (item) {
            return existingKeys.indexOf(item) === -1;
        });
        for (const col of deletedKeys) {
            this.removeColumnFilter({ detail: { columnNameLCF: col } });
        }
        this.changeFilterColumns();
    }
    removeApplyFilter(nameLCF) {
        if (this.filters[nameLCF]) {
            delete this.filters[nameLCF];
            this.applyFilter();
        }
    }
    removeColumnFilter(e) {
        if (e.detail) {
            this.selectedFilterColumnKeys = this.selectedFilterColumnKeys.filter(f => f !== e.detail.columnNameLCF);
            this.changeFilterColumns();
            this.removeApplyFilter(e.detail.columnNameLCF);
            const removedFilter = this.filterColumnsViewModels.find(f => f && f.column.nameLCF === e.detail.columnNameLCF);
            if (removedFilter)
                removedFilter.reset();
        }
    }
    resetFilters() {
        for (const filter of this.fixedColumnsViewModels) {
            if (filter)
                filter.reset();
        }
        for (const filter of this.filterColumnsViewModels) {
            if (filter)
                filter.reset();
        }
        this.filterColumns = [];
        this.selectedFilterColumnKeys = [];
        this.filterTerm = '';
        this.filters = {};
        this.applyFilter();
        this.handleTableHeight();
    }
    get canResetFilters() {
        return Object.keys(this.filters).length !== 0 || this.filterColumns.length !== 0;
    }
    setSelectRouteParameter() {
        if (JSON.stringify(this.visibleColumns.map(({ nameLCF }) => nameLCF)) === JSON.stringify(this.config.initial.columns)) {
            delete this.routeParameters.$select;
            this.updateRouterParameters(this.routeParameters);
        }
        else {
            this.updateRouteParameter('select', this.visibleColumns);
        }
    }
    setSelectedColumnsToVisibleColumns() {
        let selectedColumns = this.visibleColumns.filter(vc => this.selectedColumnKeys.includes(vc.nameLCF));
        for (const column of this.allColumns.filter(c => this.selectedColumnKeys.includes(c.nameLCF) && !this.visibleColumns.find(vc => vc.nameLCF === c.nameLCF))) {
            selectedColumns.push(column);
        }
        this.visibleColumns = selectedColumns;
    }
    selectedColumnsChanged() {
        this.setSelectedColumnsToVisibleColumns();
        this.setSelectRouteParameter();
    }
    updateFiltersObject(e) {
        this.filters[e.detail.field] = e.detail;
    }
    applyFilters(e) {
        if (e.detail.in && !e.detail.in.length) {
            delete this.filters[e.detail.field];
        }
        else {
            this.filters[e.detail.field] = e.detail;
        }
        this.applyFilter();
    }
    applyFilter() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.items = [];
            this.state.page = 0;
            yield this.loadNextPage();
            this.updateRouteParameter('filter', this.filters);
        });
    }
    filter() {
        if (this.filterTerm) {
            this.applyFilters({ detail: { field: 'name', op: 'contains', value: this.filterTerm } });
        }
        else {
            this.removeColumnFilter({ detail: { columnNameLCF: 'name' } });
        }
    }
    resetFilterTerm() {
        this.filterTerm = '';
        this.filter();
    }
    filterKeyUp(event) {
        if (event.keyCode !== 13)
            return true;
        this.filter();
        return false;
    }
    sort(column = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.containerElement.scrollTo(0, 0);
            const previousSortDir = column.sort;
            this.allColumns.forEach(col => col.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.NONE);
            if (previousSortDir === _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.ASC) {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.DESC;
            }
            else if (previousSortDir === _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.DESC) {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.NONE;
            }
            else {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"].SORT.ASC;
            }
            this.state.sort.key = column.nameLCF;
            this.state.sort.dir = column.sort;
            this.items.splice.apply(this.items, [0, this.items.length]);
            this.state.page = 0;
            yield this.loadNextPage();
            this.updateRouteParameter('orderby', this.state.sort);
        });
    }
    cellView(column) {
        return new aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["InlineViewStrategy"](`<template>${column.renderer || this.getRenderer(column)}</template>`);
    }
    toggleItemSelected(item) {
        if (item.isSelected === undefined) {
            item.isSelected = true;
        }
        else {
            item.isSelected = !item.isSelected;
        }
        return true;
    }
    setVisibleColumns() {
        for (const viewColumn of this.selectedColumnKeys) {
            const column = this.allColumns.find(c => c.nameLCF === viewColumn);
            if (column) {
                this.visibleColumns.push(column);
            }
        }
    }
    setSortedColumn() {
        const sortColumn = this.visibleColumns.find(c => c.nameLCF === this.state.sort.key);
        if (sortColumn) {
            sortColumn.sort = this.state.sort.dir;
        }
    }
    initialColumnSort() {
        if (!this.state.sort) {
            this.state.sort = Object.assign({}, this.config.initial.sort);
        }
        this.setSortedColumn();
    }
    resertSortState() {
        if (JSON.stringify(this.state.sort) !== JSON.stringify(this.config.initial.sorting)) {
            const sortColumn = this.visibleColumns.find(c => c.nameLCF === this.state.sort.key);
            if (sortColumn) {
                sortColumn.sort = undefined;
            }
            this.state.sort = Object.assign({}, this.config.initial.sorting);
        }
    }
    resetSelectedColumns() {
        this.selectedColumnKeys.splice.apply(this.selectedColumnKeys, [0, this.selectedColumnKeys.length].concat(this.config.initial.columns));
        const defaultColumns = [];
        for (const columnName of this.config.initial.columns) {
            defaultColumns.push(this.visibleColumns.find(c => c.nameLCF === columnName));
        }
        this.visibleColumns.splice.apply(this.visibleColumns, [0, this.visibleColumns.length].concat(defaultColumns));
    }
    resetColumns() {
        this.columnSelectorViewModel.reset();
        this.resetSelectedColumns();
        this.resertSortState();
        this.setSelectedColumnsToVisibleColumns();
        this.setSortedColumn();
        this.loadNextPage();
        delete this.routeParameters.$select;
        delete this.routeParameters.$orderby;
        this.updateRouterParameters(this.routeParameters);
    }
    get canResetColumns() {
        if (!this.config.initial) {
            this.config = Object.assign({}, this.defaultConfig, this.config);
        }
        return (JSON.stringify(this.state.sort) !== JSON.stringify(this.config.initial.sorting)) || (JSON.stringify(this.visibleColumns.map(({ nameLCF }) => nameLCF)) !== JSON.stringify(this.config.initial.columns));
    }
    handleTableHeight() {
        if (this.selectedFilterColumnKeys.length) {
            if (this.height) {
                this.tableHeight = this.height - 145;
            }
            else {
                this.tableHeight = '79.7vh';
            }
        }
        else {
            if (this.height) {
                this.tableHeight = this.height - 102;
            }
            else {
                this.tableHeight = '84vh';
            }
        }
        if (this.config.options.allowFilter || this.config.options.allowExport) {
            if (this.height) {
                this.tableHeight = `${this.tableHeight}px`;
            }
        }
        else {
            if (this.height) {
                this.tableHeight = `${this.tableHeight + 37}px`;
            }
            else {
                this.tableHeight = '87.8vh';
            }
        }
    }
    getRenderer(column) {
        if (this.listColumnPlugins[column.name] && this.listColumnPlugins[column.name].view && this.listColumnPlugins[column.name].view()) {
            return this.listColumnPlugins[column.name].view();
        }
        if (column.nameLCF === 'id') {
            return `<a href="/#/entity/${this.eClass}/\${item.id}">\${item.id}</a>`;
        }
        if (column.type === 'bool') {
            return `<span class="fa fa-\${item[${column.nameLCF}] ? 'check' : ''}-square-o"></span>`;
        }
        else if (column.dbType === 'DATETIME2') {
            return `\${ item.${column.nameLCF} | dateTimeFormat }`;
        }
        else if (column.dbType === 'DATE') {
            return `\${ item.${column.nameLCF} | dateFormat }`;
        }
        else if (column.foreignKeyTo) {
            return `<a href="/#/entity/${column.foreignKeyTo}/\${item.${column.nameLCF}}">\${item.${column.nameLCF}}</a>`;
        }
        return `\${ item.${column.nameLCF} ? item.${column.nameLCF} : '' }`;
    }
    loadNextPage() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.state.loading = true;
            const result = yield this.server.getEntities(this.eClass, Object.values(this.filters), [{ field: this.state.sort.key, direction: this.state.sort.dir }], this.state.page * this.config.pageSize, this.config.pageSize);
            if (result !== null) {
                this.state.page++;
                this.items = this.items.concat(result.data);
                this.state.hasMoreItems = this.items.length < result.total;
                this.state.loading = false;
                this.state.total = result.total;
                this.state.currentTotal = this.items.length;
                this.signaler.signal('update-results');
            }
        });
    }
    get canExport() {
        return this.items.length > 0;
    }
    getExcelHeaders(options) {
        const entitiesDataColums = this.getEntitiesDataColumns(options);
        if (options.headers === 'label') {
            return entitiesDataColums.map(({ form }) => form.label);
        }
        else {
            return entitiesDataColums.map(({ nameLCF }) => nameLCF);
        }
    }
    getEntitiesDataColumns(options) {
        if (options.columns === 'all') {
            return this.allColumns;
        }
        else {
            return this.visibleColumns;
        }
    }
    getEntitiesDataRows(options) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let dataRows = Object.assign([], this.items);
            if (options.rows === 'all') {
                if (this.state.currentTotal !== this.state.total) {
                    const result = yield this.server.getEntities(this.eClass, Object.values(this.filters), [{ field: this.state.sort.key, direction: this.state.sort.dir }], this.state.currentTotal, this.state.total - this.state.currentTotal);
                    dataRows = dataRows.concat(result.data);
                }
            }
            return dataRows;
        });
    }
    getDataRow(data, columns) {
        let dataRow = [];
        for (const column of columns) {
            let cell;
            if (column.nameLCF.indexOf('.') !== -1) {
                let fielName = column.nameLCF.split('.')[0];
                let fielProperty = column.nameLCF.split('.')[1];
                cell = data[fielName] ? data[fielName][fielProperty] : '';
            }
            else if (column.type === 'DateTime') {
                cell = new Date(data[column.nameLCF]);
            }
            else {
                if (typeof data[column.nameLCF] === 'object') {
                    cell = data[column.nameLCF] ? JSON.stringify(data[column.nameLCF]) : '';
                }
                else {
                    cell = data[column.nameLCF];
                }
            }
            dataRow.push(cell);
        }
        return dataRow;
    }
    getExportDatas(options) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let datas = [];
            const headers = this.getExcelHeaders(options);
            datas.push(headers);
            const entitiesDataRows = yield this.getEntitiesDataRows(options);
            const entitiesDataColums = this.getEntitiesDataColumns(options);
            for (const item of entitiesDataRows) {
                const row = this.getDataRow(item, entitiesDataColums);
                datas.push(row);
            }
            return datas;
        });
    }
    getDateTimeColumnsHeaders(options) {
        const entitiesDataColums = this.getEntitiesDataColumns(options);
        if (options.headers === 'raw') {
            return entitiesDataColums.filter(c => c.dbType === 'DATETIME2').map(({ nameLCF }) => nameLCF);
        }
        else {
            return entitiesDataColums.filter(c => c.dbType === 'DATETIME2').map(({ form }) => form.label);
        }
    }
    applyDateTimeFormat(ws, options) {
        const entitiesDataColums = this.getEntitiesDataColumns(options);
        const dateColumnHeaders = this.getDateTimeColumnsHeaders(options);
        const dateTimeFormat = _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["Config"].get().configuration.format.datetime;
        const totalRows = Number(ws['!ref'].split(':')[1].replace(/\D/g, ''));
        for (let idx = 0; idx < entitiesDataColums.length; idx++) {
            if (dateColumnHeaders.includes(ws[`${this.colNames[idx]}1`].v)) {
                for (let index = 2; index <= totalRows; index++) {
                    ws[`${this.colNames[idx]}${index}`].z = dateTimeFormat;
                }
            }
        }
    }
    exportFile(options) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["LoadingSpinner"].show('Exporting...');
                const fileName = this.eClass + '.xlsx';
                const datas = yield this.getExportDatas(options);
                const wsName = this.eClass;
                const wb = XLSX.utils.book_new();
                const ws = XLSX.utils.aoa_to_sheet(datas, { dateNF: _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["Config"].get().configuration.format.date, cellDates: true });
                this.applyDateTimeFormat(ws, options);
                XLSX.utils.book_append_sheet(wb, ws, wsName);
                let wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
                Object(file_saver__WEBPACK_IMPORTED_MODULE_4__["saveAs"])(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), fileName);
            }
            finally {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["LoadingSpinner"].hide();
            }
        });
    }
    s2ab(s) {
        let buf = new ArrayBuffer(s.length);
        let view = new Uint8Array(buf);
        for (let i = 0; i != s.length; ++i)
            view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
    }
    export(e) {
        this.dialog
            .open({
            viewModel: entity_list_export_dialog__WEBPACK_IMPORTED_MODULE_8__["ExportDialog"],
            model: { state: this.state }
        })
            .whenClosed((result) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!result.wasCancelled) {
                yield this.exportFile(result.output);
            }
        }));
    }
    getMore(scrollContext) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.state.hasMoreItems && !this.state.loading)
                yield this.loadNextPage();
        });
    }
    onDragStop() {
        this.setSelectRouteParameter();
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ListView.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Number)
], ListView.prototype, "height", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ListView.prototype, "config", void 0);
ListView = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('list-view'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_5__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_6__["Dialog"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_5__["DataModel"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_7__["PluginManager"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_7__["PluginLoader"],
        aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_2__["BindingSignaler"]])
], ListView);



/***/ }),

/***/ "element/list-view.html":
/*!************************************!*\
  !*** ./SPA/element/list-view.html ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"entity/list/filtering/column-selector\"></require>\r\n    <require from=\"entity/list/filtering/column-list-filter\"></require>\r\n    <require from=\"entity/list/export-list-as\"></require>    \r\n\r\n                <div if.bind=\"config.options.allowFilter || config.options.allowExport\" class=\"search-container-wrapper\">                  \r\n                     <template if.bind=\"config.options.allowExport\">\r\n                            <export-list-as style=\"padding-right: 0\" \r\n                                  class=\"float-right\" \r\n                                  disabled.bind=\"!canExport\" \r\n                                  title=\"Export list as\" \r\n                                  export.delegate=\"export($event)\"></export-list-as>\r\n                     </template> \r\n                    <div class=\"search-container\">                                                               \r\n                        <template if.bind=\"config.options.allowFilter\">\r\n                            <template repeat.for=\"column of fixedColumnFilters\">                                \r\n                                <column-list-filter column.bind=\"column\" \r\n                                e-class.bind=\"eClass\" \r\n                                apply.delegate=\"applyFilters($event)\" \r\n                                view-model.ref=\"fixedColumnsViewModels[$index]\"></column-list-filter>\r\n                            </template>\r\n\r\n                            <div class=\"input-group search-input\">\r\n                                <input type=\"text\" placeholder=\"Name contains...\" value.bind=\"filterTerm\" keyup.trigger=\"filterKeyUp($event)\">\r\n                                <button class=\"input-group-btn fa fa-remove secondary\" title=\"Clear\" disabled.bind=\"!filterTerm\" click.delegate=\"resetFilterTerm()\"></button>\r\n                                <button class=\"input-group-btn fa fa-search\" title=\"Search\" click.delegate=\"filter()\"></button>\r\n                            </div>\r\n\r\n                            <column-selector text=\"More\" \r\n                                            title=\"Add more fields to search with\" \r\n                                            columns.bind=\"availableFilterColumns\" \r\n                                            selected-options.bind=\"selectedFilterColumnKeys\"\r\n                                            apply.delegate=\"selectedFilterColumnsChanged()\" \r\n                                            apply-on-changed.bind=\"true\" \r\n                                            click-dismisses.bind=\"false\"></column-selector>\r\n\r\n                            <button disabled.bind=\"!canResetFilters\" style=\"margin-left: 5px;\" class=\"secondary\" title=\"Reset all filters\" click.delegate=\"resetFilters()\">Reset</button>\r\n                        </template>\r\n                        <template else> \r\n                                &nbsp; \r\n                        </template>  \r\n                    </div> \r\n                </div>\r\n                <div if.bind=\"filterColumns.length\" class=\"search-container-wrapper\">\r\n                    <div class=\"search-container\">\r\n                        <template repeat.for=\"column of filterColumns\">\r\n                            <column-list-filter column.bind=\"column\" \r\n                                                e-class.bind=\"eClass\" \r\n                                                apply.delegate=\"applyFilters($event)\" \r\n                                                allow-remove.bind=\"true\"\r\n                                                remove.delegate=\"removeColumnFilter($event)\" \r\n                                                view-model.ref=\"filterColumnsViewModels[$index]\"></column-list-filter>\r\n                        </template>\r\n                    </div>\r\n                </div>\r\n                <div class=\"info-bar\">\r\n                    <div if.bind=\"config.options.allowAddColumns\" class=\"float-right\">\r\n                        <button disabled.bind=\"!canResetColumns\" class=\"secondary\" title=\"Reset columns and sortings\" click.delegate=\"resetColumns()\">Reset</button>\r\n                        <column-selector text=\"Columns\" \r\n                                        title=\"Columns\" \r\n                                        show-footer.bind=\"true\" \r\n                                        columns.bind=\"allColumns\" \r\n                                        right-align.bind=\"true\"\r\n                                        selected-options.bind=\"selectedColumnKeys\" \r\n                                        apply.delegate=\"selectedColumnsChanged()\" \r\n                                        click-dismisses.bind=\"false\"\r\n                                        outside-click-dismisses.bind=\"false\" \r\n                                        default-columns.bind=\"config.initial.columns\" \r\n                                        view-model.ref=\"columnSelectorViewModel\"></column-selector>\r\n\r\n                    </div>\r\n                    Results:\r\n                    <span class=\"text-bold\" if.bind=\"state.hasMoreItems\">${state.currentTotal}</span>\r\n                    <span if.bind=\"state.hasMoreItems\"> of </span>\r\n                    <span class=\"text-bold\">${state.total}</span>\r\n                </div>\r\n                <div class=\"list-view\" style=\"width:100%\">\r\n                    <div class=\"list-view-container\" style=\"width:100%; height:${tableHeight}\">\r\n                        <div class=\"list-view-header\"></div>\r\n                        <div class=\"list-view-container-inner\" ref=\"containerElement\">\r\n                            <!-- start table -->\r\n                            <div class=\"table\">\r\n                                <template if.bind=\"config.options.allowMoveColumns\">\r\n                                        <div class=\"row\" oa-sortable.ref=\"sortable\" oa-sortable=\"items.bind: visibleColumns; axis.bind: 'x'; allowed-drag-selector.bind: '.handle'; on-stop.call: onDragStop();\" >\r\n                                                <div class=\"cell th\" css.bind=\"column.style\" repeat.for=\"column of visibleColumns\" >\r\n                                                     <div class=\"list-view-th-inner\" oa-sortable-item=\"item.bind: column;\" draggable=\"false\"> \r\n                                                        <a click.trigger=\"sort(column)\" href=\"#\" if.bind=\"config.options.allowSort\">${column.form.label}\r\n                                                            <span class=\"fa fa-sort${ column.sort ? '-' + column.sort : ''}\"></span>\r\n                                                        </a>\r\n                                                        <span if.bind=\"!config.options.allowSort\">${column.form.label}</span>   \r\n                                                        <span class=\"reorder-icon\">\r\n                                                            <i class=\"handle fa fa-arrows\" title=\"Drag to reorder column\"></i>\r\n                                                        </span>     \r\n                                                    </div>                                                                           \r\n                                                </div>\r\n                                            </div>\r\n                                </template>\r\n                                <template else>\r\n                                        <div class=\"row\">\r\n                                                <div class=\"cell th\" css.bind=\"column.style\" repeat.for=\"column of visibleColumns\" >\r\n                                                     <div class=\"list-view-th-inner\"> \r\n                                                        <a click.trigger=\"sort(column)\" href=\"#\" if.bind=\"config.options.allowSort\">${column.form.label}\r\n                                                            <span class=\"fa fa-sort${ column.sort ? '-' + column.sort : ''}\"></span>\r\n                                                        </a>\r\n                                                        <span if.bind=\"!config.options.allowSort\">${column.form.label}</span>  \r\n                                                    </div>                                                                           \r\n                                                </div>\r\n                                        </div>\r\n                                </template>                   \r\n                                <div class=\"row\" virtual-repeat.for=\"item of items & signal:'update-results'\" class=\"${item.isSelected ? 'selected' : ''}\" click.trigger=\"toggleItemSelected(item)\"\r\n                                    infinite-scroll-next.call=\"getMore($scrollContext)\">\r\n                                    <div class=\"cell td\" css.bind=\"column.style\" repeat.for=\"column of visibleColumns\">\r\n                                        <compose containerLess view.bind=\"cellView(column)\"></compose>\r\n                                    </div>\r\n                                </div>\r\n                                <div class=\"row empty\" if.bind=\"!state.loading && items.length === 0\">                                          \r\n                                    <div class=\"cell td colspan\">No results</div>\r\n                                </div>\r\n                                <div class=\"row loading\" if.bind=\"state.loading\">                  \r\n                                </div>\r\n                            </div>\r\n                            <!-- end table -->\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n</template>";

/***/ }),

/***/ "element/notes-panel":
/*!************************************!*\
  !*** ./SPA/element/notes-panel.ts ***!
  \************************************/
/*! exports provided: NotesPanel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "NotesPanel", function() { return NotesPanel; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let NotesPanel = class NotesPanel {
    constructor(server, user, queue) {
        this.server = server;
        this.user = user;
        this.queue = queue;
        this.hideNew = false;
        this.editable = true;
    }
    entityChanged() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.entity.eClass || !this.entity.id) {
                return;
            }
            this.entityExists = !this.entity.id.startsWith('#');
            if (this.entityExists && !this.entity.notes) {
                const result = yield this.server.getEntities('Note', [{ field: 'SubjectClass', value: this.entity.eClass }, { field: 'SubjectID', value: this.entity.id }]);
                this.entity.notes = result.data;
            }
            else if (!this.entity.notes) {
                this.entity.notes = [];
            }
        });
    }
    createNewNote() {
        this.newNote = {
            title: '',
            content: ''
        };
        this.queue.queueMicroTask(() => this.inputTitle.focus());
    }
    saveNewNote() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.entity.notes === undefined) {
                this.entity.notes = [];
            }
            if (this.newNote && this.newNote.content) {
                let newNote = {
                    type: 'Note',
                    subjectID: this.entity.id,
                    subjectClass: this.entity.eClass,
                    content: this.newNote.content,
                    description: this.newNote.title,
                    userID: this.user.id,
                    eClass: 'Note'
                };
                if (this.entityExists) {
                    const response = yield this.server.saveEntities([newNote]);
                    if (response.newEntities && response.newEntities.length === 1) {
                        newNote = Object.assign(newNote, response.newEntities[0]);
                    }
                }
                this.addNote(newNote);
                this.resetNewNote();
            }
        });
    }
    addNote(newNote) {
        newNote.createdUtc = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DateUtils"].createDotNetUtc();
        this.entity.notes.push(newNote);
    }
    resetNewNote() {
        this.newNote = null;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], NotesPanel.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], NotesPanel.prototype, "hideNew", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], NotesPanel.prototype, "editable", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], NotesPanel.prototype, "class", void 0);
NotesPanel = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"], aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["TaskQueue"]])
], NotesPanel);



/***/ }),

/***/ "element/notes-panel.html":
/*!**************************************!*\
  !*** ./SPA/element/notes-panel.html ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"note\" repeat.for=\"note of entity.notes\">\r\n        <div class=\"note-header\">\r\n            <span class=\"title\">${note.description}</span>\r\n            <span>${note.userID} / ${note.createdUtc | dateFormat} </span>\r\n        </div>\r\n        <div class=\"note-body\" innerhtml.bind=\"note.content\"></div>\r\n    </div>\r\n    <div class=\"text-center no-content hide-in-print\" if.bind=\"!editable && entity.notes && !entity.notes.length\">No notes</div>\r\n    <div class=\"text-center\" if.bind=\"entity.notes && entity.notes.length === 0\">\r\n        <button class=\"btn-link\" if.bind=\"!newNote && editable\" click.delegate=\"createNewNote()\">Add note</button>\r\n    </div>\r\n    <div class=\"loading\" if.bind=\"!entity.notes\"><br/></div>\r\n    <div if.bind=\"!hideNew\" class=\"panel-footer\">            \r\n        <div if.bind=\"newNote\">\r\n            <input ref=\"inputTitle\" value.bind=\"newNote.title\" type=\"text\" placeholder=\"Title\" style=\"margin-bottom: 5px;\" tabindex=\"1\"/>\r\n            <rich-text-editor value.bind=\"newNote.content\" placeholder=\"Note...\" style=\"margin-bottom: 5px;\" tabindex=\"2\"></rich-text-editor>\r\n            <div class=\"float-right btn-group\">\r\n                <button class=\"small\" click.delegate=\"saveNewNote()\" disabled.bind=\"!newNote.content\" tabindex=\"3\">Save</button>\r\n                <button class=\"small secondary\" click.delegate=\"resetNewNote()\" tabindex=\"4\">Cancel</button>\r\n            </div>\r\n        </div>\r\n\r\n        <button class=\"small btn-link float-right\"\r\n                style=\"margin:-10px;\" \r\n                if.bind=\"!newNote && entity.notes && entity.notes.length > 0\" \r\n                click.delegate=\"createNewNote()\">Add note</button>\r\n    </div>      \r\n</template>";

/***/ }),

/***/ "element/quick-help":
/*!***********************************!*\
  !*** ./SPA/element/quick-help.ts ***!
  \***********************************/
/*! exports provided: QuickHelp */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "QuickHelp", function() { return QuickHelp; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let QuickHelp = class QuickHelp {
    constructor() {
        this.minWidth = '300px';
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], QuickHelp.prototype, "minWidth", void 0);
QuickHelp = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('quick-help')
], QuickHelp);



/***/ }),

/***/ "element/quick-help.html":
/*!*************************************!*\
  !*** ./SPA/element/quick-help.html ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"popover popover-right\">\r\n        <button class=\"question\">\r\n            <i class=\"fa fa-question-circle\"></i>\r\n        </button>\r\n        <div class=\"popover-container\" css=\"min-width: ${minWidth}\">\r\n            <slot></slot>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/render-plugin":
/*!**************************************!*\
  !*** ./SPA/element/render-plugin.ts ***!
  \**************************************/
/*! exports provided: RenderPlugin, ScifeonCompose */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(Promise) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RenderPlugin", function() { return RenderPlugin; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ScifeonCompose", function() { return ScifeonCompose; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-binding */ "./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_binding__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-templating */ "./node_modules/aurelia-templating/dist/commonjs/aurelia-templating.js");
/* harmony import */ var aurelia_templating__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! querystring */ "./node_modules/querystring-es3/index.js");
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(querystring__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! module/app/dev-bar */ "module/app/dev-bar");

var RenderPlugin_1;







let RenderPlugin = RenderPlugin_1 = class RenderPlugin {
    constructor(taskQueue, pluginLoader, pluginManager) {
        this.taskQueue = taskQueue;
        this.pluginLoader = pluginLoader;
        this.pluginManager = pluginManager;
        this.viewModel = null;
        this.largeLoadingIndicator = false;
        this.loading = true;
        this.changes = Object.create(null);
        this.reloadHMR = (status) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.logger.debug(status);
            if (status === 'apply') {
                this.disableHMR();
                const app = this.plugin.metadata.app;
                this.logger.debug('[HMR] reloading plugin: ', this.plugin.metadata.id);
                if (this.plugin.metadata.types.includes(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PLUGIN_TYPE"].PAGE) && location.href.includes('?')) {
                    Object.assign(this.context.params, querystring__WEBPACK_IMPORTED_MODULE_6__["parse"](location.href.substr(location.href.indexOf('?') + 1)));
                }
                this.plugin = yield this.pluginManager.getPluginFromApp(this.plugin.metadata.id, app);
            }
        });
        this.instanceNo = RenderPlugin_1.instanceNo++;
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].getLogger('RenderPlugin-' + this.instanceNo);
        module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__["DevBar"].instance.addRenderPlugin(this);
    }
    created(owningView) {
        this.owningView = owningView;
    }
    bind(bindingContext, overrideContext) {
        this.bindingContext = bindingContext;
        this.overrideContext = overrideContext;
        this.changes.plugin = this.plugin;
        this.changes.options = this.options;
        this.changes.view = this.view;
        this.changes.context = this.context;
        this.changes.location = this.location;
        this.logger.debug('Bound:', this.plugin ? this.plugin.metadata.name : '');
        this.enableHMR();
    }
    attached() {
        this.logger.debug('Attached');
        this.requestUpdate();
    }
    unbind() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.logger.debug('Unbind');
            if (this.viewModel && this.viewModel.unbind) {
                yield this.viewModel.unbind();
            }
        });
    }
    detached() {
        this.logger.debug('Detached');
        this.disableHMR();
        module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__["DevBar"].instance.removeRenderPlugin(this);
    }
    pluginChanged(newValue) {
        this.changes.plugin = newValue;
        this.logger.debug('Plugin changed:', this.plugin ? this.plugin.metadata.name : '');
        this.requestUpdate();
        this.enableHMR();
    }
    optionsChanged(newValue) {
        this.changes.options = newValue;
        this.logger.debug('Options changed:', newValue);
        this.requestUpdate();
    }
    contextChanged(newValue) {
        this.changes.context = newValue;
        this.logger.debug('Context changed:', newValue);
        this.requestUpdate();
    }
    locationChanged(newValue) {
        this.changes.location = newValue;
        this.logger.debug('Location changed:', newValue);
        this.requestUpdate();
    }
    enableHMR() {
        if (!this.plugin)
            return;
        const app = this.plugin.metadata.app;
        if (app.hot && app.hot.addStatusHandler && (!app.hot.renderPlugins || !app.hot.renderPlugins[this.instanceNo])) {
            this.logger.debug('[HMR] enabled: ', this.plugin.metadata.id);
            app.hot.addStatusHandler(this.reloadHMR);
            app.hot.renderPlugins = app.hot.renderPlugins || {};
            app.hot.renderPlugins[this.instanceNo] = true;
        }
    }
    disableHMR() {
        if (!this.plugin)
            return;
        const app = this.plugin.metadata.app;
        if (app.hot && app.hot.removeStatusHandler) {
            app.hot.removeStatusHandler(this.reloadHMR);
        }
    }
    loadPlugin() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                this.error = null;
                if (this.largeLoadingIndicator)
                    _scifeon_core__WEBPACK_IMPORTED_MODULE_4__["LoadingSpinner"].show();
                this.logger.debug('Loading plugin:', this.plugin.metadata.id, 'app:', this.plugin.metadata.app.namespace + '.' + this.plugin.metadata.app.name);
                this.viewModel = yield this.pluginLoader.getInstance(this.plugin, this.context, this.location);
                this.logger.debug('Plugin loaded.');
                let customView = this.view;
                if (customView && !customView.trim().toLowerCase().startsWith('<template>')) {
                    if (this.viewModel[this.view] instanceof Function) {
                        customView = yield this.viewModel[this.view]();
                    }
                    else {
                        customView = '';
                    }
                }
                this.inlineView = yield this.pluginLoader.getView(this.plugin, this.viewModel, this.location, customView);
            }
            catch (error) {
                this.error = error;
                throw error;
            }
            finally {
                if (this.largeLoadingIndicator)
                    _scifeon_core__WEBPACK_IMPORTED_MODULE_4__["LoadingSpinner"].hide();
            }
        });
    }
    processChanges() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.changes = Object.create(null);
            this.pendingTask = new Promise((resolve) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                this.loading = true;
                yield this.loadPlugin();
                this.logger.debug('Life-cycle methods called, and plugin shown:', this.plugin.metadata.id);
                this.loading = false;
                resolve();
            }));
            this.pendingTask = this.pendingTask.then(() => {
                this.completeCompositionTask();
            }, reason => {
                this.completeCompositionTask();
                throw reason;
            });
        });
    }
    completeCompositionTask() {
        this.pendingTask = null;
        if (!this.changesIsEmpty()) {
            this.requestUpdate();
        }
    }
    requestUpdate() {
        if (!this.plugin) {
            this.logger.debug('Ignore update. Plugin not set.');
            return;
        }
        if (this.pendingTask || this.updateRequested) {
            this.logger.debug('Ignore update. Update in progress.');
            return;
        }
        this.logger.debug('Update requested.');
        this.updateRequested = true;
        this.taskQueue.queueMicroTask(() => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.updateRequested = false;
            yield this.processChanges();
        }));
    }
    changesIsEmpty() {
        for (const key in this.changes) {
            return false;
        }
        return true;
    }
};
RenderPlugin.instanceNo = 0;
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "plugin", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "options", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], RenderPlugin.prototype, "view", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "context", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "location", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"])({ defaultBindingMode: aurelia_binding__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].fromView }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "viewModel", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], RenderPlugin.prototype, "largeLoadingIndicator", void 0);
RenderPlugin = RenderPlugin_1 = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('render-plugin'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["TaskQueue"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PluginLoader"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PluginManager"]])
], RenderPlugin);

let ScifeonCompose = class ScifeonCompose {
    constructor(element, container, compositionEngine, viewSlot, viewResources, taskQueue) {
        this.element = element;
        this.container = container;
        this.compositionEngine = compositionEngine;
        this.viewSlot = viewSlot;
        this.viewResources = viewResources;
        this.taskQueue = taskQueue;
        this.currentController = null;
        this.currentViewModel = null;
        this.changes = Object.create(null);
    }
    bind() {
        this.changes.view = this.view;
        this.changes.viewModel = this.viewModel;
        this.changes.model = this.model;
        if (!this.pendingTask) {
            processChanges(this);
        }
    }
    unbind() {
        this.changes = Object.create(null);
        this.bindingContext = null;
        this.overrideContext = null;
        let returnToCache = true;
        let skipAnimation = true;
        this.viewSlot.removeAll(returnToCache, skipAnimation);
    }
    modelChanged(newValue, oldValue) {
        this.changes.model = newValue;
        requestUpdate(this);
    }
    viewChanged(newValue, oldValue) {
        this.changes.view = newValue;
        requestUpdate(this);
    }
    viewModelChanged(newValue, oldValue) {
        this.changes.viewModel = newValue;
        requestUpdate(this);
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "model", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "view", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "viewModel", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "swapOrder", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", aurelia_templating__WEBPACK_IMPORTED_MODULE_5__["View"])
], ScifeonCompose.prototype, "owningView", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "bindingContext", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScifeonCompose.prototype, "overrideContext", void 0);
ScifeonCompose = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('scifeon-compose'),
    aurelia_templating__WEBPACK_IMPORTED_MODULE_5__["noView"],
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element,
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["Container"],
        aurelia_templating__WEBPACK_IMPORTED_MODULE_5__["CompositionEngine"],
        aurelia_templating__WEBPACK_IMPORTED_MODULE_5__["ViewSlot"],
        aurelia_templating__WEBPACK_IMPORTED_MODULE_5__["ViewResources"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["TaskQueue"]])
], ScifeonCompose);

function isEmpty(obj) {
    for (const key in obj) {
        return false;
    }
    return true;
}
function tryActivateViewModel(vm, model) {
    if (vm && typeof vm.activate === 'function') {
        return Promise.resolve(vm.activate(model));
    }
}
function createInstruction(composer, instruction) {
    return Object.assign(instruction, {
        bindingContext: composer.bindingContext,
        overrideContext: composer.overrideContext,
        owningView: composer.owningView,
        container: composer.container,
        viewSlot: composer.viewSlot,
        viewResources: composer.viewResources,
        currentController: composer.currentController,
        host: composer.element,
        swapOrder: composer.swapOrder
    });
}
function processChanges(composer) {
    const changes = composer.changes;
    composer.changes = Object.create(null);
    if (!('view' in changes) && !('viewModel' in changes) && ('model' in changes)) {
        composer.pendingTask = tryActivateViewModel(composer.currentViewModel, changes.model);
        if (!composer.pendingTask) {
            return;
        }
    }
    else {
        let instruction = {
            view: composer.view,
            viewModel: composer.currentViewModel || composer.viewModel,
            model: composer.model
        };
        instruction = Object.assign(instruction, changes);
        instruction = createInstruction(composer, instruction);
        composer.pendingTask = composer.compositionEngine.compose(instruction).then(controller => {
            composer.currentController = controller;
            composer.currentViewModel = composer.currentController ? composer.currentController.viewModel : null;
        });
    }
    composer.pendingTask = composer.pendingTask
        .then(() => {
        completeCompositionTask(composer);
    }, reason => {
        completeCompositionTask(composer);
        throw reason;
    });
}
function completeCompositionTask(composer) {
    composer.pendingTask = null;
    if (!isEmpty(composer.changes)) {
        processChanges(composer);
    }
}
function requestUpdate(composer) {
    if (composer.pendingTask || composer.updateRequested) {
        return;
    }
    composer.updateRequested = true;
    composer.taskQueue.queueMicroTask(() => {
        composer.updateRequested = false;
        processChanges(composer);
    });
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ }),

/***/ "element/render-plugin.html":
/*!****************************************!*\
  !*** ./SPA/element/render-plugin.html ***!
  \****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <scifeon-compose if.bind=\"!loading\"\r\n        view-model.bind=\"viewModel\"\r\n        view.bind=\"inlineView\"\r\n        owning-view.bind=\"owningView\"\r\n        binding-context.bind=\"viewModel\"\r\n        override-context.bind=\"overrideContext\"></scifeon-compose>\r\n\r\n    <div if.bind=\"loading && !largeLoadingIndicator\">\r\n        <div class=\"loading\"></div>\r\n        <br/>\r\n    </div>\r\n    \r\n    <div if.bind=\"error\" class=\"error\" style=\"font-family:'Courier New', Courier, monospace; font-size: 90%;\">\r\n        An error occurred during loading of plugin: ${plugin.metadata.app.namespace}.${plugin.metadata.app.name}.${plugin.metadata.id}\r\n    </div>\r\n</template>";

/***/ }),

/***/ "element/status-selector":
/*!****************************************!*\
  !*** ./SPA/element/status-selector.ts ***!
  \****************************************/
/*! exports provided: StatusSelector */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StatusSelector", function() { return StatusSelector; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let statusCache = {};
let StatusSelector = class StatusSelector {
    constructor(server) {
        this.server = server;
        this.statusItems = [];
        this.loading = true;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.entity.eClass) {
                throw new Error('EClass must be set on entity.');
            }
            let url = '/api/query/status/' + this.entity.eClass;
            if (!statusCache[url]) {
                const response = yield this.server.get(url);
                statusCache[url] = yield response.json();
            }
            this.loading = false;
            this.statusItems = statusCache[url];
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], StatusSelector.prototype, "entity", void 0);
StatusSelector = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], StatusSelector);



/***/ }),

/***/ "element/status-selector.html":
/*!******************************************!*\
  !*** ./SPA/element/status-selector.html ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"loading text-center\" if.bind=\"loading\"></div>\r\n    <select if.bind=\"!loading\" value.bind=\"entity.status\">\r\n        <option repeat.for=\"status of statusItems\" value.bind=\"status\">${status}</option>\r\n    </select>\r\n</template>";

/***/ }),

/***/ "entity/list/export-dialog":
/*!******************************************!*\
  !*** ./SPA/entity/list/export-dialog.ts ***!
  \******************************************/
/*! exports provided: ExportDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExportDialog", function() { return ExportDialog; });
class ExportDialog {
    constructor(dialog) {
        this.dialog = dialog;
        this.selectedHeaderOption = 'label';
        this.selectedColumnOption = 'selected';
        this.selectedRowOption = 'shown';
        this.headersOption = [
            { value: 'label', name: 'Export label as header' },
            { value: 'raw', name: 'Export raw name as header' }
        ];
        this.columnsOption = [
            { value: 'selected', name: 'Selected columns' },
            { value: 'all', name: 'All columns' }
        ];
        this.rowsOption = [
            { value: 'shown', name: 'Shown rows' },
            { value: 'all', name: 'All rows' }
        ];
        this.view = () => __webpack_require__(/*! ./export-dialog.html */ "entity/list/export-dialog.html");
    }
    init(model) {
        this.title = 'Export as Excel';
        this.state = model.state;
    }
    export() {
        this.dialog.ok({ columns: this.selectedColumnOption, rows: this.selectedRowOption, headers: this.selectedHeaderOption });
    }
    get canExport() {
        return this.selectedColumnOption && this.selectedRowOption && this.selectedHeaderOption;
    }
}


/***/ }),

/***/ "entity/list/export-dialog.html":
/*!********************************************!*\
  !*** ./SPA/entity/list/export-dialog.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 600px\">\r\n        <ux-dialog-header>\r\n            <h2>${title}</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div class=\"form-group\">\r\n                <label>Header</label>\r\n                <div repeat.for=\"option of headersOption\">\r\n                    <label><input type=\"radio\" name=\"selectedHeaders\" model.bind=\"option.value\" checked.bind=\"selectedHeaderOption\"> ${option.name}</label>\r\n                </div>\r\n            </div>\r\n            <div class=\"form-group\">\r\n                <label>Columns</label>\r\n                <div repeat.for=\"option of columnsOption\">\r\n                    <label><input type=\"radio\" name=\"selctedColumns\" model.bind=\"option.value\" checked.bind=\"selectedColumnOption\"> ${option.name}</label>\r\n                </div>\r\n            </div>\r\n            <div class=\"form-group\">\r\n                <label>Rows</label>\r\n                <div repeat.for=\"option of rowsOption\">\r\n                    <label><input type=\"radio\" name=\"selctedRows\" model.bind=\"option.value\" checked.bind=\"selectedRowOption\"> ${option.name}\r\n                    <template if.bind=\"option.value === 'shown'\">\r\n                        (${state.currentTotal})\r\n                    </template>\r\n                    <template if.bind=\"option.value === 'all'\">\r\n                        (${state.total})\r\n                    </template></label>\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"export()\" disabled.bind=\"!canExport\">OK</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "entity/list/export-list-as":
/*!*******************************************!*\
  !*** ./SPA/entity/list/export-list-as.ts ***!
  \*******************************************/
/*! exports provided: ExportListAs */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExportListAs", function() { return ExportListAs; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let ExportListAs = class ExportListAs {
    constructor(element) {
        this.element = element;
        this.title = '';
        this.selectedExportOptions = [];
        this.exportOptions = [
            { type: 'excel', name: 'Excel', icon: 'file-excel-o' }
        ];
    }
    export(e) {
        this.element.dispatchEvent(new CustomEvent('export', { detail: { type: e.type }, bubbles: true }));
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ExportListAs.prototype, "title", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ExportListAs.prototype, "disabled", void 0);
ExportListAs = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Element])
], ExportListAs);



/***/ }),

/***/ "entity/list/export-list-as.html":
/*!*********************************************!*\
  !*** ./SPA/entity/list/export-list-as.html ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <dropdown-button text=\"Export\" \r\n                     view-model.ref=\"dropdownButton\" \r\n                     fa-icon=\"caret-down\" \r\n                     outside-click-dismisses.bind=\"true\"\r\n                     click-dismisses.bind=\"true\" \r\n                     disabled.bind=\"disabled\" \r\n                     title.bind=\"title\" \r\n                     right-align.bind=\"true\">\r\n        <ul class=\"menu\">\r\n            <li repeat.for=\"option of exportOptions\" class=\"menu-item\">\r\n                <a click.delegate=\"export(option)\" title=\"Export as ${option.name}\"><i class=\"fa fa-${option.icon}\"></i> ${option.name}</a>\r\n            </li>\r\n        </ul>\r\n    </dropdown-button>\r\n</template>";

/***/ }),

/***/ "entity/list/filtering/column-list-filter":
/*!*********************************************************!*\
  !*** ./SPA/entity/list/filtering/column-list-filter.ts ***!
  \*********************************************************/
/*! exports provided: ColumnListFilter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ColumnListFilter", function() { return ColumnListFilter; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let ColumnListFilter = class ColumnListFilter {
    constructor(server, element) {
        this.server = server;
        this.element = element;
        this.selectedValues = [];
        this.allItems = [];
    }
    apply() {
        this.buildText();
        let detailJson = {};
        if (this.column.filterOptions.type === 'select') {
            detailJson = { field: this.column.nameLCF, in: this.selectedValues };
        }
        else if (this.column.filterOptions.type === 'text') {
            detailJson = { field: this.column.nameLCF, op: 'contains', value: this.searchCriteria };
        }
        else {
            detailJson = { field: this.column.nameLCF };
        }
        this.element.dispatchEvent(new CustomEvent('apply', { bubbles: true, detail: detailJson }));
    }
    initialValue() {
        if (this.column.filterOptions && this.column.filterOptions.value) {
            if (this.column.filterOptions.type === 'select') {
                this.selectedValues = this.column.filterOptions.value;
            }
            else if (this.column.filterOptions.type === 'text') {
                this.searchCriteria = this.column.filterOptions.value;
            }
        }
    }
    bind() {
        this.initialValue();
        this.buildText();
        if (this.allowRemove && !this.column.filterOptions) {
            this.dropdownButton.open();
            this.open();
        }
    }
    filterTermChanged() {
        if (this.column.filterOptions.type === 'select') {
            this.filterList();
        }
    }
    filterList() {
        if (this.filterTerm) {
            let items = [];
            for (let item of this.allItems) {
                const isMatch = Object.keys(item).some(column => {
                    const property = item[column];
                    return (property &&
                        property
                            .toString()
                            .toLowerCase()
                            .indexOf(this.filterTerm.toLowerCase()) > -1);
                });
                if (isMatch)
                    items.push(item);
            }
            this.options.splice.apply(this.options, [0, this.options.length].concat(items));
        }
        else {
            this.options.splice.apply(this.options, [0, this.options.length].concat(this.allItems));
        }
    }
    open() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.allItems.length)
                return;
            this.loading = true;
            let response = yield this.server.get(`/api/query/suggest/field/${this.eClass}/${this.column.nameLCF}`);
            let values = yield response.json();
            if (values.length) {
                this.column.filterOptions = { type: 'select' };
                this.options = Object.assign([], values);
                this.allItems = Object.assign([], values);
            }
            else {
                this.column.filterOptions = { type: 'text' };
            }
            this.loading = false;
        });
    }
    close() {
        this.dropdownButton.close();
        this.searchCriteria = this.searchCriteria ? this.searchCriteria : '';
    }
    remove() {
        this.element.dispatchEvent(new CustomEvent('remove', { detail: { columnNameLCF: this.column.nameLCF }, bubbles: true }));
        this.searchCriteria = '';
        this.selectedValues = [];
    }
    reset() {
        this.searchCriteria = '';
        this.selectedValues = [];
        this.buildText();
    }
    buildText() {
        if (this.column.filterOptions && this.column.filterOptions.type === 'select') {
            if (this.selectedValues.length) {
                var criteriaText = this.selectedValues.map(o => this.getValue({ value: o })).join(', ');
                this.text = `${this.column.form.label}: "${criteriaText}"`;
            }
            else {
                this.text = this.column.form.label + ': All';
            }
        }
        else {
            if (this.searchCriteria)
                this.text = this.column.form.label + `: "${this.searchCriteria}"`;
            else
                this.text = this.column.form.label + ': All';
        }
    }
    getValue(option) {
        if (this.column.dbType === 'DATE') {
            return _scifeon_core__WEBPACK_IMPORTED_MODULE_2__["DateUtils"].toDateFormat(option.value);
        }
        else if (this.column.dbType === 'DATETIME2') {
            return _scifeon_core__WEBPACK_IMPORTED_MODULE_2__["DateUtils"].toDateTimeFormat(option.value);
        }
        return option.name ? option.name + ' (' + option.value + ')' : option.value;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ColumnListFilter.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ColumnListFilter.prototype, "filterTerm", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ColumnListFilter.prototype, "column", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnListFilter.prototype, "allowRemove", void 0);
ColumnListFilter = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"], Element])
], ColumnListFilter);



/***/ }),

/***/ "entity/list/filtering/column-list-filter.html":
/*!***********************************************************!*\
  !*** ./SPA/entity/list/filtering/column-list-filter.html ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <dropdown-button view-model.ref=\"dropdownButton\" text.bind=\"text\" click-dismisses.bind=\"false\" open.delegate=\"open()\" title.bind=\"text\"\r\n        fa-icon=\"caret-down\" secondary-action.bind=\"allowRemove\" secondary-click.delegate=\"remove()\" secondary-title=\"Remove column filter\"\r\n        secondary-icon=\"times-circle\">\r\n        <div if.bind=\"loading\" class=\"loading text-center\" style=\"margin-bottom:1.6rem\"></div>\r\n        <div if.bind=\"column.filterOptions.type === 'select'\" class=\"input-group search-input\">\r\n            <input type=\"text\" placeholder=\"Find ${column.form.label}...\" value.bind=\"filterTerm & throttle:500\">\r\n            <button class=\"input-group-btn fa fa-${!filterTerm? 'search': 'remove'}\" title=\"Clear\" click.delegate=\"filterTerm=''\" disabled.bind=\"!filterTerm\"></button>\r\n        </div>\r\n        <div if.bind=\"column.filterOptions.type === 'select'\" class=\"list-scroll\">\r\n            <ul class=\"menu\">\r\n                <li repeat.for=\"option of options\" class=\"menu-item\">\r\n                    <label title.bind=\"getValue(option)\">\r\n                        <input type=\"checkbox\" value.bind=\"option.value\" checked.bind=\"selectedValues\" change.delegate=\"apply()\">${getValue(option)}\r\n                    </label>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n        <div if.bind=\"column.filterOptions.type === 'text'\">\r\n            <div class=\"input-group search-input\">\r\n                <input type=\"text\" value.bind=\"searchCriteria\">\r\n            </div>\r\n        </div>\r\n        <div if.bind=\"column.filterOptions.type === 'text'\" class=\"dropdown-footer\">\r\n            <button class=\"input-group-btn\" title=\"Update\" click.delegate=\"apply()\" disabled.bind=\"!searchCriteria\">Update</button>\r\n            <button class=\"btn-link\" click.delegate=\"close()\">Cancel</button>\r\n        </div>\r\n    </dropdown-button>\r\n</template>";

/***/ }),

/***/ "entity/list/filtering/column-selector":
/*!******************************************************!*\
  !*** ./SPA/entity/list/filtering/column-selector.ts ***!
  \******************************************************/
/*! exports provided: ColumnSelector */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ColumnSelector", function() { return ColumnSelector; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_3__);




let ColumnSelector = class ColumnSelector {
    constructor(server, element) {
        this.server = server;
        this.element = element;
        this.rightAlign = false;
        this.outsideClickDismisses = true;
        this.columns = [];
        this.defaultColumns = [];
        this.allColumns = [];
        this.dirtyOptions = [];
    }
    bind() {
        this.columns = this.columns.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_3__(a.form.label, b.form.label));
        this.allColumns = Object.assign([], this.columns);
        this.dirtyOptions.splice.apply(this.dirtyOptions, [0, this.dirtyOptions.length].concat(this.selectedOptions));
    }
    apply(e) {
        if (e && e.target.checked) {
            this.close();
        }
        if (this.showFooter) {
            this.close();
        }
        this.element.dispatchEvent(new CustomEvent('apply', { bubbles: true, detail: { selectedColumns: this.selectedOptions } }));
        this.dirtyOptions.splice.apply(this.dirtyOptions, [0, this.dirtyOptions.length].concat(this.selectedOptions));
    }
    close() {
        this.dropdownButton.close();
    }
    filterTermChanged() {
        this.filter();
    }
    cancel() {
        this.dropdownButton.close();
        this.selectedOptions.splice.apply(this.selectedOptions, [0, this.selectedOptions.length].concat(this.dirtyOptions));
    }
    get canApply() {
        return this.selectedOptions.length !== 0 && JSON.stringify(this.dirtyOptions.sort(o => o)) !== JSON.stringify(this.selectedOptions.sort(o => o));
    }
    filter() {
        if (this.filterTerm) {
            let items = this.allColumns.filter(i => i.nameLC.includes(this.filterTerm.toLowerCase()));
            this.columns.splice.apply(this.columns, [0, this.columns.length].concat(items));
        }
        else {
            this.columns.splice.apply(this.columns, [0, this.columns.length].concat(this.allColumns));
        }
    }
    closedEventHandler() {
        this.filterTerm = '';
    }
    reset() {
        this.dirtyOptions.splice.apply(this.dirtyOptions, [0, this.dirtyOptions.length].concat(this.defaultColumns));
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ColumnSelector.prototype, "text", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ColumnSelector.prototype, "title", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnSelector.prototype, "rightAlign", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnSelector.prototype, "clickDismisses", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnSelector.prototype, "outsideClickDismisses", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnSelector.prototype, "applyOnChanged", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Boolean)
], ColumnSelector.prototype, "showFooter", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ColumnSelector.prototype, "selectedOptions", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], ColumnSelector.prototype, "columns", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], ColumnSelector.prototype, "defaultColumns", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ColumnSelector.prototype, "filterTerm", void 0);
ColumnSelector = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"], Element])
], ColumnSelector);



/***/ }),

/***/ "entity/list/filtering/column-selector.html":
/*!********************************************************!*\
  !*** ./SPA/entity/list/filtering/column-selector.html ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <dropdown-button text.bind=\"text\" view-model.ref=\"dropdownButton\" close.delegate=\"closedEventHandler()\" fa-icon=\"caret-down\" outside-click-dismisses.bind=\"outsideClickDismisses\"\r\n        click-dismisses.bind=\"false\" title.bind=\"title\" fa-icon=\"caret-down\" right-align.bind=\"rightAlign\">\r\n        <div class=\"input-group search-input\">\r\n            <input type=\"text\" placeholder=\"Search\" value.bind=\"filterTerm & throttle:500\">\r\n            <button class=\"input-group-btn fa fa-${!filterTerm? 'search': 'remove'}\" title=\"Clear\" click.delegate=\"filterTerm=''\" disabled.bind=\"!filterTerm\"></button>\r\n        </div>\r\n        <div class=\"list-scroll\">\r\n            <ul class=\"menu \">\r\n                <li repeat.for=\"column of columns\" class=\"menu-item\">\r\n                    <label>\r\n                        <template if.bind=\"applyOnChanged\">\r\n                            <input type=\"checkbox\" value.bind=\"column.nameLCF\" checked.bind=\"selectedOptions\" change.delegate=\"apply($event)\"> \r\n                        </template>\r\n                        <template else>\r\n                            <input type=\"checkbox\" value.bind=\"column.nameLCF\" checked.bind=\"selectedOptions\">\r\n                        </template>\r\n                        ${column.form.label}\r\n                    </label>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n        <div if.bind=\"showFooter\" class=\"dropdown-footer\">\r\n            <button click.delegate=\"apply()\" disabled.bind=\"!canApply\">Done</button>\r\n            <button class=\"btn-link\" click.delegate=\"cancel()\">Cancel</button>\r\n        </div>\r\n    </dropdown-button>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=elements.7d2e17d8ae74be98b4b6.js.map