(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["protected"],{

/***/ "./SPA/entity/plugins/step/in-vivo-results-renderer.ts":
/*!*************************************************************!*\
  !*** ./SPA/entity/plugins/step/in-vivo-results-renderer.ts ***!
  \*************************************************************/
/*! exports provided: InVivoResultsRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InVivoResultsRenderer", function() { return InVivoResultsRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let InVivoResultsRenderer = class InVivoResultsRenderer {
    constructor(server) {
        this.server = server;
        this.loading = true;
    }
    static isMatch(context) {
        let match = context.step && context.step.type === 'GammaReading'
            && context.resultSet && context.resultSet.type === 'GandW';
        return match && context.experiment;
    }
    view() {
        return `
        <template>
            <div class="loading" if.bind="loading"></div>

            <div style="display: grid; grid-template-columns: 1fr 1fr;">
                <table>
                    <thead>
                        <tr>
                            <th>Organ</th>
                            <th repeat.for="group of groups">\${group.name}</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr repeat.for="organ of organs">
                            <td>\${organ}</td>
                            <td repeat.for="group of groups">\${group.avgGammaRel[organ] | significant}</td>
                        </tr>
                    </tbody>
                </table>

                <c3chart setup.bind="chartSetup.average"></c3chart>
            </div>
            
            <div class="group" repeat.for="group of groups">
                <h2>Group: \${group.name}</h2>
    
                <button click.delegate="toggleIndividual(group)">Individual</button>
                <div id="RSIndividual\${group.id}" style="display: none">
                    <div style="display: flex; flex-wrap: wrap;">
                        <div class="animal" repeat.for="animal of group.animals">
                            <h3>Animal: \${animal.name}</h3>    
                            <table>
                                <thead>
                                    <tr>
                                        <th>Sample</th>
                                        <th>CPM</th>
                                        <th>Weight Empty (g)</th>
                                        <th>Weight Filled (g)</th>
                                        <th>Weight Organ (g)</th>
                                        <th>CPM / g</th>
                                        <th>Relative<th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr repeat.for="sample of getSamples(animal.id)">
                                        <td><a href="/#/entity/Sample/\${sample.id}">\${sample.name}</a></td>
                                        <td class="number">\${results3[sample.id].Gamma.valueDecimal | significant}</td>
                                        <td class="number">\${results3[sample.id].WeightEmpty.valueDecimal | significant}</td>
                                        <td class="number">\${results3[sample.id].WeightFilled.valueDecimal | significant}</td>
                                        <td class="number">\${results3[sample.id].weightOrgan | significant}</td>
                                        <td class="number">\${results3[sample.id].gammaPrGram | significant}</td>
                                        <td class="number">\${results3[sample.id].gammaRelative | significant}</td>
                                    </tr>
                                </tbody>
                            </table>    
                            <c3chart setup.bind="chartSetup[animal.id]"></c3chart>

                        </div>
                    </div>
                </div>
            </div>
        </template>       
        `;
    }
    init(context) {
        this.loading = true;
        this.server.datasetQuery([
            { eClass: 'ResultSet', collection: 'resultSets', filters: [{ field: 'OriginID', value: context.step.id }] },
            { eClass: 'ResultValue', collection: 'results', filters: [{ field: 'ResultSetID', in: 'resultSets.ID' }] },
            { eClass: 'Sample', collection: 'samples', filters: [{ field: 'ID', in: 'results.SubjectID' }] },
            { eClass: 'Animal', collection: 'animals', filters: [{ field: 'ID', in: 'samples.AnimalID' }] },
            { eClass: 'AnimalGroup', collection: 'groups', filters: [{ field: 'ID', in: 'animals.GroupID' }] }
        ]).then(dataset => {
            this.resultSets = dataset.resultSets;
            this.results = dataset.results;
            this.samples = dataset.samples;
            this.animals = dataset.animals;
            this.groups = dataset.groups;
            this.loading = false;
            for (let animal of this.animals) {
                let group = this.groups.find(g => g.id === animal.groupID);
                if (!group.animals)
                    group.animals = [];
                group.animals.push(animal);
            }
            this.results3 = {};
            for (let result of this.results) {
                if (!this.results3[result.subjectID])
                    this.results3[result.subjectID] = {};
                this.results3[result.subjectID][result.type] = result;
            }
            this.chartSetup = {};
            let rvInjected = this.results.find(r => r.type === 'Injected');
            if (rvInjected) {
                rvInjected.valueDecimal = parseFloat(rvInjected.valueText);
                for (let sample of this.samples) {
                    let result = this.results3[sample.id];
                    if (!result || !result.WeightFilled || !result.WeightEmpty)
                        continue;
                    result.weightOrgan = result.WeightFilled.valueDecimal - result.WeightEmpty.valueDecimal;
                    result.gammaPrGram = result.Gamma.valueDecimal / result.weightOrgan;
                    if (rvInjected)
                        result.gammaRelative = result.gammaPrGram / rvInjected.valueDecimal * 100;
                }
                let organs = new Set();
                for (let group of this.groups) {
                    let sumGammaRel = {};
                    for (let animal of group.animals) {
                        for (let sample of this.samples.filter(s => s.animalID === animal.id)) {
                            if (!sumGammaRel[sample.content])
                                sumGammaRel[sample.content] = 0.0;
                            sumGammaRel[sample.content] += this.results3[sample.id].gammaRelative;
                            organs.add(sample.content);
                        }
                    }
                    group.avgGammaRel = {};
                    for (let key in sumGammaRel)
                        group.avgGammaRel[key] = sumGammaRel[key] / group.animals.length;
                }
                this.organs = Array.from(organs);
                let chartAverage = {
                    data: {
                        x: 'Organ',
                        columns: [['Organ']].concat(this.groups.map(g => [g.name])),
                        type: 'bar'
                    },
                    axis: {
                        x: {
                            type: 'category',
                            tick: { rotate: 55, multiline: false },
                            height: 150
                        }
                    }
                };
                for (let organ of this.organs) {
                    chartAverage.data.columns[0].push(organ);
                    for (let iGroup = 0; iGroup < this.groups.length; iGroup++)
                        if (this.groups[iGroup].avgGammaRel[organ])
                            chartAverage.data.columns[iGroup + 1].push(this.groups[iGroup].avgGammaRel[organ]);
                }
                this.chartSetup.average = chartAverage;
            }
            for (let animal of this.animals) {
                let setup = {
                    data: {
                        x: 'Organ',
                        columns: [
                            ['CPM'],
                            ['Organ']
                        ],
                        type: 'bar'
                    },
                    axis: {
                        x: {
                            type: 'category',
                            tick: { rotate: 55, multiline: false },
                            height: 150
                        }
                    }
                };
                this.chartSetup[animal.id] = setup;
                let samples = this.samples.filter(s => s.animalID === animal.id).sort((a, b) => a.name > b.name ? 1 : -1);
                for (let sample of samples) {
                    setup.data.columns[0].push(this.results.find(r => r.subjectID === sample.id && r.type === 'Gamma').valueDecimal);
                    setup.data.columns[1].push(sample.content);
                }
            }
        });
    }
    getSamples(animalID) {
        return this.samples.filter(s => s.animalID === animalID).sort((a, b) => a.name > b.name ? 1 : -1);
    }
    ;
    toggleIndividual(group) {
        $(`#RSIndividual${group.id}`).toggle();
    }
    ;
};
InVivoResultsRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], InVivoResultsRenderer);



/***/ }),

/***/ "./SPA/entity/plugins/step/in-vivo-setup-renderer.ts":
/*!***********************************************************!*\
  !*** ./SPA/entity/plugins/step/in-vivo-setup-renderer.ts ***!
  \***********************************************************/
/*! exports provided: InVivoSetupRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InVivoSetupRenderer", function() { return InVivoSetupRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let InVivoSetupRenderer = class InVivoSetupRenderer {
    constructor(server) {
        this.server = server;
        this.loading = true;
    }
    static isMatch(context) {
        const matchStep = context.step && (context.step.type === 'RegisterAnimals' || context.step.type === 'BiodistributionSetup');
        return matchStep && context.experiment;
    }
    view(context) {
        return `
        <template>
            <div class="loading" if.bind="loading"></div>
            <div style="display: flex; flex-wrap: wrap;">
                <div repeat.for="group of groups" style="margin-right: 10px;">
                    <h3>Group: \${group.name}</h3>
                    <div class="view-group">
                        <label>Type</label>
                        <p>\${group.type}</p>
                    </div>
        
                    <div class="view-group">
                        <label>Animals</label>
                        <p>\${group.animals.length}</p>
                    </div>
                </div>
            </div>
        </template>    
        `;
    }
    init(context) {
        this.server.datasetQuery([
            { eClass: 'AnimalGroup', collection: 'groups', filters: [{ field: 'OriginID', value: context.step.id }] },
            { eClass: 'Animal', collection: 'animals', filters: [{ field: 'GroupID', in: 'groups.ID' }] }
        ]).then(dataset => {
            this.groups = dataset.groups.sort((a, b) => a.name > b.name ? 1 : -1);
            this.animals = dataset.animals.sort((a, b) => a.name > b.name ? 1 : -1);
            this.loading = false;
            for (let animal of this.animals) {
                let group = this.groups.find(g => g.id === animal.groupID);
                if (!group.animals)
                    group.animals = [];
                group.animals.push(animal);
            }
        });
    }
};
InVivoSetupRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], InVivoSetupRenderer);



/***/ }),

/***/ "./SPA/entity/plugins/step/plate-assay-results-renderer.ts":
/*!*****************************************************************!*\
  !*** ./SPA/entity/plugins/step/plate-assay-results-renderer.ts ***!
  \*****************************************************************/
/*! exports provided: PlateAssayResultsRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PlateAssayResultsRenderer", function() { return PlateAssayResultsRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");


class PlateAssayResultsRenderer {
    static isMatch(context) {
        return (context.step && context.step.type === 'DoseResponse' && context.position === _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["POSITIONS"].ELN_STEP_RESULTS);
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.resultSet = context.resultSet;
            if (['CurveFit', 'DataSeries', 'PlateLayer'].indexOf(this.resultSet.type) > -1) {
                this.resultSet.template = this.resultSet.type;
            }
            else {
                this.resultSet.template = 'Generic';
            }
        });
    }
    view(location) {
        let template = `
        <require from="element/result-panels/rs-panel-curvefit"></require>
        <require from="element/result-panels/rs-panel-dataseries"></require>
        <require from="element/result-panels/rs-panel-generic"></require>
        <require from="element/result-panels/rs-panel-platelayer"></require>

        <rs-panel-curvefit result-set.bind="resultSet" if.bind="resultSet.template === 'CurveFit'"></rs-panel-curvefit>
        
        <rs-panel-dataseries result-set.bind="resultSet" if.bind="resultSet.template === 'DataSeries'"></rs-panel-dataseries>

        <rs-panel-platelayer result-set.bind="resultSet" if.bind="resultSet.template === 'PlateLayer'"></rs-panel-platelayer>

        <rs-panel-generic result-set.bind="resultSet" if.bind="resultSet.template === 'Generic'"></rs-panel-generic>`;
        if (this.resultSet.type === 'ReaderOutput') {
            template = `<a href="/#/module/assaydm/analyzer/\${resultSet.id}">Analyzer</a>` + template;
        }
        return template;
    }
}


/***/ }),

/***/ "./SPA/entity/plugins/step/plate-assay-setup-renderer.ts":
/*!***************************************************************!*\
  !*** ./SPA/entity/plugins/step/plate-assay-setup-renderer.ts ***!
  \***************************************************************/
/*! exports provided: PlateAssaySetupRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PlateAssaySetupRenderer", function() { return PlateAssaySetupRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let PlateAssaySetupRenderer = class PlateAssaySetupRenderer {
    constructor(server) {
        this.server = server;
    }
    static isMatch(context) {
        return (context.step && context.step.type === 'DoseResponse' && context.position === _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_SETUP)
            || (context.entity.eClass === 'Step' && context.entity.type === 'DoseResponse');
    }
    view(location) {
        const template = `
                <a href="/#/module/assaydm/result-upload/\${step.id}">Upload results</a>
                <div if.bind="plates.length > 0">                    

                    <h3>Layout</h3>
                    <plate-view n-cols.bind="plates[0].nCols" n-rows.bind="plates[0].nRows" wells.bind="layerLayout.content.wells" well-template="layer"></plate-view>
                
                    <h3>Concentration</h3>
                    <plate-view n-cols.bind="plates[0].nCols" n-rows.bind="plates[0].nRows" wells.bind="layerConcentration.content.wells" well-template="layer"></plate-view>

                    <template repeat.for="plate of plates">
                        <h3>Plate: \${plate.name}</h3>
                        <plate-view n-cols.bind="plate.nCols" n-rows.bind="plate.nRows" wells.bind="getSamples(plate)" well-template="sample"></plate-view>
                    </template>

                </div>
        `;
        if (!location.position) {
            return `
            <div class="panel full-width">
                <div class="panel-heading">Plate Setup <collapsible default="collapsed"/></div>
                <div class="panel-body">${template}</div>
            </div>`;
        }
        return template;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.step = context.step || context.entity;
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Plate', collection: 'plates', filters: [{ field: 'OriginID', value: this.step.id }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'OriginID', value: this.step.id }] },
                { eClass: 'PlateLayer', collection: 'layers', filters: [{ field: 'PlateID', in: 'plates.ID' }] }
            ]);
            this.plates = dataset.plates;
            this.samples = dataset.samples;
            this.layerLayout = dataset.layers.find(pl => pl.type === 'SampleLayout');
            this.layerConcentration = dataset.layers.find(pl => pl.type === 'Concentration');
        });
    }
    getSamples(plate) {
        return this.samples.filter(s => s.plateID === plate.id);
    }
};
PlateAssaySetupRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], PlateAssaySetupRenderer);



/***/ }),

/***/ "./SPA/entity/plugins/template/samples2plates-panel-edit.html":
/*!********************************************************************!*\
  !*** ./SPA/entity/plugins/template/samples2plates-panel-edit.html ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/grid/sample-plates-editor\"></require>\r\n    <entity-form columns.bind=\"columns\" \r\n                    object.bind=\"entity.content\" \r\n                    valid.bind=\"isValid\" \r\n                    dirty.bind=\"isDirty\"></entity-form>\r\n    <sample-plates-editor dirty.bind=\"plateEditorIsDirty\" \r\n                            n-rows.bind=\"entity.content.nRows\" \r\n                            n-cols.bind=\"entity.content.nCols\"\r\n                            wells.bind=\"entity.content.layout.wells\" \r\n                            field-name=\"fieldName\"></sample-plates-editor>\r\n</template>";

/***/ }),

/***/ "./SPA/entity/plugins/template/samples2plates-panel-render.html":
/*!**********************************************************************!*\
  !*** ./SPA/entity/plugins/template/samples2plates-panel-render.html ***!
  \**********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/plate-view\"></require>\r\n    <div class=\"view-group\" repeat.for=\"column of evColumns\">\r\n        <label>${ column.form.label}</label>\r\n        <p if.bind=\"column.type === 'string'\">${ entity.content.entityValues[column.name] }</p>\r\n        <p if.bind=\"column.type === 'int'\">${ entity.content.entityValues[column.name] }</p>\r\n    </div>\r\n    <div class=\"view-group\" repeat.for=\"column of columns\">\r\n        <label>${ column.form.label}</label>\r\n        <p if.bind=\"column.type === 'string'\">${ entity.content[column.name] }</p>\r\n        <p if.bind=\"column.type === 'int'\">${ entity.content[column.name] }</p>\r\n    </div>\r\n    <div class=\"form-group\"></div>\r\n        <plate-view n-rows.bind=\"entity.content.nRows\" n-cols.bind=\"entity.content.nCols\" wells.bind=\"entity.content.layout.wells\"\r\n            well-template.bind=\"wellTemplate\"></plate-view>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "./SPA/entity/plugins/template/samples2plates-panel.ts":
/*!*************************************************************!*\
  !*** ./SPA/entity/plugins/template/samples2plates-panel.ts ***!
  \*************************************************************/
/*! exports provided: Samples2PlatesPanelPlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Samples2PlatesPanelPlugin", function() { return Samples2PlatesPanelPlugin; });
class Samples2PlatesPanelPlugin {
    constructor() {
        this.columns = [
            { name: 'entityValues.name', type: 'string', form: { label: 'Name', isRequired: true } },
            { name: 'entityValues.type', type: 'string', form: { label: 'Type', isRequired: true } },
            { name: 'nRows', type: 'int', form: { label: 'Rows', isRequired: true }, defaultValue: 3 },
            { name: 'nCols', type: 'int', form: { label: 'Columns', isRequired: true }, defaultValue: 4 }
        ];
        this.wellTemplate = well => { return well.fieldName; };
        this.renderView = () => __webpack_require__(/*! ./samples2plates-panel-render.html */ "./SPA/entity/plugins/template/samples2plates-panel-render.html");
        this.editView = () => __webpack_require__(/*! ./samples2plates-panel-edit.html */ "./SPA/entity/plugins/template/samples2plates-panel-edit.html");
    }
    get canSave() {
        return this.plateEditorIsDirty || (this.isValid && this.isDirty);
    }
    init(context) {
        this.entity = context.entity;
        if (!this.entity.content) {
            this.entity.content = {};
        }
        if (!this.entity.content.layout) {
            this.entity.content.layout = { wells: [] };
        }
    }
}
Samples2PlatesPanelPlugin.isMatch = (context) => context.entity.eClass === 'Template' && (!context.entity.type || context.entity.type === 'Samples2Plates');
Samples2PlatesPanelPlugin.getOptions = () => ({ entityType: 'Samples2Plates', eClass: 'Template', field: 'Content' });


/***/ }),

/***/ "./SPA/module/assaydm/assays/generic.js":
/*!**********************************************!*\
  !*** ./SPA/module/assaydm/assays/generic.js ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PlateAssayGeneric = exports.PlateAssayGeneric = function () {
    function PlateAssayGeneric() {
        _classCallCheck(this, PlateAssayGeneric);

        this.label = 'Generic Plate Assay';
        this.description = 'Generic plate setup for dose-response and other assay types';
        this.outputPanelView = '../wfm/panels/std-panel-output.html';
    }

    _createClass(PlateAssayGeneric, [{
        key: 'prepareSetup',
        value: function prepareSetup(setup) {}

        // INPUT ////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'processInput',
        value: function processInput(setup) {
            if (setup.input.plates.length === 0) return;

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                var _loop = function _loop() {
                    var sample = _step.value;

                    var layoutWell = layerSample.content.wells.find(function (w) {
                        return w.posRow === sample.posRow && w.posCol === sample.posCol;
                    });
                    if (!layoutWell) layerSample.content.wells.push({ posRow: sample.posRow, posCol: sample.posCol, valueText: 'Prefilled' });
                };

                for (var _iterator = setup.input.samples[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }

        // OUTPUT ///////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'createOutput',
        value: function createOutput(setup) {
            setup.output = {
                samples: [],
                plates: [],
                layers: [],
                rows: []
            };

            if (setup.mode === 'InputPlates') this.createOutputFromPlates(setup);else this.createOutputFromSamples(setup);
        }
    }, {
        key: 'createOutputFromPlates',
        value: function createOutputFromPlates(setup) {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {

                for (var _iterator2 = setup.input.plates[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var plate = _step2.value;

                    this.fillPlate(setup, plate);
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                var _loop2 = function _loop2() {
                    var sample = _step3.value;

                    if (!sample.concentration) return 'continue';

                    var layerConc = setup.output.layers['concentration'];
                    var well = layerConc.content.wells.find(function (w) {
                        return w.posRow === sample.posRow && w.posCol === sample.posCol;
                    });

                    if (well) {
                        well.valueDecimal = sample.concentration;
                        well.valueText = sample.concentration.toString();
                    } else layerConc.content.wells.push({
                        posRow: sample.posRow, posCol: sample.posCol,
                        valueDecimal: sample.concentration, valueText: sample.concentration.toString()
                    });
                };

                for (var _iterator3 = setup.input.samples[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var _ret2 = _loop2();

                    if (_ret2 === 'continue') continue;
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
        }
    }, {
        key: 'createOutputFromSamples',
        value: function createOutputFromSamples(setup) {
            var inputSamples = setup.input.samples.slice(); // Copy of the sample list

            var iPlate = 0;
            while (inputSamples.length > 0) {
                var plate = {
                    eClass: 'Plate',
                    name: 'Plate-' + (iPlate + 1),
                    id: '#idPlate' + iPlate,
                    originID: '#idStep',
                    type: 'Assay',
                    nRows: setup.layout.nRows,
                    nCols: setup.layout.nCols,
                    format: 'Plate'
                };

                var nRemainingBefore = inputSamples.length;
                this.fillPlate(setup, plate, inputSamples);

                if (nRemainingBefore === inputSamples.length) break; // Avoid endless loop caused by template w/o Test sample markers

                iPlate++;
            }
        }
    }, {
        key: 'fillPlate',
        value: function fillPlate(setup, plate, inputSamples) {
            var layoutSmp = setup.layout.layers['sample-layout'];
            var layoutConc = setup.layout.layers['concentration'];
            //let layoutConcPM = setup.input.layers.find(layer => layer.plateID === plate.id && layer.type === 'ConcPM');

            setup.output.plates.push(plate);

            var layerConc = {
                eClass: 'PlateLayer',
                plateID: plate.id,
                name: 'Concentration',
                type: 'Concentration',
                content: { wells: [] }
            };
            setup.output.layers.push(layerConc);

            setup.output.layers.push({
                eClass: 'PlateLayer',
                plateID: plate.id,
                name: 'Layout',
                type: 'SampleLayout',
                content: {
                    wells: JSON.parse(JSON.stringify(layoutSmp.content.wells))
                }
            });

            var inputSamplesPlate = {};

            var _loop3 = function _loop3(iRow) {
                var _loop4 = function _loop4(iCol) {
                    // Concentration
                    var wellConcPM = null;
                    //                if(layoutConcPM)
                    //                    wellConcPM = layoutConcPM.content.wells.find(w => w.posCol === iCol && w.posRow === iRow);
                    var wellConcLayout = layoutConc.content.wells.find(function (w) {
                        return w.posCol === iCol && w.posRow === iRow;
                    });

                    if (wellConcPM) {
                        layerConc.content.wells.push({
                            posRow: iRow, posCol: iCol,
                            valueText: wellConcPM.valueText,
                            valueDecimal: wellConcPM.valueDecimal
                        });
                    } else if (wellConcLayout) {
                        layerConc.content.wells.push({
                            posRow: iRow, posCol: iCol,
                            valueText: wellConcLayout.valueText,
                            valueDecimal: wellConcLayout.valueDecimal
                        });
                    }

                    // New Sample
                    var wellTemplate = layoutSmp.content.wells.find(function (w) {
                        return w.posCol === iCol && w.posRow === iRow;
                    });
                    if (!wellTemplate || wellTemplate.valueText === 'Prefilled') return 'continue';

                    var outputSample = {
                        eClass: 'Sample',
                        format: 'Well',
                        originID: '#idStep',
                        plateID: plate.id,
                        posCol: iCol,
                        posRow: iRow,
                        status: 'Initial',
                        type: 'Assay'
                    };

                    var matchTestSample = /^T-(\d+)$/.exec(wellTemplate.valueText);
                    if (matchTestSample) {
                        var iTestSample = parseInt(matchTestSample[1]);
                        var inputSample = inputSamplesPlate[iTestSample];
                        if (!inputSample) {
                            if (inputSamples.length === 0) return 'continue'; // No more input samples; plate will be partially filled

                            inputSample = inputSamples.shift();
                            inputSamplesPlate[iTestSample] = inputSample;
                        }

                        outputSample.name = inputSample.name;
                        outputSample.parentID = inputSample.id;
                        outputSample.content = inputSample.content;

                        setup.output.samples.push(outputSample);
                    } else if (wellTemplate.valueText) {
                        outputSample.name = wellTemplate.valueText;
                        outputSample.content = wellTemplate.valueText;
                        outputSample.isControl = true;
                        outputSample.controlType = 'Reference';

                        setup.output.samples.push(outputSample);
                    }
                };

                for (var iCol = 0; iCol < plate.nCols; iCol++) {
                    var _ret4 = _loop4(iCol);

                    if (_ret4 === 'continue') continue;
                }
            };

            for (var iRow = 0; iRow < plate.nRows; iRow++) {
                _loop3(iRow);
            }
        }
    }], [{
        key: 'isMatch',
        value: function isMatch(context) {
            return context.template === 'PlateAssayGeneric';
        }
    }]);

    return PlateAssayGeneric;
}();

/***/ }),

/***/ "./SPA/module/assaydm/assays/with-child-plates.js":
/*!********************************************************!*\
  !*** ./SPA/module/assaydm/assays/with-child-plates.js ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PlateAssayWithChildPlates = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _generic = __webpack_require__(/*! ./generic */ "./SPA/module/assaydm/assays/generic.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlateAssayWithChildPlates = exports.PlateAssayWithChildPlates = function (_PlateAssayGeneric) {
    _inherits(PlateAssayWithChildPlates, _PlateAssayGeneric);

    function PlateAssayWithChildPlates() {
        _classCallCheck(this, PlateAssayWithChildPlates);

        var _this = _possibleConstructorReturn(this, (PlateAssayWithChildPlates.__proto__ || Object.getPrototypeOf(PlateAssayWithChildPlates)).call(this));

        _this.template = 'PlateAssayWithChildPlates';
        _this.label = 'Incubation and ELISA';
        _this.description = 'Incubation plate, PrestoBlue, child plates for ELISA';
        _this.outputPanelView = './panels/panel-output-child-plates.html';
        _this.stepPanelView = './panels/panel-step-child-plates.html';
        return _this;
    }

    _createClass(PlateAssayWithChildPlates, [{
        key: 'prepareSetup',
        value: function prepareSetup(setup) {
            setup.operation.assays = [];
            setup.operation.assayTypes = ['PrestoBlue', 'ELISA-IL-2', 'ELISA-IL-4', 'MSD-IL-17'];
        }

        // OUTPUT //////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'createOutput',
        value: function createOutput(setup) {
            _get(PlateAssayWithChildPlates.prototype.__proto__ || Object.getPrototypeOf(PlateAssayWithChildPlates.prototype), 'createOutput', this).call(this, setup); // Creates/fills the root assay plates
            this.createChildAssayPlates(setup);
        }
    }, {
        key: 'addStandard',
        value: function addStandard(wells, concentrations) {
            for (var iRow = 0; iRow < 16; iRow++) {
                wells.push({ posRow: iRow, posCol: 22, valueDecimal: concentrations[iRow] });
                wells.push({ posRow: iRow, posCol: 23, valueDecimal: concentrations[iRow] });
            }
        }
    }, {
        key: 'createChildAssayPlates',
        value: function createChildAssayPlates(setup) {
            setup.layerSmp = setup.operation.plate.layers.find(function (layer) {
                return layer.name === 'Sample';
            });
            setup.layerConc = setup.operation.plate.layers.find(function (layer) {
                return layer.name === 'Concentration';
            });

            this.iChildPlate = 0;
            var rootPlates = setup.output.plates.slice(); // The output.plates array will grow during loop execution, so we work with a copy
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = rootPlates[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var rootPlate = _step.value;

                    var row = { plates: [rootPlate] };
                    setup.output.rows.push(row);

                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = setup.operation.assays[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var assay = _step2.value;

                            this.addChildPlate(setup, row, rootPlate, assay);
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'addChildPlate',
        value: function addChildPlate(setup, row, rootPlate, assay) {
            this.iChildPlate++;

            if (assay.startsWith('ELISA-')) this.addELISA(setup, row, rootPlate, assay);
            //else if(assay.startsWith('MSD-'))
            //    this.addMSD(setup, row, rootPlate, assay);
            else if (assay !== 'PrestoBlue') // PB is run in the root plate
                    this.addOther(setup, row, rootPlate, assay);
        }
    }, {
        key: 'addELISA',
        value: function addELISA(setup, row, rootPlate, assay) {
            // Assay plate
            var plate = {
                eClass: 'Plate',
                name: assay + '-' + rootPlate.name,
                id: '#idPlateChild' + this.iChildPlate,
                originID: '#idStep',
                type: 'Assay',
                nRows: 16, nCols: 24,
                format: 'Plate',
                parents: [rootPlate.id],
                description: assay + ' assay for plate ' + rootPlate.name
            };

            setup.output.layers.push({
                eClass: 'PlateLayer',
                plateID: plate.id,
                name: 'Layout',
                type: 'SampleLayout',
                content: {
                    wells: JSON.parse(JSON.stringify(setup.layerSmp.content.wells))
                }
            });

            var conc = {
                eClass: 'PlateLayer',
                plateID: plate.id,
                name: 'Concentration',
                type: 'Concentration',
                content: {
                    wells: JSON.parse(JSON.stringify(setup.layerConc.content.wells))
                }
            };

            row.plates.push(plate);
            setup.output.plates.push(plate);
            this.addStandard(conc.content.wells, [150000, 75000, 37500, 18750, 9375, 4688, 2344, 1172, 586, 293, 146, 73, 37, 18, 0, 0]); // TODO: Get from assay definition
            setup.output.layers.push(conc);

            // Samples
            var parentSamples = setup.input.samples.filter(function (s) {
                return s.plateID === rootPlate.id;
            }).concat(setup.output.samples.filter(function (s) {
                return s.plateID === rootPlate.id;
            }));

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = parentSamples[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var parentSample = _step3.value;

                    setup.output.samples.push({
                        eClass: 'Sample',
                        name: parentSample.name,
                        content: parentSample.content,
                        format: 'Well',
                        originID: '#idStep',
                        plateID: plate.id,
                        posCol: parentSample.posCol,
                        posRow: parentSample.posRow,
                        parentID: parentSample.id,
                        status: 'Initial',
                        type: assay
                    });
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
        }
    }]);

    return PlateAssayWithChildPlates;
}(_generic.PlateAssayGeneric);

/***/ }),

/***/ "./SPA/module/assaydm/data-loaders/data-loader-plate-reader-envision.js":
/*!******************************************************************************!*\
  !*** ./SPA/module/assaydm/data-loaders/data-loader-plate-reader-envision.js ***!
  \******************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DataLoaderPlateReaderEnvision = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _peEnvision = __webpack_require__(/*! ./pe-envision */ "./SPA/module/assaydm/data-loaders/pe-envision.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataLoaderPlateReaderEnvision = exports.DataLoaderPlateReaderEnvision = function () {
    function DataLoaderPlateReaderEnvision(envision) {
        _classCallCheck(this, DataLoaderPlateReaderEnvision);

        this.envision = new _peEnvision.PEEnvision();
    }

    _createClass(DataLoaderPlateReaderEnvision, [{
        key: 'init',
        value: function init(context) {
            this.context = context;
        }
    }, {
        key: 'getResult',
        value: function getResult() {

            var entities = [];
            var lookups = [{
                eClass: 'Plate',
                alias: '#idPlate',
                barcode: this.context.envisionContent.plateLayers[0].Barcode
                //, origin: context.step.id
            }];

            entities.push({ eClass: 'ResultSet', id: '#idRS', type: 'PlateLayer',
                name: context.filename.substring(0, this.context.filename.length - 4), originID: this.context.step.id });

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.context.envisionContent.plateLayers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var plateLayer = _step.value;

                    entities.push({
                        eClass: 'PlateLayer',
                        plateID: '#idPlate',
                        name: this.context.filename.replace(/\.[^/\.]+$/, ''),
                        resultSetID: '#idRS',
                        type: 'RawData',
                        content: plateLayer.content,
                        description: plateLayer.description
                    });
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return { content: 'new-entities', entities: entities, lookups: lookups };
        }
    }], [{
        key: 'isMatch',
        value: function isMatch(context) {
            if (context.category !== 'DataImport' || !context.step || !context.filename.toLowerCase().endsWith('.txt')) return false;

            var envisionContent = this.envision.parse(context.filename, context.fileContent);

            if (!envisionContent) return false;

            context.envisionContent = envisionContent;
            return true;
        }
    }]);

    return DataLoaderPlateReaderEnvision;
}();

/***/ }),

/***/ "./SPA/module/assaydm/data-loaders/data-loader-plate-reader-msd.js":
/*!*************************************************************************!*\
  !*** ./SPA/module/assaydm/data-loaders/data-loader-plate-reader-msd.js ***!
  \*************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataLoaderPlateReaderMsd = exports.DataLoaderPlateReaderMsd = function () {
    function DataLoaderPlateReaderMsd() {
        _classCallCheck(this, DataLoaderPlateReaderMsd);
    }

    _createClass(DataLoaderPlateReaderMsd, [{
        key: 'init',
        value: function init(context) {
            this.context = context;
        }
    }, {
        key: 'getResult',
        value: function getResult() {
            var entities = [];

            var barcode = this.context.msdHeader['Barcode1'];
            var lookups = [{
                eClass: 'Plate',
                alias: '#idPlate',
                barcode: barcode,
                origin: context.step.id
            }];

            entities.push({ eClass: 'ResultSet', id: '#idRS', type: 'PlateLayer',
                name: this.context.filename.substring(0, this.context.filename.length - 4), originID: this.context.step.id });

            for (var iLayer = 0; iLayer < this.context.msdLayers.length; iLayer++) {
                if (this.context.msdLayers.length < 3 && this.context.msdLayers[iLayer].wells.length > 1 || this.context.msdLayers.length > 3 && iLayer === 6) // TODO: Figure out how to handle selection of these layers / channels
                    entities.push({
                        eClass: 'PlateLayer',
                        plateID: '#idPlate',
                        name: this.context.filename + '-' + iLayer,
                        resultSetID: '#idRS',
                        type: 'RawData',
                        content: this.context.msdLayers[iLayer]
                    });
            }

            return { content: 'new-entities', entities: entities, lookups: lookups };
        }
    }], [{
        key: 'isMatch',
        value: function isMatch(context) {
            if (context.category !== 'DataImport' || !context.step || !context.filename.toLowerCase().endsWith('.txt') || !context.fileContent.startsWith('FileName :')) return false;

            // Split into sections
            var currentSection = { name: 'Header', lines: [] };
            var sections = [currentSection];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = context.fileContent.split('\n')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var line = _step.value;

                    if (line.startsWith('=====')) {
                        var match = /=*([^=]+)===/.exec(line);
                        if (!match) return false; // Then this is not an MSD file
                        currentSection = { name: match[1], lines: [] };
                        sections.push(currentSection);
                    } else currentSection.lines.push(line);
                }

                // Parse header
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            var sectionHeader = sections[0];
            var msdHeader = {};
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = sectionHeader.lines[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var line2 = _step2.value;

                    var iSeparator = line2.indexOf(':');
                    if (iSeparator < 0) continue;
                    var key = line2.substring(0, iSeparator);
                    var value = line2.substring(iSeparator + 1);
                    msdHeader[key.trim()] = value.trim();
                }

                // Parse data sections
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }

            var sectionData = sections[1];
            if (sectionData.name !== 'Data') return false; // Then this is not an MSD file

            var msdLayers = [];
            var currentRow = void 0;
            var currentPosRow = -1;
            var iLayer = 0;
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = sectionData.lines.slice(1)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var _line = _step3.value;

                    var parts = _line.split('\t');
                    if (parts[0]) {
                        currentRow = _line[0];
                        currentPosRow++;
                        iLayer = 0;
                    }
                    while (msdLayers.length <= iLayer) {
                        msdLayers.push({ wells: [] });
                    }for (var posCol = 0; posCol < parts.length - 1; posCol++) {
                        msdLayers[iLayer].wells.push({ posRow: currentPosRow, posCol: posCol,
                            valueText: parts[posCol + 1], valueDecimal: parseFloat(parts[posCol + 1]) });
                    }iLayer++;
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            context.msdSections = sections;
            context.msdHeader = msdHeader;
            context.msdLayers = msdLayers;

            return true;
        }
    }]);

    return DataLoaderPlateReaderMsd;
}();

/***/ }),

/***/ "./SPA/module/assaydm/data-loaders/pe-envision.js":
/*!********************************************************!*\
  !*** ./SPA/module/assaydm/data-loaders/pe-envision.js ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// File sections:
// - Plate information (3L Tab Col)
// - Background information (3L Tab Col)
// - Readings: Raw numbers in tab-array
// - Basic assay information (KVP, 4Tab)
// - Protocol information / Protocol (KVP, 4Tab)
// - Plate type (KVP, 4Tab)
// - Coordinates of corners (special, incl empty line)
// - Platemap (special, incl empty line)
// - Calculations (???)
// - Auto export parameters (KVP, 4Tab)
// - Operations (nested + KVP, 4Tab)
// - Labels (KVP, 4Tab)
// - Filters (KVP, group by empty lines, 4Tab)
// - Mirror modules (KVP, 4Tab)
// - Instrument (KVP, 4Tab)
// - Software version (single line)

var PEEnvision = exports.PEEnvision = function () {
    function PEEnvision() {
        _classCallCheck(this, PEEnvision);
    }

    _createClass(PEEnvision, [{
        key: 'parse',
        value: function parse(filename, fileContent) {
            var result = { filename: filename, plateLayers: [] };

            try {
                this.reKVP4Tab = /^([\w ]+):? ?[\t,;]{4}(.*)/;
                this.reRawData = /(\d+(\.\d+)?[\t,;]){8}/;
                this.reRawDataColHeadings = /^[\t,;](\d+(\.\d+)?[\t,;]){8}/;
                this.reRawDataWithHeadings = /^[A-Z][\t,;](\d+(\.\d+)?[\t,;]){8}/;

                var latestPlateLayer = null;
                var lines = fileContent.split('\n');

                this.separator = '\t';
                if (lines[0].startsWith('sep=')) this.separator = lines[0][4];else if (lines[0].indexOf('\t') >= 0) this.separator = '\t';else if (lines[0].indexOf(';') >= 0) this.separator = ';';else if (lines[0].indexOf(',') >= 0) this.separator = ',';

                for (var i = 0; i < lines.length; i++) {
                    var line = lines[i];

                    if (line.startsWith('Plate information')) {
                        latestPlateLayer = this.readTabCols(result, lines[i + 1], lines[i + 2]);
                        result.plateLayers.push(latestPlateLayer);
                        latestPlateLayer.no = result.plateLayers.length;
                        i += 2;
                    } else if (line.startsWith('Background information')) {
                        result['background'] = this.readTabCols(result, lines[i + 1], lines[i + 2]);
                        i += 2;
                    } else if (line.startsWith('Calculated results: ')) {
                        latestPlateLayer.description = line.substring(20, 120);
                    } else if (line.startsWith('Results for ')) {
                        latestPlateLayer.description = line.substring(12);
                    } else if (line.match(this.reRawData) && latestPlateLayer) {
                        i += this.readRawData(latestPlateLayer, lines, i, false);
                        latestPlateLayer = null;
                    } else if (line.match(this.reRawDataColHeadings) && latestPlateLayer) {
                        i += this.readRawData(latestPlateLayer, lines, i, true);
                        latestPlateLayer = null;
                    } else if (line.startsWith('Basic assay information')) {
                        i += this.readKVP4Tab(result, lines, i + 1, 'basicAssay');
                    } else if (line.startsWith('Protocol:')) {
                        i += this.readKVP4Tab(result, lines, i + 1, 'protocol');
                    } else if (line.startsWith('Plate type:')) {
                        i += this.readKVP4Tab(result, lines, i + 1, 'plateType');
                    } else if (line.startsWith('Instrument:')) {
                        i += this.readKVP4Tab(result, lines, i + 1, 'instrument');
                    }
                }
            } catch (ex) {
                return null;
            }

            if (result.plateLayers.length === 0) return null;

            return result;
        }
    }, {
        key: 'readRawData',
        value: function readRawData(plateLayer, lines, iFirstLine, hasHeadings) {
            plateLayer.content = { wells: [] };

            var offset = hasHeadings ? 1 : 0;
            var nRead = offset;
            while (nRead + iFirstLine < lines.length) {
                var match = void 0;
                if (hasHeadings) match = this.reRawDataWithHeadings.exec(lines[iFirstLine + nRead]);else match = this.reRawData.exec(lines[iFirstLine + nRead]);
                if (!match) break;

                var iCol = 0;
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = lines[iFirstLine + nRead].trim().split(this.separator).map(function (s) {
                        return parseFloat(s);
                    })[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var measurement = _step.value;

                        if (iCol >= offset && measurement) plateLayer.content.wells.push({
                            posRow: nRead - offset,
                            posCol: iCol - offset,
                            valueDecimal: parseFloat(measurement),
                            valueText: measurement
                        });
                        iCol++;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                nRead++;
            }

            return nRead;
        }
    }, {
        key: 'readTabCols',
        value: function readTabCols(result, lineTitles, lineData) {
            var tabColsData = {};

            var titles = lineTitles.split(this.separator);
            var data = lineData.split(this.separator);

            if (titles.length != data.length) throw new Error('Error reading tab-cols section');

            for (var i = 0; i < titles.length; i++) {
                tabColsData[titles[i]] = data[i];
            }

            return tabColsData;
        }
    }, {
        key: 'readKVP4Tab',
        value: function readKVP4Tab(result, lines, iFirstLine, key) {
            result[key] = {};

            var nRead = 0;
            while (nRead + iFirstLine < lines.length) {
                var match = this.reKVP4Tab.exec(lines[iFirstLine + nRead]);
                if (!match) break;

                result[key][match[1]] = match[2];

                nRead++;
            }

            return nRead;
        }
    }]);

    return PEEnvision;
}();

/***/ }),

/***/ "./SPA/module/assaydm/prism/prism-builder.ts":
/*!***************************************************!*\
  !*** ./SPA/module/assaydm/prism/prism-builder.ts ***!
  \***************************************************/
/*! exports provided: PrismBuilder */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PrismBuilder", function() { return PrismBuilder; });
class PrismBuilder {
    constructor(userName) {
        this.dataTables = [];
        this.dtInfoSequences = [];
        this.iNextInfoSequence = 1;
        this.header = '<?xml version="1.0" encoding="UTF-8"?>\n' +
            '<GraphPadPrismFile xmlns="http://graphpad.com/prism/Prism.htm" PrismXMLVersion="5.00">\n' +
            '<Created>\n' +
            `<OriginalVersion CreatedByProgram="GraphPad Prism" CreatedByVersion="7.0.2.197" Login="${userName}" DateTime="2016-12-28T14:38:25+01:00"/>\n` +
            '</Created>\n';
    }
    generateFile() {
        let dataTables = this.generateDataTables();
        let projectInfo = this.generateProjectInfo();
        let content = this.header +
            projectInfo +
            dataTables +
            '\n</GraphPadPrismFile>\n';
        return content;
    }
    generateDataTables() {
        let content = '';
        let iTable = 0;
        let tableIDs = [];
        for (let dataTable of this.dataTables) {
            let matrix = this.createMatrix(dataTable);
            let tableID = 'Table' + iTable;
            tableIDs.push(tableID);
            content += `<Table ID="${tableID}" XFormat="numbers" YFormat="replicates" Replicates="${matrix.replicates}" TableType="XY" EVFormat="AsteriskAfterNumber">\n` +
                `<Title>${dataTable.resultSet.name}</Title>\n`;
            let infoID = 'Info' + this.iNextInfoSequence;
            this.dtInfoSequences.push(infoID);
            content += `<Info ID="${infoID}">\n` +
                `<Title>${dataTable.resultSet.name}</Title>\n` +
                `<Constant><Name>Scifeon ResultSetID</Name><Value>${dataTable.resultSet.id}</Value></Constant>` +
                `<Constant><Name>Scifeon ResultSet OriginID</Name><Value>${dataTable.resultSet.originID}</Value></Constant>` +
                `</Info>\n`;
            this.iNextInfoSequence++;
            let contentX = '<XColumn Width="200" Subcolumns="1" Decimals="15">\n' +
                '<Title>X</Title>\n<Subcolumn>\n';
            let contentSeries = [];
            for (let series of dataTable.series) {
                let content = {
                    series: series,
                    header: `<YColumn Width="200" Decimals="15" SubColumns="${matrix.replicates}">\n<Title>${series.name}</Title>`,
                    subColumns: []
                };
                contentSeries.push(content);
                for (let i = 0; i < matrix.replicates; i++) {
                    content.subColumns.push('<Subcolumn>\n');
                }
            }
            for (let row of matrix.rows) {
                contentX += `<d>${row.valueX}</d>\n`;
                for (let iSeries = 0; iSeries < dataTable.series.length; iSeries++) {
                    for (let iReplicate = 0; iReplicate < matrix.replicates; iReplicate++) {
                        if (row.series[iSeries].length > iReplicate)
                            contentSeries[iSeries].subColumns[iReplicate] += `<d>${row.series[iSeries][iReplicate]}</d>\n`;
                        else
                            contentSeries[iSeries].subColumns[iReplicate] += '<d></d>\n';
                    }
                }
            }
            content += contentX + '</Subcolumn>\n</XColumn>';
            for (let series of contentSeries) {
                content += series.header;
                for (let iReplicate = 0; iReplicate < matrix.replicates; iReplicate++) {
                    content += series.subColumns[iReplicate] + '</Subcolumn>\n';
                }
                content += '</YColumn>\n';
            }
            content += '</Table>\n';
            iTable++;
        }
        content = '<TableSequence Selected="1">\n' +
            tableIDs.map(id => { return `  <Ref ID="${id}"/>\n`; }) +
            '</TableSequence>\n' + content;
        return content;
    }
    createMatrix(dataTable) {
        let matrix = { replicates: 1, rows: [] };
        for (let iSeries = 0; iSeries < dataTable.series.length; iSeries++) {
            let series = dataTable.series[iSeries];
            for (let point of series.content) {
                let row = this.findRow(matrix.rows, point.valueX);
                while (row.series.length <= iSeries)
                    row.series.push([]);
                row.series[iSeries].push(point.valueY);
                if (row.series[iSeries].length > matrix.replicates)
                    matrix.replicates = row.series[iSeries].length;
            }
        }
        matrix.rows.sort((a, b) => a.valueX - b.valueX);
        return matrix;
    }
    findRow(rows, valueX) {
        let row;
        if (valueX === 0.0)
            row = rows.find(r => r.valueX === 0.0);
        else
            for (let r of rows) {
                let ratio = r.valueX / valueX;
                if (ratio > 0.999 && ratio < 1.001) {
                    row = r;
                    break;
                }
            }
        if (!row) {
            row = { valueX: valueX, series: [] };
            rows.push(row);
        }
        return row;
    }
    addDataSeriesRaw(dataSeriesContent) {
        this.dataTables.push({ series: dataSeriesContent.map(c => { return { eClass: 'ResultDataSeries', content: c.content }; }) });
    }
    addDataSeries(resultSet, dataSeriesEntities) {
        this.dataTables.push({ resultSet: resultSet, series: dataSeriesEntities });
    }
    generateProjectInfo() {
        let content = '<InfoSequence>\n' +
            '  <Ref ID="Info0" Selected="1"/>\n' +
            this.dtInfoSequences.map(id => { return `  <Ref ID="${id}" Selected="1"/>\n`; }) +
            '</InfoSequence>\n' +
            '<Info ID="Info0">\n' +
            '  <Title>Project Info</Title>\n' +
            `  <Constant><Name>Scifeon ExperimentID</Name><Value>${this.experiment.id}</Value></Constant>\n` +
            (this.experiment.elnNo ? `  <Constant><Name>Scifeon ELN No</Name><Value>${this.experiment.elnNo}</Value></Constant>\n` : '') +
            `  <Constant><Name>Scifeon Analyst</Name><Value>${this.experiment.analystID}</Value></Constant>\n` +
            `  <Constant><Name>Scifeon Scientist</Name><Value>${this.experiment.scientistID}</Value></Constant>\n` +
            '</Info>\n';
        return content;
    }
    setExperiment(experiment) {
        this.experiment = experiment;
    }
    setStep(step) {
        this.step = step;
    }
}


/***/ }),

/***/ "./SPA/module/assaydm/setup.ts":
/*!*************************************!*\
  !*** ./SPA/module/assaydm/setup.ts ***!
  \*************************************/
/*! exports provided: AssayDMSetup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AssayDMSetup", function() { return AssayDMSetup; });
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _assays_generic__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./assays/generic */ "./SPA/module/assaydm/assays/generic.js");
/* harmony import */ var _assays_generic__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_assays_generic__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _assays_with_child_plates__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./assays/with-child-plates */ "./SPA/module/assaydm/assays/with-child-plates.js");
/* harmony import */ var _assays_with_child_plates__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_assays_with_child_plates__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _data_loaders_data_loader_plate_reader_envision__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./data-loaders/data-loader-plate-reader-envision */ "./SPA/module/assaydm/data-loaders/data-loader-plate-reader-envision.js");
/* harmony import */ var _data_loaders_data_loader_plate_reader_envision__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_data_loaders_data_loader_plate_reader_envision__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _data_loaders_data_loader_plate_reader_msd__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./data-loaders/data-loader-plate-reader-msd */ "./SPA/module/assaydm/data-loaders/data-loader-plate-reader-msd.js");
/* harmony import */ var _data_loaders_data_loader_plate_reader_msd__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_data_loaders_data_loader_plate_reader_msd__WEBPACK_IMPORTED_MODULE_4__);





class AssayDMSetup {
    setup(api, plugins) {
        plugins.add(_assays_generic__WEBPACK_IMPORTED_MODULE_1__["PlateAssayGeneric"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_0__["PLUGIN_TYPE"].ASSAY_DEFINITION]);
        plugins.add(_assays_with_child_plates__WEBPACK_IMPORTED_MODULE_2__["PlateAssayWithChildPlates"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_0__["PLUGIN_TYPE"].ASSAY_DEFINITION]);
        plugins.add(_data_loaders_data_loader_plate_reader_envision__WEBPACK_IMPORTED_MODULE_3__["DataLoaderPlateReaderEnvision"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_0__["PLUGIN_TYPE"].DATA_LOADER]);
        plugins.add(_data_loaders_data_loader_plate_reader_msd__WEBPACK_IMPORTED_MODULE_4__["DataLoaderPlateReaderMsd"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_0__["PLUGIN_TYPE"].DATA_LOADER]);
    }
    addRoutes(configMap) {
    }
}


/***/ }),

/***/ "./SPA/module/dashboard/default-dashboard.json":
/*!*****************************************************!*\
  !*** ./SPA/module/dashboard/default-dashboard.json ***!
  \*****************************************************/
/*! exports provided: id, name, description, widgets, shares, default */
/***/ (function(module) {

module.exports = {"id":"scifeonDefaultDashboard","name":"Default Dashboard","description":"New Dashboard","widgets":[{"plugin":{"id":"DashboardWidget","app":{"namespace":"com.scifeon","name":"scifeon_widgets"}},"grid":{"x":3,"y":2,"w":1,"h":1,"minw":1,"minh":1},"config":{},"header":"All available dashboard"},{"plugin":{"id":"AppsWidget","app":{"namespace":"com.scifeon","name":"scifeon_widgets"}},"grid":{"x":1,"y":2,"w":2,"h":1,"minw":1,"minh":1},"config":{},"header":"All enabled apps"},{"plugin":{"id":"HTMLWidget","app":{"namespace":"com.scifeon","name":"scifeon_widgets"}},"grid":{"x":1,"y":1,"w":1,"h":1,"minw":1,"minh":1},"config":{"content":"<div>Text...</div>"},"header":"Getting Started"},{"plugin":{"id":"HTMLWidget","app":{"namespace":"com.scifeon","name":"scifeon_widgets"}},"grid":{"x":2,"y":1,"w":1,"h":1,"minw":1,"minh":1},"config":{"content":"<div>Links...</div>"},"header":"Documentation"},{"plugin":{"id":"DemoPagesWidget","app":{"namespace":"com.scifeon","name":"scifeon_apps_demo"}},"grid":{"x":3,"y":1,"w":1,"h":1,"minw":1,"minh":1},"config":{},"header":""},{"plugin":{"id":"HTMLWidget","app":{"namespace":"com.scifeon","name":"scifeon_widgets"}},"grid":{"x":4,"y":1,"w":1,"h":1,"minw":1,"minh":1},"config":{"content":"<div>Links...</div>"},"header":"Browse Data"}],"shares":{"userIDs":[],"departmentIDs":[],"projectIDs":[],"userRoles":["User"]}};

/***/ }),

/***/ "./SPA/module/data-upload/excel/data-loader-excel-entities.ts":
/*!********************************************************************!*\
  !*** ./SPA/module/data-upload/excel/data-loader-excel-entities.ts ***!
  \********************************************************************/
/*! exports provided: DataLoaderExcelEntities */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderExcelEntities", function() { return DataLoaderExcelEntities; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");


let DataLoaderExcelEntities = class DataLoaderExcelEntities {
    constructor() {
        this.colNames = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'AA', 'AB', 'AC', 'AD', 'AE', 'AF', 'AG', 'AH', 'AI', 'AJ', 'AK', 'AL', 'AM', 'AN', 'AO', 'AP'];
        this.entities = [];
        this.entitiesView = () => `
<require from="entity/shared-fields.html"></require>
<require from="entity/unique-fields"></require>
<table class="loaded-entities">
    <thead>
        <tr>
            <th>ID Alias</th>
            <th>Class</th>
            <th>Name</th>
            <th>Type</th>
        </tr>
    </thead>
    <tbody>
        <tr repeat.for="entity of entities">
            <td click.delegate="selectWaitingEntity(entity)" style="cursor: pointer">#{entity.id || '-'}</td>
            <td>#{entity.eClass}</td>
            <td>#{entity.name}</td>
            <td>#{entity.type}</td>
        </tr>
    </tbody>
</table>
<div if.bind="selectedEntity">
    <h3>#{selectedEntity.eClass}: #{selectedEntity.id}</h3>
    <div>
        <shared-fields style="float:left" entity.bind="selectedEntity"></shared-fields>
    </div>
    <div>
        <unique-fields style="float:left" entity.bind="selectedEntity"></unique-fields>
    </div>
</div>`;
    }
    init(context) {
        this.context = context;
    }
    readFiles() {
        this.entities = [];
        for (let fileInfo of this.context.fileInfos) {
            let ws = fileInfo.wb.Sheets['ScirexEntities'] || fileInfo.wb.Sheets['ScifeonEntities'];
            let xlrowMax = this.getXlrowMax(ws);
            for (let xlrow = 1; xlrow <= xlrowMax; xlrow++) {
                let cellA = ws['A' + xlrow];
                if (cellA && cellA.v === 'Class')
                    this.readNewEntityClass(ws, xlrow);
                else {
                    let entity = this.readNewEntity(ws, xlrow);
                    if (!entity)
                        continue;
                    this.entities.push(entity);
                    if (this.currentClass === 'PlateLayer' && ws['B' + (xlrow + 1)].v === 'Content')
                        xlrow += this.readPlateLayerContent(ws, xlrow + 1, entity);
                }
            }
        }
    }
    getResult() {
        return { entities: this.entities };
    }
    selectWaitingEntity(entity) {
        this.selectedEntity = entity;
    }
    readNewEntity(ws, xlrow) {
        if (!ws['C' + xlrow])
            return;
        if (!this.currentClass)
            throw new Error("Please include a row with column titles before any content rows");
        let entity = { eClass: this.currentClass };
        for (let iCol = 2; iCol < this.colTitles.length; iCol++) {
            let cell = ws[this.colNames[iCol] + xlrow];
            if (!cell)
                continue;
            if (this.colTitles[iCol].startsWith('a:')) {
                if (!entity.attributes)
                    entity.attributes = {};
                entity.attributes[this.colTitles[iCol].substring(2)] = cell.v;
            }
            else if (this.colTitles[iCol] === 'tags')
                entity.tags = cell.v.split(',').map(tag => tag.trim());
            else if (this.colTitles[iCol] === 'parents')
                entity.parents = cell.v.split(',');
            else
                entity[this.colTitles[iCol]] = cell.v;
        }
        return entity;
    }
    readNewEntityClass(ws, xlrow) {
        this.currentClass = ws['B' + xlrow].v;
        this.colTitles = [];
        for (let iCol = 0; iCol < this.colNames.length; iCol++) {
            let cellTitle = ws[this.colNames[iCol] + xlrow];
            if (!cellTitle)
                break;
            let title = cellTitle.v.charAt(0).toLowerCase() + cellTitle.v.slice(1);
            if (title === 'iD')
                title = 'id';
            if (cellTitle.v === 'Parent')
                this.colTitles.push('parents');
            else
                this.colTitles.push(title);
        }
    }
    readPlateLayerContent(ws, xlrow, layer) {
        let nRows = ws['C' + (xlrow + 1)].v;
        let nCols = ws['C' + (xlrow + 2)].v;
        layer.content = { wells: [] };
        for (let iRow = 0; iRow < nRows; iRow++) {
            for (let iCol = 0; iCol < nCols; iCol++) {
                let cell = ws[this.colNames[iCol + 3] + (xlrow + iRow)];
                if (!cell)
                    continue;
                let valueDecimal = parseFloat(cell.v);
                if (valueDecimal)
                    layer.content.wells.push({
                        posRow: iRow,
                        posCol: iCol,
                        valueText: cell.w,
                        valueDecimal: valueDecimal
                    });
            }
        }
        if (nRows < 3)
            nRows = 3;
        return nRows;
    }
    getXlrowMax(ws) {
        let match = /^\w+:[A-Z]+(\d+)$/i.exec(ws['!ref']);
        if (!match)
            throw new Error('Invalid !ref info in Excel file');
        return parseInt(match[1]);
    }
};
DataLoaderExcelEntities = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["scifeonPlugin"])({
        name: 'Create entities from Excel file',
        description: 'Import data entities from Excel file',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.fileInfos.every(fileInfo => fileInfo.category === 'ExcelImport' && (fileInfo.wb.Sheets['ScirexEntities'] || fileInfo.wb.Sheets['ScifeonEntities']))
    })
], DataLoaderExcelEntities);



/***/ }),

/***/ "./SPA/module/data-upload/excel/data-loader-excel-in-vivo-results.ts":
/*!***************************************************************************!*\
  !*** ./SPA/module/data-upload/excel/data-loader-excel-in-vivo-results.ts ***!
  \***************************************************************************/
/*! exports provided: DataLoaderExcelInVivoResults */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(Promise) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderExcelInVivoResults", function() { return DataLoaderExcelInVivoResults; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");




let DataLoaderExcelInVivoResults = class DataLoaderExcelInVivoResults {
    constructor(api) {
        this.api = api;
    }
    init(context) {
        this.context = context;
    }
    getResult() {
        let setup = new _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ReadExcelCommon"]().execute(this.context.wb.Sheets['ScirexInVivoResults'], {
            a1content: 'In Vivo Results',
            detailSections: ['Results']
        });
        let studyNo = setup['Study No'];
        return new Promise((resolve, reject) => {
            this.api.datasetQuery([
                { eClass: 'Experiment', alias: 'exp', filters: [{ field: 'StudyNo', value: studyNo }] },
                { eClass: 'Step', alias: 'stepSetup', filters: [{ field: 'ExperimentID', value: '$exp.ID' }, { field: 'Type', value: 'Setup' }] },
                { eClass: 'Animal', collection: 'animals', filters: [{ field: 'OriginID', value: '$stepSetup.ID' }] }
            ]).then(dataset => {
                resolve(this.process(this.context, setup, dataset));
            }, response => {
                reject(response);
            });
        });
    }
    process(context, setup, ds) {
        let entities = [{
                eClass: 'Step',
                id: '#idStep',
                name: `${ds.exp.name}-Day-${setup.Day}`,
                experimentID: ds.exp.id,
                parentID: ds.stepSetup.id,
                type: 'InVivoResults',
                status: 'Completed',
                description: `Results, study ${ds.exp.name}, day ${setup.Day}, ${setup.Results[0].Type}`
            }, {
                eClass: 'ResultSet',
                id: '#idRS',
                type: 'InVivo-' + setup.Results[0].Type,
                status: 'Completed',
                originID: '#idStep',
                description: `Results, study ${ds.exp.name}, day ${setup.Day}, ${setup.Results[0].Type}`
            }
        ];
        for (let result of setup.Results) {
            let animal = ds.animals.find(a => a.name === result.Animal);
            entities.push({
                eClass: 'ResultAnimalValue',
                resultSetID: '#idRS',
                status: 'Completed',
                animalID: animal.id,
                groupID: animal.groupID,
                cage: animal.cage,
                type: result.Type,
                unit: result.Unit,
                day: setup.Day,
                valueDecimal: result.Value,
                valueText: result.Value
            });
        }
        return { entities: entities };
    }
};
DataLoaderExcelInVivoResults = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["scifeonPlugin"])({
        name: 'DataLoaderExcelInVivoResults',
        description: 'Import data entities from Excel file',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.category === 'ExcelImport' && context.wb.Sheets['ScirexInVivoResults']
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DataLoaderExcelInVivoResults);


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ }),

/***/ "./SPA/module/data-upload/excel/excel-standard-data-loader.ts":
/*!********************************************************************!*\
  !*** ./SPA/module/data-upload/excel/excel-standard-data-loader.ts ***!
  \********************************************************************/
/*! exports provided: ExcelStandardDataLoader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExcelStandardDataLoader", function() { return ExcelStandardDataLoader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _excel_standard_parser__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./excel-standard-parser */ "./SPA/module/data-upload/excel/excel-standard-parser.ts");
/* harmony import */ var _format_converter__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./format-converter */ "./SPA/module/data-upload/excel/format-converter.ts");
/* harmony import */ var _scifeon_data__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @scifeon/data */ "./packages/data/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");






let ExcelStandardDataLoader = class ExcelStandardDataLoader {
    constructor(dataParser, formatConverter, workflowBuilder) {
        this.dataParser = dataParser;
        this.formatConverter = formatConverter;
        this.workflowBuilder = workflowBuilder;
        this.entitiesView = () => `

    `;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.context = context;
        });
    }
    getResult() {
        return {
            entities: this.entities
        };
    }
    readFiles() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.entities = [];
            this.formatConverter.reset();
            let sheets = {};
            for (let fileInfo of this.context.fileInfos) {
                for (let ws in fileInfo.wb.Sheets) {
                    if (!sheets[ws]) {
                        sheets[ws] = fileInfo.wb.Sheets[ws];
                    }
                    else {
                        throw new Error('Duplicate sheet title: ' + ws);
                    }
                }
            }
            let sectionList = this.dataParser.parseDataSheet(sheets);
            switch (sectionList.tag) {
                case "Experiment": {
                    let WFBformat = this.formatConverter.generateExperimentTemplate(sectionList.sections);
                    if (WFBformat.samples) {
                        this.entities = this.entities.concat(WFBformat.samples);
                    }
                    if (WFBformat.resultSet) {
                        this.entities = this.entities.concat(WFBformat.resultSet);
                    }
                    const dsOut = yield this.workflowBuilder.execute(WFBformat.templates, {
                        samples: WFBformat.samples
                    });
                    this.entities = this.entities.concat(dsOut.entities);
                    break;
                }
                case "Results": {
                    if (sectionList.sections[0].resultvalues) {
                        this.entities = yield this.formatConverter.generateResultValueEntities(sectionList.sections);
                    }
                    else if (sectionList.sections[0].plate) {
                        this.entities = yield this.formatConverter.generatePlateLayerResultEntities(sectionList.sections);
                    }
                    else {
                        throw new Error("Unknown Upload type");
                    }
                    break;
                }
                default: {
                    throw new Error("Unknown type in A1: " + sectionList.tag);
                }
            }
        });
    }
};
ExcelStandardDataLoader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_5__["scifeonPlugin"])({
        name: 'ExcelStandardDataLoader',
        description: 'Imports workflows from Excel file and generates entities',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_5__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.fileInfos.some(fileInfo => fileInfo.wb.Sheets["Scifeon"])
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_excel_standard_parser__WEBPACK_IMPORTED_MODULE_2__["ExcelStandardParser"], _format_converter__WEBPACK_IMPORTED_MODULE_3__["FormatConverter"], _scifeon_data__WEBPACK_IMPORTED_MODULE_4__["WorkflowBuilder"]])
], ExcelStandardDataLoader);



/***/ }),

/***/ "./SPA/module/data-upload/excel/excel-standard-parser.ts":
/*!***************************************************************!*\
  !*** ./SPA/module/data-upload/excel/excel-standard-parser.ts ***!
  \***************************************************************/
/*! exports provided: ExcelStandardParser */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExcelStandardParser", function() { return ExcelStandardParser; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let ExcelStandardParser = class ExcelStandardParser {
    constructor(server) {
        this.server = server;
    }
    parseDataSheet(sheets, sheetName = "Scifeon") {
        let ws = sheets[sheetName];
        if (!ws) {
            throw new Error(`No ${sheetName} sheet was found`);
        }
        this.row = 1;
        this.getXlBorders(ws["!ref"]);
        this.getLettersArray();
        let sections = this.readSections(ws, "A");
        return { tag: ws["A1"].v, sections: sections };
    }
    readSections(sheet, col) {
        let section = {};
        let sections = [];
        let colIndex = this.lA.indexOf(col);
        let letters = this.lA.slice(0, colIndex);
        for (this.row; this.row < this.lastRow + 1; this.row++) {
            let cellLeftID = col + this.row;
            let cellRightID = this.lA[colIndex + 1] + this.row;
            let cellLeftValue = this.convertCell(sheet[cellLeftID], true);
            let cellRightValue = this.convertCell(sheet[cellRightID]);
            for (let letter of letters) {
                let cell = this.convertCell(sheet[letter + this.row]);
                if (cell.v) {
                    this.row--;
                    break;
                }
            }
            if (cellLeftValue.c.includes("[object]")) {
                this.row++;
                let subSections = this.readSections(sheet, this.lA[colIndex + 1]);
                section[cellLeftValue.v] = subSections;
            }
            else if (cellLeftValue.c.includes("[platelayer]")) {
                section[cellLeftValue.v] = this.readPlateLayer(sheet, this.lA[colIndex + 1]);
            }
            else if (cellLeftValue.c.includes("[array]")) {
                section[cellLeftValue.v] = this.readArray(sheet, this.lA[colIndex + 1]);
            }
            else if (cellLeftValue.c.includes("[section]")) {
                sections.push(section);
                section = {};
                section["section"] = cellLeftValue.v;
            }
            else if (cellLeftValue.v && cellRightValue.v) {
                section[cellLeftValue.v] = cellRightValue.v;
            }
        }
        sections.push(section);
        return sections;
    }
    readPlateLayer(sheet, col) {
        let wells = [];
        let colIndex = this.lA.indexOf(col);
        this.row += 2;
        let colLabels = this.row - 1;
        let prevLetters = this.lA.slice(0, colIndex);
        let nextLetters = this.lA.slice(colIndex + 1);
        let numberOfCols = nextLetters.findIndex(l => !this.convertCell(sheet[l + colLabels]).v);
        if (numberOfCols === -1) {
            numberOfCols = nextLetters.length;
        }
        if (numberOfCols === -1) {
            numberOfCols = nextLetters.length;
        }
        let rowNum = 0;
        let colNum = 0;
        for (this.row; this.row < this.lastRow + 1; this.row++) {
            if (prevLetters.some(l => this.convertCell(sheet[l + this.row]).v)) {
                this.row--;
                break;
            }
            else {
                let rowID = col + this.row;
                let rowLabel = this.convertCell(sheet[rowID]);
                if (!rowLabel.v) {
                    continue;
                }
                else {
                    for (let currentCol = colIndex + 1; currentCol < colIndex + numberOfCols + 1; currentCol++) {
                        let cellID = this.lA[currentCol] + this.row;
                        let colID = this.lA[currentCol] + colLabels;
                        let cellValue = this.convertCell(sheet[cellID]);
                        let colLabel = this.convertCell(sheet[colID]);
                        if (cellValue.v || cellValue.v === 0) {
                            wells.push({
                                posRow: rowNum,
                                posCol: colNum,
                                rowLabel: rowLabel.v,
                                colLabel: colLabel.v,
                                valueText: cellValue.v
                            });
                        }
                        colNum++;
                    }
                }
            }
            rowNum++;
            colNum = 0;
        }
        return wells;
    }
    readArray(sheet, col) {
        let samples = [];
        let sample = {};
        let colIndex = this.lA.indexOf(col);
        this.row += 2;
        let colLabels = this.row - 1;
        let prevLetters = this.lA.slice(0, colIndex);
        let nextLetters = this.lA.slice(colIndex + 1);
        let numberOfCols = nextLetters.findIndex(l => !this.convertCell(sheet[l + this.row]).v);
        if (numberOfCols === -1) {
            numberOfCols = nextLetters.length;
        }
        for (this.row; this.row < this.lastRow + 1; this.row++) {
            if (prevLetters.some(l => this.convertCell(sheet[l + this.row]).v)) {
                this.row--;
                break;
            }
            else {
                for (let currentCol = colIndex; currentCol < colIndex + numberOfCols + 1; currentCol++) {
                    let cellID = this.lA[currentCol] + this.row;
                    let colID = this.lA[currentCol] + colLabels;
                    let cellValue = this.convertCell(sheet[cellID]);
                    let colLabel = this.convertCell(sheet[colID], true);
                    if (cellValue.v || cellValue.v === 0) {
                        sample[colLabel.v] = cellValue.v;
                    }
                }
                if (Object.keys(sample).length > 0) {
                    samples.push(sample);
                    sample = {};
                }
            }
        }
        return samples;
    }
    convertCell(o, toLowerCase) {
        let v = null;
        let c = "";
        if (o) {
            v = o.v;
            if (typeof (v) === "string") {
                if (toLowerCase) {
                    v = v.replace(/\s/g, '').toLowerCase();
                }
                else {
                    v = v.replace(/\s/g, '');
                }
            }
            if (o.c) {
                if (toLowerCase) {
                    c = o.c[0].t.replace(/\s/g, '').toLowerCase();
                }
                else {
                    c = o.c[0].t.replace(/\s/g, '');
                }
            }
        }
        return { v: v, c: c };
    }
    getLettersArray() {
        let letters = [];
        let ciphers = this.lastCol.length;
        let min = 65;
        let max = 91;
        if (ciphers > 0) {
            for (let i = min; i < max; i++) {
                let c1 = String.fromCharCode(i);
                letters.push(c1);
                if (c1 === this.lastCol) {
                    break;
                }
            }
        }
        if (ciphers > 1) {
            nested: for (let i = min; i < max; i++) {
                let c1 = String.fromCharCode(i);
                for (let j = min; j < max; j++) {
                    let c2 = String.fromCharCode(j);
                    letters.push(c1 + c2);
                    if (c1 + c2 === this.lastCol) {
                        break nested;
                    }
                }
            }
        }
        if (ciphers > 2) {
            nested: for (let i = min; i < max; i++) {
                let c1 = String.fromCharCode(i);
                for (let j = min; j < max; j++) {
                    let c2 = String.fromCharCode(j);
                    for (let k = min; k < max; k++) {
                        let c3 = String.fromCharCode(k);
                        letters.push(c1 + c2 + c3);
                        if (c1 + c2 + c3 === this.lastCol) {
                            break nested;
                        }
                    }
                }
            }
        }
        this.lA = letters;
    }
    getXlBorders(ref) {
        this.lastRow = parseInt(/^\w+:[A-Z]+(\d+)$/i.exec(ref)[1]);
        this.lastCol = ref.split(":")[1].replace(/[0-9]/g, '');
    }
};
ExcelStandardParser = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], ExcelStandardParser);



/***/ }),

/***/ "./SPA/module/data-upload/excel/format-converter.ts":
/*!**********************************************************!*\
  !*** ./SPA/module/data-upload/excel/format-converter.ts ***!
  \**********************************************************/
/*! exports provided: FormatConverter */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FormatConverter", function() { return FormatConverter; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let FormatConverter = class FormatConverter {
    constructor(server) {
        this.server = server;
    }
    reset() {
        this.experiment = null;
        this.dependencies = [];
        this.samples = [];
        this.results = [];
        this.stepID = null;
    }
    generateExperimentTemplate(sections) {
        let expSection = sections.find(s => s.section === "experiment");
        this.initExperimentTemplate(expSection);
        for (let stepSection of sections.filter(s => s.section === "step")) {
            this.addStep(stepSection);
            this.addSupplemental(stepSection);
        }
        for (let unknownSection of sections.filter(s => s.section !== "step" && s.section !== "experiment")) {
            console.warn("No template for " + unknownSection.section);
        }
        return {
            templates: {
                targets: [this.experiment],
                dependencies: this.dependencies
            },
            samples: this.samples,
            resultSet: this.results
        };
    }
    generateResultValueEntities(sections) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let section = sections[0];
            if (!section.resultvalues) {
                throw new Error("Missing ResultValues section in upload file.");
            }
            this.addResults(section);
            return this.results;
        });
    }
    generatePlateLayerResultEntities(sections) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let section = sections[0];
            let entities = [];
            if (!section.step || !section.plate) {
                throw new Error("Missing step or plate property in upload file.");
            }
            let stepName = section.step;
            let plateName = section.plate;
            let result = yield this.server.datasetQuery([
                {
                    eClass: "Step", alias: "step", filters: [{ field: "Name", value: stepName }]
                },
                {
                    eClass: "Plate", entity: 'plate', filters: [{ field: "OriginID", value: "$step.id" }, { field: "Name", value: plateName }]
                }
            ]);
            if (!result) {
                throw new Error("No entities found in database.");
            }
            if (result.plate.nCols * result.plate.nRows !== section.readings.length) {
                throw new Error("plate sizes are not identical");
            }
            entities.push({
                eClass: "resultset",
                originID: result.step.id,
                id: "#idRS",
                type: "PlateLayer",
            });
            entities.push({
                eClass: 'PlateLayer',
                plateID: result.plate.id,
                resultSetID: '#idRS',
                type: section.type || 'RawData',
                content: {
                    wells: section.readings.map(w => { return { posRow: w.posRow, posCol: w.posCol, valueDecimal: parseFloat(w.valueText), valueText: String(w.valueText) }; })
                },
                description: section.description
            });
            return entities;
        });
    }
    addSupplemental(section) {
        if (section.samples) {
            this.addSamples(section);
        }
        if (section.plates) {
            this.addPlates(section);
        }
        if (section.results) {
            this.addResults(section);
        }
    }
    addStep(section) {
        this.experiment.content.steps.push({
            key: section.name,
            template: section.template || section.name,
            parent: section.parent,
        });
        let stepInfo = {
            eClass: 'Template',
            type: 'Step',
            name: section.name,
            content: {
                entityValues: {
                    type: section.type,
                    name: section.name,
                    id: "#idStep" + this.dependencies.length,
                    experimentID: section.experiment
                },
                builder: this.getBuilder(section),
                plates: []
            }
        };
        this.dependencies.push(stepInfo);
    }
    addSamples(section) {
        let samples = section.samples;
        for (let sample of samples) {
            if (!sample.name) {
                continue;
            }
            this.samples.push({
                eClass: "Sample",
                name: sample.name,
                type: sample.type || "other",
                format: sample.format || "other",
                description: sample.description,
                id: "#idsmp" + this.samples.length,
                sortIndex: this.samples.length,
            });
        }
    }
    addPlates(section) {
        let wells = section.plates[0].layout;
        wells.forEach(w => w.attributes = {});
        for (let key in section.plates[0]) {
            if (key.slice(0, 2) === "a:") {
                let wellKey = key.slice(2);
                for (let i = 0; i < wells.length; i++) {
                    let attribute = section.plates[0][key].find(a => a.posRow === wells[i].posRow && a.posCol === wells[i].posCol);
                    if (attribute) {
                        wells[i].attributes[wellKey] = attribute.valueText;
                    }
                    else {
                        wells[i].attributes[wellKey] = null;
                    }
                }
            }
        }
        this.dependencies[this.dependencies.length - 1].content.plates.push({
            entityValues: {
                name: section.name,
                type: section.type
            },
            nRows: section.plates[0].rows,
            nCols: section.plates[0].columns,
            directionIn: section.plates[0].directionin,
            directionOut: section.plates[0].directionout,
            layout: {
                wells: wells
            }
        });
    }
    addResults(section) {
        let nextSortIndex = 0;
        for (let result of section.resultvalues) {
            this.results.push({
                eClass: "ResultValue",
                subjectID: '!' + result.sample,
                subjectClass: "Sample",
                type: result.type,
                description: result.description,
                valuetext: (result.measurement || "MISSING").toString(),
                valuefloat: result.measurement,
                valuedecimal: result.measurement,
                sortIndex: nextSortIndex++
            });
        }
    }
    getBuilder(section) {
        let builder = section.builder || "Generic";
        if (!builder) {
            if (section.samples) {
                builder = "Generic";
            }
            else if (section.plates) {
                if (section.plates[0].layout) {
                    builder = "Samples2Plates";
                }
                else {
                    builder = "Plates2PlatesDirect";
                }
            }
            else {
                builder = null;
            }
        }
        return builder;
    }
    initExperimentTemplate(expSection) {
        this.experiment = {
            key: "experiment",
            eClass: "Template",
            type: "Experiment",
            name: expSection.name,
            content: {
                setup: expSection.name,
                builder: this.getBuilder(expSection),
                entityValues: {
                    type: expSection.type,
                    name: expSection.name
                },
                steps: []
            }
        };
        this.addSupplemental(expSection);
    }
};
FormatConverter = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], FormatConverter);



/***/ }),

/***/ "./SPA/module/data-upload/excel/simple-experiment-data-loader.ts":
/*!***********************************************************************!*\
  !*** ./SPA/module/data-upload/excel/simple-experiment-data-loader.ts ***!
  \***********************************************************************/
/*! exports provided: SimpleExperimentDataLoader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SimpleExperimentDataLoader", function() { return SimpleExperimentDataLoader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let SimpleExperimentDataLoader = class SimpleExperimentDataLoader {
    constructor() {
        this.entitiesView = () => `
<h2>Experiment</h2>
<div class="view-group">
    <label>Name</label>
    <p>#{experiment.name}</p>
</div>
<div class="view-group">
    <label>Type</label>
    <p>#{experiment.type}</p>
</div>
<div class="view-group">
    <label>Scientist</label>
    <p>#{experiment.scientistID}</p>
</div>
<div class="view-group">
    <label>Title</label>
    <p>#{experiment.description}</p>
</div>
<h2>Samples</h2>
<table>
    <thead>
        <tr>
            <th>Name</th>
            <th>Type</th>
            <th>Content</th>
        </tr>
    </thead>
    <tbody>
        <tr repeat.for="smp of content.Samples">
            <td>#{smp.Name}</td>
            <td>#{smp.Type}</td>
            <td>#{smp.Content}</td>
        </tr>
    </tbody>
</table>

<h2>Results</h2>
<table>
    <thead>
        <tr>
            <th>Sample</th>
            <th>Type</th>
            <th>Value</th>
        </tr>
    </thead>
    <tbody>
        <tr repeat.for="res of content.Results">
            <td>#{res.Sample}</td>
            <td>#{res.Type}</td>
            <td>#{res.Value}</td>
        </tr>
    </tbody>
</table>
`;
    }
    init(context) {
        this.context = context;
    }
    readFiles() {
        const sheetName = 'Experiment';
        const sheetTitle = 'Experiment';
        for (let fileInfo of this.context.fileInfos) {
            let ws = fileInfo.wb.Sheets[sheetName];
            if (!ws)
                throw new Error('Missing "Experiment" worksheet');
            if (!(ws['A1'] && ws['A1'].v === sheetTitle))
                throw new Error('Missing "Experiment" in A1');
            this.content = new _scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ReadExcelCommon"]().execute(ws, {
                a1content: sheetTitle,
            });
            this.experiment = this.prepareExperimentEntity();
            let stepEntity = this.prepareStepEntity();
            let sampleEntity = this.prepareSampleEntity();
            let resultSetEntity = this.prepareResultSetEntity();
            let resultEntity = this.prepareResultValueEntity();
            this.entities = [this.experiment]
                .concat(stepEntity)
                .concat(sampleEntity)
                .concat(resultSetEntity)
                .concat(resultEntity);
        }
    }
    getResult() {
        return { entities: this.entities };
    }
    prepareExperimentEntity() {
        let exp = {};
        exp.eClass = 'experiment';
        exp.name = this.content.Name || this.content.Project;
        exp.type = this.content.Type || this.content.type;
        exp.description = this.content.Title;
        exp.id = '#idExp';
        exp.scientistID = this.content.scientist || this.content.Scientist;
        exp.analystID = this.content.analyst || this.content.Analyst;
        return exp;
    }
    prepareStepEntity() {
        let step = {};
        step.eClass = 'step';
        step.experimentID = '#idExp';
        step.type = this.content.type || this.content.Type;
        step.id = '#idStep';
        if (this.content['Date Started']) {
            step.dateStarted = this.content['Date Started'];
        }
        if (this.content['Date Completed']) {
            step.dateCompleted = this.content['Date Completed'];
        }
        return step;
    }
    prepareSampleEntity() {
        let samples = [];
        let counter = 0;
        for (let current of this.content['Samples'] || this.content['samples']) {
            let sample = {};
            sample.eClass = 'sample';
            sample.format = current.format || current.Format || 'unknown';
            sample.id = '#id' + 'smp' + counter;
            sample.sortIndex = counter + 1;
            sample.type = current.Type || current.type;
            sample.name = current.Name || current.name;
            counter++;
            samples.push(sample);
        }
        return samples;
    }
    prepareResultSetEntity() {
        let resultSet = {};
        resultSet.eClass = 'resultset';
        resultSet.id = '#idRS';
        resultSet.originID = '#idStep';
        return resultSet;
    }
    prepareResultValueEntity() {
        let results = [];
        let counter = 0;
        for (let current of this.content['Results'] || this.content['results']) {
            let result = {};
            result.eClass = 'resultvalue';
            result.resultSetID = '#idRS';
            result.id = '#IDRes' + counter;
            result.type = current.Type || current.type || 'unknown';
            result.name = current.Name || current.name || 'unknown';
            result.valuetext = (current.Value || current.value).toString();
            result.valuefloat = current.Value || current.value;
            result.valuedecimal = current.Value || current.value;
            result.subjectID = '#idRS';
            result.subjectClass = 'ResultSet';
            counter++;
            results.push(result);
        }
        return results;
    }
};
SimpleExperimentDataLoader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["scifeonPlugin"])({
        name: 'Simple Experiment Excel file importer',
        description: 'Imports Excel files to entity format',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.fileInfos[0].wb && context.fileInfos[0].wb.Sheets['Experiment']
    })
], SimpleExperimentDataLoader);



/***/ }),

/***/ "./SPA/module/eln/renderers/default-result-renderer.ts":
/*!*************************************************************!*\
  !*** ./SPA/module/eln/renderers/default-result-renderer.ts ***!
  \*************************************************************/
/*! exports provided: DefaultResultRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DefaultResultRenderer", function() { return DefaultResultRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let DefaultResultRenderer = class DefaultResultRenderer {
    constructor(server) {
        this.server = server;
        this.loading = true;
    }
    static isMatch(context) {
        return context.position === 'eln.step.results';
    }
    view(context) {
        return `
            <template>
                <h2>Default Result View</h2>
                <table>
                  <thead>
                    <tr>
                      <th>Sample</th>
                      <th>Type</th>
                      <th>Value</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr repeat.for="result of results">
                      <td>#{result.subjectID}</td>
                      <td>#{result.type}</td>
                      <td>#{result.resultText}</td>
                    </tr>
                  </tbody>
                </table>
            </template>
        `;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.context = context;
            this.server.get('/api/query/view/ResultIndex?$filter=ResultSetID eq \'' + this.context.resultSet.id + '\'')
                .then(response => response.json())
                .then(response => {
                this.results = response.data;
            });
        });
    }
};
DefaultResultRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DefaultResultRenderer);



/***/ }),

/***/ "./SPA/module/eln/renderers/setup-renderer-default.ts":
/*!************************************************************!*\
  !*** ./SPA/module/eln/renderers/setup-renderer-default.ts ***!
  \************************************************************/
/*! exports provided: DefaultSetupRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DefaultSetupRenderer", function() { return DefaultSetupRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let DefaultSetupRenderer = class DefaultSetupRenderer {
    constructor(server) {
        this.server = server;
        this.loading = true;
    }
    static isMatch(context) {
        return context.experiment && context.step;
    }
    view(context) {
        return `
            <template if.bind="plates.length > 0">
                <h2>Output Plates</h2>
                <table>
                <thead>
                    <tr>
                    <th>Name</th>
                    <th>Type</th>
                    <th>NRows</th>
                    <th>NCols</th>
                    </tr>
                </thead>
                <tbody>
                    <tr repeat.for="plate of plates">
                    <td><a href='/#/entity/Plate/\${plate.id}'>\${plate.name}</td>
                    <td>\${plate.type}</td>
                    <td>\${plate.nRows}</td>
                    <td>\${plate.nCols}</td>
                    </tr>
                </tbody>
                </table>
            </template>
        `;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.context = context;
            this.plates = context.plates.filter(p => p.originID === context.step.id);
        });
    }
};
DefaultSetupRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], DefaultSetupRenderer);



/***/ }),

/***/ "./SPA/module/in-vivo/data-loader-register-animals.ts":
/*!************************************************************!*\
  !*** ./SPA/module/in-vivo/data-loader-register-animals.ts ***!
  \************************************************************/
/*! exports provided: DataLoaderRegisterAnimals */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderRegisterAnimals", function() { return DataLoaderRegisterAnimals; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



let DataLoaderRegisterAnimals = class DataLoaderRegisterAnimals {
    init(context) {
        this.context = context;
    }
    getResult() {
        let setup = new _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ReadExcelCommon"]().execute(this.context.wb.Sheets['ScirexRegisterAnimals'], {
            a1content: 'Register Animals',
            detailSections: ['Animal Groups']
        });
        return { entities: this.createEntities(setup) };
    }
    createEntities(setup) {
        let entities = [];
        let studyNo = setup['Study No'];
        entities.push({
            eClass: 'Experiment',
            id: '#idExp',
            name: studyNo,
            studyNo: studyNo,
            type: setup['Type'],
            scientistID: setup.Scientist,
            analystID: setup.Analyst,
            departmentID: setup.Department,
            description: `In vivo ${setup['Type']} study ${studyNo}`
        });
        entities.push({
            eClass: 'Step',
            id: '#idStep',
            name: `Animals-${studyNo}`,
            experimentID: '#idExp',
            type: 'RegisterAnimals',
            analystID: setup.Analyst,
            description: setup.Title
        });
        let animalNo = 1;
        for (let group of setup['Animal Groups']) {
            group.Name = group.Name.toString();
            entities.push({
                eClass: 'AnimalGroup',
                id: '#idGroup' + group.Name,
                type: group.type,
                name: group.Name,
                originID: '#idStep',
                description: `Study ${studyNo}, group ${group.Name}`
            });
            for (let i = 0; i < group.Animals; i++) {
                entities.push({
                    eClass: 'Animal',
                    groupID: '#idGroup' + group.Name,
                    type: 'Mouse',
                    name: animalNo,
                    originID: '#idStep',
                    description: `Study ${studyNo}, group ${group.Name}`
                });
                animalNo++;
            }
        }
        return entities;
    }
};
DataLoaderRegisterAnimals = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'DataLoaderRegisterAnimals',
        description: 'Register Animals for In Vivo Study',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.category == 'ExcelImport' && context.wb.Sheets['ScirexRegisterAnimals']
    })
], DataLoaderRegisterAnimals);



/***/ }),

/***/ "./SPA/module/pns/data-loaders/data-loader-batch-content.js":
/*!******************************************************************!*\
  !*** ./SPA/module/pns/data-loaders/data-loader-batch-content.js ***!
  \******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DataLoaderBatchContent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _core = __webpack_require__(/*! scifeon/core */ "./SPA/scifeon/core.ts");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataLoaderBatchContent = exports.DataLoaderBatchContent = function () {
    function DataLoaderBatchContent() {
        _classCallCheck(this, DataLoaderBatchContent);

        this.description = 'Import data entities from Excel file';
        this.sheetName = 'ScirexBatchContent';
    }

    _createClass(DataLoaderBatchContent, [{
        key: 'init',
        value: function init(context) {
            this.context = context;
        }
    }, {
        key: 'getResult',
        value: function getResult() {
            this.content = new _core.ReadExcelCommon().execute(this.context.wb.Sheets[this.sheetName], {
                a1content: 'Upload Batch',
                detailSections: ['Compounds']
            });

            var entities = this.createEntities();

            return { entities: entities };
        }
    }, {
        key: 'createEntities',
        value: function createEntities() {
            var entities = [{
                eClass: 'Batch',
                name: this.content.Name,
                preparedBy: this.content['Prepared by'],
                preparedDate: this.content['Prepared date'],
                attributes: {
                    solvent: this.content.Solvent,
                    initialVolume_ml: this.content.InitialVolume_ml
                },
                description: this.content.Description,
                batchContents: []
            }];

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.content.Compounds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var compound = _step.value;

                    entities[0].batchContents.push({
                        compoundID: '?' + compound.Name,
                        conc: compound.Conc,
                        concUnit: compound.ConcUnit,
                        attributes: {
                            targetConc_mM: compound.TargetConc_mM,
                            targetWeight_mg: compound.TargetWeight_mg,
                            actualWeight_mg: compound.ActualWeight_mg
                        }
                    });
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return entities;
        }
    }], [{
        key: 'isMatch',
        value: function isMatch(context) {

            return context.category === 'ExcelImport' && context.wb.Sheets[this.sheetName];
        }
    }]);

    return DataLoaderBatchContent;
}();

/***/ }),

/***/ "./SPA/module/shoppingcart/shopping-cart.js":
/*!**************************************************!*\
  !*** ./SPA/module/shoppingcart/shopping-cart.js ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ShoppingCart = exports.ShoppingCart = function () {
    function ShoppingCart() {
        _classCallCheck(this, ShoppingCart);

        if (localStorage.getItem('scirex-shopping-cart')) this.entities = JSON.parse(localStorage.getItem('scirex-shopping-cart'));else this.entities = [];
    }

    _createClass(ShoppingCart, [{
        key: 'add',
        value: function add(entity) {
            var eClass = entity.eClass.toLowerCase();
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.entities[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var e = _step.value;

                    if (e.eClass.toLowerCase() === eClass && e.id === entity.id) return;
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            this.entities.push(entity);

            this.save();
        }
    }, {
        key: 'clear',
        value: function clear() {
            this.entities = [];
            this.save();
        }
    }, {
        key: 'remove',
        value: function remove(eClass, id) {
            this.entities = this.entities.filter(function (e) {
                return e.eClass !== eClass || e.id !== id;
            });
            this.save();
        }
    }, {
        key: 'save',
        value: function save() {
            localStorage.setItem('scirex-shopping-cart', JSON.stringify(this.entities));
        }
    }]);

    return ShoppingCart;
}();

/***/ }),

/***/ "./SPA/module/wfm/data-loaders/data-loader-step-create.js":
/*!****************************************************************!*\
  !*** ./SPA/module/wfm/data-loaders/data-loader-step-create.js ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DataLoaderStepCreate = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _core = __webpack_require__(/*! scifeon/core */ "./SPA/scifeon/core.ts");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataLoaderStepCreate = exports.DataLoaderStepCreate = function () {
    function DataLoaderStepCreate(api) {
        _classCallCheck(this, DataLoaderStepCreate);

        this.api = api;
        this.description = 'Import step setup info from an Excel file';
    }

    _createClass(DataLoaderStepCreate, [{
        key: 'init',
        value: function init(context) {
            this.context = context;
        }
    }, {
        key: 'getResult',
        value: function getResult() {
            var setup = new _core.ReadExcelCommon().execute(this.context.wb.Sheets['ScirexStep'], {
                a1content: 'Setup a Plate Transfer Step',
                detailSections: ['Plate Transfer']
            });

            var entities = [];

            var step = this.addStepAndExperiment(setup, entities);
            this.addTransfers(setup, entities, step);

            return { entities: entities };
        }
    }, {
        key: 'addTransfers',
        value: function addTransfers(setup, entities, step) {
            var plates = {};

            var nextRank = 0;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = setup['Plate Transfer'][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var transfer = _step.value;

                    step.input.push({ eClass: 'Sample', id: transfer.Sample, rank: nextRank }); // TODO: Support lookups of name or barcode

                    var outputPlate = plates[transfer['Output Plate']];
                    if (!outputPlate) {
                        outputPlate = {
                            eClass: 'Plate',
                            id: '#idPlate' + transfer['Output Plate'],
                            originID: '#idStep',
                            type: setup['Output Type'],
                            nRows: 8, // TODO: Support for different sizes
                            nCols: 12,
                            format: 'Plate'
                        };
                        plates[transfer['Output Plate']] = outputPlate;
                        entities.push(outputPlate);
                    }

                    entities.push({
                        eClass: 'Sample',
                        type: setup['Output Type'],
                        parentID: transfer.Sample,
                        format: 'Well',
                        originID: '#idStep',
                        originRank: nextRank,
                        plateID: outputPlate.id,
                        posRow: transfer['Output Row'],
                        posCol: transfer['Output Col']
                    });
                    nextRank++;
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'addStepAndExperiment',
        value: function addStepAndExperiment(setup, entities) {

            entities.push({
                eClass: 'Experiment',
                id: '#idExp',
                type: setup['Experiment Type'],
                name: setup['Experiment Name'],
                status: 'Initial',
                scientistID: setup['Scientist'],
                analystID: setup['Analyst']
            });

            var step = {
                eClass: 'Step',
                id: '#idStep',
                experimentID: '#idExp',
                type: setup['Step Type'],
                name: setup['Step Name'],
                analystID: setup['Analyst'],
                input: []
            };

            entities.push(step);

            return step;
        }
    }], [{
        key: 'isMatch',
        value: function isMatch(context) {
            return context.category === 'ExcelImport' && context.wb.Sheets['ScirexStep'];
        }
    }]);

    return DataLoaderStepCreate;
}();

/***/ }),

/***/ "./SPA/scifeon/core.ts":
/*!*****************************!*\
  !*** ./SPA/scifeon/core.ts ***!
  \*****************************/
/*! exports provided: ExcelStandardParser, PrismBuilder */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var module_assaydm_prism_prism_builder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! module/assaydm/prism/prism-builder */ "./SPA/module/assaydm/prism/prism-builder.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "PrismBuilder", function() { return module_assaydm_prism_prism_builder__WEBPACK_IMPORTED_MODULE_0__["PrismBuilder"]; });

/* harmony import */ var module_data_upload_excel_excel_standard_parser__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! module/data-upload/excel/excel-standard-parser */ "./SPA/module/data-upload/excel/excel-standard-parser.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "ExcelStandardParser", function() { return module_data_upload_excel_excel_standard_parser__WEBPACK_IMPORTED_MODULE_1__["ExcelStandardParser"]; });





/***/ }),

/***/ "./SPA/services/router-steps/app-insights-step.ts":
/*!********************************************************!*\
  !*** ./SPA/services/router-steps/app-insights-step.ts ***!
  \********************************************************/
/*! exports provided: AppInsightsStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppInsightsStep", function() { return AppInsightsStep; });
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_0__);

class AppInsightsStep {
    constructor() {
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_0__["LogManager"].getLogger('AppInsights');
        if (window.location.hostname !== 'localhost' && window['appInsights']) {
            this.client = window['appInsights'];
        }
        else {
            this.logger.debug('AppInsights not loaded.');
        }
    }
    run(routingContext, next) {
        if (this.client) {
            if (routingContext.previousInstruction) {
                this.client.stopTrackPage(routingContext.previousInstruction.fragment, window.location.href);
            }
            else {
                this.client.trackPageView(routingContext.fragment, window.location.href);
            }
            this.logger.debug('Tracking page view:', routingContext.fragment);
            this.client.startTrackPage(routingContext.fragment);
        }
        return next();
    }
}


/***/ }),

/***/ "./SPA/services/router-steps/authorize-step.ts":
/*!*****************************************************!*\
  !*** ./SPA/services/router-steps/authorize-step.ts ***!
  \*****************************************************/
/*! exports provided: AuthorizeStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AuthorizeStep", function() { return AuthorizeStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var module_app_dev_bar__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! module/app/dev-bar */ "module/app/dev-bar");





let AuthorizeStep = class AuthorizeStep {
    constructor(user) {
        this.user = user;
    }
    run(navigationInstruction, next) {
        module_app_dev_bar__WEBPACK_IMPORTED_MODULE_4__["DevBar"].instance.route = navigationInstruction;
        if (navigationInstruction.getAllInstructions().some(i => i.config.settings
            && i.config.settings.roles
            && !this.user.hasOneOfRoles(...i.config.settings.roles))) {
            return next.cancel(new aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Redirect"]('no-access'));
        }
        else {
            return next();
        }
    }
};
AuthorizeStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], AuthorizeStep);



/***/ }),

/***/ "./SPA/services/router-steps/close-all-dialogs-step.ts":
/*!*************************************************************!*\
  !*** ./SPA/services/router-steps/close-all-dialogs-step.ts ***!
  \*************************************************************/
/*! exports provided: CloseAllDialogsStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CloseAllDialogsStep", function() { return CloseAllDialogsStep; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-dialog */ "aurelia-dialog");
/* harmony import */ var aurelia_dialog__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__);



let CloseAllDialogsStep = class CloseAllDialogsStep {
    constructor(dialog) {
        this.dialog = dialog;
    }
    run(navigationInstruction, next) {
        this.dialog.closeAll();
        return next();
    }
};
CloseAllDialogsStep = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_dialog__WEBPACK_IMPORTED_MODULE_2__["DialogService"]])
], CloseAllDialogsStep);



/***/ }),

/***/ "./SPA/services/router-steps/loading-steps.ts":
/*!****************************************************!*\
  !*** ./SPA/services/router-steps/loading-steps.ts ***!
  \****************************************************/
/*! exports provided: LoadingAuthorizeStep, LoadingPreActivateStep, LoadingPreRenderStep, LoadingPostRenderStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingAuthorizeStep", function() { return LoadingAuthorizeStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreActivateStep", function() { return LoadingPreActivateStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPreRenderStep", function() { return LoadingPreRenderStep; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadingPostRenderStep", function() { return LoadingPostRenderStep; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! nprogress */ "./node_modules/nprogress/nprogress.js");
/* harmony import */ var nprogress__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(nprogress__WEBPACK_IMPORTED_MODULE_1__);


class LoadingAuthorizeStep {
    constructor() {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["configure"]({ showSpinner: false });
    }
    run(routingContext, next) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true);
        nprogress__WEBPACK_IMPORTED_MODULE_1__["start"]();
        return next();
    }
}
class LoadingPreActivateStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.2);
        return next();
    }
}
class LoadingPreRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["set"](0.6);
        return next();
    }
}
class LoadingPostRenderStep {
    run(routingContext, next) {
        nprogress__WEBPACK_IMPORTED_MODULE_1__["done"]();
        return next();
    }
}


/***/ }),

/***/ "./SPA/services/router-steps/reset-help-context-url-step.ts":
/*!******************************************************************!*\
  !*** ./SPA/services/router-steps/reset-help-context-url-step.ts ***!
  \******************************************************************/
/*! exports provided: ResetHelpContextUrlStep */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResetHelpContextUrlStep", function() { return ResetHelpContextUrlStep; });
/* harmony import */ var _help__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../help */ "./SPA/services/help.js");
/* harmony import */ var _help__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_help__WEBPACK_IMPORTED_MODULE_0__);

class ResetHelpContextUrlStep {
    run(navigationInstruction, next) {
        _help__WEBPACK_IMPORTED_MODULE_0__["Help"].ContextUrl = '';
        return next();
    }
}


/***/ }),

/***/ "./node_modules/nprogress/nprogress.js":
/*!*****************************************************************************************!*\
  !*** delegated ./node_modules/nprogress/nprogress.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/nprogress/nprogress.js");

/***/ }),

/***/ "./packages/data/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/data/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: WorkflowBuilder */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/data/index.ts");

/***/ }),

/***/ "app":
/*!*********************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/app.ts ***!
  \*********************************************************/
/*! exports provided: App */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "App", function() { return App; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var entity_plugins_step_in_vivo_results_renderer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! entity/plugins/step/in-vivo-results-renderer */ "./SPA/entity/plugins/step/in-vivo-results-renderer.ts");
/* harmony import */ var entity_plugins_step_in_vivo_setup_renderer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! entity/plugins/step/in-vivo-setup-renderer */ "./SPA/entity/plugins/step/in-vivo-setup-renderer.ts");
/* harmony import */ var entity_plugins_step_plate_assay_results_renderer__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! entity/plugins/step/plate-assay-results-renderer */ "./SPA/entity/plugins/step/plate-assay-results-renderer.ts");
/* harmony import */ var entity_plugins_step_plate_assay_setup_renderer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! entity/plugins/step/plate-assay-setup-renderer */ "./SPA/entity/plugins/step/plate-assay-setup-renderer.ts");
/* harmony import */ var entity_plugins_template_samples2plates_panel__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! entity/plugins/template/samples2plates-panel */ "./SPA/entity/plugins/template/samples2plates-panel.ts");
/* harmony import */ var module_assaydm_assays_generic__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! module/assaydm/assays/generic */ "./SPA/module/assaydm/assays/generic.js");
/* harmony import */ var module_assaydm_assays_generic__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(module_assaydm_assays_generic__WEBPACK_IMPORTED_MODULE_10__);
/* harmony import */ var module_data_upload_excel_data_loader_excel_entities__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! module/data-upload/excel/data-loader-excel-entities */ "./SPA/module/data-upload/excel/data-loader-excel-entities.ts");
/* harmony import */ var module_data_upload_excel_data_loader_excel_in_vivo_results__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! module/data-upload/excel/data-loader-excel-in-vivo-results */ "./SPA/module/data-upload/excel/data-loader-excel-in-vivo-results.ts");
/* harmony import */ var module_data_upload_excel_excel_standard_data_loader__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! module/data-upload/excel/excel-standard-data-loader */ "./SPA/module/data-upload/excel/excel-standard-data-loader.ts");
/* harmony import */ var module_data_upload_excel_simple_experiment_data_loader__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! module/data-upload/excel/simple-experiment-data-loader */ "./SPA/module/data-upload/excel/simple-experiment-data-loader.ts");
/* harmony import */ var module_eln_renderers_default_result_renderer__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! module/eln/renderers/default-result-renderer */ "./SPA/module/eln/renderers/default-result-renderer.ts");
/* harmony import */ var module_eln_renderers_setup_renderer_default__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! module/eln/renderers/setup-renderer-default */ "./SPA/module/eln/renderers/setup-renderer-default.ts");
/* harmony import */ var module_in_vivo_data_loader_register_animals__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! module/in-vivo/data-loader-register-animals */ "./SPA/module/in-vivo/data-loader-register-animals.ts");
/* harmony import */ var module_pns_data_loaders_data_loader_batch_content__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! module/pns/data-loaders/data-loader-batch-content */ "./SPA/module/pns/data-loaders/data-loader-batch-content.js");
/* harmony import */ var module_pns_data_loaders_data_loader_batch_content__WEBPACK_IMPORTED_MODULE_18___default = /*#__PURE__*/__webpack_require__.n(module_pns_data_loaders_data_loader_batch_content__WEBPACK_IMPORTED_MODULE_18__);
/* harmony import */ var module_wfm_data_loaders_data_loader_step_create__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! module/wfm/data-loaders/data-loader-step-create */ "./SPA/module/wfm/data-loaders/data-loader-step-create.js");
/* harmony import */ var module_wfm_data_loaders_data_loader_step_create__WEBPACK_IMPORTED_MODULE_19___default = /*#__PURE__*/__webpack_require__.n(module_wfm_data_loaders_data_loader_step_create__WEBPACK_IMPORTED_MODULE_19__);
/* harmony import */ var _module_assaydm_setup__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./module/assaydm/setup */ "./SPA/module/assaydm/setup.ts");
/* harmony import */ var _services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./services/router-steps/app-insights-step */ "./SPA/services/router-steps/app-insights-step.ts");
/* harmony import */ var _services_router_steps_authorize_step__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./services/router-steps/authorize-step */ "./SPA/services/router-steps/authorize-step.ts");
/* harmony import */ var _services_router_steps_close_all_dialogs_step__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./services/router-steps/close-all-dialogs-step */ "./SPA/services/router-steps/close-all-dialogs-step.ts");
/* harmony import */ var _services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./services/router-steps/loading-steps */ "./SPA/services/router-steps/loading-steps.ts");
/* harmony import */ var _services_router_steps_reset_help_context_url_step__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./services/router-steps/reset-help-context-url-step */ "./SPA/services/router-steps/reset-help-context-url-step.ts");



























let App = class App {
    constructor(router, pluginManager, server, appLoader, dataModel) {
        this.router = router;
        this.appLoader = appLoader;
        this.dataModel = dataModel;
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].getLogger('App');
        this.loadInternalPlugins(pluginManager);
        this.moduleSetup = [new _module_assaydm_setup__WEBPACK_IMPORTED_MODULE_20__["AssayDMSetup"]()];
        for (let setup of this.moduleSetup)
            setup.setup(server, pluginManager);
        appLoader.loadSdkApps();
        this.loadRoutes();
    }
    loadRoutes() {
        for (const app of this.appLoader.enabledApps().filter(app => app.scifeon.scopes.includes(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ROUTES))) {
            for (const route of app.scifeon.contributions.routes) {
                const urls = Array.isArray(route.route) ? route.route : [route.route];
                for (const url of urls) {
                    this.logger.debug(`Loading route '${url}' from App '${app.namespace}.${app.name}'.`);
                    let routeConfig = {
                        route: url,
                        name: route.id,
                        moduleId: 'services/app/page-plugin',
                        title: route.title,
                        settings: { pageId: route.pageId, app: app, roles: route.roles }
                    };
                    if (route.type === _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].DATA_ADMINISTRATION) {
                        routeConfig.moduleId = 'services/app/data-admin-page-plugin';
                    }
                    else if (route.type === _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION) {
                        routeConfig.moduleId = 'services/app/admin-page-plugin';
                    }
                    this.router.addRoute(routeConfig);
                }
            }
        }
    }
    loadInternalPlugins(pluginManager) {
        pluginManager.add(module_data_upload_excel_data_loader_excel_entities__WEBPACK_IMPORTED_MODULE_11__["DataLoaderExcelEntities"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_pns_data_loaders_data_loader_batch_content__WEBPACK_IMPORTED_MODULE_18__["DataLoaderBatchContent"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_data_upload_excel_data_loader_excel_in_vivo_results__WEBPACK_IMPORTED_MODULE_12__["DataLoaderExcelInVivoResults"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_wfm_data_loaders_data_loader_step_create__WEBPACK_IMPORTED_MODULE_19__["DataLoaderStepCreate"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_in_vivo_data_loader_register_animals__WEBPACK_IMPORTED_MODULE_17__["DataLoaderRegisterAnimals"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_data_upload_excel_simple_experiment_data_loader__WEBPACK_IMPORTED_MODULE_14__["SimpleExperimentDataLoader"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(module_data_upload_excel_excel_standard_data_loader__WEBPACK_IMPORTED_MODULE_13__["ExcelStandardDataLoader"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER]);
        pluginManager.add(entity_plugins_step_plate_assay_setup_renderer__WEBPACK_IMPORTED_MODULE_8__["PlateAssaySetupRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(entity_plugins_step_plate_assay_results_renderer__WEBPACK_IMPORTED_MODULE_7__["PlateAssayResultsRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(entity_plugins_step_in_vivo_setup_renderer__WEBPACK_IMPORTED_MODULE_6__["InVivoSetupRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(entity_plugins_step_in_vivo_results_renderer__WEBPACK_IMPORTED_MODULE_5__["InVivoResultsRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(module_eln_renderers_setup_renderer_default__WEBPACK_IMPORTED_MODULE_16__["DefaultSetupRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(module_eln_renderers_default_result_renderer__WEBPACK_IMPORTED_MODULE_15__["DefaultResultRenderer"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL]);
        pluginManager.add(module_assaydm_assays_generic__WEBPACK_IMPORTED_MODULE_10__["PlateAssayGeneric"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ASSAY_DEFINITION]);
        pluginManager.add(entity_plugins_template_samples2plates_panel__WEBPACK_IMPORTED_MODULE_9__["Samples2PlatesPanelPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].JSON_FIELD_EDITOR]);
        pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["KVPJsonFieldPanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], {
            columns: [
                {
                    name: 'processStep',
                    type: 'string',
                    form: {
                        label: 'Process Step',
                        isRequired: true
                    }
                }
            ],
            entityType: 'TestSample',
            eClass: 'Sample',
            field: 'attributes'
        });
        pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["KVPJsonFieldPanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], {
            columns: [
                {
                    name: 'expectedTiter',
                    type: 'string',
                    form: {
                        label: 'Expected Titer',
                        isRequired: true
                    }
                },
            ],
            entityType: 'TestSample',
            eClass: 'Sample',
            name: 'Expected Titer Editor',
            field: 'attributes'
        });
    }
    activate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.dataModel.load();
        });
    }
    configureRouter(config, router) {
        config.title = 'scifeon';
        config.addAuthorizeStep(_services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_24__["LoadingAuthorizeStep"]);
        config.addPreActivateStep(_services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_24__["LoadingPreActivateStep"]);
        config.addPreRenderStep(_services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_24__["LoadingPreRenderStep"]);
        config.addPostRenderStep(_services_router_steps_loading_steps__WEBPACK_IMPORTED_MODULE_24__["LoadingPostRenderStep"]);
        config.addAuthorizeStep(_services_router_steps_authorize_step__WEBPACK_IMPORTED_MODULE_22__["AuthorizeStep"]);
        config.addPreActivateStep(_services_router_steps_reset_help_context_url_step__WEBPACK_IMPORTED_MODULE_25__["ResetHelpContextUrlStep"]);
        config.addPreActivateStep(_services_router_steps_close_all_dialogs_step__WEBPACK_IMPORTED_MODULE_23__["CloseAllDialogsStep"]);
        config.addAuthorizeStep(_services_router_steps_app_insights_step__WEBPACK_IMPORTED_MODULE_21__["AppInsightsStep"]);
        let configMap = [
            { route: ['', 'dashboard/:id'], name: 'Dashboard', moduleId: 'module/dashboard/index', title: 'Dashboard' },
            { route: ['no-access'], name: 'NoAccess', moduleId: 'module/app/no-access', title: 'Home' },
            { route: ['user/profile'], name: 'UserProfile', moduleId: 'module/user/profile', title: 'User Profile' },
            { route: ['login'], name: 'Login', moduleId: 'module/public/user/login', title: 'Login' },
            { route: ['spreadsheet', 'spreadsheet/query'], name: 'Spreadsheet', moduleId: 'module/spreadsheet/query', title: 'Spreadsheet' },
            { route: ['spreadsheet/work'], name: 'Spreadsheet', moduleId: 'module/spreadsheet/index', title: 'Spreadsheet' },
            { route: ['spreadsheet/export'], name: 'Spreadsheet', moduleId: 'module/spreadsheet/export', title: 'Spreadsheet' },
            { route: ['entity/browse'], name: 'EntityBrowse', moduleId: 'entity/browse', title: 'Browse' },
            { route: ['entity/:eClass', 'entity/:eClass/list'], name: 'GenericList', moduleId: 'entity/list', title: 'List' },
            { route: ['request/create'], name: 'RequestCreate', moduleId: 'module/request/create', title: 'Create Request' },
            { route: ['entity/batch/create'], name: 'BatchCreate', moduleId: 'entity/edit/batch-edit', title: 'Create Batch' },
            { route: ['entity/batch/edit/:id'], name: 'BatchEdit', moduleId: 'entity/edit/batch-edit', title: 'Edit Batch' },
            { route: ['entity/collection/create'], name: 'CollectionCreate', moduleId: 'entity/edit/collection-edit', title: 'Create Collection' },
            { route: ['entity/collection/edit/:id'], name: 'CollectionEdit', moduleId: 'entity/edit/collection-edit', title: 'Edit Collection' },
            { route: ['entity/compound/create'], name: 'CompoundCreate', moduleId: 'entity/edit/compound-edit', title: 'Create Compound' },
            { route: ['entity/compound/edit/:id'], name: 'CompoundEdit', moduleId: 'entity/edit/compound-edit', title: 'Edit Compound' },
            { route: ['eln/step-setup/:id'], name: 'ELNStepSetup', moduleId: 'module/eln/pages/step-setup', title: 'Experiment' },
            { route: ['eln/add-step'], name: 'ELNAddStep', moduleId: 'module/eln/pages/add-step', title: 'AddStep' },
            { route: ['eln/create-step-template'], name: 'ELNCreateStepTemplate', moduleId: 'module/eln/pages/edit-step-template', title: 'Step Template' },
            { route: ['entity/experiment/:id', 'eln/:id'], name: 'ELNPage', moduleId: 'module/eln/index', title: 'ELN' },
            { route: ['entity/plasmid/create'], name: 'PlasmidCreate', moduleId: 'entity/edit/plasmid-edit', title: 'Create Plasmid' },
            { route: ['entity/plasmid/edit/:id'], name: 'PlasmidEdit', moduleId: 'entity/edit/plasmid-edit', title: 'Edit Plasmid' },
            { route: ['entity/plate/create'], name: 'PlateCreate', moduleId: 'entity/edit/plate-create', title: 'Create Plate' },
            { route: ['entity/plate/clone/:id'], name: 'PlateClone', moduleId: 'entity/edit/plate-clone', title: 'Clone Plate' },
            { route: ['entity/sample/clone/:id'], name: 'SampleClone', moduleId: 'entity/edit/sample-clone', title: 'Clone Sample' },
            { route: ['entity/sample/clone'], name: 'SampleClone', moduleId: 'entity/edit/sample-clone', title: 'Clone Sample' },
            { route: ['entity/sample/create'], name: 'SampleCreate', moduleId: 'entity/edit/sample-create', title: 'Create Sample' },
            { route: ['entity/sample/edit/:id'], name: 'SampleEdit', moduleId: 'entity/edit/sample-edit', title: 'Edit Sample' },
            { route: ['entity/:eClass/:id'], name: 'EntityDetail', moduleId: 'entity/detail', title: 'Entity Detail' },
            { route: ['module/data-upload'], name: 'DataUpload', moduleId: 'module/data-upload/index', title: 'Data Upload' },
            { route: ['module/data-upload/visual-data-loader'], name: 'DataUploadVisual', moduleId: 'module/data-upload/visual-data-loader', title: 'Visual Data Loader' },
            { route: ['module/pns/step-create-cherry-pick'], name: 'CreateStepCherryPick', moduleId: 'module/pns/step-create-cherry-pick', title: 'Cherry Pick Step' },
            { route: ['module/pns/step-create-plate-transfer'], name: 'CreateStepPlateTransfer', moduleId: 'module/pns/step-create-plate-transfer', title: 'Plate Transfer Step' },
            { route: ['module/shoppingcart'], name: 'ShoppingCart', moduleId: 'module/shoppingcart/scart-content', title: 'Shopping Cart' },
            { route: ['search'], name: 'Search', moduleId: 'module/search/index', title: 'Search' },
            { route: ['module/assaydm/analyzer/:id'], name: 'AssayAnalyser', moduleId: 'module/assaydm/analyzer', title: 'AssayAnalyser' },
            { route: ['module/assaydm/designer'], name: 'AssayDM', moduleId: 'module/assaydm/designer', title: 'AssayDM' },
            { route: ['module/assaydm/result-upload/:id'], name: 'AssayDM', moduleId: 'module/assaydm/result-upload', title: 'AssayDM' },
            { route: ['integration-test/error'], moduleId: 'module/integration-test/error' },
        ];
        for (let setup of this.moduleSetup)
            setup.addRoutes(configMap);
        config.map(configMap);
        config.mapUnknownRoutes('module/app/not-found');
        this.router = router;
    }
};
App = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["AppLoader"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"]])
], App);



/***/ }),

/***/ "app.html":
/*!**********************!*\
  !*** ./SPA/app.html ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"module/error/error-panel\"></require>\r\n    <require from=\"module/app/main-menu\"></require>\r\n    <require from=\"module/app/dev-bar\"></require>\r\n\r\n    <main-menu></main-menu>\r\n    \r\n    <div id=\"scifeon-main-app\">\r\n        <router-view></router-view>\r\n        <error-panel></error-panel>\r\n    </div>\r\n    \r\n    <dev-bar></dev-bar>\r\n</template>";

/***/ }),

/***/ "async!entity/browse":
/*!****************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/browse.ts ***!
  \****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../node_modules/ts-loader?silent=true!./browse.ts */ "entity/browse"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/detail":
/*!****************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/detail.ts ***!
  \****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../node_modules/ts-loader?silent=true!./detail.ts */ "entity/detail"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/batch-edit":
/*!*************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/batch-edit.js ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./batch-edit.js */ "entity/edit/batch-edit"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/collection-edit":
/*!******************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/collection-edit.js ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./collection-edit.js */ "entity/edit/collection-edit"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/compound-edit":
/*!****************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/compound-edit.js ***!
  \****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./compound-edit.js */ "entity/edit/compound-edit"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/plasmid-edit":
/*!***************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/plasmid-edit.js ***!
  \***************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./plasmid-edit.js */ "entity/edit/plasmid-edit"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/plate-clone":
/*!**************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/plate-clone.js ***!
  \**************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./plate-clone.js */ "entity/edit/plate-clone"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/plate-create":
/*!***************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/plate-create.js ***!
  \***************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./plate-create.js */ "entity/edit/plate-create"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/sample-clone":
/*!***************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/sample-clone.js ***!
  \***************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./sample-clone.js */ "entity/edit/sample-clone"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/sample-create":
/*!****************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/sample-create.js ***!
  \****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./sample-create.js */ "entity/edit/sample-create"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/edit/sample-edit":
/*!**************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/edit/sample-edit.js ***!
  \**************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./sample-edit.js */ "entity/edit/sample-edit"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!entity/list":
/*!**************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=entity!./SPA/entity/list.ts ***!
  \**************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | entity */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("eln~entity"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("entity")]).then((function(require) {
		cb(__webpack_require__(/*! !../../node_modules/ts-loader?silent=true!./list.ts */ "entity/list"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/assaydm/analyzer":
/*!***********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/assayadm!./SPA/module/assaydm/analyzer.ts ***!
  \***********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | module/assayadm */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("module/assayadm")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./analyzer.ts */ "module/assaydm/analyzer"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/assaydm/designer":
/*!***********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/assayadm!./SPA/module/assaydm/designer.ts ***!
  \***********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | module/assayadm */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("module/assayadm")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./designer.ts */ "module/assaydm/designer"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/assaydm/result-upload":
/*!****************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/assayadm!./SPA/module/assaydm/result-upload.ts ***!
  \****************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | module/assayadm */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("entity~module/assayadm"), __webpack_require__.e("module/assayadm")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./result-upload.ts */ "module/assaydm/result-upload"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/data-upload/index":
/*!********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=data-upload!./SPA/module/data-upload/index.ts ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | data-upload */ "data-upload").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./index.ts */ "module/data-upload/index"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/data-upload/visual-data-loader":
/*!****************************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/data-upload!./SPA/module/data-upload/visual-data-loader.ts ***!
  \****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | module/data-upload */ "module/data-upload").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./visual-data-loader.ts */ "module/data-upload/visual-data-loader"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/eln/index":
/*!****************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=eln!./SPA/module/eln/index.ts ***!
  \****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | eln */[__webpack_require__.e("eln~entity"), __webpack_require__.e("eln")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./index.ts */ "module/eln/index"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/eln/pages/add-step":
/*!*************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=eln!./SPA/module/eln/pages/add-step.ts ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | eln */[__webpack_require__.e("eln~entity"), __webpack_require__.e("eln")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./add-step.ts */ "module/eln/pages/add-step"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/eln/pages/edit-step-template":
/*!***********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=eln!./SPA/module/eln/pages/edit-step-template.ts ***!
  \***********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | eln */[__webpack_require__.e("eln~entity"), __webpack_require__.e("eln")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./edit-step-template.ts */ "module/eln/pages/edit-step-template"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/eln/pages/step-setup":
/*!***************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=eln!./SPA/module/eln/pages/step-setup.ts ***!
  \***************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | eln */[__webpack_require__.e("eln~entity"), __webpack_require__.e("eln")]).then((function(require) {
		cb(__webpack_require__(/*! !../../../../node_modules/ts-loader?silent=true!./step-setup.ts */ "module/eln/pages/step-setup"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/pns/step-create-cherry-pick":
/*!*****************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/pns!./SPA/module/pns/step-create-cherry-pick.js ***!
  \*****************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | module/pns */ "module/pns").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./step-create-cherry-pick.js */ "module/pns/step-create-cherry-pick"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/pns/step-create-plate-transfer":
/*!********************************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=module/pns!./SPA/module/pns/step-create-plate-transfer.js ***!
  \********************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | module/pns */ "module/pns").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/babel-loader/lib!./step-create-plate-transfer.js */ "module/pns/step-create-plate-transfer"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/spreadsheet/export":
/*!*********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=spreadsheet!./SPA/module/spreadsheet/export.ts ***!
  \*********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | spreadsheet */ "spreadsheet").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./export.ts */ "module/spreadsheet/export"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/spreadsheet/index":
/*!********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=spreadsheet!./SPA/module/spreadsheet/index.ts ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | spreadsheet */ "spreadsheet").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./index.ts */ "module/spreadsheet/index"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!module/spreadsheet/query":
/*!********************************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=spreadsheet!./SPA/module/spreadsheet/query.ts ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | spreadsheet */ "spreadsheet").then((function(require) {
		cb(__webpack_require__(/*! !../../../node_modules/ts-loader?silent=true!./query.ts */ "module/spreadsheet/query"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "element/grid/plate-editor":
/*!******************************************!*\
  !*** ./SPA/element/grid/plate-editor.js ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PlateEditor = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _gridEditorBase = __webpack_require__(/*! ./grid-editor-base */ "./SPA/element/grid/grid-editor-base.js");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var PlateEditor = exports.PlateEditor = (_class = function (_GridEditorBase) {
    _inherits(PlateEditor, _GridEditorBase);

    _createClass(PlateEditor, [{
        key: 'wellsChanged',
        value: function wellsChanged() {
            this.createGrid();
        }
    }, {
        key: 'nRowsChanged',
        value: function nRowsChanged() {
            this.createGrid();
        }
    }, {
        key: 'nColsChanged',
        value: function nColsChanged() {
            this.createGrid();
        }
    }, {
        key: 'fieldNameChanged',
        value: function fieldNameChanged() {
            this.createGrid();
        }
    }]);

    function PlateEditor() {
        var _ref;

        _classCallCheck(this, PlateEditor);

        for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
            rest[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_ref = PlateEditor.__proto__ || Object.getPrototypeOf(PlateEditor)).call.apply(_ref, [this].concat(rest)));

        _initDefineProp(_this, 'wells', _descriptor, _this);

        _initDefineProp(_this, 'nRows', _descriptor2, _this);

        _initDefineProp(_this, 'nCols', _descriptor3, _this);

        _initDefineProp(_this, 'fieldName', _descriptor4, _this);

        _this.rowNames = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P'];
        return _this;
    }

    _createClass(PlateEditor, [{
        key: 'getTRowMin',
        value: function getTRowMin() {
            return 1;
        }
    }, {
        key: 'getTRowMax',
        value: function getTRowMax() {
            return this.nRows; // Since trow 0 contains the column labels
        }
    }, {
        key: 'getTColMin',
        value: function getTColMin() {
            return 1; // Since tcol 0 contains the row labels
        }
    }, {
        key: 'getTColMax',
        value: function getTColMax() {
            return this.nCols; // Since tcol 0 contains the row labels
        }
    }, {
        key: 'canAddRows',
        value: function canAddRows() {
            return false;
        }

        // SELECTION ///////////////////////////////////////////////////////////////////

    }, {
        key: 'clearSelection',
        value: function clearSelection() {
            if (!this.grid) return;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.grid[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var row = _step.value;
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = row.wells[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var wellInfo = _step2.value;

                            wellInfo.htmlClass = '';
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            this.hasSelection = false;
        }
    }, {
        key: 'selectData',
        value: function selectData(trow, tcol) {
            this.grid[trow - 1].wells[tcol - 1].htmlClass = 'selected';
        }

        // CELL EDITING ////////////////////////////////////////////////////////////////

    }, {
        key: 'createGrid',
        value: function createGrid() {
            if (!this.wells || !this.nRows || !this.nCols || !this.fieldName) return;

            // Grid content
            this.columns = [];
            for (var iCol = 0; iCol < this.nCols; iCol++) {
                this.columns.push({ name: iCol + 1 });
            }

            this.grid = [];
            for (var iRow = 0; iRow < this.nRows; iRow++) {
                var row = { name: this.rowNames[iRow], wells: [] };
                this.grid.push(row);

                for (var _iCol = 0; _iCol < this.nCols; _iCol++) {
                    row.wells.push({
                        posRow: iRow,
                        posCol: _iCol,
                        htmlClass: '',
                        well: { isNew: true, posRow: iRow, posCol: _iCol },
                        value: '',
                        tabIndex: row * this.nCols * 2 + _iCol * 2
                    });
                }
            }

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = this.wells[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var well = _step3.value;

                    var wellInfo = this.grid[well.posRow].wells[well.posCol] || {};
                    wellInfo.well = well;
                    wellInfo.value = well[this.fieldName];
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
        }

        // CONTENT MANIPULATION ////////////////////////////////////////////////////////

    }, {
        key: 'setDataContent',
        value: function setDataContent(trow, tcol, content) {
            var posRow = trow - 1;
            var posCol = tcol - 1;
            this.grid[posRow].wells[posCol].value = content;

            var well = this.grid[posRow].wells[posCol].well;
            well[this.fieldName] = content;

            if (well.isNew) {
                this.wells.push(well);
                delete well.isNew;
            }
        }
    }, {
        key: 'getDataContent',
        value: function getDataContent(trow, tcol) {
            this.currentWellInfo = this.grid[trow - 1].wells[tcol - 1];
            return this.editorContent = this.currentWellInfo.value;
        }
    }]);

    return PlateEditor;
}(_gridEditorBase.GridEditorBase), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'wells', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'nRows', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'nCols', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'fieldName', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class);

/***/ }),

/***/ "element/grid/plate-editor.html":
/*!********************************************!*\
  !*** ./SPA/element/grid/plate-editor.html ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <table ref=\"table\" class=\"plate\" mouseup.delegate=\"mouseUp($event)\" mouseenter.trigger=\"mouseEnter($event)\">\r\n        <tbody>\r\n            <tr>\r\n                <th></th>\r\n                <th repeat.for=\"col of columns\">${col.name}</th>\r\n            </tr>\r\n            <tr repeat.for=\"row of grid\">\r\n                <th>${row.name}</th>\r\n                <td repeat.for=\"well of row.wells\" tabindex.bind=\"well.tabIndex\" class.bind=\"well.htmlClass\"\r\n                    dblclick.delegate=\"editCell($event)\" mousedown.delegate=\"mouseDown($event)\"\r\n                    mousemove.delegate=\"mouseMove($event)\" focus.trigger=\"tdFocus($event)\">\r\n                    <span class=\"content\">${well.value & signal:'updategrid'}</span>\r\n                </td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n    <div ref=\"editor\" class=\"cell-editor\" style=\"display: none\"><input value.bind=\"editorContent\" blur.trigger=\"inputBlur()\"/></div>\r\n</template>";

/***/ }),

/***/ "element/grid/sample-plates-editor":
/*!**************************************************!*\
  !*** ./SPA/element/grid/sample-plates-editor.ts ***!
  \**************************************************/
/*! exports provided: SamplePlatesEditor */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SamplePlatesEditor", function() { return SamplePlatesEditor; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let SamplePlatesEditor = class SamplePlatesEditor {
    constructor() {
        this.dirty = false;
    }
    attached() {
        this.dirtyWells = JSON.parse(JSON.stringify(this.editorSamples.wells) || "{}");
    }
    updateIsDirty() {
        this.dirty = JSON.stringify(this.dirtyWells) !== JSON.stringify(this.editorSamples.wells);
    }
    clearSamples() {
        this.editorSamples.clearSelectedContent();
        this.updateIsDirty();
    }
    fillSamples(content) {
        let area = this.editorSamples.getSelectionArea();
        for (let trow = area.trowMin; trow <= area.trowMax; trow++) {
            for (let tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                this.editorSamples.setDataContent(trow, tcol, content);
            }
        }
        this.updateIsDirty();
    }
    fillTestSamples(direction) {
        let area = this.editorSamples.getSelectionArea();
        if (direction === 'horizontal') {
            let nSamples = area.trowMax - area.trowMin + 1;
            for (let iSample = 0; iSample < nSamples; iSample++) {
                let trow = area.trowMin + iSample;
                for (let tcol = area.tcolMin; tcol <= area.tcolMax; tcol++) {
                    this.editorSamples.setDataContent(trow, tcol, `T-${iSample + 1}`);
                }
            }
        }
        else {
            let nSamples = area.tcolMax - area.tcolMin + 1;
            for (let iSample = 0; iSample < nSamples; iSample++) {
                let col = area.tcolMin + iSample;
                for (let row = area.trowMin; row <= area.trowMax; row++) {
                    this.editorSamples.setDataContent(row, col, `T-${iSample + 1}`);
                }
            }
        }
        this.updateIsDirty();
    }
    view() {
        return __webpack_require__(/*! ./sample-plates-editor.html */ "element/grid/sample-plates-editor.html");
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], SamplePlatesEditor.prototype, "wells", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], SamplePlatesEditor.prototype, "nRows", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], SamplePlatesEditor.prototype, "nCols", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], SamplePlatesEditor.prototype, "fieldName", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], SamplePlatesEditor.prototype, "dirty", void 0);
SamplePlatesEditor = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('sample-plates-editor')
], SamplePlatesEditor);



/***/ }),

/***/ "element/grid/sample-plates-editor.html":
/*!****************************************************!*\
  !*** ./SPA/element/grid/sample-plates-editor.html ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/grid/plate-editor\"></require>\r\n    <p>\r\n        <button class=\"small\" click.delegate=\"fillSamples('C-0')\">C-0</button>\r\n        <button class=\"small\" click.delegate=\"fillSamples('C-100')\">C-100</button>\r\n        <button class=\"small\" click.delegate=\"fillSamples('Standard')\">Standard</button>\r\n        <button class=\"small\" click.delegate=\"fillTestSamples('horizontal')\">Test Horz</button>\r\n        <button class=\"small\" click.delegate=\"fillTestSamples('vertical')\">Test Vert</button>\r\n        <button class=\"small\" click.delegate=\"clearSamples()\">Clear</button>\r\n    </p>\r\n    <plate-editor view-model.ref=\"editorSamples\" n-rows.bind=\"nRows\" n-cols.bind=\"nCols\" wells.bind=\"wells\" field-name.bind=\"fieldName\"></plate-editor>\r\n</template>";

/***/ }),

/***/ "element/scirex-table":
/*!*************************************!*\
  !*** ./SPA/element/scirex-table.ts ***!
  \*************************************/
/*! exports provided: ScirexTable */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ScirexTable", function() { return ScirexTable; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-binding */ "./node_modules/aurelia-binding/dist/commonjs/aurelia-binding.js");
/* harmony import */ var aurelia_binding__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_binding__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_dependency_injection__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-dependency-injection */ "./node_modules/aurelia-dependency-injection/dist/commonjs/aurelia-dependency-injection.js");
/* harmony import */ var aurelia_dependency_injection__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_dependency_injection__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_6__);







let ScirexTable = class ScirexTable {
    constructor(dataModel, server, dialog) {
        this.dataModel = dataModel;
        this.server = server;
        this.dialog = dialog;
        this.allItems = [];
        this.filters = {};
        this.items = [];
        this.state = {
            loading: true,
            hasMoreItems: true,
            page: 0,
            sort: {
                key: '',
                dir: null
            }
        };
        this.defaultConfig = {
            pageSize: 100,
            initialSort: null,
            showToolbar: true,
            enableSorting: true
        };
        this.config = Object.assign({}, this.defaultConfig);
    }
    configChanged() {
        this.config = Object.assign({}, this.config, this.defaultConfig);
    }
    bind(bindingContext, overrideContext) {
        this.parentVM = { parent: bindingContext };
        if (typeof this.columns === 'string') {
            this.columns = this.columns.split(',').map(c => this.getColumn({ key: c.trim() }));
        }
        else if (Array.isArray(this.columns)) {
            let columns = [];
            for (let column of this.columns) {
                if (typeof column === 'string') {
                    columns.push(this.getColumn({ key: column.trim() }));
                }
                else {
                    columns.push(this.getColumn(column));
                }
            }
            this.columns.splice.apply(this.columns, [0, this.columns.length].concat(columns));
        }
        if (!this.height) {
            this.height = '90vh';
        }
        if (this.config.initialSort) {
            const sortDict = this.config.initialSort.toLowerCase().split(',');
            this.state.sort.key = sortDict[0].trim();
            if (sortDict.length === 2) {
                this.state.sort.dir = sortDict[1].trim();
            }
            else {
                this.state.sort.dir = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.ASC;
            }
            const sortColumn = this.columns.find(c => c.key.toLowerCase() === this.state.sort.key);
            if (sortColumn) {
                sortColumn.sort = this.state.sort.dir;
            }
        }
        if (this.eClass) {
            this.initializeWithEClass();
        }
        else if (this.inMemoryItems) {
            this.initializeWithInMemoryItems();
        }
    }
    inMemoryItemsChanged() {
        this.allItems.splice.apply(this.allItems, [0, this.allItems.length].concat(this.inMemoryItems));
        this.items.splice.apply(this.items, [0, this.items.length].concat(this.inMemoryItems));
    }
    initializeWithInMemoryItems() {
        if (this.inMemoryItems.length) {
            this.columns = this.columns || Object.keys(this.inMemoryItems[0]).map(c => this.getColumn({ key: c.trim() }));
            this.addItems(this.inMemoryItems);
        }
        if (!this.columns) {
            throw new Error('columns was not initialized.');
        }
        this.state.hasMoreItems = false;
        this.state.loading = false;
    }
    getEntityDescription() {
        if (this.eClass && !this.eClassDescription) {
            this.eClassDescription = this.dataModel.tables.find(t => t.name.toLowerCase() === this.eClass.toLowerCase());
            if (!this.eClassDescription) {
                this.eClassDescription = this.dataModel.views.find(v => v.name.toLowerCase() === this.eClass.toLowerCase());
            }
            return this.eClassDescription;
        }
        return this.eClassDescription;
    }
    initializeWithEClass() {
        const selectedColumns = this.getEntityDescription().columns.map(c => {
            c.key = c.name[0].toLowerCase() + c.name.substring(1, c.name.length);
            return c;
        });
        if (this.columns) {
            const columns = [];
            for (let column of this.columns) {
                if (column.key.toLowerCase() === 'id') {
                    column.key = 'id';
                }
                const selectedColumn = selectedColumns.find(sc => sc.nameLC === column.key.toLowerCase());
                if (selectedColumn) {
                    columns.push(Object.assign({}, this.getColumn(selectedColumn), column));
                }
                else {
                    columns.push(this.getColumn(column));
                }
            }
            this.columns = columns;
        }
        else {
            this.columns = selectedColumns.map(sc => this.getColumn(sc));
        }
        this.loadNextPage();
        this.table.addEventListener('scroll', event => {
            if (this.table.scrollHeight - this.table.scrollTop === this.table.clientHeight) {
                this.nextPage();
            }
        });
    }
    nextPage() {
        if (!this.filterTerm && this.state.hasMoreItems && !this.state.loading) {
            this.loadNextPage();
        }
    }
    filterTermChanged() {
        this.filter();
    }
    apply(e) {
        this.filters[e.detail.field] = e.detail;
        this.items = [];
        this.allItems = [];
        this.state.page = 0;
        this.loadNextPage();
    }
    filter() {
        if (this.filterTerm) {
            let items = [];
            for (let item of this.allItems) {
                const isMatch = Object.keys(item).some(column => {
                    const property = item[column];
                    return property && property.toString().toLowerCase().indexOf(this.filterTerm.toLowerCase()) > -1;
                });
                if (isMatch)
                    items.push(item);
            }
            this.items.splice.apply(this.items, [0, this.items.length].concat(items));
        }
        else {
            this.items.splice.apply(this.items, [0, this.items.length].concat(this.allItems));
        }
    }
    sort(column = null) {
        if (!column && this.state.sort.key) {
            column = this.columns.find(c => c.key === this.state.sort.key);
        }
        if (column) {
            const previousSortDir = column.sort;
            this.columns.forEach(col => col.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.NONE);
            if (previousSortDir === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.ASC) {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.DESC;
            }
            else if (previousSortDir === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.DESC) {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.NONE;
            }
            else {
                column.sort = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.ASC;
            }
            this.state.sort.key = column.key;
            this.state.sort.dir = column.sort;
            if (this.state.hasMoreItems) {
                this.items.splice.apply(this.items, [0, this.items.length]);
                this.allItems.splice.apply(this.items, [0, this.allItems.length]);
                this.state.page = 0;
                this.loadNextPage();
            }
            else {
                this.sortItems();
            }
        }
    }
    renderCell(column, item) {
        return column.renderer(item, column);
    }
    cellView(column, item) {
        return new aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["InlineViewStrategy"](`<template>${column.renderer(item, column)}</template>`);
    }
    toggleItemSelected(item) {
        if (item.isSelected === undefined) {
            item.isSelected = true;
        }
        else {
            item.isSelected = !item.isSelected;
        }
        return true;
    }
    sortItems() {
        if (this.state.sort.dir === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.ASC) {
            this.items.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_6__(a[this.state.sort.key], b[this.state.sort.key]));
        }
        else if (this.state.sort.dir === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"].SORT.DESC) {
            this.items.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_6__(b[this.state.sort.key], a[this.state.sort.key]));
        }
    }
    addItems(items) {
        items.forEach(item => {
            this.allItems.push(item);
            this.items.push(item);
        });
    }
    getColumn(column) {
        if (!column.key) {
            throw new Error('The column must have at least the key.');
        }
        column.name = column.name || column.key[0].toUpperCase() + column.key.substring(1, column.key.length);
        column.nameLC = column.nameLC || column.name.toLowerCase();
        column.sort = column.sort || '';
        column.renderer = column.renderer || this.getRenderer(column);
        column.style = column.style || '';
        if (column.nameLC === 'id' && this.eClass) {
            column.style = 'width: 100px';
        }
        return column;
    }
    getRenderer(column) {
        if (this.getEntityDescription()) {
            if (column.key.toLowerCase() === 'id') {
                return (item, col) => `<a href="/#/entity/${this.eClass}/${item.id}">${item[col.key]}</a>`;
            }
            const columnDescription = this.getEntityDescription().columns.find(c => c.nameLC === column.key.toLowerCase());
            if (columnDescription) {
                if (columnDescription.type === 'bool') {
                    return (item, col) => `<span class="fa fa-${item[col.key] ? 'check' : ''}-square-o"></span>`;
                }
            }
        }
        return (item, col) => {
            const value = item[col.key];
            return value === null ? '' : value;
        };
    }
    loadNextPage() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.state.loading = true;
            const result = yield this.server.getEntities(this.eClass, Object.values(this.filters), [{ field: this.state.sort.key, direction: this.state.sort.dir }], this.state.page * this.config.pageSize, this.config.pageSize);
            if (result !== null) {
                this.state.page++;
                this.addItems(result.data);
                this.state.hasMoreItems = this.items.length < result.total;
                this.state.loading = false;
            }
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ScirexTable.prototype, "filterTerm", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ScirexTable.prototype, "eClass", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ScirexTable.prototype, "style", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Array)
], ScirexTable.prototype, "inMemoryItems", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", String)
], ScirexTable.prototype, "height", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"])({ defaultBindingMode: aurelia_binding__WEBPACK_IMPORTED_MODULE_3__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScirexTable.prototype, "columns", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], ScirexTable.prototype, "config", void 0);
ScirexTable = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_dependency_injection__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ScirexTable);



/***/ }),

/***/ "element/scirex-table.html":
/*!***************************************!*\
  !*** ./SPA/element/scirex-table.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"scirex-table\" css.bind=\"style\">\r\n        <div class=\"scirex-table-toolbar\">\r\n            <div>\r\n                <div class=\"input-group\">\r\n                    <input type=\"text\" placeholder=\"Filter\" value.bind=\"filterTerm & throttle:500\" />\r\n                    <button class=\"input-group-btn fa fa-filter\" title=\"Filter\" click.delegate=\"filter()\" disabled.bind=\"!filterTerm\"></button>\r\n                </div>\r\n            </div>\r\n            <div>\r\n                <slot></slot>\r\n            </div>\r\n        </div>\r\n        <div class=\"scirex-table-container\" css=\"${style};height:${height}\">\r\n            <div class=\"scirex-table-header\"></div>\r\n            <div class=\"scirex-table-container-inner\" ref=\"table\">\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th repeat.for=\"column of columns\" css.bind=\"column.style\">\r\n                                    ${column.name}\r\n                                <div class=\"scirex-table-th-inner\">              \r\n                                    <a click.trigger=\"sort(column)\" href=\"#\" if.bind=\"config.enableSorting\">${column.name}\r\n                                    <span class=\"fa fa-sort${ column.sort ? '-' + column.sort : ''}\"></span></a>\r\n                                    <span if.bind=\"!config.enableSorting\">${column.name}</span>\r\n                                    <column-filter column-name.bind=\"column.name\" if.bind=\"column.showFilter\" options.bind=\"column.filterOptions\" apply.delegate=\"apply($event)\"></column-filter>                                                         \r\n                                </div>\r\n                            </th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"item of items\" class=\"${item.isSelected ? 'selected' : ''}\" click.trigger=\"toggleItemSelected(item)\">\r\n                            <td repeat.for=\"column of columns\" css.bind=\"column.style\">\r\n                                <compose containerLess view.bind=\"cellView(column, item)\" view-model.one-time=\"parentVM\"></compose>\r\n                            </td>\r\n                        </tr>\r\n                    </tbody>\r\n                    <tfoot>\r\n                        <tr class=\"empty\" if.bind=\"!state.loading && items.length === 0\">\r\n                            <td colspan.bind=\"columns.length\">No results</td>\r\n                        </tr>\r\n                        <tr class=\"loading\" if.bind=\"state.loading\">\r\n                            <td colspan.bind=\"columns.length\"></td>\r\n                        </tr>\r\n                    </tfoot>\r\n                </table>\r\n            </div>\r\n        </div>\r\n        <div class=\"float-right\">\r\n            Results: <span if.bind=\"items.length !== allItems.length\">${items.length} / </span>${allItems.length}\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/app/no-access":
/*!*************************************!*\
  !*** ./SPA/module/app/no-access.ts ***!
  \*************************************/
/*! exports provided: NoAccess */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "NoAccess", function() { return NoAccess; });
class NoAccess {
}


/***/ }),

/***/ "module/app/no-access.html":
/*!***************************************!*\
  !*** ./SPA/module/app/no-access.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-header\">\r\n        <h1>No access</h1>\r\n    </div>\r\n    <div class=\"page-panels\">\r\n        You don't have permission to view this page. \r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/app/not-found":
/*!*************************************!*\
  !*** ./SPA/module/app/not-found.ts ***!
  \*************************************/
/*! exports provided: NotFound */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "NotFound", function() { return NotFound; });
class NotFound {
}


/***/ }),

/***/ "module/app/not-found.html":
/*!***************************************!*\
  !*** ./SPA/module/app/not-found.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-header\">\r\n        <h1>Not found</h1>\r\n    </div>\r\n    <div class=\"page-panels\">\r\n        The requested page was not found.\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/dashboard/dashboard-picker":
/*!**************************************************!*\
  !*** ./SPA/module/dashboard/dashboard-picker.ts ***!
  \**************************************************/
/*! exports provided: DashboardPicker */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DashboardPicker", function() { return DashboardPicker; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");

class DashboardPicker {
    constructor() {
        this.dashboards = [];
        this.view = () => __webpack_require__(/*! ./dashboard-picker.html */ "module/dashboard/dashboard-picker.html");
    }
    init(dashboards) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dashboards = dashboards;
        });
    }
    copy() {
        this.dialog.ok(this.selectedDashboard);
    }
}


/***/ }),

/***/ "module/dashboard/dashboard-picker.html":
/*!****************************************************!*\
  !*** ./SPA/module/dashboard/dashboard-picker.html ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog>\r\n        <ux-dialog-header>\r\n            <h2>Copy widget</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div class=\"share-widget-dialog form-horizontal\">\r\n                <div class=\"form-group\">\r\n                    <label>Dashboard</label>\r\n                    <div>\r\n                        <select value.bind=\"selectedDashboard\">\r\n                            <option value=\"\">Select a Dashboard</option>\r\n                            <option repeat.for=\"dashboard of dashboards\" value.bind=\"dashboard.id\">\r\n                                ${dashboard.name}\r\n                            </option>\r\n                        </select>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"copy()\" disabled.bind=\"!selectedDashboard\">Copy</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/dashboard/index":
/*!***************************************!*\
  !*** ./SPA/module/dashboard/index.ts ***!
  \***************************************/
/*! exports provided: Dashboard */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Dashboard", function() { return Dashboard; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-templating-resources */ "aurelia-templating-resources");
/* harmony import */ var aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _dashboard_picker__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./dashboard-picker */ "module/dashboard/dashboard-picker");
/* harmony import */ var _share_dashboard_dialog__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./share-dashboard-dialog */ "module/dashboard/share-dashboard-dialog");
/* harmony import */ var _widget_selector_dialog__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./widget-selector-dialog */ "module/dashboard/widget-selector-dialog");
/* harmony import */ var _widget_settings_dialog__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./widget-settings-dialog */ "module/dashboard/widget-settings-dialog");











let Dashboard = class Dashboard {
    constructor(server, pluginManager, appLoader, dialog, signaler, user, taskQueue) {
        this.server = server;
        this.pluginManager = pluginManager;
        this.appLoader = appLoader;
        this.dialog = dialog;
        this.signaler = signaler;
        this.user = user;
        this.taskQueue = taskQueue;
        this.loading = false;
        this.dashboards = [];
        this.gridSterViewModels = [];
        this.gridSterElements = [];
        this.gridOpts = {
            'margins': [5],
            'auto_resize': true,
            'draggable': false,
            'resizable': false,
            'auto_style': true,
            'cascade': null,
            'col_width': 300,
            'row_height': 300
        };
        this.listOptions = {
            allowMoveColumns: false,
            allowSort: false,
            allowFilter: false,
            allowExport: false,
            allowAddColumns: false,
            updateURL: false
        };
        this.defaultDashboard = __webpack_require__(/*! ./default-dashboard.json */ "./SPA/module/dashboard/default-dashboard.json");
        this.widgets = [];
        this.SELECTED_DASHBOARD_ID = 'SELECTED_DASHBOARD_ID';
        this.DASHBOARD_API = '/api/dashboard';
    }
    activate(params) {
        if (params.id) {
            localStorage.setItem(this.SELECTED_DASHBOARD_ID, params.id);
        }
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.initialize();
        });
    }
    initialize() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Loading dashboard...');
            this.dashboards = [];
            this.dashboards.push(this.defaultDashboard);
            this.dashboards.push(...yield this.getDashboards());
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            if (this.dashboards.length) {
                const selectedDashboardID = localStorage.getItem(this.SELECTED_DASHBOARD_ID);
                const selectedDashboard = this.dashboards.find(d => d.id === selectedDashboardID);
                if (selectedDashboardID && selectedDashboard) {
                    this.initializeDashboard(selectedDashboard);
                }
                else {
                    this.initializeDashboard(this.dashboards[0]);
                }
            }
        });
    }
    switchDashboard(dashboard) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.selectedDashboard.id !== dashboard.id) {
                yield this.initializeDashboard(dashboard);
            }
        });
    }
    resetWidgetData() {
        this.widgets.splice.apply(this.widgets, [0, this.widgets.length]);
        this.gridSterViewModels.splice.apply(this.gridSterViewModels, [0, this.gridSterViewModels.length]);
        this.gridSterElements.splice.apply(this.gridSterElements, [0, this.gridSterElements.length]);
    }
    initializeDashboard(dashboard) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.resetWidgetData();
            if (dashboard.id) {
                localStorage.setItem(this.SELECTED_DASHBOARD_ID, dashboard.id);
            }
            this.selectedDashboard = JSON.parse(JSON.stringify(dashboard));
            this.isDashboardOwner = this.user.id === this.selectedDashboard.userID;
            this.dashboardName = dashboard.name;
            const widgets = JSON.parse(JSON.stringify(dashboard.widgets));
            for (const widget of widgets) {
                widget.loading = true;
                this.transformGridProperty(widget);
                this.widgets.push(widget);
            }
            for (const widget of widgets) {
                try {
                    yield this.loadWidget(widget);
                }
                catch (err) {
                    widget.error = err;
                }
                finally {
                    widget.loading = false;
                }
            }
            this.signaler.signal('update-widgets');
        });
    }
    cleanLeftoverWidget() {
        let elements = document.getElementsByTagName('au-gridster-item');
        for (let index = 0; index < elements.length; index++) {
            let widget = elements[index];
            if (widget.querySelector('.panel-body').textContent.trim() === '')
                widget.remove();
        }
    }
    loadWidget(widget) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.transformGridProperty(widget);
            if (!widget.vm)
                widget.vm = {};
            if (!widget.vm.plugin) {
                const loadedApp = yield this.appLoader.load({ name: widget.plugin.app.name, namespace: widget.plugin.app.namespace });
                const plugin = yield this.pluginManager.getPluginFromApp(widget.plugin.id, loadedApp);
                widget.vm.plugin = plugin;
            }
            widget.vm.context = {
                config: JSON.parse(JSON.stringify(widget.config)),
                grid: JSON.parse(JSON.stringify(widget.grid))
            };
        });
    }
    transformGridProperty(widget) {
        if (!widget.grid)
            widget.grid = {};
        widget.gridster = JSON.parse(JSON.stringify({
            dragHandle: '.handle',
            resizeHandle: '.resize-handle',
            sizex: widget.grid.w,
            sizey: widget.grid.h,
            minCols: widget.grid.minw || 1,
            minRows: widget.grid.minh || 1,
            col: widget.grid.x,
            row: widget.grid.y
        }));
    }
    addWidget(plugin) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const maxY = this.gridSterViewModels.length > 0
                ? this.gridSterViewModels.reduce((p, c) => p.sizey > c.sizey ? p : c).sizey
                : 0;
            const widget = {
                plugin: {
                    id: plugin.metadata.id,
                    app: {
                        namespace: plugin.metadata.app.namespace,
                        name: plugin.metadata.app.name,
                    }
                },
                vm: {
                    plugin: plugin,
                    context: {
                        config: {},
                        grid: { x: 1, y: maxY }
                    }
                },
                grid: { x: 1, y: maxY + 1 },
                config: {},
                header: ''
            };
            yield this.loadWidget(widget);
            this.editWidget(widget, true);
        });
    }
    removeWidget(index) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const confirmed = yield this.dialog.confirm(`Are you sure you want to remove this widget from the dashboard?`);
            if (confirmed) {
                this.widgets.splice(index, 1);
                this.gridSterViewModels.splice(index, 1);
                this.signaler.signal('update-widgets');
                this.taskQueue.queueMicroTask(this.cleanLeftoverWidget);
            }
        });
    }
    deleteLeftOverWidgetElement(element) {
        if (element)
            element.remove();
    }
    editWidget(widget, add = false) {
        this.dialog.open({
            viewModel: _widget_settings_dialog__WEBPACK_IMPORTED_MODULE_10__["WidgetSettingsDialog"],
            model: { widget: widget, isadd: add }
        }).whenClosed((result) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!result.wasCancelled) {
                widget.grid.minw = result.output.grid.minw || 1;
                widget.grid.minh = result.output.grid.minh || 1;
                widget.grid.w = widget.grid.w || widget.grid.minw;
                widget.grid.h = widget.grid.h || widget.grid.minh;
                widget.config = result.output.config;
                widget.header = result.output.header;
                yield this.loadWidget(widget);
                if (add) {
                    this.widgets.push(widget);
                }
                this.signaler.signal('update-widgets');
            }
        }));
    }
    showWidgetSelectorDialog() {
        this.dialog.open({
            viewModel: _widget_selector_dialog__WEBPACK_IMPORTED_MODULE_9__["WidgetSelectorDialog"],
        }).whenClosed(result => {
            if (!result.wasCancelled) {
                this.addWidget(result.output);
            }
        });
    }
    toggleEditMode(isEditMode) {
        this.isEditing = isEditMode;
        this.gridSter.dragEnable = isEditMode;
        this.gridSter.resizeEnable = isEditMode;
    }
    edit() {
        this.toggleEditMode(true);
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.selectedDashboard.widgets = [];
            for (let idx = 0; idx < this.gridSterViewModels.length; idx++) {
                let widget = this.widgets[idx];
                const gridsterItem = this.gridSterViewModels[idx];
                widget.grid = {
                    x: gridsterItem.col,
                    y: gridsterItem.row,
                    w: gridsterItem.sizex,
                    h: gridsterItem.sizey,
                    minw: widget.gridster.minCols,
                    minh: widget.gridster.minRows
                };
                let updatedWidget = JSON.parse(JSON.stringify(widget));
                delete updatedWidget.vm;
                delete updatedWidget.gridster;
                this.selectedDashboard.widgets.push(updatedWidget);
            }
            this.selectedDashboard.name = this.dashboardName;
            yield this.saveDashboard();
            this.toggleEditMode(false);
        });
    }
    cancel() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.selectedDashboard.id) {
                yield this.initializeDashboard(this.selectedDashboard);
            }
            else {
                yield this.initialize();
            }
            this.toggleEditMode(false);
        });
    }
    newDashboard() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const newDB = {
                userID: this.user.id,
                name: 'New Dashboard',
                description: 'New Dashboard',
                widgets: [],
                shares: {
                    userIDs: [],
                    departmentIDs: [],
                    projectIDs: [],
                    userRoles: []
                }
            };
            this.initializeDashboard(newDB);
            this.toggleEditMode(true);
        });
    }
    delete() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const confirmed = yield this.dialog.confirm(`Are you sure you want to delete this dashboard?`);
            if (confirmed) {
                yield this.deleteDashboard(this.selectedDashboard.id);
                yield this.initialize();
            }
        });
    }
    copy() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.edit();
            let newDashboard = Object.assign({}, this.selectedDashboard);
            delete newDashboard.id;
            newDashboard.userID = this.user.id;
            newDashboard.name += "-Clone";
            yield this.initializeDashboard(newDashboard);
        });
    }
    export() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let dbOBject = Object.assign({}, this.selectedDashboard);
            delete dbOBject.id;
            delete dbOBject.userID;
            const dbJson = JSON.stringify(dbOBject);
            var blob = new Blob([dbJson], { type: "application/json;charset=utf-8" });
            Object(file_saver__WEBPACK_IMPORTED_MODULE_6__["saveAs"])(blob, `${this.selectedDashboard.name}.json`);
        });
    }
    share() {
        this.dialog.open({
            viewModel: _share_dashboard_dialog__WEBPACK_IMPORTED_MODULE_8__["ShareDashboardDialog"],
            model: this.selectedDashboard.shares.userIDs
        }).whenClosed(result => {
            if (!result.wasCancelled) {
                this.assignUserToDashboard(result.output);
            }
        });
    }
    assignUserToDashboard(users) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.selectedDashboard.shares.userIDs = users;
            yield this.saveDashboard();
        });
    }
    showCopyWidget(widget) {
        this.dialog.open({
            viewModel: _dashboard_picker__WEBPACK_IMPORTED_MODULE_7__["DashboardPicker"],
            model: this.dashboards.filter(d => d.userID === this.user.id)
        }).whenClosed(result => {
            if (!result.wasCancelled) {
                this.copyWidgetToDashboard(widget, result.output);
            }
        });
    }
    copyWidgetToDashboard(widget, dashboardId) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let copyWidget = JSON.parse(JSON.stringify(widget));
            delete copyWidget.vm;
            delete copyWidget.gridster;
            let dasboard = yield this.getDashboards(dashboardId);
            let yPosition = 1;
            if (dasboard.widgets.length) {
                let lastRowGridItem = dasboard.widgets.reduce((l, e) => e.grid.y > l.grid.y ? e : l);
                yPosition = lastRowGridItem.grid.y + 1;
            }
            copyWidget.grid.x = 1;
            copyWidget.grid.y = yPosition;
            dasboard.widgets.push(copyWidget);
            yield this.initializeDashboard(dasboard);
        });
    }
    saveDashboard() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            let dashboardId = this.selectedDashboard.id;
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Saving dashboard...');
            if (dashboardId) {
                yield this.server.putJson(`${this.DASHBOARD_API}/${dashboardId}`, this.selectedDashboard);
                const dashboard = this.dashboards.find(d => d.id === dashboardId);
                const copy = JSON.parse(JSON.stringify(this.selectedDashboard));
                dashboard.name = copy.name;
                dashboard.shares = copy.shares;
                dashboard.widgets = copy.widgets;
            }
            else {
                const newDB = yield this.createDashboard(this.selectedDashboard);
                dashboardId = newDB.id;
                this.selectedDashboard.id = dashboardId;
                this.dashboards.push(newDB);
            }
            localStorage.setItem(this.SELECTED_DASHBOARD_ID, dashboardId);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            this.loading = false;
        });
    }
    getDashboards(id) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (id)
                return yield this.server.getJson(`${this.DASHBOARD_API}/${id}`);
            else
                return yield this.server.getJson(this.DASHBOARD_API);
        });
    }
    createDashboard(newDashBoard) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const responseJson = yield this.server.postJson(this.DASHBOARD_API, newDashBoard);
            return yield responseJson.json();
        });
    }
    deleteDashboard(dashboardId) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dashboards = this.dashboards.filter(d => d.id !== dashboardId);
            yield this.server.delete(`${this.DASHBOARD_API}/${dashboardId}`);
        });
    }
};
Dashboard = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["AppLoader"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"],
        aurelia_templating_resources__WEBPACK_IMPORTED_MODULE_5__["BindingSignaler"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["TaskQueue"]])
], Dashboard);



/***/ }),

/***/ "module/dashboard/index.html":
/*!*****************************************!*\
  !*** ./SPA/module/dashboard/index.html ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1 if.bind=\"!isEditing\">${dashboardName}</h1>\r\n            <input type=\"text\" if.bind=\"isEditing\" value.bind=\"dashboardName\" style=\"width: 300px;margin-top: -2px;\"/>\r\n            <div class=\"btn-header-group\">\r\n                <button if.bind=\"isEditing\" click.delegate=\"showWidgetSelectorDialog()\" title=\"Add widget\" class=\"fa fa-plus\"></button>\r\n                <dropdown-button title=\"Actions\" class=\"btn\" fa-icon=\"ellipsis-h\" click-dismisses.bind=\"true\" right-align=\"true\">\r\n                    <ul class=\"menu\">                       \r\n                        <li if.bind=\"!isEditing && isDashboardOwner\" class=\"menu-item\">\r\n                            <a click.delegate=\"edit()\">\r\n                                Edit Dashboard\r\n                            </a>\r\n                        </li>                                                                                        \r\n                        <li if.bind=\"!isEditing && isDashboardOwner\" class=\"menu-item\">\r\n                            <a click.delegate=\"delete()\">\r\n                                Delete Dashboard\r\n                            </a>\r\n                        </li>  \r\n                        <li if.bind=\"!isEditing\" class=\"menu-item\">\r\n                            <a click.delegate=\"copy()\">\r\n                                Copy Dashboard\r\n                            </a>\r\n                        </li> \r\n                        <li if.bind=\"!isEditing\" class=\"menu-item\">\r\n                            <a click.delegate=\"share()\">\r\n                                Share Dashboard\r\n                            </a>\r\n                        </li>                      \r\n                        <li if.bind=\"!isEditing\" class=\"menu-item\">\r\n                            <a click.delegate=\"newDashboard()\">\r\n                                Create New Dashboard\r\n                            </a>\r\n                        </li>                                                                                  \r\n                        <li class=\"menu-item\">\r\n                            <a click.delegate=\"export()\">\r\n                                Export Dashboard\r\n                            </a>\r\n                        </li>\r\n                    </ul>\r\n                </dropdown-button> \r\n                <button if.bind=\"isEditing\" click.delegate=\"save()\" title=\"Save\" class=\"secondary\">Save</button>\r\n                <button if.bind=\"isEditing\" click.delegate=\"cancel()\" title=\"Cancel\" class=\"secondary\">Cancel</button>\r\n                <dropdown-button if.bind=\"!isEditing\"\r\n                         text=\"Switch Dashboard\" \r\n                         fa-icon=\"caret-down\" \r\n                         outside-click-dismisses.bind=\"true\"\r\n                         click-dismisses.bind=\"true\" \r\n                         title=\"Switch Dashboard\" \r\n                         right-align.bind=\"true\">\r\n                    <ul class=\"menu\">\r\n                        <li if.bind=\"!loading\" repeat.for=\"dashboard of dashboards\" class=\"menu-item\">\r\n                            <a click.delegate=\"switchDashboard(dashboard)\" title=\"${dashboard.name}\"><i class=\"fa fa-table\"></i> ${dashboard.name}</a>\r\n                        </li>\r\n                        <li class=\"menu-item\" if.bind=\"loading\">\r\n                            <div class=\"loading\"></div>\r\n                        </li>\r\n                        <li  class=\"menu-item\">\r\n                            <a click.delegate=\"newDashboard()\" title=\"New Dashboard\"><i class=\"fa fa-plus\"></i> New Dashboard</a>\r\n                        </li>\r\n                    </ul>\r\n                </dropdown-button>\r\n            </div>\r\n        </div>\r\n        <div class=\"page-panels\">\r\n            <au-gridster grid-opts.bind=\"gridOpts\" style=\"margin: -5px\" view-model.ref=\"gridSter\">\r\n                <au-gridster-item ref=\"gridSterElements[$index]\" view-model.ref=\"gridSterViewModels[$index]\" item-opts.two-way=\"widget.gridster\" repeat.for=\"widget of widgets & signal:'update-widgets'\">\r\n                    <div class=\"panel\">\r\n                        <div class=\"panel-heading\" if.bind=\"!widget.error && !widget.loading && (widget.header || isEditing)\">\r\n                            <span if.bind=\"widget.header\">${widget.header}</span>\r\n                            <span else>&nbsp;</span>\r\n                            <div class=\"btn-widget-header-group\">               \r\n                                <button class=\"sm fa fa-trash\" if.bind=\"isEditing\" title=\"Delete\" click.delegate=\"removeWidget($index)\"></button>\r\n                                <button class=\"sm fa fa-pencil\" if.bind=\"isEditing\" title=\"Edit\" click.delegate=\"editWidget(widget)\"></button>\r\n                                <button class=\"sm fa fa-copy\" if.bind=\"isEditing\" title=\"Copy\" click.delegate=\"showCopyWidget(widget)\"></button>\r\n                                <button class=\"sm handle fa fa-arrows\" if.bind=\"isEditing\" title=\"Drag to reorder\"></button>                      \r\n                            </div>\r\n                        </div>\r\n                        <div class=\"panel-body\">\r\n                            <span class=\"loading\" if.bind=\"widget.loading\"></span>\r\n                            <div if.bind=\"widget.error\" class=\"error\" style=\"font-family:'Courier New', Courier, monospace; font-size: 90%;\">\r\n                                An error occurred during loading of widget: ${widget.plugin.app.namespace}.${widget.plugin.app.name}${widget.plugin.id}:\r\n                                <p>${widget.error.message}</p>\r\n                            </div>\r\n                            <render-plugin if.bind=\"widget.vm.plugin && !widget.loading && !widget.error\" \r\n                                           plugin.bind=\"widget.vm.plugin\" \r\n                                           context.bind=\"widget.vm.context\"></render-plugin>\r\n                        </div>\r\n                    </div>\r\n                    <span if.bind=\"isEditing\" class=\"resize-handle\" title=\"Drag to resize\"></span>\r\n                </au-gridster-item>\r\n            </au-gridster>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/dashboard/share-dashboard-dialog":
/*!********************************************************!*\
  !*** ./SPA/module/dashboard/share-dashboard-dialog.ts ***!
  \********************************************************/
/*! exports provided: ShareDashboardDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ShareDashboardDialog", function() { return ShareDashboardDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let ShareDashboardDialog = class ShareDashboardDialog {
    constructor(server) {
        this.server = server;
        this.users = [];
        this.dirtyObject = [];
        this.view = () => __webpack_require__(/*! ./share-dashboard-dialog.html */ "module/dashboard/share-dashboard-dialog.html");
    }
    loadUsers(userIDs) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.users = (yield this.server.getEntities('User', null, [{ field: 'name', direction: 'asc' }]))
                .data.filter(u => userIDs.includes(u.id));
        });
    }
    init(userIDs) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadUsers(userIDs);
            this.dirtyObject = Object.assign([], this.users);
        });
    }
    addUser() {
        const isUserExist = this.users.find(u => u.id === this.newUserEntity.id);
        if (!isUserExist) {
            this.users.push(this.newUserEntity);
        }
    }
    removeUser(index) {
        this.users.splice(index, 1);
    }
    get canSave() {
        return JSON.stringify(this.dirtyObject) !== JSON.stringify(this.users);
    }
    share() {
        this.dialog.ok(this.users.map(({ id }) => id));
    }
};
ShareDashboardDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"]])
], ShareDashboardDialog);



/***/ }),

/***/ "module/dashboard/share-dashboard-dialog.html":
/*!**********************************************************!*\
  !*** ./SPA/module/dashboard/share-dashboard-dialog.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 500px\">\r\n        <ux-dialog-header>\r\n            <h2>Share Dashboard</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body style=\"height: 300px;\">\r\n            <div class=\"share-widget-dialog form-horizontal\">\r\n                <div class=\"form-group\">\r\n                    <label>Users</label>\r\n                    <template if.bind=\"users.length === 0\">Dashboard has not been assigned any user.</template>\r\n                    <template else>\r\n                        <ol class=\"assign-user-menu\">\r\n                            <li repeat.for=\"user of users\">\r\n                                <label style=\"width: 150px\">${user.name}</label>\r\n                                <button click.delegate=\"removeUser($index)\" class=\"sm float-right\" title=\"Remove\" style=\"width:6rem\">Remove</button>\r\n                            </li>\r\n                        </ol>\r\n                    </template>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>&nbsp;</label>\r\n                    <div>                        \r\n                        <input-foreign-key value.bind=\"newUserId\"\r\n                                           entity.bind=\"newUserEntity\" \r\n                                           placeholder=\"Share with user\" \r\n                                           e-class=\"User\"></input-foreign-key>\r\n\r\n                        <button click.delegate=\"addUser()\" disabled.bind=\"!newUserId\" class=\"sm btn-add-user float-right\" title=\"Add\" style=\"width:6rem\">Add</button>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"share()\" disabled.bind=\"!canSave\">Share</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/dashboard/widget-selector-dialog":
/*!********************************************************!*\
  !*** ./SPA/module/dashboard/widget-selector-dialog.ts ***!
  \********************************************************/
/*! exports provided: WidgetSelectorDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WidgetSelectorDialog", function() { return WidgetSelectorDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let WidgetSelectorDialog = class WidgetSelectorDialog {
    constructor(pluginManager, dialog) {
        this.pluginManager = pluginManager;
        this.dialog = dialog;
        this.widgetPlugins = {};
        this.view = () => __webpack_require__(/*! ./widget-selector-dialog.html */ "module/dashboard/widget-selector-dialog.html");
    }
    init() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.widgetPlugins = yield this.pluginManager.getPlugins([_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].DASHBOARD_WIDGET]);
        });
    }
    add(plugin) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dialog.ok(plugin);
        });
    }
};
WidgetSelectorDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginManager"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], WidgetSelectorDialog);



/***/ }),

/***/ "module/dashboard/widget-selector-dialog.html":
/*!**********************************************************!*\
  !*** ./SPA/module/dashboard/widget-selector-dialog.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 600px;\">\r\n        <ux-dialog-header>\r\n            <h2>Add Widget</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <ul class=\"widget-selector\">\r\n                <li repeat.for=\"plugin of widgetPlugins\" click.delegate=\"add(plugin)\"> \r\n                    <h3>${plugin.metadata.name}</h3>\r\n                    <p>${plugin.metadata.description}</p>\r\n                </li>\r\n            </ul>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>           \r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/dashboard/widget-settings-dialog":
/*!********************************************************!*\
  !*** ./SPA/module/dashboard/widget-settings-dialog.ts ***!
  \********************************************************/
/*! exports provided: WidgetSettingsDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WidgetSettingsDialog", function() { return WidgetSettingsDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let WidgetSettingsDialog = class WidgetSettingsDialog {
    constructor(dialog) {
        this.dialog = dialog;
        this.useHeader = true;
        this.view = () => __webpack_require__(/*! ./widget-settings-dialog.html */ "module/dashboard/widget-settings-dialog.html");
    }
    init(model) {
        this.widget = model.widget;
        this.isAdd = model.isadd;
        this.context = JSON.parse(JSON.stringify(this.widget.vm.context));
        this.header = this.widget.header;
    }
    viewModelChanged() {
        if (this.viewModel && this.viewModel.defaultConfig) {
            const config = this.viewModel.defaultConfig();
            this.useHeader = config.useHeader || config.useHeader === undefined;
            if (!this.useHeader) {
                this.header = '';
            }
            else if (this.isAdd) {
                this.header = config.header;
            }
        }
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dialog.ok({
                grid: this.viewModel.defaultConfig && this.viewModel.defaultConfig().size || {},
                header: this.header,
                config: this.viewModel.getConfig && this.viewModel.getConfig() || {}
            });
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["observable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], WidgetSettingsDialog.prototype, "viewModel", void 0);
WidgetSettingsDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_1__["Dialog"]])
], WidgetSettingsDialog);



/***/ }),

/***/ "module/dashboard/widget-settings-dialog.html":
/*!**********************************************************!*\
  !*** ./SPA/module/dashboard/widget-settings-dialog.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 600px;\">\r\n        <ux-dialog-header>\r\n            <h2>Configure Widget</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div class=\"config-widget form-horizontal\" if.bind=\"useHeader\">\r\n                <div class=\"form-group\">\r\n                    <label>Header</label>\r\n                    <input type=\"text\" value.bind=\"header\" />\r\n                </div>    \r\n                <br/>   \r\n            </div>\r\n            <render-plugin plugin.bind=\"widget.vm.plugin\"\r\n                           context.bind=\"context\"\r\n                           view-model.bind=\"viewModel\"\r\n                           view=\"configView\"></render-plugin>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"save()\">OK</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/error/error-panel":
/*!*****************************************!*\
  !*** ./SPA/module/error/error-panel.ts ***!
  \*****************************************/
/*! exports provided: ErrorPanel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ErrorPanel", function() { return ErrorPanel; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/error/bug-report-service */ "./SPA/module/error/bug-report-service.ts");
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");







let ErrorPanel = class ErrorPanel {
    constructor(errorManager, reportService, http, dialog) {
        this.errorManager = errorManager;
        this.reportService = reportService;
        this.http = http;
        this.dialog = dialog;
        this.errorManager.subscribe(this);
    }
    hide() {
        this.message = '';
    }
    showMessage(message, error = null) {
        const code = error ? error.code || -1 : -1;
        message = message || error ? error.message : '';
        const hint = error ? error.hint : '';
        const stack = error ? error.message + '\n' + (error.stack || error.stacktrace) : '';
        this.showApiError({
            code: code,
            message: message,
            hint: hint,
            stacktrace: stack
        });
    }
    showError(error) {
        if (!error)
            return;
        this.showApiError({
            code: error.code || -1,
            message: error.message,
            hint: error.hint,
            stacktrace: error.stack || error.stacktrace
        });
    }
    showApiError(error) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        this.error = error;
        this.message = error.message;
    }
    showDetails() {
        let html = '<pre><b>Message: </b> ' + this.message;
        if (this.error.hint) {
            html += '<br/><b>Hint:</b><br/>' + this.error.hint;
        }
        if (this.error.stacktrace) {
            html += '<br/><b>Stacktrace:</b><br/>' + this.error.stacktrace;
        }
        html += '</pre>';
        this.dialog.message(html);
    }
    report() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.reportService.report(this.error);
        });
    }
};
ErrorPanel = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [module_error_error_manager__WEBPACK_IMPORTED_MODULE_6__["ErrorManager"], module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_5__["BugReportService"], aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__["HttpClient"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ErrorPanel);



/***/ }),

/***/ "module/error/error-panel.html":
/*!*******************************************!*\
  !*** ./SPA/module/error/error-panel.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div id=\"error-panel\" class=\"toast toast-error\" if.bind=\"message\">\r\n        <div class=\"float-right\">\r\n            <span if.bind=\"error.stacktrace || error.hint\"><a click.delegate=\"showDetails()\">Show details</a> | </span>\r\n            <a href=\"#\" click.delegate=\"report()\" title=\"Submit Bug Report\">Report</a>\r\n            <button class=\"btn-clear float-right\" style=\"color: white;\" title=\"Close\" click.trigger=\"hide()\"></button>\r\n        </div>\r\n        ${message}\r\n    </div>\r\n    <div style=\"position:absolute;bottom:0; width: 100%;\" id=\"screenshot-screen-widener\"></div>\r\n</template>";

/***/ }),

/***/ "module/integration-test/error":
/*!**********************************************!*\
  !*** ./SPA/module/integration-test/error.ts ***!
  \**********************************************/
/*! exports provided: IntegrationTestError */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "IntegrationTestError", function() { return IntegrationTestError; });
class IntegrationTestError {
    constructor() {
        throw new Error('Cannot navigate to...');
    }
}


/***/ }),

/***/ "module/public/user/login":
/*!******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/public/user/login.ts ***!
  \******************************************************************************/
/*! exports provided: Login */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Login", function() { return Login; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var services_auth__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! services/auth */ "./SPA/services/auth.ts");




let Login = class Login {
    constructor(auth, router) {
        this.auth = auth;
        this.router = router;
        this.username = null;
        this.password = null;
        this.rememberMe = false;
        this.isLoading = false;
        this.validationErrors = null;
    }
    activate(params) {
        if (window.location.search.indexOf('ReturnUrl')) {
            this.returnUrl = decodeURIComponent(window.location.search).substring(12);
        }
    }
    login() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.isLoading = true;
            this.validationErrors = null;
            if (this.username && this.password) {
                try {
                    const response = yield this.auth.login(this.username, this.password, this.rememberMe);
                    if (this.returnUrl) {
                        window.location.href = this.returnUrl;
                    }
                    else if (window.location.hash.toLowerCase() === '#/login') {
                        window.location.href = '/';
                    }
                    else {
                        window.location.reload();
                    }
                }
                catch (error) {
                    this.validationErrors = error;
                    this.isLoading = false;
                }
            }
        });
    }
    get canLogin() {
        return this.username && this.password;
    }
    reset() {
        this.username = null;
        this.password = null;
        this.rememberMe = false;
        this.validationErrors = null;
        this.isLoading = false;
    }
};
Login = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [services_auth__WEBPACK_IMPORTED_MODULE_3__["AuthService"], aurelia_router__WEBPACK_IMPORTED_MODULE_2__["Router"]])
], Login);



/***/ }),

/***/ "module/public/user/login.html":
/*!*******************************************!*\
  !*** ./SPA/module/public/user/login.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"login-form\">\r\n        <div class=\"content\">\r\n            <img src=\"/images/logo.png\" style=\"float:right;\" />\r\n            <h1><a href=\"https://scifeon.com\" target=\"_blank\">scifeon</a></h1>\r\n            <p>\r\n                Please login.\r\n                <br/><br/><br/>\r\n            </p>\r\n            <form submit.trigger=\"login()\">\r\n                <div class=\"form-group ${validationErrors !== null ? 'has-error' : ''}\">\r\n                    <input type=\"text\" value.bind=\"username\" id=\"username\" placeholder=\"Username\"/>\r\n                </div>\r\n                <div class=\"form-group ${validationErrors !== null ? 'has-error' : ''}\">\r\n                    <input type=\"password\" value.bind=\"password\" id=\"password\" placeholder=\"Password\"/>                    \r\n                    <p if.bind=\"validationErrors !== null\" class=\"form-input-hint\">${validationErrors}</p>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label class=\"form-switch\">\r\n                        <input type=\"checkbox\" id=\"rememberMe\" checked.bind=\"rememberMe\"/>\r\n                        <i class=\"form-icon\"></i> Remember login?\r\n                    </label>\r\n                    <div class=\"float-right\">\r\n                        <div if.bind=\"isLoading\" class=\"loading float-left\" style=\"margin-right:8px;\"></div>\r\n                        <button class=\"primary\" type=\"submit\" disabled.bind=\"!canLogin\">Log in</button>\r\n                        <button click.delegate=\"reset()\" class=\"btn-link\">Reset</button>\r\n                    </div>  \r\n                    <br/>\r\n                    <a href=\"/#/forgot\">Forgot password?</a>                \r\n                </div>\r\n            </form>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/request/create":
/*!**************************************!*\
  !*** ./SPA/module/request/create.ts ***!
  \**************************************/
/*! exports provided: CreateRequest */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CreateRequest", function() { return CreateRequest; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);





let CreateRequest = class CreateRequest {
    constructor(server, user, router, sis) {
        this.server = server;
        this.user = user;
        this.router = router;
        this.sis = sis;
        this.request = {
            eClass: 'Request',
            id: '#idRequest',
            status: _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].SENT
        };
        this.selectedMethods = [];
        this.note = {
            eClass: 'Note',
            content: '',
            subjectClass: 'Request',
            subjectID: '#idRequest',
            type: 'EntryNotes'
        };
        this.samples = [];
        this.nextInputSampleAlias = 1;
    }
    activate(params) {
        this.request.type = params.type;
        this.request.inboxID = params.inboxID;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Method', collection: 'methods' }
            ]);
            this.methods = dataset.methods;
        });
    }
    showAddSamplesPopup() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const newSamples = yield this.sis.editSamples('externalID, type, content, tags, description', this.samples.slice(0));
            this.samples = newSamples.filter(s => s.type || s.externalID || s.content);
        });
    }
    createRequest() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const entities = this.samples.map(sample => {
                sample.id = `#idSmp${this.nextInputSampleAlias++}`;
                sample.name = '!CustomerSampleNo';
                sample.barcode = '!Barcode';
                sample.format = 'Vial';
                sample.requestID = '#idRequest';
                return sample;
            });
            entities.push({
                eClass: 'Collection',
                id: '#idPayloadCollection',
                type: 'Payload',
                collItems: entities.filter(e => e.eClass === 'Sample').map(s => ({ entityClass: 'Sample', entityID: s.id }))
            });
            const payload = {
                methods: this.selectedMethods.map(m => m.id),
                sampleMethodMap: []
            };
            this.selectedMethods.map(m => this.samples.map(s => {
                payload.sampleMethodMap.push({
                    sampleID: s.id, methodID: m.id
                });
            }));
            this.request.sentByID = this.user.id;
            this.request.dateSent = new Date();
            this.request.payload = payload;
            this.request.xrefs = [{ type: 'Payload', toID: '#idPayloadCollection', toClass: 'Collection' }];
            entities.push(this.request);
            if (this.note.content.length > 0)
                entities.push(this.note);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            const response = yield this.server.saveEntities(entities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            let requestID = response.newEntities.find(e => e.eClass === 'Request').id;
            this.router.navigate('/entity/request/' + requestID);
        });
    }
};
CreateRequest = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["SampleInputSelectorDialogService"]])
], CreateRequest);



/***/ }),

/***/ "module/request/create.html":
/*!****************************************!*\
  !*** ./SPA/module/request/create.html ***!
  \****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Create Request</h1>\r\n            <div class=\"toolbar\">\r\n                <button disabled.bind=\"!isValid\" click.delegate=\"createRequest()\">Save</button>\r\n            </div>\r\n        </div>\r\n        <div class=\"grid page-panels\" style=\"grid-template-columns: 0.5fr 1fr;\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">\r\n                    Request Info\r\n                </div>\r\n                <div class=\"panel-body\">\r\n                    <entity-form e-class=\"request\" valid.bind=\"isValid\" object.bind=\"request\" fields=\"customerID, type, description, inboxID, recipientID\" horizontal.bind=\"false\"></entity-form>\r\n\r\n                    <div class=\"form\" if.bind=\"methods.length\">\r\n                        <div class=\"form-group\">\r\n                            <label>Methods</label>\r\n                            <label repeat.for=\"method of methods\">\r\n                                <input type=\"checkbox\" model.bind=\"method\" checked.bind=\"selectedMethods\" />\r\n                                ${method.name} (${method.stepType})\r\n                            </label>\r\n                        </div>\r\n                    </div>\r\n                </div>   \r\n            </div>\r\n            <div>\r\n                <div class=\"panel\" style=\"margin-bottom: 10px\">\r\n                    <div class=\"panel-heading\">\r\n                        Notes\r\n                    </div>\r\n                    <rich-text-editor value.bind=\"note.content\" class=\"no-border\"></rich-text-editor>\r\n                </div>\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">\r\n                        Samples\r\n                    </div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <button click.delegate=\"showAddSamplesPopup()\">${samples.length ? 'Edit' : 'Add'} Samples</button>\r\n                        </div>\r\n                        <div class=\"form-group\" if.bind=\"samples.length\">\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>External ID</th>\r\n                                        <th>Type</th>\r\n                                        <th>Content</th>\r\n                                        <th>Tags</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"sample of samples\">\r\n                                        <td>${sample.externalID}</td>\r\n                                        <td>${sample.type}</td>\r\n                                        <td>${sample.content}</td>\r\n                                        <td>${sample.tags}</td>\r\n                                        <td>${sample.description}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>    \r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/search/index":
/*!************************************!*\
  !*** ./SPA/module/search/index.ts ***!
  \************************************/
/*! exports provided: Index */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Index", function() { return Index; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);




let Index = class Index {
    constructor(server, router) {
        this.server = server;
        this.router = router;
        this.entities = [];
        this.searchColumns = [
            { key: 'id', name: 'ID', renderer: (item, column) => `<a href="/#/entity/${item.eClass}/${item.id}">${item.id}</a>` },
            { key: 'eClass', name: 'Class' },
            { key: 'type', name: 'Type' },
            { key: 'name', name: 'Name' },
            { key: 'status', name: 'Status' },
            { key: 'userID', name: 'User' },
            { key: 'departmentID', name: 'Department' },
            { key: 'description', name: 'Description' }
        ];
        this.loading = true;
    }
    activate(params, route) {
        const overlay = document.getElementById('main-menu-overlay');
        if (overlay) {
            overlay.click();
        }
        this.searchTerm = params.q;
        route.navModel.setTitle('Search: ' + this.searchTerm);
        this.search();
    }
    attached() {
        this.eSearchInput.addEventListener('keydown', event => {
            if (event.key === 'Enter' && this.searchTerm) {
                event.preventDefault();
                this.searchClick();
            }
        });
    }
    determineActivationStrategy() {
        return aurelia_router__WEBPACK_IMPORTED_MODULE_3__["activationStrategy"].replace;
    }
    searchClick() {
        this.router.navigate('/search?q=' + this.searchTerm);
    }
    search() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            const response = yield this.server.get('/api/query/freetext/' + this.searchTerm);
            const json = yield response.json();
            this.entities = json.data;
            this.loading = false;
        });
    }
};
Index = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"]])
], Index);



/***/ }),

/***/ "module/search/index.html":
/*!**************************************!*\
  !*** ./SPA/module/search/index.html ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/scirex-table\"></require>\r\n\r\n    <div class=\"page-header\"><h1>Search</h1></div>\r\n\r\n    <div class=\"page-panels\">\r\n\r\n        <div class=\"panel\">\r\n            <div class=\"input-group has-icon-right\">\r\n                <input type=\"text\" placeholder=\"Search by id, name, or barcode\" ref=\"eSearchInput\" value.bind=\"searchTerm\" class=\"input-lg\" />\r\n                <i if.bind=\"loading\" style=\"margin-right:107px;margin-top:2px;\" class=\"form-icon loading\"></i>\r\n                <button class=\"input-group-btn btn-lg fa fa-search\" title=\"Search\" click.delegate=\"searchClick()\" disabled.bind=\"!searchTerm\" style=\"width:100px;\"></button>\r\n            </div>\r\n        </div>\r\n        <br/>\r\n\r\n        <div class=\"panel\" if.bind=\"!loading\">\r\n            <div class=\"panel-body\">\r\n                <scirex-table in-memory-items.bind=\"entities\" style=\"width:100%\" columns.bind=\"searchColumns\" height=\"80vh\"></scirex-table>\r\n            </div>\r\n        </div>\r\n\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "module/shoppingcart/scart-content":
/*!**************************************************!*\
  !*** ./SPA/module/shoppingcart/scart-content.js ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SCartContent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _shoppingCart = __webpack_require__(/*! ./shopping-cart */ "./SPA/module/shoppingcart/shopping-cart.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SCartContent = exports.SCartContent = (_dec = (0, _aureliaFramework.inject)(_shoppingCart.ShoppingCart), _dec(_class = function () {
    function SCartContent(cart) {
        _classCallCheck(this, SCartContent);

        this.cart = cart;
    }

    _createClass(SCartContent, [{
        key: 'remove',
        value: function remove(entity) {
            this.cart.remove(entity.eClass, entity.id);
        }
    }, {
        key: 'clearCart',
        value: function clearCart() {
            this.cart.clear();
        }
    }]);

    return SCartContent;
}()) || _class);

/***/ }),

/***/ "module/shoppingcart/scart-content.html":
/*!****************************************************!*\
  !*** ./SPA/module/shoppingcart/scart-content.html ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <h1>Cart</h1>\r\n\r\n    <p>\r\n        <button class=\"btn-default\" click.delegate=\"clearCart()\">Clear Cart</button>\r\n    </p>\r\n\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Entities in Cart</div>\r\n        <div class=\"panel-body\">\r\n            <table class=\"compact\">\r\n                <thead>\r\n                    <tr>\r\n                        <th>Class</th>\r\n                        <th>Name</th>\r\n                        <th>Type</th>\r\n                        <th>Status</th>\r\n                        <th>User</th>\r\n                        <th>Description</th>\r\n                    </tr>\r\n                </thead>\r\n                <tbody>\r\n                    <tr repeat.for=\"entity of cart.entities\">\r\n                        <td>${entity.eClass}</td>\r\n                        <td><a href=\"/#/entity/${entity.eClass}/${entity.id}\">${entity.name}</a></td>\r\n                        <td>${entity.type}</td>\r\n                        <td>${entity.status}</td>\r\n                        <td>${entity.userID}</td>\r\n                        <td>${entity.description}</td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "module/user/change-password-dialog":
/*!***************************************************!*\
  !*** ./SPA/module/user/change-password-dialog.ts ***!
  \***************************************************/
/*! exports provided: ChangePasswordDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChangePasswordDialog", function() { return ChangePasswordDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let ChangePasswordDialog = class ChangePasswordDialog {
    constructor(server, dialog) {
        this.server = server;
        this.errors = [];
        this.isLoading = true;
        this.dialog = dialog;
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.errors = [];
            this.isLoading = true;
            try {
                yield this.server.postJson('/api/user/password/change', {
                    currentPassword: this.currentPassword,
                    password: this.password,
                    repeatPassword: this.repeatPassword
                });
                this.dialog.ok();
            }
            catch (error) {
                this.errors.push(error);
            }
            this.isLoading = false;
        });
    }
    get isValid() {
        return this.currentPassword && this.password && this.password === this.repeatPassword;
    }
};
ChangePasswordDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ChangePasswordDialog);



/***/ }),

/***/ "module/user/change-password-dialog.html":
/*!*****************************************************!*\
  !*** ./SPA/module/user/change-password-dialog.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog>\r\n        <ux-dialog-body>\r\n            <div class=\"form-group ${errors.length ? 'has-error' : '' }\">\r\n                <label>Current password</label>\r\n                <input type=\"password\" value.bind=\"currentPassword\" placeholder=\"Current password\"/>\r\n            </div>\r\n            <div class=\"form-group ${errors.length ? 'has-error' : '' }\">\r\n                <label>New password</label>\r\n                <input type=\"password\" value.bind=\"password\" placeholder=\"New password\"/>\r\n            </div>\r\n            <div class=\"form-group ${errors.length ? 'has-error' : '' }\">\r\n                <label>Repeat password</label>\r\n                <input type=\"password\" value.bind=\"repeatPassword\" placeholder=\"Repeat password\"/>\r\n                <p class=\"form-input-hint\" repeat.for=\"error of errors\">${error.message}</p>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>            \r\n            <button class=\"primary loading\" click.delegate=\"save()\" disabled.bind=\"!isValid\">OK</button><button class=\"btn-link\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer> \r\n    </ux-dialog>   \r\n</template>";

/***/ }),

/***/ "module/user/profile":
/*!************************************!*\
  !*** ./SPA/module/user/profile.ts ***!
  \************************************/
/*! exports provided: Profile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Profile", function() { return Profile; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _change_password_dialog__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./change-password-dialog */ "module/user/change-password-dialog");





let Profile = class Profile {
    constructor(dialog, user) {
        this.dialog = dialog;
        this.user = user;
    }
    changePassword() {
        this.dialog.open({
            view: __webpack_require__(/*! ./change-password-dialog.html */ "module/user/change-password-dialog.html"),
            viewModel: _change_password_dialog__WEBPACK_IMPORTED_MODULE_4__["ChangePasswordDialog"]
        });
    }
};
Profile = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], Profile);



/***/ }),

/***/ "module/user/profile.html":
/*!**************************************!*\
  !*** ./SPA/module/user/profile.html ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Profile and Settings</h1>\r\n        </div>\r\n\r\n        <div class=\"detail-panels\" style=\"padding-left: 10px;padding-right: 10px;\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Profile</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"view-group\">\r\n                        <label>ID</label>\r\n                        ${user.id}\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Department</label>\r\n                        ${user.departmentID}\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>E-mail</label>\r\n                        ${user.email}\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Settings</div>\r\n                <div class=\"panel-body\">\r\n                    <button click.delegate=\"changePassword()\">Change password</button>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "services/app/admin-page-plugin":
/*!***********************************************!*\
  !*** ./SPA/services/app/admin-page-plugin.ts ***!
  \***********************************************/
/*! exports provided: AdminPagePlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdminPagePlugin", function() { return AdminPagePlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _page_plugin__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./page-plugin */ "services/app/page-plugin");




let AdminPagePlugin = class AdminPagePlugin extends _page_plugin__WEBPACK_IMPORTED_MODULE_3__["PagePlugin"] {
    constructor(pluginLoader, pluginManager) {
        super(pluginManager);
        this.pluginLoader = pluginLoader;
        this.menuItemsKey = 'admin';
        this.sections = {
            General: [],
            Data: []
        };
    }
    attached() {
        const _super = name => super[name];
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const menuItems = this.pluginLoader.getMenuItems(this.menuItemsKey);
            const otherSection = [];
            for (const item of menuItems) {
                this.transformMenuItem(item);
                if (item.section) {
                    const section = Object.keys(this.sections).find(s => s.toLowerCase() === item.section.toLowerCase()) || item.section;
                    this.sections[section] = this.sections[section] || [];
                    this.sections[section].push(item);
                }
                else {
                    otherSection.push(item);
                }
                if (item.route) {
                    item.active = item.route === this.routeConfig.route;
                }
            }
            if (otherSection.length) {
                this.sections.Other = otherSection;
            }
            yield _super("attached").call(this);
        });
    }
    transformMenuItem(item) {
        if (!item.url && item.route) {
            item.url = '/#/' + item.route;
        }
    }
};
AdminPagePlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginLoader"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginManager"]])
], AdminPagePlugin);



/***/ }),

/***/ "services/app/admin-page-plugin.html":
/*!*************************************************!*\
  !*** ./SPA/services/app/admin-page-plugin.html ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-sidebar as-menu\">\r\n        <div class=\"sidebar fixed\">\r\n            <ul repeat.for=\"section of sections | objectKeys\" class=\"menu\">\r\n                <li class=\"section-header\">\r\n                    ${section}\r\n                </li>\r\n                <li class=\"menu-item\" repeat.for=\"item of sections[section]\">\r\n                    <a class=\"${item.active ? 'active' : ''}\" href.bind=\"item.url\">${item.text}</a>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n        <div class=\"content\">\r\n            <render-plugin if.bind=\"plugin\"\r\n                plugin.bind=\"plugin\" \r\n                context.bind=\"context\" \r\n                location.bind=\"location\"\r\n                large-loading-indicator=\"true\"></render-plugin>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "services/app/data-admin-page-plugin":
/*!****************************************************!*\
  !*** ./SPA/services/app/data-admin-page-plugin.ts ***!
  \****************************************************/
/*! exports provided: DataAdminPagePlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataAdminPagePlugin", function() { return DataAdminPagePlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _admin_page_plugin__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./admin-page-plugin */ "services/app/admin-page-plugin");



let DataAdminPagePlugin = class DataAdminPagePlugin extends _admin_page_plugin__WEBPACK_IMPORTED_MODULE_2__["AdminPagePlugin"] {
    constructor() {
        super(...arguments);
        this.menuItemsKey = 'data-admin';
        this.sections = {
            General: [],
            Audit: []
        };
    }
};
DataAdminPagePlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["useView"])('./admin-page-plugin.html')
], DataAdminPagePlugin);



/***/ }),

/***/ "services/app/page-plugin":
/*!*****************************************!*\
  !*** ./SPA/services/app/page-plugin.ts ***!
  \*****************************************/
/*! exports provided: PagePlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PagePlugin", function() { return PagePlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);





let PagePlugin = class PagePlugin {
    constructor(pluginManager) {
        this.pluginManager = pluginManager;
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].getLogger('PagePlugin');
    }
    determineActivationStrategy() {
        return aurelia_router__WEBPACK_IMPORTED_MODULE_4__["activationStrategy"].replace;
    }
    activate(params, routeConfig, navigationInstruction) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.params = params;
            this.routeConfig = routeConfig;
            this.navigationInstruction = navigationInstruction;
            this.pageId = routeConfig.settings.pageId;
            this.app = routeConfig.settings.app;
            this.context = { params: this.params, routeConfig: this.routeConfig, navigationInstruction: this.navigationInstruction };
            this.location = { type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].PAGE };
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
        });
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.routeConfig.hasChildRouter) {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
                throw new Error('Page not found.');
            }
            this.plugin = yield this.pluginManager.getPluginFromApp(this.pageId, this.app);
            this.logger.debug(`Page with ID '${this.pageId}' from App '${this.app.fqAppName}' loaded.`);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
};
PagePlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"]])
], PagePlugin);



/***/ }),

/***/ "services/app/page-plugin.html":
/*!*******************************************!*\
  !*** ./SPA/services/app/page-plugin.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <render-plugin if.bind=\"plugin\"\r\n                   plugin.bind=\"plugin\" \r\n                   context.bind=\"context\" \r\n                   location.bind=\"location\"\r\n                   large-loading-indicator=\"true\"></render-plugin>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=protected.7d2e17d8ae74be98b4b6.js.map